
# TO BE SET: path where you have these scripts
# metqcpath="D:/Linux_share/MetQC_INDECIS"
metqcpath=getwd()

# TO BE SET: path where you have data
datapath_in=paste0(metqcpath,'/Data')
datapath_out=paste0(metqcpath,'/Data')


# directory, usually temporary, in which files with parameters settings are located, 
workpath=paste0(metqcpath,"/Temp")
				  
		  # checks, if directories exist
		  if (!dir.exists(paste0(metqcpath,'/Temp/'))) dir.create(paste0(metqcpath,'/Temp/'))
		  if (!dir.exists(paste0(datapath_in,'/'))) dir.create(paste0(datapath_in,'/'))
		  if (!dir.exists(paste0(datapath_in,'/Temp/'))) dir.create(paste0(datapath_in,'/Temp/'))
		  if (!dir.exists(paste0(datapath_out,'/'))) dir.create(paste0(datapath_out,'/Temp/'))
		  if (!dir.exists(workpath)) dir.create(workpath, recursive = FALSE)

setwd(metqcpath)

			  

# outputs as for ECAD (KNMI), can be changed in launch_QC.r
k_ECAD_mode=TRUE 			  
# run the processes parallel? you can change this number of parallle processes
k_run_parallel=FALSE
n_processes_=3
			  
			  
# -----			  
			  
			  
# TO BE SET: region and dataset to process
# naming convention is set for INDECIS benchmark dataset
	# to set any other input and output files, please adjust corresponding parameters in given functions
#####################
ss_region="se"

# ss_bench_dataset="fC"
ss_bench_dataset="fQM"
# ss_bench_dataset="fB"
# ss_bench_dataset="fBM"
# ss_bench_dataset="fQMB"


region=paste0(ss_region,'_',ss_bench_dataset)

# list of stations with coordinates:
file_geography=paste0(ss_region,'_Stations','.txt')

######################	
	
	
# list of elements to be processed:	
	# list of INDECIS elements:
elem_list=toupper( c('CC','FG','HU','PP','RR','SD','SS','TN','TX') )
	# whole list of ECAD elements:
	# elem_list=toupper( c('CC','DD','FG','FX','HU','PP','RR','SD','SS','TG','TN','TX') )
	# some selection only:
	# elem_list=toupper( c('TN','TX') )
	# elem_list=toupper( c('CC','SD','RR') )
			  
			  
ii_sel_elem=seq(from=1, to=length(elem_list))		  
			  
		  

#---------------------------------------------------------------------------------------	  
			  		  
			  
setwd(metqcpath)	  
# load needed auxiliary functions:
source("rprog/load_package_my.r", TRUE)
source("rprog/fce_rprog.r", TRUE)

	# library(data.table)
# load_package_my("data.table")

# -----		


file_parameters='R_input_parameters.txt'
log_file_corr='log_Rterm_.txt'

		
		
###############	
###############	
###############	



# conversion function from Jose A. Guijarro, as taken from indecis.R on 28/10/2018 (by the way, the date of 100 years of Czech(oSlovakia) state)

#- ecad2csv.- Convert ECAD files to CSV format.
ecad2csv <- function(direcad,csvfile,inidate,enddate) {
#direcad: directory of the ECAD files (FOR A SINGLE VARIABLE)
#csvfile: name of the output CSV file
#inidate: initial date, in '%Y-%m-%d' format
#enddate: final date, in '%Y-%m-%d' format
  fech <- seq(as.Date(inidate),as.Date(enddate),1)
  nd=length(fech)
  Fs <- file('ecad2csv.aux','w') #auxiliary output file
  names <- "Dates"
  for(fich in dir(direcad)) {
    cat(fich,'\n')
    dat=rep(NA,nd)
    d <- read.table(sprintf('%s/%s',direcad,fich),skip=19,header=FALSE,sep=',',strip.white=TRUE,na.strings='-9999',as.is=TRUE)
    names <- c(names,d[1,2]) #SOUID will be the column name in the CSV file
    fe <- as.Date(as.character(d$V3),format='%Y%m%d')
    kd <- match(fe,fech)
    kf <- which(!is.na(kd))
    dat[kd[kf]] <- d[kf,4]
    write(dat,Fs,ncolumns=10)
  }
  close(Fs)
  #read the auxiliary file and write the CSV file:
  dat <- scan('ecad2csv.aux')
  dim(dat) <- c(nd,length(dat)/nd)
  df <- data.frame(fech,dat)
  names(df) <- names
  write.csv(df,csvfile,row.names=FALSE)
  file.remove('ecad2csv.aux')
}



###############	
###############	
		
		
# functions needed to run MetQC:	
		
		
		# this function changes parameters settings (taken from a given  template), and sets a new value (replaces a default one) for the specified parameter
Parameter_exchange2=function(set_controls, param_find="x ", set_value="y",  put_quotes=TRUE , k_version2=TRUE ) {	
		# k_version2=TRUE - there are needed settings here,  DO NOT CHANGE
				
		# example of usage:
			# set_controls <- readLines(a_controls_template)
			# set_controls=Parameter_exchange2(set_controls, "data_file ", file_in_copy)			
			# writeLines(set_controls, con=a_controls)				  

			
	
		## Review output
		# cat( set_controls , sep="\n")
				
				
			param_find=as.character(param_find)
			set_value=as.character(set_value)
							
		ii_pom=grep(param_find,set_controls, fixed=TRUE)[1] #first occurence
		
		if (!is.na(ii_pom))  {
		
			if (k_version2) {
				value_find=strextract(set_controls[ii_pom], ss_beg="=" , ss_end="" , k_last=TRUE) 
							} else {
				value_find=strextract(set_controls[ii_pom], ss_beg=" " , ss_end="" , k_last=TRUE)
									}

			if (nchar(value_find)>0) {
					if (k_version2) {
					set_controls[ii_pom] = gsub( pattern = paste0("=",value_find), replace = paste0("= ",ifelse(put_quotes,'"',''), set_value ,ifelse(put_quotes,'"','')) ,  set_controls[ii_pom] )										   	
							} else {
					set_controls[ii_pom] = gsub( pattern = paste0(" ",value_find), replace = paste0(" ",ifelse(put_quotes,'"',''), set_value ,ifelse(put_quotes,'"','')) ,  set_controls[ii_pom] )
									}
								 } else {
warning( paste0(" Value: ",set_value," not found ...") )
										}
							} else {
warning( paste0(" Parameter ", param_find, " not found ...") )
									}
	
	return(set_controls)
								} # Parameter_exchange2=function



								
###############	  





	#in parallel processes, this file may be created more times which is then a problem ... 
		# here it is guarded that only one occurence happens
	Create__file_parameters=function(ss_print="", ss_text, file_parameters='R_input_parameters.txt') {
		# write( c("run_QC_7_4 (temporary write)",ii,ele), file_parameters , append=FALSE)
		# unlink(file_parameters)
			ss_text2=""
		while (!all(ss_text2==ss_text)) {
		# waits again for the file to be ready (not existing)
			  while (file.exists(file_parameters)) {
				# print(paste("XXX function: file with parameters exists - ",file_parameters," - waiting with further launch of launch_QC.r"))
				if (length(ss_print)>0) print(ss_print)
				Sys.sleep(1.53)
													} #while
			# creates the file_parameters, to be sure, no other process will make it before it is created in the next function
			write.table( ss_text , file_parameters , append=FALSE)
			# it may happend that in parallel processes the file is created more times ... so now check it ... in while cyclus, that what you wrote is there
			Sys.sleep(1.17)
			ss_text2=read.table(file_parameters, fill = TRUE)			
						
										} # while (!all(ss_text2==ss_text))
														}	 #	Create__file_parameters=function	
		


###############	  
###############	  


  

# wrapper for the launch_QC.r script,  
	# launch_QC.r script is suitable for running  1-1 function in ProClimDB,  
# this creates info file - list of stations, with coordinates joined from geography, period of measurement, and number of missing values
Run__Get_info_file = function ( MetQC_path=getwd() ,  
								launch_script='launch_QC.r' , 
								k_launch_script=TRUE ,
								file_parameters='R_input_parameters.txt' ,
								a_files=paste0(MetQC_path,"/Temp/R_input_files_1_1_0.txt") , 
								a_controls=paste0(MetQC_path,"/Temp/R_input_controls_1_1_0.txt") ,
								a_controls_template=paste0(MetQC_path,"/Templates/",basename(a_controls)) , 
								
								input_data_file="" ,
								geography_file="" ,
								info_file=paste0(filename2(input_data_file) , "_info.", file_extension(input_data_file) ) ,
								data_file=paste0(filename2(input_data_file) , "_new.", file_extension(input_data_file) ) ,
								
								missval=-999 ,
								k_fill_gaps=1 ,	
								n_fill_max_years=5									
								) {
			# MetQC_path: directory where scripts with QC to run  are located
			# launch_script: a script to launch a processing itself			
			# a_files: txt file with parameters settings for input and output files - to be used in the main QC script (launch_QC.r)
			# a_controls: txt file with parameters settings of the function - to be used in the main QC script (launch_QC.r)
				# templates are saved here: a_controls_template
				# this a new file created based on the a_controls_template, with changed parameters settings - input into this function, usually saved into Temp folder
			
			# input_data_file: input data file
			# geography_file=: with list of stations and their coordinates
			# info_file: output info_file (list of stations, with coordinates joined from geography, period of measurement, and number of missing values)
			# data_file: output data file, with filled gaps - replaced with missing value code (missval)
			
			# missval: code for missing values (in data file)
			# k_fill_gaps - do you want to fill gaps? Put 1, otherwise 0
			# n_fill_max_years - maximum number of yeas wit missing values to be filled with NA, otherwise the series is split into more parts
			
		  dir_original=getwd()	

					  
		  # set the files, settings are put into .txt files, e.g. Temp/R_input_files_1_1_0.txt
		  setwd(MetQC_path)
		  
		  write( c(paste0('edit1 = "', input_data_file , '"'),
				   paste0('edit3 = "', geography_file , '"'),
				   paste0('edit5 = "', info_file , '"'),
				   paste0('edit7 = "', data_file , '"')
				   ),				   
				a_files,
				append=FALSE)
				# unlink(a_files)	
print(paste0("Creating: ",a_files))				

		  # set the function parameters, settings are put into .txt files, e.g. Temp/R_input_controls_1_1_0.txt
		  if (file.exists(a_controls_template)) {
		  
			set_controls <- readLines(a_controls_template)

			# change parameters settings (taken from template)
			# set_controls=Parameter_exchange2(set_controls, param_find="Fill gaps with missvals ", set_value=as.character(k_fill_gaps) , put_quotes=FALSE , k_version2=TRUE )
			set_controls=Parameter_exchange2(set_controls, "Fill gaps with missvals ", k_fill_gaps , put_quotes=FALSE )
			set_controls=Parameter_exchange2(set_controls, "Max missing years;days ", n_fill_max_years , put_quotes=FALSE )
				## Review output
				# cat( set_controls , sep="\n")
			
			writeLines(set_controls, con=a_controls)
print(paste0("Creating: ",a_controls))
			
															} else {
stop("error in Run__Get_info_file function, no template parameters file specified")
																	}
				  
				  			
							
	  # writes down general parameters file	, 		
      # setwd(MetQC_path)
		# write(c( ""), file_parameters, append=FALSE)
      write( c( paste0('a_files ',a_files),
                paste0('a_controls ',a_controls), 
              'idcol ""',
              's_plot_type png',
              paste0('missval ',as.character(missval)),
              'n_file_CodePage 852',
              'n_transformation 0',
              '',
              'R_mode "RGui"'),
            file_parameters ,
            append=FALSE)
			# R_mode: run R in "RGui" or as "Rterm",  suitable for Windows
			# unlink(file_parameters)	
print(paste0("Creating: ",file_parameters))     
	  
	  
	  # runs the script		
      setwd(MetQC_path)
      if (k_launch_script) source('launch_QC.r',local=TRUE)
     
	 	 
	  setwd(dir_original)	
	 
																					} # Run__Get_info_file

																					
###


	  # encapsulating function for Run__Get_info_file(): 		
		# parameter k_wait_while_file_parameters==TRUE: wait while file_parameters file exists (previous process is in run)
      run_Get_Info_1_1 = function(ii_sel_elem, elem_list , k_wait_while_file_parameters=TRUE,file_parameters='R_input_parameters.txt' ) {
		# examples of run: 
			  #run given elements, elements given by they ordinal number				
				# only one element:
				# run_Get_Info_1_1( 4 ,elem_list)
			  
			  # run all:
			  # run_Get_Info_1_1(1:12,elem_list)
					  
				  # run_Get_Info_1_1(1:3,elem_list)		
				  # run_Get_Info_1_1(4:6,elem_list)		
				  # run_Get_Info_1_1(7:9,elem_list)		
				  # run_Get_Info_1_1(10:12,elem_list)		
						

						
        for (ii in ii_sel_elem )
        {
          ele=elem_list[ii]	
          if (is.na(ele))  next 		
          
		  print("")
          print(paste("Running basic loop, 1-1, for element: ", ele))
		  		   		
						
		  setwd(metqcpath)
		  
			# not to confuse parallel runnings, the parameters file (the same name for everything) has to be free (not existing ...)	
			Create__file_parameters( c("run_Get_Info_1_1 (temporary write)",ii,ele) , file_parameters, ss_print=paste("run_Get_Info_1_1 function: file with parameters exists - ",file_parameters," - waiting with further launch of launch_QC.r") )				
						
			#	if (k_write_log) {
		#		ss_file=paste0("log_temp_7-2_",ii,".txt")
		#		write( c("run_Find_Ngbs_7_2 (temporary write)",ii,ele), ss_file , append=FALSE)			
				# unlink(ss_file)
			#					}
			
								
		### CALL 1 1 
		Run__Get_info_file( MetQC_path=metqcpath ,  
							file_parameters=file_parameters , 
							a_files=paste0(workpath,'/R_input_files_1_1_0','__',ele,'.txt') ,
						   input_data_file=paste0(datapath_in,'/',ele,'_',region,'','.csv') ,
						   geography_file =paste0(datapath_in,'/',file_geography) ,
						   info_file=paste0(datapath_out,'/info_file_',ele,'_',region,'.csv')  ,
						   data_file=paste0(datapath_out,'/QC_datafile_',ele,'_',region,'_new.csv' )
							)
																
							
	  	} #for 
																} # run_Get_Info_1_1
		 																					
																					
																					
###############																					
					
		  
# wrapper for the launch_QC.r script,  
	# launch_QC.r script is suitable for running  7-2 function in ProClimDB,  
# it finds neighbors according to given criterions
Run__Find_Neighbors= function ( MetQC_path=getwd() ,  
								launch_script='launch_QC.r' , 
								k_launch_script=TRUE ,
								file_parameters='R_input_parameters.txt' , 
								a_files=paste0(MetQC_path,"/Temp/R_input_files_7_2_0.txt") , 
								a_controls=paste0(MetQC_path,"/Temp/R_input_controls_7_2_0.txt") ,
								a_controls_template=paste0(MetQC_path,"/Templates/",basename(a_controls)) , 
								
								data_file="" , 
								info_file="" , 								
								ngbs_info=paste0(filename2(data_file) , "_ngbs_info.", file_extension(data_file) ) ,
								
								missval=-999 ,
								n_number_of_stations=6 ,	
								limit_distance=400 ,
								limit_diffs_altitude=500 ,
								k_clever_altitude_sel=1 ,
								n_period_length=0 ,
								n_period_overlap=0 ,
								k_common_period=1 ,
								k_the_same_region=1
								
								) {
			# MetQC_path: directory where scripts with QC to run  are located				
			# launch_script: a script to launch a processing itself
			# a_files: txt file with parameters settings for input and output files - to be used in the main QC script (launch_QC.r)
			# a_controls: txt file with parameters settings of the function - to be used in the main QC script (launch_QC.r)
				# templates are saved here: a_controls_template
				# this a new file created based on the a_controls_template, with changed parameters settings - input into this function, usually saved into Temp folder
						
			# input_data_file: input data file (not needed, can be void)
			# info_file: input info_file (list of stations, with coordinates joined from geography, period of measurement, and number of missing values)
			# ngbs_info: output file with list of neighbors for each of base station
			
			# missval: code for missing values (in data file)
			# n_number_of_stations: number of neighbors to find ,	
			# limit_distance: limit distance (weight=0) ,
			# limit_diffs_altitude: limit altitude difference (weight=0) ,
			# k_clever_altitude_sel: put 1 to use a larger sample of altitudes for the linear regression
			# n_period_length: put 1 to cut the periods into segments with the given length ,
			# n_period_overlap: in case of period segments, length of overlap ,
			# k_common_period: put 1 for finding only neighbors with the common period
			# k_the_same_region: put 1 for finding only neighbors with the same region
			

		  dir_original=getwd()	

		  
		  
		  setwd(MetQC_path)
		  
		  # set the files, settings are put into .txt files, e.g. Temp/R_input_files_7_2_0.txt
		  write( c(paste0('edit1 = "', data_file , '"' ),
				   paste0('edit2 = "', info_file , '"' ),
				   paste0('edit5 = "', "" , '"' ), # ngbs_file: output file with neighbors info (not needed, let it be void)
				   paste0('edit6 = "', ngbs_info , '"' )
				   ),
				a_files,
				append=FALSE)
				# unlink(a_files)	
print(paste0("Creating: ",a_files))
		  
		 		  
				
		  # set the function parameters, settings are put into .txt files, e.g. Temp/R_input_controls_1_1_0.txt
		  if (file.exists(a_controls_template)) {
		  
			set_controls <- readLines(a_controls_template)

			# change parameters settings (taken from template)
			# set_controls=Parameter_exchange2(set_controls, param_find="Fill gaps with missvals ", set_value=as.character(k_fill_gaps) , put_quotes=FALSE , k_version2=TRUE )
			set_controls=Parameter_exchange2(set_controls, "Number of Stations ", n_number_of_stations , put_quotes=FALSE )
			set_controls=Parameter_exchange2(set_controls, "Limit - Distance/km ", limit_distance , put_quotes=FALSE )
			set_controls=Parameter_exchange2(set_controls, "Maximum altitude diff. ", limit_diffs_altitude , put_quotes=FALSE )
			set_controls=Parameter_exchange2(set_controls, '"Clever" ngb. selection', k_clever_altitude_sel , put_quotes=FALSE )
			set_controls=Parameter_exchange2(set_controls, "Refer begin / Years per part ", n_period_length , put_quotes=FALSE )
			set_controls=Parameter_exchange2(set_controls, "Refer end / Overlap - years ", n_period_overlap , put_quotes=FALSE )
			set_controls=Parameter_exchange2(set_controls, "Common period ", k_common_period , put_quotes=FALSE )
			set_controls=Parameter_exchange2(set_controls, "the same region ", k_the_same_region , put_quotes=FALSE )
				## Review output
				# cat( set_controls , sep="\n")
						
			writeLines(set_controls, con=a_controls)
print(paste0("Creating: ",a_controls))
			
															} else {
stop("error in Run__Find_Neighbors function, no template parameters file specified")
																	}
				  
							
	  # writes down general parameters file	, 		
      # setwd(MetQC_path)
		# write(c( ""), file_parameters, append=FALSE)
      write( c( paste0('a_files ',a_files),
                paste0('a_controls ',a_controls), 
              'idcol ""',
              's_plot_type png',
              paste0('missval ',as.character(missval)),
              'n_file_CodePage 852',
              'n_transformation 0',
              '',
              'R_mode "RGui"'),
            file_parameters ,
            append=FALSE)
			# R_mode: run R in "RGui" or as "Rterm",  suitable for Windows
			# unlink(file_parameters)
print(paste0("Creating: ",file_parameters))      
	  
	  
	  # runs the script		
      setwd(MetQC_path)
      if (k_launch_script) source('launch_QC.r',local=TRUE)
     
	 
	  setwd(dir_original)	
	 
																					} # Run__Find_Neighbors

###


	  # encapsulating function for Run__Find_Neighbors(): 		
		# parameter k_wait_while_file_parameters==TRUE: wait while file_parameters file exists (previous process is in run)
      run_Find_Ngbs_7_2 = function(ii_sel_elem, elem_list , k_wait_while_file_parameters=TRUE,file_parameters='R_input_parameters.txt' ) {
		# examples of run: 
			  #run given elements, elements given by they ordinal number				
				# only one element:
				# run_Find_Ngbs_7_2( 4 ,elem_list)
			  
			  # run all:
			  # run_Find_Ngbs_7_2(1:12,elem_list)
					  	  
				  # run_QC_7_2(1:3,elem_list)		
				  # run_Find_Ngbs_7_2(4:6,elem_list)		
				  # run_Find_Ngbs_7_2(7:9,elem_list)		
				  # run_Find_Ngbs_7_2(10:12,elem_list)		
		  
		  
        for (ii in ii_sel_elem )
        {
          ele=elem_list[ii]	
          if (is.na(ele))  next 		
          
		  print("")
          print(paste("Running basic loop, 7-2, for element: ", ele))
		  
		  
		  setwd(metqcpath)

			# not to confuse parallel runnings, the parameters file (the same name for everything) has to be free (not existing ...)	
			Create__file_parameters( c("run_Find_Ngbs_7_2 (temporary write)",ii,ele) , file_parameters, ss_print=paste("run_Find_Ngbs_7_2 function: file with parameters exists - ",file_parameters," - waiting with further launch of launch_QC.r") )				

			
			#	if (k_write_log) {
		#		ss_file=paste0("log_temp_7-2_",ii,".txt")
		#		write( c("run_Find_Ngbs_7_2 (temporary write)",ii,ele), ss_file , append=FALSE)			
				# unlink(ss_file)
			#					}
						   		
								
		Run__Find_Neighbors( MetQC_path=metqcpath, 
							 file_parameters=file_parameters , 
							 a_files=paste0(workpath,'/R_input_files_7_2_0','__',ele,'.txt') ,
							data_file="" ,  
							info_file=paste0(datapath_out,'/info_file_',ele,'_',region,'.csv')  ,
						    ngbs_info=paste0(datapath_out,'/ngbs_info_',ele,'_',region,'.csv' )
							)
																		
							
	  	} #for 
										} # run_Find_Ngbs_7_2
																							
																					
###############																					
		  
					  
			# wrapper for the launch_corr.r script,  
				# launch_corr.r script is suitable for running  4-3 function in ProClimDB,  
			# it calculates correlations of all pairs
			Run__Calculate_corr= function ( MetQC_path=getwd() ,  
											launch_script='launch_QC.r' , 
											k_launch_script=TRUE ,
											file_parameters='R_input_parameters.txt' , 
											a_files=paste0(MetQC_path,"/Temp/R_input_files_4_3_0.txt") , 
											a_controls=paste0(MetQC_path,"/Temp/R_input_controls_4_3_0.txt") ,
											a_controls_template=paste0(MetQC_path,"/Templates/",basename(a_controls)) , 
											
											data_file="" , 
											info_file="" , 				
											corr_info=paste0(filename2(data_file) , "_corr.", file_extension(data_file) ) ,
											corr2_info=paste0(filename2(data_file) , "_corr2.", file_extension(data_file) ) ,
											
											missval=-999 ,
											k_first_differences=1 ,	
											k_months_individually=1 ,
											k_corr_pearson=1 ,
												k_corr_p_value=0 ,
												k_corr_spearman=0 ,
												k_corr_spearman_pval=0 ,
												k_corr_cov=0 ,
											k_run_KS_test=0 ,
											k_plot_figures=0 ,
											k_plot_type="pdf"
											
											) {
						# MetQC_path: directory where scripts with QC to run  are located				
						# launch_script: a script to launch a processing itself
						# a_files: txt file with parameters settings for input and output files - to be used in the main QC script (launch_QC.r)
						# a_controls: txt file with parameters settings of the function - to be used in the main QC script (launch_QC.r)
							# templates are saved here: a_controls_template
							# this a new file created based on the a_controls_template, with changed parameters settings - input into this function, usually saved into Temp folder
									
						# input_data_file: input data file (not needed, can be void)
						# info_file: input info_file (list of stations, with coordinates joined from geography, period of measurement, and number of missing values)
						# corr_info: calculated correlations to be saved
						# corr2_info: another structure of the output - one big matrix
						
						# missval: code for missing values (in data file)
						# k_first_differences: ... ,	
						

					  dir_original=getwd()	

					  
					  
					  setwd(MetQC_path)
					  
					  # set the files, settings are put into .txt files, e.g. Temp/R_input_files_7_2_0.txt
					  write( c(paste0('edit1 = "', data_file , '"' ),
							   paste0('edit2 = "', info_file , '"' ),
							   paste0('edit5 = "', corr_info , '"' ),
							   paste0('edit7 = "', corr2_info , '"' )
							   ),
							a_files,
							append=FALSE)
							# unlink(a_files)
			print(paste0("Creating: ",a_files))
					  
							  
							
					  # set the function parameters, settings are put into .txt files, e.g. Temp/R_input_controls_1_1_0.txt
					  if (file.exists(a_controls_template)) {
					  
						set_controls <- readLines(a_controls_template)

						# change parameters settings (taken from template)
						# set_controls=Parameter_exchange2(set_controls, param_find="Fill gaps with missvals ", set_value=as.character(k_fill_gaps) , put_quotes=FALSE , k_version2=TRUE )
						set_controls=Parameter_exchange2(set_controls, "Series of First Differences ", k_first_differences , put_quotes=FALSE )
						set_controls=Parameter_exchange2(set_controls, "Months individually ", k_months_individually , put_quotes=FALSE )
						set_controls=Parameter_exchange2(set_controls, "Pearson correlations ", k_corr_pearson , put_quotes=FALSE )
							set_controls=Parameter_exchange2(set_controls, "p-values (Pearson) ", k_corr_p_value , put_quotes=FALSE )
							set_controls=Parameter_exchange2(set_controls, "Spearman rank correlations ", k_corr_spearman , put_quotes=FALSE )
							set_controls=Parameter_exchange2(set_controls, "p-values (Spearman rank) ", k_corr_spearman_pval , put_quotes=FALSE )
							set_controls=Parameter_exchange2(set_controls, "Covariance ", k_corr_cov , put_quotes=FALSE )
						set_controls=Parameter_exchange2(set_controls, "Run K&S test ", k_run_KS_test , put_quotes=FALSE )
						set_controls=Parameter_exchange2(set_controls, "Plot figures ", k_plot_figures , put_quotes=FALSE )
						set_controls=Parameter_exchange2(set_controls, "Plot file type ", k_plot_type , put_quotes=FALSE )
							## Review output
							# cat( set_controls , sep="\n")
									
						writeLines(set_controls, con=a_controls)
			print(paste0("Creating: ",a_controls))
						
																		} else {
			stop("error in Run__Calculate_corr function, no template parameters file specified")
																				}
							  
										
				  # writes down general parameters file	, 		
				  # setwd(MetQC_path)
					# write(c( ""), file_parameters, append=FALSE)
				  write( c( paste0('a_files ',a_files),
							paste0('a_controls ',a_controls), 
						  'idcol ""',
						  's_plot_type png',
						  paste0('missval ',as.character(missval)),
						  'n_file_CodePage 852',
						  'n_transformation 0',
						  '',
						  'R_mode "RGui"'),
						file_parameters ,
						append=FALSE)
						# R_mode: run R in "RGui" or as "Rterm",  suitable for Windows
						# unlink(file_parameters)
			print(paste0("Creating: ",file_parameters))      
				  
				  
				  # runs the script		
				  setwd(MetQC_path)
				  # if (k_launch_script) source('launch_QC.r',local=TRUE)
						k_ECAD_mode__orig=k_ECAD_mode
						k_ECAD_mode=TRUE
				  if (k_launch_script) source('launch_corr.r',local=TRUE)
						k_ECAD_mode=k_ECAD_mode__orig
				 
				 
				  setwd(dir_original)	
				 
																								} # Run__Calculate_corr

###																								
																								
	
							  
			# encapsulating function for Run__Calculate_corr(): 		
				# parameter k_wait_while_file_parameters==TRUE: wait while file_parameters file exists (previous process is in run)
			run_Calc_corr_4_3 = function(ii_sel_elem, elem_list , k_wait_while_file_parameters=TRUE,file_parameters='R_input_parameters.txt' ) {
					  
					# examples of run: 
						  #run given elements, elements given by they ordinal number				
							# only one element:
							# run_Calc_corr_4_3( 8 ,elem_list)					  
			
					for (ii in ii_sel_elem )
					{
					  ele=elem_list[ii]	
					  if (is.na(ele))  next 		
					  
					  print("")
					  print(paste("Running basic loop, 4-3, for element: ", ele))
					  
					  
					  setwd(metqcpath)

						# not to confuse parallel runnings, the parameters file (the same name for everything) has to be free (not existing ...)	
						Create__file_parameters( c("run_Calc_corr_4_3 (temporary write)",ii,ele) , file_parameters, ss_print=paste("run_Calc_corr_4_3 function: file with parameters exists - ",file_parameters," - waiting with further launch of launch_QC.r") )				

					   
					Run__Calculate_corr( MetQC_path=metqcpath, 
										 file_parameters=file_parameters , 
										 a_files=paste0(workpath,'/R_input_files_4_3_0','__',ele,'.txt') ,
										data_file=paste0(datapath_out,'/QC_datafile_',ele,'_',region,'_new.csv' )  ,
										info_file=paste0(datapath_out,'/info_file_',ele,'_',region,'.csv')  ,
										corr_info=paste0(datapath_out,'/corr_',ele,'_',region,'.csv' ) ,
										corr2_info=paste0(datapath_out,'/corr2_',ele,'_',region,'.csv' )
										)
																															
					} #for 
													} # run_Calc_corr_4_3
							  
				

	
																								
###############																					
								
					  
		  
      				  
					  
			# wrapper for the launch_QC.r script,  
				# launch_QC.r script is suitable for running  7-1 function in ProClimDB,  
			# it finds neighbors according to given criterions
			Run__Find_Neighbors_corr= function ( MetQC_path=getwd() ,  
											launch_script='launch_QC.r' , 
											k_launch_script=TRUE ,
											file_parameters='R_input_parameters.txt' , 
											a_files=paste0(MetQC_path,"/Temp/R_input_files_7_1_0.txt") , 
											a_controls=paste0(MetQC_path,"/Temp/R_input_controls_7_1_0.txt") ,
											a_controls_template=paste0(MetQC_path,"/Templates/",basename(a_controls)) , 
											
											data_file="" , 
											info_file="" , 				
											corr_info="" ,
											ngbs_info=paste0(filename2(data_file) , "_ngbs_info_corr.", file_extension(data_file) ) ,
											
											missval=-999 ,
											n_number_of_stations="1,6" ,	
											limit_corr_distance="0.7;400" ,
											limit_diffs_altitude=500 ,
											k_clever_altitude_sel=1 ,
											n_period_length=0 ,
											n_period_overlap=0 ,
											k_common_period=1 ,
											col_correlation="KMEAN",
											k_the_same_region=1
											
											) {
						# MetQC_path: directory where scripts with QC to run  are located				
						# launch_script: a script to launch a processing itself
						# a_files: txt file with parameters settings for input and output files - to be used in the main QC script (launch_QC.r)
						# a_controls: txt file with parameters settings of the function - to be used in the main QC script (launch_QC.r)
							# templates are saved here: a_controls_template
							# this a new file created based on the a_controls_template, with changed parameters settings - input into this function, usually saved into Temp folder
									
						# input_data_file: input data file (not needed, can be void)
						# info_file: input info_file (list of stations, with coordinates joined from geography, period of measurement, and number of missing values)
						# corr_info: calculated correlations to be saved
						# ngbs_info: output file with list of neighbors for each of base station
						
						# missval: code for missing values (in data file)
						# n_number_of_stations: numbef of neighbors to find (you can also put minimum and maximum, separated by comma),	
							# limit_corr_distance: limit correlation and distance, separated by semicoln ,
						# limit_diffs_altitude: limit altitude difference (weight=0) ,
						# k_clever_altitude_sel: put 1 for ,
						# n_period_length: put 1 to cut the periods into segments with the given length ,
						# n_period_overlap: in case of period segments, lenght of overlap ,
						# k_common_period: put 1 for finding only neighbors with the common period
							# col_correlation: column with corrlelations
						# k_the_same_region: put 1 for finding only neighbors with the same region
						

					  dir_original=getwd()	

					  
					  
					  setwd(MetQC_path)
					  
					  # set the files, settings are put into .txt files, e.g. Temp/R_input_files_7_2_0.txt
					  write( c(paste0('edit1 = "', data_file , '"' ),
							   paste0('edit2 = "', info_file , '"' ),
							   paste0('edit3 = "', corr_info , '"' ),
							   paste0('edit5 = "', "" , '"' ), # ngbs_file: output file with neighbors info (not needed, let it be void)
							   paste0('edit6 = "', ngbs_info , '"' )
							   ),
							a_files,
							append=FALSE)
							# unlink(a_files)
			print(paste0("Creating: ",a_files))
					  
							  
							
					  # set the function parameters, settings are put into .txt files, e.g. Temp/R_input_controls_1_1_0.txt
					  if (file.exists(a_controls_template)) {
					  
						set_controls <- readLines(a_controls_template)

						# change parameters settings (taken from template)
						# set_controls=Parameter_exchange2(set_controls, param_find="Fill gaps with missvals ", set_value=as.character(k_fill_gaps) , put_quotes=FALSE , k_version2=TRUE )
						set_controls=Parameter_exchange2(set_controls, "Number of Stations ", n_number_of_stations , put_quotes=FALSE )
						set_controls=Parameter_exchange2(set_controls, "Limit - correlation (; dist.) ", limit_corr_distance , put_quotes=FALSE )
						set_controls=Parameter_exchange2(set_controls, "Maximum altitude diff. ", limit_diffs_altitude , put_quotes=FALSE )
						set_controls=Parameter_exchange2(set_controls, '"Clever" ngb. selection', k_clever_altitude_sel , put_quotes=FALSE )
						set_controls=Parameter_exchange2(set_controls, "Refer begin / Years per part ", n_period_length , put_quotes=FALSE )
						set_controls=Parameter_exchange2(set_controls, "Refer end / Overlap - years ", n_period_overlap , put_quotes=FALSE )
						set_controls=Parameter_exchange2(set_controls, "Common period ", k_common_period , put_quotes=FALSE )
						set_controls=Parameter_exchange2(set_controls, "Correlations column ", col_correlation , put_quotes=FALSE )
						set_controls=Parameter_exchange2(set_controls, "the same region ", k_the_same_region , put_quotes=FALSE )
							## Review output
							# cat( set_controls , sep="\n")
									
						writeLines(set_controls, con=a_controls)
			print(paste0("Creating: ",a_controls))
						
																		} else {
			stop("error in Run__Find_Neighbors_corr function, no template parameters file specified")
																				}
							  
										
				  # writes down general parameters file	, 		
				  # setwd(MetQC_path)
					# write(c( ""), file_parameters, append=FALSE)
				  write( c( paste0('a_files ',a_files),
							paste0('a_controls ',a_controls), 
						  'idcol ""',
						  's_plot_type png',
						  paste0('missval ',as.character(missval)),
						  'n_file_CodePage 852',
						  'n_transformation 0',
						  '',
						  'R_mode "RGui"'),
						file_parameters ,
						append=FALSE)
						# R_mode: run R in "RGui" or as "Rterm",  suitable for Windows
						# unlink(file_parameters)
			print(paste0("Creating: ",file_parameters))      
				  
				  
				  # runs the script		
				  setwd(MetQC_path)
				  if (k_launch_script) source('launch_QC.r',local=TRUE)
				 
				 
				  setwd(dir_original)	
				 
																								} # Run__Find_Neighbors_corr

			###############																					
								
###


				  
		# encapsulating function for Run__Find_Neighbors_corr():  		
			# parameter k_wait_while_file_parameters==TRUE: wait while file_parameters file exists (previous process is in run)
		run_Find_Ngbs_corr_7_1 = function(ii_sel_elem, elem_list , k_wait_while_file_parameters=TRUE,file_parameters='R_input_parameters.txt' ) {
				# examples of run: 
					  #run given elements, elements given by they ordinal number				
						# only one element:
						# run_Find_Ngbs_corr_7_1( 4 ,elem_list)
					  
									  
				for (ii in ii_sel_elem )
				{
				  ele=elem_list[ii]	
				  if (is.na(ele))  next 		
				  
				  print("")
				  print(paste("Running basic loop, 7-1, for element: ", ele))
				  
				  
				  setwd(metqcpath)
				  
				# not to confuse parallel runnings, the parameters file (the same name for everything) has to be free (not existing ...)	
				Create__file_parameters( c("run_Find_Ngbs_corr_7_1 (temporary write)",ii,ele) , file_parameters, ss_print=paste("run_Find_Ngbs_7_1 function: file with parameters exists - ",file_parameters," - waiting with further launch of launch_QC.r") )								  
				  
				#	if (k_write_log) {
			#		ss_file=paste0("log_temp_7-1_",ii,".txt")
			#		write( c("run_Find_Ngbs_corr_7_1 (temporary write)",ii,ele), ss_file , append=FALSE)			
					# unlink(ss_file)
				#					}

				  
				Run__Find_Neighbors_corr( MetQC_path=metqcpath, 
									 file_parameters=file_parameters , 
									 a_files=paste0(workpath,'/R_input_files_7_1_0','__',ele,'.txt') ,
									data_file="" , 
									info_file=paste0(datapath_out,'/info_file_',ele,'_',region,'.csv')  ,
									corr_info=paste0(datapath_out,'/corr_',ele,'_',region,'.csv')  ,
									ngbs_info=paste0(datapath_out,'/ngbs_info_corr_',ele,'_',region,'.csv' )
									)
																				
									
				} #for 
												} # run_Find_Ngbs_corr_7_1
					  
		  
###############	     
		  
		  
# wrapper for the launch_QC.r script,  
	# launch_QC.r script is suitable for running  7-4 function in ProClimDB,  
# this runs runs QC itself
Run__MetQC= function ( MetQC_path=getwd() , 
								launch_script='launch_QC.r' , 
								k_launch_script=TRUE ,
								file_parameters='R_input_parameters.txt' , 
								a_files=paste0(MetQC_path,"/Temp/R_input_files_7_4_0.txt") , 
								a_controls=paste0(MetQC_path,"/Temp/R_input_controls_7_4_0.txt") ,
								a_controls_template=paste0(MetQC_path,"/Templates/",basename(a_controls)) , 
								a_controls_input="" ,  # paste0(MetQC_path,"/Templates/",basename(a_controls)) 
								
								data_file="" , 
								info_file="" , 
								ngbs_info=paste0(filename2(data_file) , "_ngbs_info.", file_extension(data_file) ) ,
								ngbs_file=paste0(filename2(data_file) , "__qc.", file_extension(data_file) ) ,
								ngbs_stats=paste0(filename2(data_file) , "__stats.", file_extension(data_file) ) ,
								
								missval=-999 ,
								k_add_standardized_vals_cols=1 ,	
								k_transformation=0 ,
								k_AVG_standardization=0 ,
								k_STD_standardization=0 ,
								k_Standardize_to_ALTitude=1,
								k_Regr_for_indiv_cases=1,
								k_1_station_apply_monhly_AVG=1,
								n_Regression_correction=0 ,
								k_Outliers_check=1 ,
								n_Outliers_check=0.999 ,
								k_Add_IQR_coef_value=1,
								k_Add_Expected_value=1,
								n_Power_for_weights=1 ,
								k_limit_repeated=1 ,
								n_limit_repeated="5,60"
								) {
								
			# MetQC_path: directory where scripts with QC to run  are located
			# launch_script: a script to launch a processing itself
			# a_files: txt file with parameters settings for input and output files - to be used in the main QC script (launch_QC.r)
			# a_controls: txt file with parameters settings of the function - to be used in the main QC script (launch_QC.r)
				# templates are saved here: a_controls_template
				# this a new file created based on the a_controls_template, with changed parameters settings - input into this function, usually saved into Temp folder						
			# a_controls_input: txt file with parameters settings, for a particular element, can be the same as a_controls_template (saved in Template folder),  
				# if specified: it replaces individual parameters settings given in the input of this function <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
			
			# data_file: input data file 
			# info_file: input info_file (list of stations, with coordinates joined from geography, period of measurement, and number of missing values)
			# ngbs_info: input file with list of neighbors for each of base station
			# ngbs_file: output file with neighbors info and quality control (main output)
			# ngbs_stats: output file with neighbors and base station statistics
	
		# parameters settings:
			# missval: code for missing values (in data file)
			# k_add_standardized_vals_cols: 1 for adding columns with standardized values into the output,	
			# k_transformation: transformation of values 
				# if k_transformation==1: 
				# ways of tranformation, to be specified in n_transformation variable (and passed into file_parameters):  
						# n_transformation==100:  "  differences (Y-X), NO transformation"
						# n_transformation==  0:  "  ratios (Y/X), NO transformation"
						# n_transformation== -1:  "  ratios X/Y, NO transformation"
						
						# n_transformation==-10:  " Equitable ratios, NO transformation (2nd/1st or -1st/2nd, the greater value, negative for 2nd/1st,   original one (1st or -2nd) if the other is"
							
						# n_transformation==1: "  Differences - values transformed with  log(x) " 
						# n_transformation==2: "  Differences - values transformed with  sqrt(x) "
						# n_transformation==3: "  Differences - values transformed with  log(x+1) "
						# n_transformation==4: "  Differences - values transformed with  sqrt(x+1) "
						# n_transformation==5: "  Differences - values transformed with  sqrt(x)+sqrt(x+1) "
											
			# k_AVG_standardization: 1 for standardization to average
			# k_STD_standardization: 1 for standardization to standard deviation
			# k_Standardize_to_ALTitude: 1 for standardization to altitude
			# k_Regr_for_indiv_cases: 1 for performing regression for each time step individually,
			# k_1_station_apply_monhly_AVG: 1 for applying monthly AVG (+STD) in case there is only one station available (thus regression cannot be calculated), 	
				# moreover, controls values, during individual regression, if neighbors altitudes are similar, but base station altitude is very different ... then the regression does not work well - and is not performed
			# n_Regression_correction: correction by means of determination coefficient, 1 - full correction, 0 - original linear regression
			# k_Outliers_check: put 1 for checking standardized neighbors values (comparing with original values of all neighbours) if they are not outliers 
			# n_Outliers_check: CDF values for the outliers check
			# k_Add_IQR_coef_value: put 1 for adding other characteristics - CDF_b_sMed - probability (CDF) of base station compared to median from standardized (to altitude) neighbors,
			# k_Add_Expected_value: put 1 for calculating expected value,
			# n_Power_for_weights: expected values are calculated as weighting average with distances, distance is used with the specified power
 

			
		  dir_original=getwd()	
		  
		  
		  setwd(MetQC_path)
		  
		  # set the files, settings are put into .txt files, e.g. Temp/R_input_files_7_4_0.txt
		  write( c(paste0('edit1 = "', data_file , '"' ),
				   paste0('edit2 = "', info_file , '"' ),
				   paste0('edit3 = "', "" , '"' ),  # time_info, for backward compatibility with ProClimDB
				   paste0('edit4 = "', ngbs_info , '"' ),
				   paste0('edit5 = "', ngbs_file , '"' ),
				   paste0('edit6 = "', ngbs_stats , '"' )
				   ),
				a_files,
				append=FALSE)
				# unlink(a_files)
print(paste0("Creating: ",a_files))		  
	 		  
				
		 # set the function parameters, settings are put into .txt files, e.g. Temp/R_input_controls_1_1_0.txt
		 if (file.exists(a_controls_input)) {
print(paste0("Taking parameters completely from the template file: ",a_controls_input) )
				if (a_controls_input!=a_controls) {
					# file copy:
					file.copy(from=a_controls_input, to=a_controls, overwrite=TRUE)
print(paste0("Copied into: ",a_controls) )
													}
											} else {

		  
		  if (file.exists(a_controls_template)) {
		  
			set_controls <- readLines(a_controls_template)

			# change parameters settings (taken from template)
			# set_controls=Parameter_exchange2(set_controls, param_find="Fill gaps with missvals ", set_value=as.character(k_fill_gaps) , put_quotes=FALSE , k_version2=TRUE )
			set_controls=Parameter_exchange2(set_controls, "Add standardized vals cols ", k_add_standardized_vals_cols , put_quotes=FALSE )
			set_controls=Parameter_exchange2(set_controls, "Transformation of vals (precip.) ", k_transformation , put_quotes=FALSE )
			set_controls=Parameter_exchange2(set_controls, "AVG standardization ", k_AVG_standardization , put_quotes=FALSE )
			set_controls=Parameter_exchange2(set_controls, "STD standardization ", k_STD_standardization , put_quotes=FALSE )
			set_controls=Parameter_exchange2(set_controls, "Standardize to ALTitude ", k_Standardize_to_ALTitude , put_quotes=FALSE )
			set_controls=Parameter_exchange2(set_controls, "Regr. for indiv. cases ", k_Regr_for_indiv_cases , put_quotes=FALSE )
			set_controls=Parameter_exchange2(set_controls, "1 station - apply monhly AVG ", k_1_station_apply_monhly_AVG  , put_quotes=FALSE )
			set_controls=Parameter_exchange2(set_controls, "Regression correction ", n_Regression_correction , put_quotes=FALSE )
			
			set_controls=Parameter_exchange2(set_controls, "control_18: Outliers check", k_Outliers_check , put_quotes=FALSE )
			set_controls=Parameter_exchange2(set_controls, "control_19: Outliers check", n_Outliers_check , put_quotes=FALSE )
			
			set_controls=Parameter_exchange2(set_controls, "Add IQR coef. value", k_Add_IQR_coef_value , put_quotes=FALSE )
			set_controls=Parameter_exchange2(set_controls, "Add Expected value", k_Add_Expected_value , put_quotes=FALSE )
			set_controls=Parameter_exchange2(set_controls, "Power for weights", n_Power_for_weights , put_quotes=FALSE )

			set_controls=Parameter_exchange2(set_controls, "control_24: Limit for repeated", k_limit_repeated , put_quotes=FALSE )
			set_controls=Parameter_exchange2(set_controls, "control_25: Limit for repeated", n_limit_repeated , put_quotes=FALSE )
				## Review output
				# cat( set_controls , sep="\n")
			
			writeLines(set_controls, con=a_controls)
print(paste0("Creating: ",a_controls))
			
															} else {
stop("error in Run__MetQC function, no template parameters file specified")
																	}

													}  # if (file.exists(a_controls_input))
																	
				  			
			
			# for tranformation: (k_transformation==1):
			n_transformation=-10  # " Equitable ratios,"	
			
	  # writes down general parameters file	, 		
      # setwd(MetQC_path)
		# write(c( ""), file_parameters, append=FALSE)
      write( c( paste0('a_files ',a_files),
                paste0('a_controls ',a_controls), 
              'idcol ""',
              's_plot_type png',
              paste0('missval ',as.character(missval)),
              'n_file_CodePage 852',
              paste0('n_transformation ',as.character(n_transformation)),
              '',
              'R_mode "RGui"'),
            file_parameters ,
            append=FALSE)
			# R_mode: run R in "RGui" or as "Rterm",  suitable for Windows
			# unlink(file_parameters)
print(paste0("Creating: ",file_parameters))     			
	  
	  
	  # runs the script		
      setwd(MetQC_path)
      if (k_launch_script) source('launch_QC.r',local=TRUE)
     
	 
	  setwd(dir_original)	
	 
																					} # Run__MetQC

###
			 
	  # encapsulating function for Run__MetQC(): 		      
		# parameter k_wait_while_file_parameters==TRUE: wait while file_parameters file exists (previous process is in run)
      run_QC_7_4 = function(ii_sel_elem, elem_list , k_wait_while_file_parameters=TRUE,file_parameters='R_input_parameters.txt' ) {
		# examples of run: 	  
			  #run given elements, elements given by they ordinal number				
				# for one element:
				# run_QC_7_4( 1 ,elem_list)
				  
			  # run all elements	  
			  # run_QC_7_4(1:12,elem_list)
			  
				  # run_QC_7_4(1:3,elem_list)		
				  # run_QC_7_4(4:6,elem_list)		
				  # run_QC_7_4(7:9,elem_list)		
				  # run_QC_7_4(10:12,elem_list)		
              
        for (ii in ii_sel_elem )
        {
          ele=elem_list[ii]	
		  # ele="PP"
		  
          if (is.na(ele))  next 		
          
		  print("")
          print(paste("Running basic loop, 7-4, for element: ", ele))

		  
		  setwd(metqcpath)
		  
			# not to confuse parallel runnings, the parameters file (the same name for everything) has to be free (not existing ...)	
			Create__file_parameters( c("run_QC_7_4 (temporary write)",ii,ele) , file_parameters, ss_print=paste("run_QC_7_4 function: file with parameters exists - ",file_parameters," - waiting with further launch of launch_QC.r") )				
			
			# log file:
			#	if (k_write_log) {
	#			ss_file=paste0("log_temp_7-4_",ii,".txt")
	#			write( c("run_QC_7_4 (temporary write)",ii,ele), ss_file , append=FALSE)			
				# unlink(ss_file)
			#						}						
			
			
							file_parameters_settings=paste0('/R_input_controls_7_4_0','__',ele,'.txt')
       Run__MetQC( MetQC_path=metqcpath,  
							 a_files   =paste0(workpath,'/R_input_files_7_4_0','__',ele,'.txt') ,
							 a_controls=paste0(workpath,file_parameters_settings) ,
							 a_controls_input=paste0(metqcpath,"/Templates/",file_parameters_settings) ,
							data_file=paste0(datapath_out,'/QC_datafile_',ele,'_',region,'_new.csv' ) ,
						    ngbs_info=paste0(datapath_out,'/ngbs_info_',ele,'_',region,'.csv' ) ,
							ngbs_file=paste0(datapath_out,'/QC_output_',ele,'_',region,'.csv' )
							)							
							# 'edit6 = ../Data/stats_',region,'_',start,'_',stop,'__',ele,'.csv'  # for statistics
							          
        } # for (ele in ...	  
      } # run_QC_7_4 = function
   																					
																																									
																																							 
###############		

						
#runs palalel calculalations						
Run_function_parallel = function( elem_list=character() , ss_function="" , n_processes_parallel=3 , k_delete_previous_logs=TRUE ) {	
					# example to run:
					# Run_function_parallel( elem_list, "run_Find_Ngbs_7_2")
						
	  
				  #deletes master log for controlling parallel processes
				  setwd(metqcpath)	  		  
				  
				  #<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
				  if (file.exists(file_parameters)) file.remove(file_parameters)
				  #<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
				  
				  if (k_delete_previous_logs==TRUE) {
				  if (file.exists("log_multi.txt")) file.remove("log_multi.txt")
				  if (file.exists("log_parallel.txt")) file.remove("log_parallel.txt")
				  # removes log files:
				  file.remove( list.files(pattern= glob2rx("log_temp_file*.txt") ) )	  	  
													}

				  
				 
			# running parallel calculations, n_processes processes in once 
					# ppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppp
				  warn=require(doParallel)
				  if (warn==FALSE) {
					  install.packages("doParallel")
					  warn=require(doParallel)
				  }
				  
				  # <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
	n_processes=n_processes_parallel # 3
				  # <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
				  
					ii_seq_all=seq(from =1, to=length(elem_list), by=ceiling(length(elem_list)/n_processes))
				print(paste("Number of processes in one step: ",  n_processes))
				print_my("Sequences to be processed: ", ii_seq_all, "(in ",length(ii_seq_all), " steps)")	
					
				  cl=makeCluster(n_processes, outfile="log_parallel.txt")  # makeCluster(detectCores(),type="SOCK")
				  clusterExport(cl, c("k_ECAD_mode", "metqcpath", "file_parameters","workpath","datapath_in","datapath_out","region","file_geography") ) 
				  registerDoParallel(cl)
				

				# pppppppppppppppppppppppppppppp
				  # foreach(ii= seq(from =1, to=12, by=3) )%do%{
				  fe_out = foreach( ii= ii_seq_all , 
						.combine='cbind' , .inorder=TRUE , 
						.export=c(
								  "Run__Get_info_file","run_Get_Info_1_1",	
									"Run__Find_Neighbors","run_Find_Ngbs_7_2",
									 "Run__Calculate_corr","run_Calc_corr_4_3",
									 "Run__Find_Neighbors_corr","run_Find_Ngbs_corr_7_1",
									"Run__MetQC","run_QC_7_4",
								  "Parameter_exchange2","Create__file_parameters","strextract","filename2","filename","file_extension") , 
						.verbose=T) %dopar%{
				                   
				  
				  
				  
					# ii_sel_elem=ii:(ii+2)
					# ii_sel_elem=ii:(ii+ (n_processes-1) )
					ii_sel_elem=ii:(ii+ (ii_seq_all[2]-ii_seq_all[1]-1) )
				  
				  
						#mypb <- tkProgressBar(title = "R progress bar", label = "", min = 0, max = 1, initial = 0, width = 300)
						#setTkProgressBar(mypb, 1, title = "xxx", label = NULL)
		
					  # it has to wait for a while, otherwise, further iterations uses the same input files ...
					  # Sys.sleep(2) # The time interval to suspend execution for, in seconds	  
					# Sys.sleep( ii*.17 ) # wait a while, not to mix parameters files ...  
					Sys.sleep( ii*.43 ) # wait a while, not to mix parameters files ...  
					Sys.sleep( ii*1.17 ) # wait a while, not to mix parameters files ...  
					
					
						#if (k_write_log) {
					#	ss_file=paste0("log_temp_parallel_",ii,".txt")
					#	write( c("Run_function_parallel (progress write)",ii_sel_elem), ss_file , append=FALSE )
						#				  }
						# unlink(ss_file)
						
					if (ss_function=="run_Get_Info_1_1") run_Get_Info_1_1(ii_sel_elem,elem_list)
					if (ss_function=="run_Find_Ngbs_7_2") run_Find_Ngbs_7_2(ii_sel_elem,elem_list)
						if (ss_function=="run_Calc_corr_4_3") run_Calc_corr_4_3(ii_sel_elem,elem_list)
						if (ss_function=="run_Find_Ngbs_corr_7_1") run_Find_Ngbs_corr_7_1(ii_sel_elem,elem_list)
					if (ss_function=="run_QC_7_4") run_QC_7_4(ii_sel_elem,elem_list)
															
				  
						#close(mypb)
					# print(paste("Iteration (doParallel): ", ii_sel_elem))
					ii_sel_elem #to print the output print(fe_out)
					  					
				} # foreach      
				# pppppppppppppppppppppppppppppp
											
				  print(fe_out)
					  
					  
				  stopCluster(cl)
				  
					# ppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppp

										} #  Run_function_parallel=function
							 
			
###############		
							
																																									
																																									
																					
###############=======================================================================================================					
###############=======================================================================================================					
###############=======================================================================================================					
		 
		 
		 
		 
# for INDECIS:
# runs the QC		 		  		  
		  
#---------------------------------------------------------------------------------------	  

		  
	  
# cleans previous results:
				  #<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
			# if (file.exists(file_parameters)) file.remove(file_parameters)
setwd(metqcpath)
				  
				if (file.exists("log_multi.txt")) x=file.remove("log_multi.txt")
				if (file.exists("log_parallel.txt")) x=file.remove("log_parallel.txt")
				# removes log files:
				# x=file.remove( list.files(pattern= glob2rx("log_temp_file*.txt") ) )	  	  
				x=file.remove( list.files(pattern= glob2rx("log_temp_*.txt") ) )	  	  
								
				
				# remove former files:
				if (file.exists(paste0(metqcpath,"/Data/Temp/_temp_rda"))) {
					setwd(paste0(metqcpath,"/Data/Temp/_temp_rda/"))
					x=file.remove( list.files(pattern= ("*.*") ) )
					# setwd("..")
					# file.remove( "_temp_rda" )  under Windows, this does not work (directory is not a file)
																		}
																				
			if (k_ECAD_mode==TRUE) {
				setwd(paste0(metqcpath,"/Data/Temp/"))
				x=file.remove( list.files(pattern= ("*.csv") ) )
				x=file.remove( list.files(pattern= ("*.dbf") ) )
				
				#/Data folder
				setwd(paste0(metqcpath,"/Data/"))
				x=file.remove( list.files(pattern= ("*_new.*") ) )
				x=file.remove( list.files(pattern= ("*.dbf") ) )				
									}							

			  #<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
			  
		  
		  
###############		

### RUN THE QUALITY CHECK ###				
		  
		  
# list of function:
	# Run__Get_info_file, # run_Get_Info_1_1	
	# Run__Find_Neighbors, # run_Find_Ngbs_7_2
		# not needed for INDECIS:
		 # Run__Calculate_corr, # run_Calc_corr_4_3
		 # Run__Find_Neighbors_corr, # run_Find_Ngbs_corr_7_1
	# Run__MetQC, # run_QC_7_4		  
		  
###############																					
		  
		  
### CALL 1-1, Run__Get_info_file		  
# Run__Get_info_file
	if (k_run_parallel) {
		Run_function_parallel( elem_list, "run_Get_Info_1_1" , n_processes_parallel=n_processes_)
						} else {
		run_Get_Info_1_1(ii_sel_elem,elem_list)
								}
																			
###############																					
							  
### CALL 7/2		  
# Run__Find_Neighbors		
	if (k_run_parallel) {
	Run_function_parallel( elem_list, "run_Find_Ngbs_7_2", n_processes_parallel=n_processes_ , k_delete_previous_logs=FALSE)
						} else {
		run_Find_Ngbs_7_2(ii_sel_elem,elem_list)
								}

###############		
				
		# run correlations calculation, 4-3 function:		
		# Run__Calculate_corr							  
#	if (k_run_parallel) {
#			Run_function_parallel( elem_list, "run_Calc_corr_4_3" ,  n_processes_parallel=n_processes_)
#						} else {
#			run_Calc_corr_4_3(ii_sel_elem,elem_list)
#								}

###############		

		### CALL 7/1		  
		# Run__Find_Neighbors_corr
#	if (k_run_parallel) {
#			Run_function_parallel( elem_list, "run_Find_Ngbs_corr_7_1" , n_processes_parallel=n_processes_)
#						} else {
#			run_Find_Ngbs_corr_7_1(ii_sel_elem,elem_list)
#								}

###############		

### CALL QC (7 4)
# Run__MetQC,
	if (k_run_parallel) {
	Run_function_parallel( elem_list, "run_QC_7_4" , n_processes_parallel=n_processes_, k_delete_previous_logs=FALSE)
						} else {
	run_QC_7_4(ii_sel_elem,elem_list)
								}
