get_os <- function(){
sysinf <- Sys.info()
if (!is.null(sysinf)){
os <- sysinf['sysname']
if (os == 'Darwin')
os <- "osx"}else{
os <- .Platform$OS.type
if (grepl("^darwin", R.version$os))
os <- "osx"
if (grepl("linux-gnu", R.version$os))
os <- "linux"}
tolower(os)}
print_my <- function(..., sep="", k_warning=FALSE , k_add_print_=k_warning ) {
ss_pom=paste(sapply(list(...),function(x) as.character(x),simplify=TRUE,USE.NAMES=FALSE ),collapse=sep )
if (k_add_print_) print("")
print(ss_pom,quote=F)
if (k_add_print_) print("")
if (k_warning) warning(ss_pom,call.=FALSE)
return(ss_pom)}
write_error_problem=function(ss_message,file_log ){
log_con <- file(file_log, open="a")
dd_datetime=Sys.time()
cat("" , file = log_con, sep="\n")
cat(paste("Time: ", dd_datetime) , file = log_con, sep="\n")
cat(ss_pom , file = log_con, sep="\n")
cat("" , file = log_con, sep="\n")
close(log_con)}
filename=function(f){
return ( basename(sub("\\.[[:alnum:]]*$", "",  basename(f) ) ) )}
file_extension=function(f,k_leave_dot=0 ){
x=sub( sub("\\.[[:alnum:]]*$", "", basename(f) ), "", basename(f) )
x=gsub("\\*", "", x )
x=gsub("\\?", "", x )
if (k_leave_dot==2) return( gsub(".","[.]", x,fixed=TRUE) )
if (k_leave_dot==0) return( gsub(".","", x,fixed=TRUE) ) else return(x)}
filepath=function(f){
return (  gsub( basename(f) , "",  f ) )}
filename2=function(f, extension="" , k_put_dot=TRUE ) {
return (  paste(( gsub( basename(f) , "",  f ) ),"",filename(f), ifelse(nchar(extension)>0,  paste(  ifelse(k_put_dot,".","")  ,extension,sep=""),"") ,   sep="") )}
relative_filepath=function(f,f2=getwd() ){
if (length(f)>1){
ff=sapply(f,function(x) relative_filepath(x,f2) )
return(ff)}
f_=unlist(strsplit(toupper(f), split=""))
f2_=unlist(strsplit(toupper(f2), split=""))
if (f2_[length(f2_)]!="/") f2_=c(f2_,"/")
if (length(f_)>length(f2_)) f_=f_[1:length(f2_)] else f2_=f2_[1:length(f_)]
ii=which((f_==f2_)==FALSE )
if (length(ii)>=1) ii=ii[1] else if (all((f_==f2_))) ii=length(f_)+1 else ii=0
return (as.character(ifelse((ii>=1),substring(f,first=ii),f ) ) )}
adjust_filename=function(sit0, char_repl="_" , k_path_care=FALSE ) {
if (k_path_care==TRUE){
return ( paste( dirname(sit0) , "/" , adjust_filename( basename(sit0), char_repl=char_repl , k_path_care=FALSE ) , sep="") )}else{
sit0_=gsub("[/\\:*?<>|%$#@!^&()+-]",char_repl,sit0)
sit0_=gsub("[][]",char_repl,sit0_)
sit0_=gsub("[}{]",char_repl,sit0_)
if (.Platform$OS.type=="windows") {
if (file.exists("rprog/fce_rprog_cz.r")) source("rprog/fce_rprog_cz.r")
if (file.exists("fce_rprog_cz.r")) source("fce_rprog_cz.r")
sit0_=adjust_filename_cz(sit0_,char_repl=char_repl,k_path_care=k_path_care)}}
return (sit0_ )}
nice_file_create <- function(filename){
directory_name <- dirname(filename)
if(!file.exists(directory_name))
{
ok <- dir.create(directory_name)
if(!ok)
{
warning("The directory of that path could not be created.")
return(invisible())}}
tryCatch(
file.create(filename),
error=function(e)
{
warning("The file could not be created.")}
)}
is.empty <- function(x,mode=NULL){
if (is.null(mode)) mode <- class(x)
identical(vector(mode,1),c(x,vector(class(x),1)))}
find_value_in_data=function (x,val_to_find=-999 ){
ii_c=grep( "integer",  lapply(x, class) )
if (length(ii_c)>0){
if (is.data.table(x)) x=x[,ii_c,with=FALSE] else x=x[,ii_c]
if (any(val_to_find==val_to_find)) return(TRUE)}
ii_c=grep( "integer",  lapply(x, class) )
if (length(ii_c)>0){
if (is.data.table(x)) x=x[,ii_c,with=FALSE] else x=x[,ii_c]
if (any(val_to_find==val_to_find)) return(TRUE)}
return(FALSE)}
colnames_exclude_missval=function(ss_group,data=NA,missval=-999.9 ){
data=as.data.frame(data)
ss_group_out=sapply(data[,ss_group],function(x) all(x==missval | x==-999 | x==-9999 | is.na(x) | is.null(x) ))
ss_group_nomv=ss_group[!(ss_group_out ) ]
return(ss_group_nomv)}
data_frame_remove_NA_cols=function(xz=NA,k_output=TRUE){
ss_pom=names(xz)
if (is.data.table(xz)){
xz=xz[,(apply(!(is.na(xz)),2,sum))!=0,with=FALSE]}else{
xz=xz[,(apply(!(is.na(xz)),2,sum))!=0 ]}
if ((length(ss_pom)!=length(names(xz)))&(k_output==TRUE)){
print_my("Columns with NA values were removed: ",ss_pom[!(ss_pom %in% names(xz))])}
return(xz)}
data_table_remove_NA_col=function(data_out=NA, column="x_Suffix", k_output=TRUE) {
if (column %in% names(data_out)){
if (all(is.na(data_out[,c(column)]))) ii_pom=0 else ii_pom=data_out[,sum(nchar(x_Suffix)!=0) ]
if (ii_pom==0){
if (k_output){
print("")
print_my("  ",column," column: it was whole empty, so it was removed")}
data_out[,c(column):=NULL ]}}
return(data_out)}
get_rows_without_NA_data=function(xz=NA,ss_cols=NA ){
xz=as.data.frame(xz)
xz=xz[ (apply(!(is.na(xz[,ss_cols])),1,sum))>0,]
return(xz)}
data_remove_X_columns=function(data=NA){
ii_d=match("X.",names(data))
if (!all(is.na(ii_d))) data=data[,-(ii_d:length(names(data)) )]
ii_d=match("X_NullFlags",names(data))
if (!all(is.na(ii_d))) data=data[,-(ii_d:length(names(data)) )]
return(data)}
Col_names_for_R=function(data){
ss_names=names(data)
k_pom=grepl("_", substr(ss_names,1,1))
if (is.data.table(data)){
setnames(data, names(data)[k_pom] , paste("x",ss_names[k_pom], sep="") )}else{
names(data)[k_pom]=paste("x",ss_names[k_pom], sep="")}}
Change_Column_order=function(DT,col_names,order,k_last=FALSE){
if (!is.data.table(DT)) DT=data.table(DT)
if (any(grepl('[*?]', col_names ))) {
col_names=names(DT)[ grep(glob2rx(basename(col_names)),names(DT) ) ]}
n_col=ncol(DT)
if (n_col==0) return(DT)
if (is.empty(order)) return(DT)
col_names=col_names[ toupper(col_names) %in% toupper(names(DT)) ]
if (typeof(order)!="character") {
if (order>n_col){k_last=TRUE ; order=n_col}}else{
order=which(order==names(DT))}
if (length(order)==0){
print(paste("Change_Column_order() function: order ",order," is wrong parameter"))
return(DT)}
ii_order=match(toupper(c(col_names)),toupper(names(DT)) )
ii_order=unique(ii_order[!is.na(ii_order)] )
if ((order-1)< 1) ii_rest1=NA else ii_rest1=setdiff(1:(order-1),ii_order)
if (order<=n_col) ii_rest2=setdiff((order):(ncol(DT)),ii_order) else ii_rest2=NA
if (k_last){
ii_order=c(ii_rest1,ii_rest2,ii_order)}else{
ii_order=c(ii_rest1,ii_order,ii_rest2 )}
ii_order=ii_order[!is.na(ii_order)]
return(DT[,ii_order,with=FALSE] )}
merge_my = function(data_out_all, data_out, ss_by=names(data_out), ss_suffixes = c("",".y"), ss_all=TRUE, k_check_unique=TRUE, k_only_last_row_B=FALSE, k_output=TRUE) {
if (all(is.na(data_out_all))) return(data_out_all)
if (all(is.na(data_out))) return(data_out_all)
if (length(ss_by)==1) if (ss_by=="all") ss_by=names(data_out)
ss_by=ss_by[ (ss_by %in% names(data_out_all)) ]
ss_by=ss_by[ (ss_by %in% names(data_out)) ]
ss_by = ss_by[ !(grepl("VAL",ss_by, ignore.case=TRUE)) ]
if (length(ss_by)==0){
print_my(ss_by)
print_my("merge_my: no 'by' parameter specified ", k_warning=TRUE)
return(data_out_all[ 0,])}
if (k_only_last_row_B==TRUE){
data_out=as.data.table(data_out)
if (nrow(data_out[,ss_by,with=FALSE])!=nrow(unique(data_out[,ss_by,with=FALSE]))){
if (k_output==T) print_my("merge_my: getting only last rows of file B (according to the given key): ",ss_by)
data_out[,row_:=1:nrow(data_out) ]
data_out[,group_end_row :=max(row_,na.rm=TRUE),by=ss_by ]
group_end_row=unique(data_out$group_end_row)
data_out[ , c("row_","group_end_row") := NULL ]
if (k_output==T) print_my("  ... got ",length(group_end_row)," rows (out of ",nrow(data_out),")")
data_out=data_out[group_end_row,]}}
if (ss_all==TRUE){
data_out_all=merge(data_out_all,unique(data_out),by=ss_by,suffixes=ss_suffixes,all=ss_all )}else{
data_out_all=merge(data_out_all,unique(data_out),by=ss_by,suffixes=ss_suffixes,all=FALSE,all.x=TRUE,all.y=FALSE )}
if (k_check_unique==TRUE){
if (is.data.table(data_out_all)){
k_pom=(length(data_out_all[,ss_by,with=FALSE])!=length(unique(data_out_all[,ss_by,with=FALSE])))}else{
k_pom=(length(data_out_all[,ss_by])!=length(unique(data_out_all[,ss_by])))}
if (k_pom){
print_my( "Problem in merge_my function, ", ss_by, " column does not have unique data ... returning NA", sep="", k_warning=TRUE )
return(data_out_all[ 0,])}}
ss_suff=ss_suffixes[2]
if (nchar(ss_suff)==0) ss_suff=ss_suffixes[1]
ss_names=names(data_out_all)
ss_pom=paste("*",ss_suff,sep="")
ii_pom=which(grepl(ss_pom,ss_names) )
ii_remove=NA
for (ii in ii_pom){
ss_pom2=paste("\\",ss_suff,"$",sep="")
ii2=which(grepl(gsub(ss_pom2,"",ss_names[ii]),ss_names))
ii2=ii2[1]
if (ii2>0){
if (is.data.table(data_out_all)){
k_pom=all(is.na(data_out_all[,ii,with=FALSE]))}else{
k_pom=all(is.na(data_out_all[,ii]))}
if (k_pom){
ii_remove=c(ii_remove,ii )}else{
if (is.data.table(data_out_all)){
k_pom=(data_out_all[,ii,with=FALSE]==data_out_all[,ii2,with=FALSE])}else{
k_pom=(data_out_all[,ii]==data_out_all[,ii2])}
k_pom[is.na(k_pom)]=FALSE
if (all(k_pom)) ii_remove=c(ii_remove,ii )}}}
ii_remove=ii_remove[!is.na(ii_remove)]
if (length(ii_remove)>0){
if (k_output==T) {print( paste( "Columns to be removed (merge_my): " ,  paste(ss_names[ii_remove],collapse=",") ) ) ; print("") }
if (is.data.table(data_out_all)){
data_out_all=data_out_all[,c(ii_remove):=NULL ]}else{
data_out_all=data_out_all[,-c(ii_remove)]}}
return(data_out_all)}
cbind_repeate_with_rows=function(data_to_join,ss_cases){
if (!is.data.table(data_to_join)) data_to_join=as.data.table(data_to_join)
if (!is.data.table(ss_cases)) ss_cases=as.data.table(ss_cases)
data_out=cbind(data_to_join[1,],ss_cases)
for (ii in (2:(dim(data_to_join)[1] )) ){
l=list(data_out,cbind(data_to_join[ii,],ss_cases) )
data_out=rbindlist(l,fill=TRUE)}
if (exists("l")) rm(l)
return(data_out)}
get_into_one_column=function(DT1){
names_measure=NA
ii_d_v=grep("VAL", substr(names(DT1),1,nchar("VAL")) , ignore.case=TRUE)
names_measure=names(DT1)[ii_d_v]
day_stM=""
if ( ("MONTH" %in% names(DT1)) & ( length(names_measure)>=28 ) )  {
if (!("DAY" %in% names(data_DT))) day_stM="dd"}
mes_stM=""
if (!("MONTH" %in% names(data_DT))) {
if ((length(names_measure)>=12 ) & (length(names_measure)<20 ) ){
if ("DAY" %in% names(DT1)) {
mes_stM="mm"}else{
mes_stM="mm"
if ( !("DAY" %in% names(DT1)) & !("MONTH" %in% names(DT1)) )
print_my("Monthly mode detected in data, months are in columns ...",k_add_print_=TRUE)}}}
if ( (day_stM=="dd")|(mes_stM=="mm") ) {
if (day_stM=="dd") name_COLUMN="DAY"
if (mes_stM=="mm") name_COLUMN="MONTH"
data_DT_1col=melt(DT1,  measure.vars=names_measure, variable.name=name_COLUMN, value.name="VALUE2")
print_my("")
print_my("convert_into_one_column: 1col created")
ii_d_v=!(names(data_DT_1col) %in% c("YEAR","MONTH","DAY","TIME","VALUE2"))
ss_group=names(data_DT_1col)[ii_d_v]
setkeyv(data_DT_1col,c(ss_group))
data_DT_1col_COLUMN=as.vector(unique(data_DT_1col[[name_COLUMN]] ) )
data_DT_1col_COLUMN2=gsub("[a-z]","",data_DT_1col_COLUMN,ignore.case=TRUE)
data_DT_1col_COLUMN2=gsub("[_]","",data_DT_1col_COLUMN2,ignore.case=TRUE)
data_DT_1col_COLUMN2=data_DT_1col_COLUMN2[!nchar(data_DT_1col_COLUMN2)==0]
if ((!(all(is.na(data_DT_1col_COLUMN)))) & (length(data_DT_1col_COLUMN)==length(data_DT_1col_COLUMN2)) ){
data_DT_1col=data_DT_1col[, col:=as.numeric( gsub("[a-z]","",data_DT_1col[[name_COLUMN]],ignore.case=TRUE) ) ]
if (day_stM=="dd") data_DT_1col[, DAY:=col]
if (mes_stM=="mm") data_DT_1col[, MONTH:=col]
data_DT_1col[, c("col"):=NULL]}
DT1=data_DT_1col}
return(DT1)}
Create_cross_table=function(data_DT_1col,cols_to_distribute="MONTH",col_value="VALUE2",names_out="N", print_output=FALSE , k_order=FALSE , col_remove=NA) {
if (print_output==TRUE) print(paste("Creating cross table - for ",cols_to_distribute," ..."))
if (!all(is.na(col_remove))){
for (ss_pom in col_remove){
if (ss_pom %in% names(data_DT_1col)){
if (is.data.table(data_DT_1col)) data_DT_1col[,c(ss_pom):=NULL ]}}}
ss_names_group=names(data_DT_1col)
ss_names_group=ss_names_group[(ss_names_group!=cols_to_distribute)&(ss_names_group!=col_value)]
ss_formula=paste( paste( ss_names_group, collapse="+" ) ,"~",cols_to_distribute)
data_out_ct=dcast.data.table(data_DT_1col,as.formula(ss_formula ),fun.aggregate=NULL,value.var=col_value )
for (ii_pom in ((length(ss_names_group)+1) ):length(names(data_out_ct)) ){
if (substr(names(data_out_ct)[ii_pom],1,1)!=names_out)
setnames(data_out_ct,  names(data_out_ct)[ii_pom] ,  paste(names_out, gsub(" ","0",format( names(data_out_ct)[ii_pom], justify="right" ,width=2) ) , sep="") )}
if (k_order==TRUE){
data_out_ct = Change_Column_order(data_out_ct, c("ID"),1 )
data_out_ct = Change_Column_order(data_out_ct, c("YEAR","MONTH","DAY","TIME"), ((length(ss_names_group)+1)-1) )
ss_names_group=names(data_out_ct)[1: ((length(ss_names_group)+1)-1) ]
ss_names_group=ss_names_group[!is.na(ss_names_group)]
setkeyv(data_out_ct,ss_names_group )}
if (print_output==TRUE) print(paste(" ... done "))
return(data_out_ct)}
re_structure_DT = function(data_DT, ss_group="ID", cols_to_melt, col_melted_="Col_melted", cols_to_distribute="MONTH", col_value="VALUE2"  , names_out="N", print_output=TRUE ) {
if (dim(data_DT)[1]==0) return(data_DT)
if (col_melted_ %in% names(data_DT)){
print(paste("Column ",col_melted_," already exists, it will be renamed to 'Col_melted' "))
col_melted_="Col_melted"}
ss_group=unique(ss_group)
data_DT_1col=melt(data_DT,id.vars=ss_group,measure.vars=cols_to_melt,variable.name=col_melted_,value.name=col_value)
if (print_output==TRUE) print("1col created")
setkeyv(data_DT_1col,c(ss_group))
data_DT_1col_COLUMN=as.vector(unique(data_DT_1col[[col_melted_]] ) )
data_DT_1col_COLUMN2=gsub("[a-z]","",data_DT_1col_COLUMN,ignore.case=TRUE)
data_DT_1col_COLUMN2=gsub("[_]","",data_DT_1col_COLUMN2,ignore.case=TRUE)
data_DT_1col_COLUMN2=data_DT_1col_COLUMN2[!nchar(data_DT_1col_COLUMN2)==0]
col_melted__puv=col_melted_
if ( (!is.empty(data_DT_1col_COLUMN2)) &(col_melted_!="ID") ) {
if (max(as.numeric(data_DT_1col_COLUMN2)) %in% c(30,31)) if (length(data_DT_1col_COLUMN2)>=30) if (!("DAY" %in% names(data_DT_1col))) col_melted_="DAY"
if (max(as.numeric(data_DT_1col_COLUMN2)) %in% c(12,13)) if (length(data_DT_1col_COLUMN2)>=12) if (!("MONTH" %in% names(data_DT_1col))) col_melted_="MONTH"
if (max(as.numeric(data_DT_1col_COLUMN2)) %in% c(24)) if (length(data_DT_1col_COLUMN2)>=24) if (!("TIME" %in% names(data_DT_1col))) col_melted_="TIME"}
if (col_melted__puv!=col_melted_){
if ((!(all(is.na(data_DT_1col_COLUMN)))) & (length(data_DT_1col_COLUMN)==length(data_DT_1col_COLUMN2)) ){
data_DT_1col=data_DT_1col[,col:=as.numeric(data_DT_1col_COLUMN2 ) ]
if (print_output==TRUE) print(paste("  Name of the melted column: ",col_melted_))
data_DT_1col[,c(col_melted_):=col]
data_DT_1col[, c("col"):=NULL]
if (col_melted_!=col_melted__puv) data_DT_1col[,c(col_melted__puv):=NULL]}}
if (cols_to_distribute==col_melted_){
ss_pom=paste("re_structure_DT() function: column to distribute is the same as melted column: ",col_melted_,", in input variable: ", deparse(substitute(data_DT)))
print(ss_pom)
warning(ss_pom)
return(data_DT)}
data_out_ct=Create_cross_table(data_DT_1col,cols_to_distribute,col_value,names_out,print_output=print_output,k_order=TRUE )
return(data_out_ct)}
standardize=function (X,na_rm=TRUE,missval=-999){
if (is.data.table(X)) X=as.numeric(unlist(X))
sd_=sd(X,na.rm=na_rm)
if (is.na(sd_)) hodn=rep(missval,length(X)) else if (sd_==0) hodn=rep(missval,length(X)) else hodn=(X-mean(X,na.rm=na_rm))/(sd_)
return(hodn)}
standardize_to_limits=function (X,r_min=0,r_max=1,na_rm=TRUE){
min_=min(X,na.rm=na_rm)
X=X-min_
max_=max(X,na.rm=na_rm)
X=(r_max-r_min) *(X/max_) + r_min
return(X)}
get_horizontal_line_value_transform=function (n_transformation=100){
retult=0
if (n_transformation %in% c(0,-1) ) result=1
return(result)}
print_transformation=function(n_transformation=100){
ss_pom=""
if (n_transformation==100)  ss_pom=" Using differences (Y-X), NO transformation"
if (n_transformation==  0)  ss_pom=" Using ratios (Y/X), NO transformation"
if (n_transformation== -1)  ss_pom=" Using ratios X/Y, NO transformation"
if (n_transformation==-10) ss_pom=" Equitable ratios, (Y/X or -Y/X, the greater value, negative for Y/X,   original one (X or -Y) if the other is zero)"
if  (n_transformation==1) ss_pom=" Using Differences - values transformed with  log(x) "
if  (n_transformation==2) ss_pom=" Using Differences - values transformed with  sqrt(x) "
if  (n_transformation==3) ss_pom=" Using Differences - values transformed with  log(x+1) "
if  (n_transformation==4) ss_pom=" Using Differences - values transformed with  sqrt(x+1) "
if  (n_transformation==5) ss_pom=" Using Differences - values transformed with  sqrt(x)+sqrt(x+1) "
return(paste(ss_pom,", code: ",n_transformation,sep=""))}
transform_data=function (Y,X,n_transformation=100,print_output=TRUE ){
X=as.data.table(X)
Y=as.data.table(Y)
if (ncol(X)!=ncol(Y)) return(NA)
if (nrow(X)!=nrow(Y)) return(NA)
if (n_transformation==100) hodn=(Y-X)
if (n_transformation==0){hodn=(Y/X) ; kk=(X[[1]]==0) ; hodn[kk]=NA}
if (n_transformation==-1){hodn=(X/Y) ; kk=(Y[[1]]==0) ; hodn[kk]=NA}
if (n_transformation==-10){
kk=(Y[[1]]<(-1)) ; Y[kk]=-1/(Y[kk])
kk=(X[[1]]<(-1)) ; X[kk]=-1/(X[kk])
hodn=Y/X ; kk=Y[[1]]>=X[[1]] ; kk=!kk ; hodn[kk]=-X[kk]/Y[kk]
kk=(X[[1]]==Y[[1]] ) ; hodn[kk]=0
kk=(((X[[1]]==0) | (Y[[1]]==0) ) & Y[[1]]>=X[[1]] ) ; hodn[kk]=Y[kk]
kk=(((X[[1]]==0) | (Y[[1]]==0) ) & (!(Y[[1]]>=X[[1]])) ) ; hodn[kk]=-X[kk]
kk=(is.na(X[[1]]) | is.na(Y[[1]]) ) ; hodn[kk]=NA}
if (n_transformation==1){hodn=(log(Y)- log(X)) ; kk=((X[[1]]>0) & (Y[[1]]>0) ) ; hodn[!kk]=NA}
if (n_transformation==2){hodn=(sqrt(Y) - sqrt(X)) ; kk=((X[[1]]>=0) & (Y[[1]]>=0) ) ; hodn[!kk]=NA}
if (n_transformation==3){hodn=(log(Y+1) - log(X+1)) ; kk=((X[[1]]+1>0) & (Y[[1]]+1>0) ) ; hodn[!kk]=NA}
if (n_transformation==4){hodn=(sqrt(Y+1)- sqrt(X+1)) ; kk=((X[[1]]+1>=0) & (Y[[1]]+1>=0) ) ; hodn[!kk]=NA}
if (n_transformation==5){hodn=((sqrt(Y)+sqrt(Y+1) ) - (sqrt(X)+sqrt(X+1) )) ; kk=((X[[1]]>=0) & (Y[[1]]>=0) ) ; hodn[!kk]=NA}
return(hodn)}
transform_data_1=function (Y,n_transformation=100,print_output=TRUE ){
Y=as.data.table(Y)
if (n_transformation==100) hodn=(Y)
if (n_transformation==0){hodn=(Y)}
if (n_transformation==-1){hodn=(Y)}
if (n_transformation==-10){
hodn=(Y)}
if (n_transformation==1){hodn=log(Y); kk=((X[[1]]>0) ) ; hodn[!kk]=NA}
if (n_transformation==2){hodn=sqrt(Y) ; kk=((X[[1]]>=0) ) ; hodn[!kk]=NA}
if (n_transformation==3){hodn=log(Y+1) ; kk=((X[[1]]+1>0) ) ; hodn[!kk]=NA}
if (n_transformation==4){hodn=sqrt(Y+1) ; kk=((X[[1]]+1>=0) ) ; hodn[!kk]=NA}
if (n_transformation==5){hodn=(sqrt(Y)+sqrt(Y+1) ) ; kk=((X[[1]]>=0) ) ; hodn[!kk]=NA}
return(hodn)}
Give_time_in_m_s=function(td){
time_in_s=as.numeric(td, units = "secs")
if (time_in_s<60*60) return( paste( gsub(" ","0",format( floor(time_in_s/60) ,width=2)), 'm ', gsub(" ","0",format( time_in_s-60*floor(time_in_s/60) ,width=2, digits=1)), 's', sep="") )
if (time_in_s>24*60*60) { ss_pomt=floor(time_in_s/(24*60*60)); time_in_s=time_in_s-(ss_pomt*24*60*60); ss_pomt=paste(ss_pomt,' days ', sep="") } else { ss_pomt=""}
ii_pom=time_in_s-(60*60)*floor(time_in_s/(60*60))
return( paste( ss_pomt, gsub(" ","0",format( floor(time_in_s/(60*60)) ,width=2)), 'h ', gsub(" ","0",format( floor(ii_pom/60) ,width=2)), 'm ' , sep="") )}
filename_with_Temp = function( filename_plot ,k_save_Auxl_into_Temp=TRUE, ss_add_path="" , dir_add="Temp", k_check_double_Temp=TRUE ) {
dir_add=paste(dir_add,ss_add_path,sep="")
if (k_save_Auxl_into_Temp==TRUE){
filename_plot=paste(dirname(filename_plot), dir_add, basename(filename_plot), sep="/")}else{}
if (!file.exists(dirname(filename_plot))) dir.create(dirname(filename_plot),recursive=TRUE )
return(filename_plot )}
stop_waiting_for_file=function( n_pred="00" , file_txt="o_wait_till_time.txt" ) {
k_out=FALSE
if (file.exists(file_txt)){
ss_time=read.table(file_txt, nrows=1, col.names=c('time'), colClasses=c('character') )
if ((nchar(ss_time$time)>=3)&(grepl(":",ss_time$time))) {
ss_time_=strptime( paste(format(Sys.time(), "%Y-%m-%d")," ",ss_time,sep=""), "%Y-%m-%d %H:%M")
ss_time_=ss_time_ + as.numeric(n_pred)*60*60
if  ( difftime(Sys.time(),ss_time_,units="secs")  > 0 )
k_out=TRUE}}
return(k_out)}
alltrim <- function(ss_prvek_puv,jak=0){
if ((jak==0)||(jak==2)){
while ( substr(ss_prvek_puv, nchar(ss_prvek_puv) , nchar(ss_prvek_puv) )==" " ) ss_prvek_puv=gsub(pattern = "[ ]$", replacement = "", ss_prvek_puv)}
if ((jak==0)||(jak==1)){
while ( substr(ss_prvek_puv, 1 , 1)==" " ) ss_prvek_puv=gsub(pattern = "^[ ]", replacement = "", ss_prvek_puv)}
return(ss_prvek_puv)}
is.wholenumber <- function(x,tol=.Machine$double.eps^0.5) abs(x - round(x)) < tol
num_dec <- function(xx){
xxs=as.character(xx )
x2=strsplit(xxs, split="")
xxsd=as.numeric(lapply(x2, length))-as.numeric(lapply(x2, grep, pattern="\\."))
return(ifelse(all(is.na(xxsd)),0,max(xxsd,na.rm=TRUE)) )}
String_Remove_numbers=function(ss_strings){
ss_strings = gsub("[0-9]","",ss_strings)}
string_get_diff_from_begin=function(text1="", text2="" ,  k_try_diff=FALSE, ss_try_diff="" , k_difference=FALSE) {
ss1=unlist(strsplit(text1,""))
ss2=unlist(strsplit(text2,""))
if (length(ss1)>length(ss2)) ss1=ss1[1:length(ss2)]
if (length(ss2)>length(ss1)) ss2=ss2[1:length(ss1)]
k_pom=(ss1==ss2)
k_pom=c(k_pom,"FALSE")
ii_pom=which(k_pom==FALSE)[1]
if (k_difference==FALSE){
ss1=substr(text1,ii_pom,nchar(file_stat2) )
ss2=substr(text2,ii_pom,nchar(file_stat2_orig) )}else{}
if ((k_try_diff)&(nchar(ss_try_diff)>0)){
ss1x=string_get_diff_from_begin(text1=ss1,text2=ss_try_diff )
ss2x=string_get_diff_from_begin(text1=ss2,text2=ss_try_diff )
ss1=string_get_diff_from_begin(ss1x,ss2x)
ss2=""}
if (length(ss1)<length(ss2)) ss1=ss2
return(ss1)}
string_same_letters <- function(ss_strings,ss_leave_chars=NA,k_leading__away=T,n_start_char=1,n_delete_chars=0){
ss_pom=string_remove_same_letters(ss_strings,ss_leave_chars=ss_leave_chars,k_leading__away=k_leading__away,n_start_char=n_start_char,n_delete_chars=n_delete_chars)
return( gsub(ss_pom[1],"",ss_strings[1]) )}
string_remove_same_letters <- function(ss_strings,ss_leave_chars=NA,k_leading__away=T,n_start_char=1,n_delete_chars=0 ){
ss_strings_puv=ss_strings
if (length(ss_strings)==1) return(ss_strings)
if (length(ss_strings)>0) ss_strings = gsub("_*$","",ss_strings)
ss_strings=ss_strings_puv
ii_stejne=NA
ii_stejne2=NA
n_len_chars=min(nchar(ss_strings))
if (n_delete_chars>0) n_len_chars=n_delete_chars+n_start_char-1
for (ii_pom in n_start_char:n_len_chars ){
if (length(unique(substr(ss_strings,ii_pom,ii_pom)))==1){
if (length(ss_leave_chars[!is.na(ss_leave_chars)])==0){ii_stejne=c(ii_stejne,ii_pom)}else{
if (!(substr(ss_strings[1],ii_pom,ii_pom) %in% ss_leave_chars )){ii_stejne=c(ii_stejne,ii_pom)}}}}
n_len_chars=min(nchar(ss_strings))
for (ii_pom in n_start_char:n_len_chars ){
ii_zac=nchar(ss_strings)-ii_pom+1
ii_kon=nchar(ss_strings)-ii_pom+1
if (length(unique(substr(ss_strings,ii_zac,ii_kon) ))==1){
if (length(ss_leave_chars[!is.na(ss_leave_chars)])==0){ii_stejne2=c(ii_stejne2,ii_pom)}else{
if (!(substr(ss_strings[1],ii_zac,ii_kon) %in% ss_leave_chars )){ii_stejne2=c(ii_stejne2,ii_pom)}}}}
ii_stejne=ii_stejne[!is.na(ii_stejne)]
ii_stejne2=ii_stejne2[!is.na(ii_stejne2)]
for (ii_pom in seq_along(ss_strings)){
ss_pom=unlist(strsplit(ss_strings[ii_pom],""))
ss_pom[ii_stejne]=NA
ss_pom[length(ss_pom)-ii_stejne2+1]=NA
if (k_leading__away==T){
ii_zac=1
while ( is.na(ss_pom[ii_zac]) | ss_pom[ii_zac]=="_" ) {
ss_pom[ii_zac]=NA
ii_zac=ii_zac+1}}
ss_pom = paste( ss_pom[!is.na(ss_pom)] ,collapse="")
ss_strings[ii_pom]=ss_pom}
return(ss_strings )}
strextract=function(ss_pom, ss_beg="", ss_end="" , k_last=TRUE, n_occur=1) {
ss_pom=as.character(ss_pom)
ii_found_beg=1
ii_found_end=nchar(ss_pom)
k_pom=(ss_beg==ss_end)&(nchar(ss_end)!=0)&(nchar(ss_beg)!=0)
if (nchar(ss_end)!=0){
ii_found_end=gregexpr(ss_end,ss_pom,fixed=T)
ii_found_end=unlist(ii_found_end)
ii_found_end=ii_found_end-1}
if (nchar(ss_beg)!=0){
ii_found_beg=gregexpr(ss_beg,ss_pom,fixed=T)
ii_found_beg=unlist(ii_found_beg)
k_pom2=grepl(ss_beg,ss_pom,fixed=T)
k_pom2=which(k_pom2==TRUE)
if (is.null(ii_found_beg)){ii_found_beg=0}else{
ii_found_beg=ii_found_beg+nchar(ss_beg)}}
if (k_pom==TRUE){
ii_found_beg=gregexpr(ss_beg,ss_pom,fixed=T)
ii_found_beg=unlist(ii_found_beg)
if ((n_occur>1)&(n_occur+1<=length(ii_found_beg))){}else{
ii_found_end=ii_found_beg[n_occur+1]-1
ii_found_beg=ii_found_beg[n_occur]+1}}
if (k_last==FALSE){
ii_found_beg=ii_found_beg[1]
ii_found_end=ii_found_end[1]}else{
ii_found_beg=ii_found_beg[length(ii_found_beg)]
ii_found_end=ii_found_end[length(ii_found_end)]}
ss_pom=substring(ss_pom,ii_found_beg,ii_found_end )
return(ss_pom )}
strextract2=function(ss_pom,ss_beg,ss_end,ss_end2){
ss_pom=as.character(ss_pom)
ss_pom1=substr(ss_pom,regexpr(ss_beg,ss_pom,fixed=T)[1],regexpr(ss_end,ss_pom,fixed=T)[1]-1 )
ss_pom2=substr(ss_pom,regexpr(ss_end,ss_pom,fixed=T)[1],nchar(ss_pom) )
ss_pom2=substr(ss_pom2,1,regexpr(ss_end2,ss_pom2,fixed=T)[1]-1 )
return( paste(ss_pom1,ss_pom2,sep="") )}
replace_character_number=function (x="") {
x_repl=x
for (ii_pom in 1:length(unique(x)) ){
print(paste('replacing ', unique(x)[ii_pom], ' with ' , ii_pom))
x_repl[ grep(unique(x)[ii_pom],x ) ]=ii_pom}
print(" ... done, chars replaced with numbers")
return(x_repl)}
String_get_last <- function (ss_pom, sep="_") {
return(lapply(strsplit(ss_pom,sep),function(x) x[length(x)] ) )}
my_diff=function (x,my_lag=1,start_NA=TRUE,k_ratios=FALSE,n_transformation=NA ){
if (class(x)[1]=="character") x=as.numeric(replace_character_number(x))
if (is.data.table(x)) x=as.numeric(unlist(x))
if (!is.numeric(x)) x=as.numeric(x)
if (!is.na(n_transformation)){
k_ratios=TRUE}else{
if (k_ratios==TRUE) n_transformation=0}
if (k_ratios==TRUE){
xx=transform_data(x,c(rep(NA,my_lag),head(x,-(my_lag) ) ),n_transformation=n_transformation,print_output=TRUE )
xx=(tail(xx[[1]],-(my_lag)) )}else{
xx=as.numeric(diff(x,lag=my_lag))}
if (start_NA) return(c(rep(NA,my_lag),xx ) ) else return(c(xx,rep(NA,my_lag) ) )}
my_diff_zmena=function (x,my_lag=1,val_0=0,val_last=NA ){
if (class(x)[1]=="character") x=as.numeric(replace_character_number(x))
x1=c(rep(val_0,my_lag),x,rep(val_0,my_lag) )
x1[is.na(x1)]=val_0
x1=diff(x1,lag=my_lag)
x1=x1[(my_lag):(length(x1))]
if (!is.na(val_last)){
if (x1[length(x1)-my_lag+1]==-1){
if (x1[length(x1)-my_lag]==val_0) x1[length(x1)-my_lag]=-1 else if (x1[length(x1)-my_lag]>=1) x1[length(x1)-my_lag]=val_0}}
x1=x1[1:(length(x1)-my_lag)]
return(x1 )}
my_diff_year=function (x,lag=1){
x=as.data.frame(x)
x=x[ order(x[,1]),]
xx=diff(x[,1],lag=1)
if (sum(xx>=2)>=1){
print("my_diff_year: gaps in data ..."); return(NA)}
if (sum(xx<1)>=1){
print("my_diff_year: inconsistent data! the same years occur"); return(NA)}
return(c(rep(NA,lag),diff(x,lag=lag)) )}
dtor=function(deg){
return(deg*(pi/180))}
rtod=function(deg){
return(deg*(180/pi))}
Get_dist_azim_xy_coordinates=function (x=0,y=0,co=1){
missval=-999
x[x==missval]=NA ; y[y==missval]=NA
if (co==1) return(sqrt(x^2+y^2) )
if (co==2){
fi_pom=rep(NA,length(x))
fi_pom[(x==0)&(y==0)]=0
ss_pom=(x>0 & !is.na(x) & !is.na(y) ) ; fi_pom[ss_pom]=atan(y[ss_pom]/x[ss_pom])
ss_pom=((x<0)&(y>0) & !is.na(x) & !is.na(y) ) ; fi_pom[ss_pom]=atan(y[ss_pom]/x[ss_pom]) + pi
ss_pom=((x<0)&(y<0) & !is.na(x) & !is.na(y) ) ; fi_pom[ss_pom]=atan(y[ss_pom]/x[ss_pom]) - pi
ss_pom=((x==0)&(y>0) & !is.na(x) & !is.na(y) ) ; fi_pom[ss_pom]=pi /2
fi_pom[((x==0)&(y<0)) & !is.na(x) & !is.na(y) ]=-pi /2
fi_pom[((x<0)&(y==0)) & !is.na(x) & !is.na(y) ]=pi
fi_pom[((x==0)&(y==0)) & !is.na(x) & !is.na(y) ]=0
data.frame(x[is.na(fi_pom)],y[is.na(fi_pom)] )
return(rtod(fi_pom ) )}
return(NA)}
rsum_cumsum <- function(x,n=3L,k_mean=FALSE ){
x_NA=is.na(x)
x_NA=which(x_NA)
x[x_NA]=0
x_out=c(rep(NA,n-1),tail(cumsum(x) - cumsum(c(rep(0,n),head(x,-n)) ),-n + 1) )
for (ii_pom in (0:(n-1))){
ii_pom2=(x_NA+ii_pom)
ii_pom2=ii_pom2[ii_pom2>=1 & ii_pom2<=length(x)]
x_out[ii_pom2]=NA}
if (k_mean==TRUE){
x_out=x_out/n
n_half=(n-1)/2
x_out=c(rep(NA,n_half),x_out[n:length(x_out)],rep(NA,n_half))}
return(x_out)}
rsum_cumsum_ireg <- function(x,n=3L,k_mean=FALSE,n_time_step=NA ){
x_NA=is.na(x)
x_NA=which(x_NA)
x[x_NA]=0
n_time_step=c(0,head(n_time_step,-1))
x_out_time=rep(0,length(x) )
x_out=rep(0,length(x) )
ii_pom=1
x_out_time[n_time_step<=n]=1
x_out[n_time_step<=n]=x[n_time_step<=n]
x_out=x
ii_pom2=(x_NA-ii_pom+1)
x_out[ii_pom2]=NA
for (ii_pom in (2:n)){
x_out_time_x=c(rep(NA,ii_pom-1),tail(cumsum(n_time_step) - cumsum(c(rep(0,ii_pom),head(n_time_step,-ii_pom))),-ii_pom + 1) )
ss_podm=(x_out_time_x<=n)&(!is.na(x_out_time_x))
x_out_time[ss_podm]=x_out_time_x[ss_podm]
x_out_x=c(rep(NA,ii_pom-1),tail(cumsum(x) - cumsum(c(rep(0,ii_pom),head(x,-ii_pom)) ),-ii_pom + 1) )
ss_podm=(x_out_time_x<=n)&(!is.na(x_out_x))
x_out[ss_podm]=x_out_x[ss_podm]
ii_pom2=(x_NA -ii_pom+1)
ii_pom2_=which(x_out_time_x<=n) -ii_pom+1
ii_pom2=ii_pom2[ (ii_pom2 %in% ii_pom2_)]
ii_pom2=ii_pom2[ii_pom2>=1 & ii_pom2<=length(x)]
x_out[ii_pom2]=NA}
if (k_mean==TRUE){
x_out=x_out/x_out_time}
return(data.frame(x=x_out,len=x_out_time) )}
Get_WAVE_Begin_End <- function(dt,END_DATE,VAL_SUM_EF,ID,k_begin=TRUE){
k_8=as.numeric(format(dt, format = "%m")) <= 8
if (VAL_SUM_EF[1]<0){
VAL_SUM_EF=tail(VAL_SUM_EF,-1)
END_DATE=tail(END_DATE,-1)
dt=tail(dt,-1)}
n_seq_sum=seq_along(VAL_SUM_EF[k_8])
n_seq_sum=n_seq_sum[-1]
n_seq_sum=n_seq_sum[n_seq_sum %% 2 !=0]
dt_cumsum=data.frame(dt=dt[k_8],VAL_SUM_EF=VAL_SUM_EF[k_8],c1=cumsum(VAL_SUM_EF[k_8]))
for (ii_pom in n_seq_sum){
ss_pom=paste("c",ii_pom,sep="")
dt_cumsum[ss_pom]=c(rep(NA,ii_pom-1),cumsum(tail(VAL_SUM_EF[k_8],-ii_pom+1 ) ) )}
waves_min=apply(dt_cumsum[c(-1,-2)],2,min,na.rm=TRUE)
ii_out= as.numeric( gsub( "c", "",    attr( which(waves_min>0), "names")    ) )
result=NA
if (k_begin==T){
if (length(ii_out)>0) result=dt[ii_out[1]] else result= as.Date(ISOdatetime( year=as.numeric(format(dt[1], format = "%Y")), month = 1, day = 1, hour = 0, min = 0, sec = 0, tz="GMT") )}else{
n_seq_sum2=seq_along(VAL_SUM_EF)
if (length(ii_out)==0) ii_out=as.numeric( gsub( "c", "", attr( which.max(waves_min), "names") ) )
n_seq_sum2=n_seq_sum2[n_seq_sum2>ii_out[1]]
n_seq_sum2=n_seq_sum2[n_seq_sum2 %% 2==0]
dt_cumsum2=data.frame(dt=dt,VAL_SUM_EF=VAL_SUM_EF )
for (ii_pom in n_seq_sum2){
ss_pom=paste("c",ii_pom,sep="")
dt_cumsum2[ss_pom]=c(rep(NA,ii_pom-1),cumsum(tail(VAL_SUM_EF,-ii_pom+1 ) ) )}
waves_max=apply(dt_cumsum2[c(-1,-2)],2,max,na.rm=TRUE)
ii_out2= as.numeric( gsub( "c", "", attr(which(waves_max<0), "names") ) )
if (length(ii_out2)>0) result=dt[ii_out2[1]]-1 else result= as.Date(ISOdatetime( year=as.numeric(format(tail(dt,1) , format = "%Y")), month = 12, day = 31, hour = 0, min = 0, sec = 0, tz="GMT") )}
return (result)}
insert_blank_rows = function (data, ss_field="ID_1") {
print("fce_rprog: insert_blank_rows()")
if (dim(data)[1]==0) return(NA)
ss=my_diff(data[[ss_field]])
pos=grep("[1-9]",ss)
if (length(pos)==0) return(data)
data_out=data[1:(pos[1]-1),]
if (length(pos)>=2){
for (jj in 2:length(pos)){
data_out=rbind(data_out,NA)
data_out=rbind(data_out,data[pos[jj-1]:(pos[jj]-1),] )}}else{
jj=1}
data_out=rbind(data_out,NA)
data_out=rbind(data_out,data[pos[jj]:(dim(data)[1]),] )
if ("mfd_" %in% names(data_out)) data_out$mfd_[is.na(data_out$mfd_)]=TRUE
return(data_out)}
Stat_calculate_row <- function( x, my_function , na_rm=ifelse(my_function %in% c("CNT","P","p","CNT_COND"), TRUE, FALSE) , probs=0.5 ) {
ii_c=grep( "character",  lapply(x, class) )
if (length(ii_c)>0){
if (is.data.table(x)) x=x[,-ii_c,with=FALSE] else x=x[,-ii_c]}
my_function=unique(my_function)
if (!(toupper(my_function) %in% c("AVG","SUM","MAX","MIN","CNT","SD","P","KS","CNT_NA","CNT_COND"))) return(NA)
if ((my_function=="VALUE2")|(nchar(my_function)==0)) {
my_function="AVG"}
if (my_function=="KS") {
my_KS_test=function(x){
x=x[!is.na(x)]
if (length(x)>=2) ks.test(x=x,y=pnorm)$p.value else NA}}
switch(toupper(my_function),
AVG=apply(x,1,mean,na.rm=na_rm ),
SUM=apply(x,1,sum,na.rm=na_rm ),
SD=apply(x,1,sd,na.rm=na_rm ),
Max=apply(x,1,max,na.rm=na_rm ),
MAX=apply(x,1,max,na.rm=na_rm ),
Min=apply(x,1,min,na.rm=na_rm ),
MIN=apply(x,1,min,na.rm=na_rm ),
p=apply(x,1,quantile,probs=probs,na.rm=na_rm,names=FALSE,type=5 ),
P=apply(x,1,quantile,probs=probs,na.rm=na_rm,names=FALSE,type=5 ),
KS=apply(x,1,my_KS_test),
CNT=apply(!is.na(x),1,sum),
CNT_NA=apply(is.na(x),1,sum)
)}
PD_calculate_row <- function(x,srazkova_mez_zad,k_eq_value,k_mt_value,k_lt_value,k_abs_val=FALSE,na_rm=FALSE){
result=0
if (all(is.na(x))) return(NA)
if (k_abs_val){
x=abs(x)}
if (k_eq_value==1) result=result + apply(x==srazkova_mez_zad,1,sum,na.rm=na_rm )
if (k_mt_value==1) result=result + apply(x>srazkova_mez_zad,1,sum,na.rm=na_rm )
if (k_lt_value==1) result=result + apply(x<srazkova_mez_zad,1,sum,na.rm=na_rm )
return (result)}
number_of_days_in_a_month=function(n_year,n_month){
a1=ISOdatetime( year=as.numeric(n_year), month = as.numeric(n_month), day = 1, hour = 0, min = 0, sec = 0, tz="GMT")
dt=a1+60*60*24*45
a2=ISOdatetime( year=as.numeric(format(dt, "%Y")), month = as.numeric(format(dt, "%m")), day = 1, hour = 0, min = 0, sec = 0, tz="GMT" )
return (as.numeric(a2-a1, units="days"))}
is.leapyear=function(year){
return(((year %% 4==0) & (year %% 100 !=0)) | (year %% 400==0))}
Existing_Date=function(year,month,day ){
k_out=rep(TRUE,length(year))
k_out[ ((day==31) & (month %in% c(2,4,6,9,11)) ) ]=FALSE
k_out[ ((day==30) & (month %in% c(2)) ) ]=FALSE
k_out[ ((day==29) & (month %in% c(2)) & (!(is.leapyear(year))) ) ]=FALSE
return(k_out)}
get_ndays <- function(month,year){
if (month %in% c(1,3,5,7,8,10,12)){
n <- 31;}
if (month %in% c(4,6,9,11)){
n <- 30;}
if (month==2){
if (((year %% 4)==0) & (((year %% 100) !=0) | ((year %% 400)==0) ) ){
n <- 29;}else{
n <- 28;}}
return(n);}
get_ndays_pole <- function(month,year){
n=rep(NA,length(month) )
n[month %in% c(1,3,5,7,8,10,12)] <- 31
n[month %in% c(4,6,9,11)] <- 30
n[ (month==2) ] <- 28
n[ (month==2) & (((year %% 4)==0) & (((year %% 100) !=0) | ((year %% 400)==0) ) ) ] <- 29
return(n);}
Get_Season=function(mes){
season=rep("",length(mes))
season[(mes %in% c(1,2,12))]=("DJF")
season[(mes %in% c(3,4,5) )]=("MAM")
season[(mes %in% c(6,7,8) )]=("JJA")
season[(mes %in% c(9,10,11))]=("SON")
return(season)}
Get_Col_number_fromSeasonName=function(mes_vyb){
season_num=rep(0,length(mes_vyb))
season_num[grepl("DJF",mes_vyb,ignore.case=TRUE)]=14
season_num[grepl("MAM",mes_vyb,ignore.case=TRUE)]=15
season_num[grepl("JJA",mes_vyb,ignore.case=TRUE)]=16
season_num[grepl("SON",mes_vyb,ignore.case=TRUE)]=17
return(season_num)}
Get_ColName_Season=function(season_num){
season=season_num
season=gsub("13","_YEAR",season,ignore.case=TRUE)
season=gsub("14","_DJF",season,ignore.case=TRUE)
season=gsub("15","_MAM",season,ignore.case=TRUE)
season=gsub("16","_JJA",season,ignore.case=TRUE)
season=gsub("17","_SON",season,ignore.case=TRUE)
return(season)}
summary_DT=function(data_DT_1col_){
cat(paste("Summary for variable:", deparse(substitute(data_DT_1col_)) ) ,"\n","\n")
if (!is.data.table(data_DT_1col_)) data_DT_1col_=as.data.table(data_DT_1col_)
ii_c=c ( grep( "character",  lapply(data_DT_1col_, class) ),  grep( "factor",  lapply(data_DT_1col_, class) ) )
cat("  Summary - number of cases for character columns:","\n","\n")
for (ss_col in names(data_DT_1col_)[ii_c] ){
cat( paste("   ",ss_col,"  column (cases and count):", sep="") ,"\n")
xx=data_DT_1col_[[ss_col]]
print(tapply(xx,xx,length) )
cat("","\n")}
cat("  Summary for  integer or numeric  columns:","\n","\n")
print(summary(data_DT_1col_[,-c(ii_c),with=FALSE]) )
cat("","\n")}
identical_DT=function(x1,x2,k_try_sloupce=TRUE,verbose=TRUE){
x1=data.table(x1)
x2=data.table(x2)
if (k_try_sloupce==TRUE){
sloupce=base:::merge(data.frame(n1=names(x1)),data.frame(n2=names(x2)), all=FALSE, sort=FALSE, by.x="n1", by.y="n2")
sloupce=unique(sloupce)
if (dim(sloupce)[1]==0) { stop(paste("Columns names does not match", names(x1), " : ", names(x2))) }
qq=quote(sloupce[,1])
x1=x1[,eval(qq),with=FALSE]
x2=x2[,eval(qq),with=FALSE]}
n_dim=dim(x1)[2]
poc_dif=0
for (ii in 1:n_dim){
if (!identical(x1[,ii,with=FALSE],x2[,ii,with=FALSE])){
poc_dif=poc_dif+1
if (verbose){
print("")
print( paste(poc_dif,": column ",ii," - ",names(x1)[ii]," - differs:" , sep=""))
setkeyv(x1,names(x1)[ii])
print(all.equal(x1[,ii,with=FALSE],x2[,ii,with=FALSE],check.attributes=FALSE) )
print("")}}else{
if (verbose) print( paste("Column ",ii," - ",names(x1)[ii]," - OK" , sep=""))}}
return(poc_dif)
if (verbose) print("")}
get_shp_name = function (my_shp="") {
my_shp=gsub( pattern ="\\\\", replacement ="/",my_shp)
if ((!file.exists(my_shp))&(file.exists(paste("../",my_shp,sep="")))) my_shp=paste("../",my_shp,sep="")
if ((!file.exists(my_shp))&(file.exists(paste("../../",my_shp,sep="")))) my_shp=paste("../../",my_shp,sep="")
if (!file.exists(my_shp)){
my_shp=gsub("(\\.\\./)*",'',my_shp)
ii_pom=4
while ((!file.exists(my_shp)) & (ii_pom>0) ){
my_shp=paste("../", my_shp, sep="")
ii_pom=ii_pom-1}}
if (!file.exists(my_shp)){
my_shp=gsub("(\\.\\./)*",'',my_shp)
print("");  print(paste("File ", my_shp , " for crop etc. does NOT exist")); print("");}
return(my_shp)}
Get_Proj=function(proj_my,raster_in=NA){
proj_my=alltrim(proj_my)
switch (proj_my,
'wgs' = {crs_ = CRS('+proj=longlat +ellps=WGS84 +datum=WGS84 +no_defs') },
'krov' = {crs_ = CRS('+proj=krovak +lat_0=49.5 +lon_0=24.83333333333333 +alpha=0 +k=0.9999 +x_0=0 +y_0=0 +ellps=bessel +units=m +no_defs') },
's42' = {crs_ = CRS('+proj=tmerc +lat_0=0 +lon_0=15 +k=1 +x_0=3500000 +y_0=0 +ellps=krass +units=m +no_defs')} ,
'utm' = {crs_ = CRS("+init=epsg:32633") } ,
'etrs' = {crs_ = CRS("+init=epsg:3035") } ,
'-'    = { proj_from = proj4string(raster_in) }
)
return(crs_)}
Convert_CZ_to_x=function(x){
if (.Platform$OS.type=="windows") {
if (file.exists("rprog/fce_rprog_cz.r")) source("rprog/fce_rprog_cz.r")
if (file.exists("fce_rprog_cz.r")) source("fce_rprog_cz.r")
x=Convert_CZ_to_x__cz(x)}
return(x)}
add_logo=function(image="rprog/Czechglobe-logo-bez-textu.png", x=.05, y=.05, size=2.25)  {
source( paste( ifelse(file.exists("load_package_my.r"),"","rprog/"),"load_package_my.r",sep="") ,TRUE)
load_package_my("png")
load_package_my("grid")
label=""
copyright.draw <- function(label,image,x,y,size,...){
lab <- textGrob(label=label,
x = unit(x, "npc"), y = unit(y, "npc"),
just = c("left", "centre"), gp = gpar(...))
sizew=size
logo <- rasterGrob(image=image,
x = unit(x, "npc") + unit(1, "grobwidth", lab), y = unit(y, "npc"),
width = unit(sizew, "cm"),
just = c("left", "centre"), gp = gpar(...))
grid.draw(lab)
grid.draw(logo)}
z=image
z <- readPNG(z)
copyright.draw(label=label,image=z,x=x,y=y,size=size,interpolate=T)}
graph_save <- function(filename_my, plotkind="png" , ss_windows="16,9", bg_color="white") {
if(dev.next()==dev.cur()){
ss_windows2=unlist(strsplit(ss_windows,","))
if (as.numeric(ss_windows2[1])>50) ss_units="px" else ss_units="in"
if ((length(ss_windows2)>2)) ss_res=ifelse(as.numeric(ss_windows2[3])>0,as.numeric(ss_windows2[3]),72) else{ss_res=72}
ss_pointsize=18
print(paste("Window size, legend: ",ss_windows, ", Units: ",ss_units, ", Resolution: ",ss_res, ", Pointsize: ",ss_pointsize,  sep=""))
if (plotkind=="png") png(file=filename_my,  bg=bg_color, width=as.numeric(ss_windows2[1]), height=as.numeric(ss_windows2[2]), units = ss_units, res=ss_res,  pointsize=ss_pointsize)
if (plotkind=="bmp") bmp(file=filename_my,  bg=bg_color, width=as.numeric(ss_windows2[1]), height=as.numeric(ss_windows2[2]), units = ss_units, res=ss_res,  pointsize=ss_pointsize)
if (plotkind=="jpeg") jpeg(file=filename_my,  bg=bg_color, width=as.numeric(ss_windows2[1]), height=as.numeric(ss_windows2[2]), units = ss_units, res=ss_res, pointsize=ss_pointsize)
if (plotkind=="tiff") tiff(file=filename_my,  bg=bg_color, width=as.numeric(ss_windows2[1]), height=as.numeric(ss_windows2[2]), units = ss_units, res=ss_res,  pointsize=ss_pointsize)
if (plotkind=="ps") postscript(file=filename_my,width=9.0,height=9.0,horizontal=F,paper="special")
if (plotkind=="pdf") pdf(file=filename_my, onefile=FALSE)
dev.set(dev.prev())}
dev.copy(which=dev.next())
dev.off()}
savePlot2 = function (filename_my = "Rplot", type = c("wmf", "emf", "png", "jpg",
"jpeg", "bmp", "tif", "tiff", "ps", "eps", "pdf"), device = dev.cur(),
restoreConsole=TRUE,n_max_dev_list=12)
{
type <- match.arg(type)
devlist <- dev.list()
devcur <- match(device,devlist,NA)
if (is.na(devcur))
stop("no such device")
devname <- names(devlist)[devcur]
print(paste("Device: (",device,", current length=",length(dev.list()),"), devname: ",devname , sep="") )
if (devname != "windows")
stop("can only copy from 'windows' devices")
if (filename_my == "clipboard" && type == "wmf")
filename_my <- ""
else if (regexpr("\\.", filename_my) < 0)
filename_my <- paste(filename_my, type, sep = ".")
filename_my <- path.expand(filename_my)
invisible(.External(grDevices:::C_savePlot,device,filename_my,type,restoreConsole))}
