my__write_dbf <- function(dataframe,my_file,n_size=NA,n_dec=15,
print_output=TRUE,factor2char=TRUE,max_nchar=254,mfd=NULL,k_append=FALSE,k_remove_duplicate_col_names=TRUE ){
if ((.Platform$OS.type=="unix")|(1==0)) {
if (print_output) print("Under Linux, saving into .dbf is not performed ... ")
return(NA)}
if (is.na(n_dec)) n_dec=15
source( paste( ifelse(file.exists("load_package_my.r"),"","rprog/"),"load_package_my.r",sep="") ,TRUE)
load_package_my("data.table")
load_package_my("reshape2")
load_package_my("utils")
dataframe=as.data.table(dataframe)
if (k_remove_duplicate_col_names==TRUE){
ss_pom=names(dataframe)
ss_pom=substr(ss_pom,1,10)
if (length(unique(ss_pom))!=length(ss_pom)){
print("my__write_dbf: Columns removed (doubled): ")
print((names(dataframe))[duplicated(ss_pom)])
ss_pom=(names(dataframe))[ !duplicated(ss_pom) ]
dataframe=dataframe[,ss_pom,with=FALSE]}}
ii_c=grep( "POSIXt",  lapply(dataframe, class) )
if (length(ii_c)>0){
for (ii_pom in ii_c){
dataframe= dataframe[ ,c(names(dataframe)[ii_pom]):= format(dataframe[ ,ii_pom , with=FALSE] , "%Y/%m/%d") ]
if (print_output==TRUE) print( paste( "   POSIXt column ",c(names(dataframe)[ii_pom])," converted") )}}
ii_c=grep( "difftime",  lapply(dataframe, class) )
if (length(ii_c)>0){
for (ii_pom in ii_c){
dataframe=dataframe[,c(names(dataframe)[ii_pom]):=as.numeric((dataframe[,ii_pom,with=FALSE])[[1]] ) ]
if (print_output==TRUE) print( paste( "   difftime column ",c(names(dataframe)[ii_pom])," converted") )}}
if (file.exists("fce_rprog.r")) source("fce_rprog.r",TRUE) else source("rprog/fce_rprog.r",TRUE)
allowed_classes <- c("logical", "integer", "numeric", "character",
"factor", "Date")
if (!is.data.frame(dataframe))
dataframe <- as.data.frame(dataframe)
if (any(sapply(dataframe,function(x) !is.null(dim(x)))))
stop("cannot handle matrix/array columns")
cl <- sapply(dataframe,function(x) class(x[1L]))
asis <- cl == "AsIs"
cl[asis & sapply(dataframe, mode) == "character"] <- "character"
if (length(cl0 <- setdiff(cl,allowed_classes)))
stop(sprintf(ngettext(length(cl0), "data frame contains columns of unsupported class %s",
"data frame contains columns of unsupported classes %s"),
paste(dQuote(cl0), collapse = ",")), domain = NA)
m <- ncol(dataframe)
DataTypes <- c(logical = "L", integer = "N", numeric = "F", character = "C", factor = if (factor2char) "C" else "N", Date = "D")[cl]
for (i in seq_len(m)){
x <- dataframe[[i]]
if (is.factor(x))
dataframe[[i]] <- if (factor2char)
as.character(x)
else as.integer(x)
else if (inherits(x, "Date"))
dataframe[[i]] <- format(x, "%Y%m%d")}
precision <- integer(m)
scale <- integer(m)
dfnames <- names(dataframe)
if (print_output==TRUE) print( "" )
if (print_output==TRUE) print( paste( "my__write_dbf.r script:", sep="" ) )
for (i in seq_len(m)){
nlen <- nchar(dfnames[i], "b")
x <- dataframe[[i]]
if (is.logical(x)){
precision[i] <- 1L
scale[i] <- 0L
x[is.na(x)]=FALSE
dataframe[[i]]=x}
else if (is.integer(x)){
x[is.na(x)]=-999
x[x==Inf]=-999
x[x==-Inf]=-999
dataframe[[i]]=x
rx <- range(x,na.rm=TRUE)
rx[!is.finite(rx)] <- 0
if (any(rx==0))
rx <- rx + 1
mrx <- as.integer(max(ceiling(log10(abs(rx)))) +
1L)
if (all(rx==0)) mrx=1
precision[i] <- min(max(nlen,mrx),19L)
scale[i] <- 0L}
else if (is.double(x)){
x[is.na(x)]=-999
x[x==Inf]=-999
x[x==-Inf]=-999
dataframe[[i]]=x
if (n_dec<15){if (all(is.wholenumber(x) )) num_dec_i=0 else num_dec_i=n_dec}else num_dec_i=num_dec(x)
if ((length(x))<1){vel_i=1}else{
vel_i=max(floor(log10 (abs (x ))) + 1,na.rm=TRUE) +1}
if (vel_i==-Inf) vel_i=1
if ((length(x[x!=-999]))<1){vel_i_mv=1}else{
vel_i_mv=max(floor(log10 (abs (x[x!=-999] ))) + 1,na.rm=TRUE) +1}
if (vel_i_mv==-Inf) vel_i_mv=1
if (-vel_i>num_dec_i){
num_dec_i=num_dec(x)}
if ((vel_i_mv-2)<0){
if (num_dec_i!=0) num_dec_i=n_dec+(-(vel_i_mv-2))}
if (!is.na(n_size)) vel_i=ifelse(vel_i< n_size,n_size,vel_i )
if (vel_i>19){
vel_i=19
x[x>1e19]=-999
x[x< (-1e19)]=-999
dataframe[[i]]=x}
if ((all(x==0))|(vel_i<0)) vel_i=1
mrx=vel_i
scale[i]=num_dec_i
precision[i]=mrx+ ifelse(num_dec_i>0,num_dec_i+1,0)
if (precision[i]>20) precision[i]=20}
else if (is.character(x)){
x[is.na(x)]=""
dataframe[[i]]=x
mf <- max(nchar(x[!is.na(x)], "b"))
p <- max(nlen,mf)
if (p > max_nchar)
warning(gettext("character column %d will be truncated to %d bytes",
i,max_nchar),domain=NA)
precision[i] <- min(p,max_nchar)
scale[i] <- 0L}
else stop( paste("unknown column type in data frame, column ",dfnames[i]) )
if (print_output==TRUE) print( paste( "write to dbf: column ",i," - ",dfnames[i]," ready:  size=", precision[i], ", dec=", scale[i], sep="" ) )}
if (any(is.na(precision)))
stop("NA in precision")
if (any(is.na(scale)))
stop("NA in scale")
if (any(precision<=0) ){
warning(paste("Some fields has negative length:", names(dataframe)[precision<=0]  ))
precision=abs(precision)}
ii_duplicated=which(duplicated(names(dataframe)) )
if (length(ii_duplicated)>0){
for (ii_d in ii_duplicated){
print(paste("Duplicate name: ",names(dataframe)[ii_d]))
ii_poc=1
ss_name=names(dataframe)[ii_d]
while (ii_d %in% which(duplicated(names(dataframe)) ) ){
ii_poc=ii_poc+1
names(dataframe)[ii_d]=paste( ss_name ,"_",ii_poc,sep="" )}
if (nchar(names(dataframe)[ii_d])>10){
names(dataframe)[ii_d]=paste(substr(names(dataframe)[ii_d],1,10-nchar(ii_poc)-1),"_",ii_poc,sep="")}
print(paste(" ... renamed to: ",names(dataframe)[ii_d]))}
print("")
print(names(dataframe))}
if ("MFD" %in% names(dataframe) ) {
names(dataframe)[which( "MFD"==names(dataframe) )]="DEL_"
if (print_output==TRUE) print("Renaming MFD to DEL_")}
if (print_output==TRUE) print(head(dataframe))
if (print_output==TRUE) print( "" )
if ((k_append==TRUE)&(file.exists(my_file))){
print(" appending data to the original file ...")
source( paste( ifelse(file.exists("my__read_dbf.r"),"","rprog/"),"my__read_dbf.r",sep="") ,TRUE)
dataframe_puv=my__read_dbf(my_file,T, F ,T,"MFD")
dataframe_puv=as.data.table(dataframe_puv)
if (!is.null(mfd)) mfd=c(dataframe_puv$MFD,mfd) else mfd=c(dataframe_puv$MFD,rep(0,nrow(dataframe)) )
l=list(dataframe_puv,dataframe)
dataframe=rbindlist(l,fill=TRUE)}
precision[precision==Inf]=ifelse(!is.na(n_size),n_size,19)
scale[scale==-Inf]=n_dec
my_file=as.character(my_file)
xx=try(invisible(.Call(foreign:::DoWritedbf,my_file,dataframe,as.integer(precision),as.integer(scale),as.character(DataTypes)) ),FALSE)
if (class(xx)== "try-error") { print( paste('error in my__write_dbf.r, file ',my_file,': ','\n')) ; print(xx);  }
addMFD <- F
if (!is.null(mfd)){
addMFD <- T
mfd[is.na(mfd)]=FALSE
if (!all(mfd %in% c(T,F,1,0))){
print("The vector with marked-for-deletion indicators (input mfd) contains unsupported values => the indicators will not be added to the dbf file.",quote=F)
addMFD <- F}
if (length(mfd) !=nrow(dataframe)){
if (length(mfd)>0) print(paste("The vector with marked-for-deletion indicators (input mfd) has wrong length (",length(mfd),"/",nrow(dataframe),") => the indicators will not be added to the dbf file"),quote=F)
addMFD <- F}}
if (addMFD){
bytes2int <- function(bytes){
return(sum(bytes*(256^(0:(length(bytes)-1)))))}
bytes <- as.integer(readBin(my_file, "raw", n=12))
n1 <- bytes2int(bytes[4:7+1])
n2 <- bytes2int(bytes[8:9+1])
n3 <- bytes2int(bytes[10:11+1])
n <- n2+n1*n3
bytes <- readBin(my_file, "raw", n=n)
m <- length(mfd)
mfd_bytes <- rep(as.raw(32),m)
mfd_bytes[mfd==1] <- as.raw(42)
inds <- n2+1+(1:m-1)*n3
bts <- bytes[inds]
if (all(bts %in% as.raw(c(32,42)))){
bytes[inds] <- mfd_bytes
writeBin(bytes,my_file)}else{
print("The original marked-for-deletion bytes contain some unexpected values => the indicators will not be added to the dbf file.",quote=F)}}
if (print_output==TRUE){
print( "" )
print(" ... my__write_dbf - Done")}}
