# source("launch_QC.r",TRUE)	
# for Linux: source("launch_QC.r",TRUE, encoding = "UTF-8")	


# ----------------------------
# general settings


# variables supported from outside the script:

if (!exists("file_parameters")) file_parameters='R_input_parameters.txt'
		  
if (!exists("log_file_corr")) log_file_corr='log_Rterm_.txt'
	if ( grepl("log_temp_file[0-9,a-z]",log_file_corr) ) log_file_corr='log_Rterm_.txt'
	
if (!exists("k_ECAD_mode"))	k_ECAD_mode=TRUE # FALSE
k_force_settigs_ECAD=TRUE #for ECAD mode, overwrites the settings with some defaults

# ----------------------------
	
	
	
	
	if (k_ECAD_mode==TRUE) if (file.exists(log_file_corr)) file.remove(log_file_corr)
	
	

 k_verbose=FALSE   # TRUE 
		if ((k_ECAD_mode)&(k_force_settigs_ECAD)) k_verbose=FALSE
		
 k_supress_output_all_possible=TRUE   # auxiliary output - print
		if ((k_ECAD_mode)&(k_force_settigs_ECAD)) k_supress_output_all_possible=TRUE
	
		
k_save_auxiliary_files=FALSE  # plots - .pdf, .png, KStest - histograms, _dist, _dist2 - distances,   csv for 1-1 whole output
		if ((k_ECAD_mode)&(k_force_settigs_ECAD)) k_save_auxiliary_files=FALSE

		
k_save_only_final_results=TRUE
		if ((k_ECAD_mode)&(k_force_settigs_ECAD)) k_save_only_final_results=TRUE
	
	

 k_save_data_into_files_rda=TRUE # FALSE #for 7/4,  
		# saving individual results (stations) to save RAM memory
		#		if (k_ECAD_mode) k_save_data_into_files_rda=FALSE
		# jinak to neukladalo pri ECAD modu, co melo ...

		

# for 1/1 function, Get_info:		
k_do_not_remove_NA=FALSE  
		# removes missing values, then put it back (and calculates numbers)
		# TRUE	- much quicker, but you do not have the iformatino about missing values
		# if ((k_ECAD_mode)&(k_force_settigs_ECAD)) k_do_not_remove_NA=FALSE
		
		
# for QC:		
n_same_values=10 # 5  #repeated values, repeated,  limit of the number of the same values ...
n_same_values_0=60 # 41  #repeated 0 values, repeated,  limit of the the number of the 0 values ...
n_same_values_dupl=30 # limit for duplicated values (the same neighbour)
max_QC_result_suspicous_per=40 # limit, in percentage, for suspicious values

	
k_remove_aux_colums=1 # when saving auxiliary results,  preserves only the most important columns
		
		
# ----------------------------




df=data.frame(Status="R_do_parallel",file_in="launch_QC.r",file_out="launch_QC.r", datetime=Sys.time())
file_log_multi='log_parallel.txt'
#pokud log neexistuje, tak udela novy soubor a zapise nazvy sloupcu
		# write.table {utils}
		warn=require("utils")
if (!file.exists(file_log_multi)) write.table( df[0,] , file=file_log_multi, sep = "\t", quote=TRUE, row.names=FALSE,col.names = TRUE,   append = FALSE )
write.table( df , file=file_log_multi, sep = "\t", quote=TRUE, row.names=FALSE,col.names = FALSE,   append = TRUE )





# if (k_ECAD_mode==TRUE) 
log_file_corr=paste("log_temp_", basename(tempfile(pattern = "file")),".txt", sep="")
	# closes previous connections:
	for (ii in (1:sink.number())) sink()
sink(log_file_corr,split=TRUE) #zaznamena do obou
 #jinak se ten vystup pohada



# remove older variables ... smazani starych promennych (good for ProClimDB but not for stand-alone run)
# rm(list = ls())
	#rm(list=ls(all=TRUE))

rm( list= ls(pattern="^data_out") )

	
	
print(R.Version()$version.string)
print("")
print("====================================")
print("Launching the script: launch_QC.r")
print("")
print(paste("Log file: ", log_file_corr) )
print("")

#Output working directory
cat(paste("Working directory, Statistics: \n ",getwd(),"\n"))

dd_datetime=Sys.time()
print(paste("Time: ", dd_datetime))
print("")



			if (file.exists(file_parameters)) {
				xx=read.csv(file_parameters, fill = TRUE)
				print("")
				print(paste("File with parameters: ",file_parameters))
				print(xx)
				print("")
												}


#################################
  

		# linux
		if (.Platform$OS.type=="unix") source("rprog/load_package_my.r",TRUE, encoding = "UTF-8") else source("rprog/load_package_my.r",TRUE )
 
  
  
  load_package_my("utils")
  load_package_my("stats") #aby fungovalo po udpatu  as.formula
  load_package_my("foreign")
  load_package_my("graphics")
   load_package_my("grDevices")  #png
  # load_package_my("colorRamps") # red2blue atp. pro barvy
  load_package_my("fields")
	 

	
##############

  load_package_my("data.table")
  load_package_my("reshape2")
							   

  if (.Platform$OS.type=="unix") {
  source("rprog/my__write_dbf.r", local=F, encoding = "UTF-8")		  		 
  source("rprog/my__read_dbf.R", local=F, encoding = "UTF-8")		  		 
								} else {
  source("rprog/my__write_dbf.r", local=F)		  		 
  source("rprog/my__read_dbf.R", local=F)		  		 
										}


		  
###########		

# print("Session info: ")
# print(sessionInfo()) #utils
# print("")

if (.Platform$OS.type=="windows") # .Platform$OS.type  ,  not linux, unix
	if (memory.limit()<2980) memory.limit(8000) #utilis
# otherwise:  .Platform$OS.type=="unix"


#################################


if (.Platform$OS.type=="unix") source("rprog/functions_corr.r", TRUE , encoding = "UTF-8")	else source("rprog/functions_corr.r", TRUE )

if (.Platform$OS.type=="unix") source("rprog/fce_rprog.r",TRUE, encoding = "UTF-8")	else source("rprog/fce_rprog.r",TRUE )

				

##################################				

#vstupni parametry, pouze pro tento script,  toto se vztvari v ProClimDB, statist_r_project
  soub_txt="R_input_function_alone.txt"
	soub_txt2=""
  # if (file.exists("R_input_parameters.txt")) {
  if (file.exists(file_parameters)) {
				# soub_txt2="R_input_parameters.txt"
				soub_txt2=file_parameters
				soub_txt=soub_txt2
									 }   # if (file.exists(file_parameters)),  soub_txt="R_input_function_alone.txt"
  
					
   if (!file.exists(soub_txt)) {
stop(paste("launch_QC.r: Error occured: file ",soub_txt," (nor ",file_parameters,") with parameters does NOT exist"))   
								}					
					
					
require(utils)
  ss=read.table(soub_txt,col.names=c("var","value"), colClasses = "character")
	#as.is 	the default behavior of read.table is to convert character variables (which are not converted to logical, numeric or complex) to factors.
	#Note: to suppress all conversions including those of numeric columns, set colClasses = "character". 

 if (length(ss$value)<1) {
  #print("not enought input values in PD_R_input.txt")
  #q()
  stop("not enought input values in R_input_function_alone.txt") 
                         }

#


if (any(ss$var=="a_files")) a_files=((as.character(ss$value[ss$var=="a_files"]))) else a_files="" #stop(paste("Parameter 'missval' is missing in input-file"))
if (any(ss$var=="a_controls")) a_controls=((as.character(ss$value[ss$var=="a_controls"]))) else a_controls="" #stop(paste("Parameter 'missval' is missing in input-file"))

    #RGui nebo prazdne
if (any(ss$var=="R_mode")) R_mode=((as.character(ss$value[ss$var=="R_mode"]))) else R_mode="RGui" #stop(paste("Parameter 'missval' is missing in input-file"))

if (any(ss$var=="missval")) missval=(as.numeric(as.character(ss$value[ss$var=="missval"]))) else missval=-999 #stop(paste("Parameter 'missval' is missing in input-file"))

	cp_local=""
if (any(ss$var=="n_file_CodePage")) cp_local=(as.numeric(as.character(ss$value[ss$var=="n_file_CodePage"]))) else cp_local="" #stop(paste("Parameter 'missval' is missing in input-file"))

if (any(ss$var=="n_transformation")) n_transformation=(as.numeric(as.character(ss$value[ss$var=="n_transformation"]))) else n_transformation=-10 #equitable ratios",   n_transformation=100 #differences






# stop("stop here before reading parameters")

  
  # two ways of giving parameters to this script, ProClimDB way or individual files and controls files
  if ( ( file.exists(soub_txt2)) ) {
	if ( ( file.exists(a_files)) ) 	{
		 a_files=read.table(a_files,col.names=c("var","value"), colClasses = "character", sep="=" , fill=TRUE)
		 a_files=a_files$value
		 a_files=as.character( sapply(a_files, alltrim) )
		 							} else {
stop(paste("Error: file with specified input files not found: ",a_files))
											}
	if ( ( file.exists(a_controls)) ) {
		 a_controls=read.table(a_controls,col.names=c("var","value"), colClasses = "character", sep="=" , fill=TRUE)
		 a_controls=a_controls$value
		 a_controls=as.character( sapply(a_controls, alltrim) )
		 							} else {
stop(paste("Error: file with controls not found: ",a_controls))
											}	
									
									} else {
   
 a_controls_delimiter="x'<,>'x"
a_files=unlist( strsplit(a_files,a_controls_delimiter, fixed=TRUE) )
a_files=a_files[2:length(a_files)]
a_controls=unlist( strsplit(a_controls,a_controls_delimiter, fixed=TRUE) )
a_controls=a_controls[2:length(a_controls)]
  
											}

  
 # renames the input file, so that it can be used by other parallel process ...
ss_pom=paste( filename2(file_parameters),".bak" , sep="")
if ( (file.exists(ss_pom))&(file.exists(file_parameters)) ) file.remove(ss_pom)
file.rename(file_parameters, ss_pom)
  
  
  
##########


 
 
 #the last item is a function in ProClimDB that calls this script
	 #posledni je funkce, ktera byla v PD volana
 #n_pd_function="1:4/3/0"
n_pd_function=a_controls[length(a_controls)]

#n_pd_function je kombinace k_program_day a n_pd_function 
  if (length(grep(':',n_pd_function))==0) {
k_program_day=1
#n_pd_function=n_pd_function
										  } else  {
		#novejsi verze dava na zacatku to k_program_day								  
k_program_day=as.numeric( unlist(strsplit(n_pd_function,':'))[1] )
n_pd_function=unlist(strsplit(n_pd_function,':'))[2]	
											    }	


												
												
												
#k_months_individually=1

 
 
	#k_plot_scatter_histo=TRUE
# k_plot=FALSE

# plotkind="pdf"
# plotkind="png"
 
 

	ss_region=""
	ss_idcol=""

	
	
	
 
	ss_begin=0
	ss_end=0
	ss_periods=0 #step
		ss_begin_all=""
		ss_end_all=""
	ss_periods_all=""
	ss_overlap_all=""
 
 
 
	k_allow_missing=0

	
	
	# hranice_dej_missval = 60
	hranice_dej_missval = round(365.25*5)
	# for 1/1 and 7/2
	
	
	
	
 
#pro  4/3 
 
#vykresli pouze nejblizsi
k_plot_only_nearest=TRUE  #k_plot_nearest
		#k_run_KS_test  f (jj==ii) 
k_plot_only_col_val_All_m=TRUE



#pro  7/1, 7/2 
#blize se to nevezme pro hledani nejblizsi stanice:
limist_near_distance=0.1	 
len_comm_per=0

# k_clever_altitude_sel
koef_data_verified=33  #PD settings: prc. of last vals
koef_1_5=1.5    	   #PD settings: Coeff. IQR		
 
ss_corr_method="pearson"
 

 
 
file_info="" 
file_stat=""
file_stat2="" 
file_geogr=""



	k_CSV=FALSE  #if to save also .csv files
			

			
			
			
			
# stop("stop here before controls")	


 if (n_pd_function=="1/1/0") {
data_file=a_files[1]

file_geogr=a_files[2]
file_info=file_geogr # <<<<<<<<<<<<<<<<<<<<


file_stat2=a_files[3]  #data_info

	
file_stat=a_files[4]   # file_out



			if (nchar(file_stat)>0) {
				# it will saves individual elements for ECAD, in Temp directory
				k_save_only_final_results=FALSE  
									}

############

						ss_pom=a_controls[4]
						ss_pom=gsub("[;]",",",ss_pom)
						if (grepl(",",ss_pom)) {
							ss_pom=unlist(strsplit(ss_pom,','))
							hranice_dej_missval=round(365.25*         as.numeric(ss_pom[1]) )
							hranice_dej_missval=hranice_dej_missval + as.numeric(ss_pom[2])
												} else {
			hranice_dej_missval=(as.numeric(as.character(ss_pom)))
			if (hranice_dej_missval<=31) hranice_dej_missval=( 365.25* hranice_dej_missval )
														}
print_my("Setting: Limit (in days) for a gap to fill missing values (otherwise, splitting into more parts): ", hranice_dej_missval, k_add_print_=TRUE)		
		
							  }

							  
							  
	
	
	
	
	

	
###############################################											
										
										
										
										
										
# stop("stop here before controls")	
		


limit_distance=0  # vzdal_hranice
	
ss_column_COR=""
limit_correlation=0   # korel_hranice

					#nnnnnnnnnnnnnnnnnngggggggggggggggbbbbbbbbbbbbbbbbbbbbbb
 if ((n_pd_function=="7/1/0")|(n_pd_function=="7/2/0")) {

 
data_file=a_files[1]
file_info=a_files[2]

#file_out=a_files[3]
# file_stat=a_files[3]    #output-neighbours,  does not make sense here
	# file_stat="void"
file_stat2=a_files[4]  #neighbour info	
   
			if (n_pd_function=="7/1/0")	{
							file_stat2=a_files[5] 
							file_corr=a_files[3] 
										} #if (n_pd_function=="7/1/0")  
 
 
 

			if (n_pd_function=="7/1/0")	k_vyb_st_jak='c' else k_vyb_st_jak='d'

											
			k_only_InfoFile=as.numeric(as.character(a_controls[1]))
			
			
			maxpoc_stanic=(as.character(a_controls[2]))		
										maxpoc_stanic=gsub(",",";",maxpoc_stanic,fixed=TRUE)
										if (grepl(";",maxpoc_stanic)) {
												ss=maxpoc_stanic
								   minpoc_stanic=as.numeric( unlist( strsplit(ss,";", fixed=TRUE) )[1] )
								   maxpoc_stanic=as.numeric( unlist( strsplit(ss,";", fixed=TRUE) )[2] )
																	} else {
									maxpoc_stanic=as.numeric(maxpoc_stanic)								
									minpoc_stanic=0
																			} 

											# *pokud se to zada jako negativni, tak se to vezme jako minimalni hodnota								
									  if (maxpoc_stanic<0) {  # &&zadane zaporne
												minpoc_stanic=-maxpoc_stanic
												maxpoc_stanic=1e10
															} 
									  if (minpoc_stanic>0) k_minpoc_stanic=T

print(paste(""))
print(paste("  Minimum number of stations: ",minpoc_stanic))			
print(paste("  Maximum number of stations: ",maxpoc_stanic))			
# print(paste(""))
			
			
			
			
									  

			limit_distance=(as.character(a_controls[3]))	
								#toto je pro>  (n_pd_function=="7/2/0")
										limit_distance=gsub(",",";",limit_distance,fixed=TRUE)
										if (grepl(";",limit_distance)) {
												ss=limit_distance
								   limit_distance=as.numeric( unlist( strsplit(ss,";", fixed=TRUE) )[1] )
								   limit_correlation=as.numeric( unlist( strsplit(ss,";", fixed=TRUE) )[2] )
																	} else {
									limit_distance=as.numeric(limit_distance)								
									limit_correlation=missval
																			} 
								if (n_pd_function=="7/1/0") {
										#correlations, je to naopak
										ii_pom=limit_correlation
										limit_correlation=limit_distance
										limit_distance=ii_pom
															}											
										
										
					if ((limit_correlation>1)&(abs(limit_distance)<=1)) {
						#swithes it
						ii_pom=limit_distance
					  limit_distance=limit_correlation
					  limit_correlation=ii_pom
																}
																
					if ((limit_distance)<0) {
					limist_near_distance=abs(limit_distance)												
print(paste("  Distance limit - minimum: ",limist_near_distance))	
							limit_distance=1e10
											}											
																
print(paste(""))
print(paste("  Distance limit: ",limit_distance))			
print(paste("  Correlation limit: ",limit_correlation))			
# print(paste(""))
								

								
								

								

			limit_diffs_altitude=as.numeric(as.character(a_controls[4]))
			if (limit_diffs_altitude<=1) {
print_my("Altitude difference of neighbours: used as ratio" , limit_diffs_altitude , k_add_print_=TRUE)			
										  }
# &output=&output+"Neighbours can differ in altitude "+;
      # IIF(limit_diffs_altitude<0,'at least: '+ALLTRIM(STR(-limit_diffs_altitude)),'maximum: '+ALLTRIM(STR(limit_diffs_altitude)))+' m '+CHR(13)+CHR(10)

			
			k_clever_altitude_sel=as.numeric(as.character(a_controls[5]))
# if (k_clever_altitude_sel) print()			
# '   The last '+TRANSFORM(koef_data_verified)+'% of neighbours are selected in the way that IQR (using ngb. altitudes) of base stattion altitude is below '+;   TRANSFORM(m.koef_1_5)+
					
		
# stop("stop here before reading periods settings")

			
				ss_begin_all=a_controls[ 6 ]
				if (ss_begin_all=="0") ss_begin_all=""
			ss_begin=as.numeric(ss_begin_all)
				if (is.na(ss_begin)) ss_begin=0 
			
				ss_end_all=a_controls[ 7 ]
				if (ss_end_all=="0") ss_end_all=""
			ss_end=as.numeric(ss_end_all)
				if (is.na(ss_end)) ss_end=0
				
				if (all(ss_begin<1000)) { ss_periods_all=ss_begin_all ; ss_begin_all="" ; ss_begin=0 }
				if (all(ss_end  <1000)) { ss_overlap_all=ss_end_all ; ss_end_all="" ; ss_end=0 }
			ss_periods=as.numeric(ss_periods_all)
				if (is.na(ss_periods)) ss_periods=0
			ss_overlap=as.numeric(ss_overlap_all)
				if (is.na(ss_overlap)) ss_overlap=0
						
									
			k_celeobd_korel=as.numeric(as.character(a_controls[8]))  #common period
			
			
										# ss_column_COR="KMEAN"
								if (n_pd_function=="7/1/0") {	
										ss_column_COR=a_controls[10] #KMEAN
															}				
			
			# k_the_same_region=T
			k_the_same_region=as.numeric(as.character(a_controls[13]))
			

			k_plot=FALSE #at nevykresluje nic pri korelacich ...	
			
#			k_plot=(as.numeric(as.character(a_controls[ 20 + k_program_day])))
				# k_plot=ifelse(k_plot==1,T,F)
#			if( k_plot==1) k_plot=T else k_plot=F
			# plotkind="pdf"
			# plotkind="png"
#			plotkind=(as.character(a_controls[ 21 + k_program_day]))
			
			
						} #if ((n_pd_function=="7/1/0")|(n_pd_function=="7/2/0"))
					#nnnnnnnnnnnnnnnnnngggggggggggggggbbbbbbbbbbbbbbbbbbbbbb
					
			if (n_pd_function=="7/1/0")	{
							if (file.exists(file_corr)) {
										
		# if (tolower(file_extension(file_corr))=="csv") {
		#	system.time( data_corr <- read.csv2( file_corr , header = TRUE, sep = ";" , stringsAsFactors=FALSE,  check.names=FALSE) )  
		#												} else {
		#	data_corr=my__read_dbf(file_corr, remove.x=T, delete=T, read_MFD=T, k_del_NA=T , k_convert_codepage=T )
		#	names(data_corr)=toupper(names(data_corr))												
		#														}

			data_corr=Read_file_dbf_csv(file_corr   ,
							k_the_same_region=k_the_same_region, k_CSV=k_CSV, k_use_marked_deleted=k_use_marked_deleted  ,
							print_output=(k_supress_output_all_possible==FALSE) )
																
			data_corr_DT=data.table(data_corr)
			
					ss_pom=c("ID_1","ID_2","BEGIN","END",ss_column_COR)
					ss_pom=ss_pom[ ss_pom %in% names(data_corr_DT) ]
				data_corr_DT=data_corr_DT[ , ss_pom , with=FALSE]
			
			rm("data_corr")
														} #if (file.exists(file_corr))
										} #if (n_pd_function=="7/1/0")  
 

 
 
 

###############################################					
					
					
					
					




					#nnnnnnnnnnnnnnnnnngggggggggggggggbbbbbbbbbbbbbbbbbbbbbb2
 if ((n_pd_function=="3/15/0")) {

 
data_file=a_files[1]
file_info=a_files[2]



grid_points=a_files[3]


#file_out=a_files[3]
# file_stat=a_files[3]    #output-neighbours,  does not make sense here
	# file_stat="void"
file_stat2=a_files[4]  #neighbour info	
   
   				
			maxpoc_stanic=(as.character(a_controls[1]))		
										maxpoc_stanic=gsub(",",";",maxpoc_stanic,fixed=TRUE)
										if (grepl(";",maxpoc_stanic)) {
												ss=maxpoc_stanic
								   minpoc_stanic=as.numeric( unlist( strsplit(ss,";", fixed=TRUE) )[1] )
								   maxpoc_stanic=as.numeric( unlist( strsplit(ss,";", fixed=TRUE) )[2] )
																	} else {
									maxpoc_stanic=as.numeric(maxpoc_stanic)								
									minpoc_stanic=0
																			} 

											# *pokud se to zada jako negativni, tak se to vezme jako minimalni hodnota								
									  if (maxpoc_stanic<0) {  # &&zadane zaporne
												minpoc_stanic=-maxpoc_stanic
												maxpoc_stanic=1e10
															} 
									  if (minpoc_stanic>0) k_minpoc_stanic=T

print(paste(""))
print(paste("  Minimum number of stations: ",minpoc_stanic))			
print(paste("  Maximum number of stations: ",maxpoc_stanic))			
# print(paste(""))
			
			
															 

			limit_distance=(as.character(a_controls[2]))	
								#toto je pro>  (n_pd_function=="7/2/0")
										limit_distance=gsub(",",";",limit_distance,fixed=TRUE)
										if (grepl(";",limit_distance)) {
												ss=limit_distance
								   limit_distance=as.numeric( unlist( strsplit(ss,";", fixed=TRUE) )[1] )
								   limit_diffs_altitude=as.numeric( unlist( strsplit(ss,";", fixed=TRUE) )[2] )
																	} else {
									limit_distance=as.numeric(limit_distance)								
									limit_diffs_altitude=missval
																			} 
							
																
print(paste(""))
print(paste("  Distance limit: ",limit_distance))			
print(paste("  Altitude difference limit: ",limit_diffs_altitude))			
# print(paste(""))
								


								
								

			# limit_diffs_altitude=as.numeric(as.character(a_controls[4]))
			if (limit_diffs_altitude<=1) {
print_my("Altitude difference of neighbours: used as ratio" , limit_diffs_altitude , k_add_print_=TRUE)			
										  }

			
			k_clever_altitude_sel=0
			
			
				ss_begin_all=a_controls[ 3 ]
				if (ss_begin_all=="0") ss_begin_all=""
			ss_begin=as.numeric(ss_begin_all)
				if (is.na(ss_begin)) ss_begin=0 
			
				ss_end_all=a_controls[ 4 ]
				if (ss_end_all=="0") ss_end_all=""
			ss_end=as.numeric(ss_end_all)
				if (is.na(ss_end)) ss_end=0 
				
				if (all(ss_begin<1000)) { ss_periods_all=ss_begin_all ; ss_begin_all="" ; ss_begin=0}
				if (all(ss_end  <1000)) { ss_overlap_all=ss_end_all ; ss_end_all="" ; ss_end=0}
			ss_periods=as.numeric(ss_periods_all)
				if (is.na(ss_periods)) ss_periods=0
			ss_overlap=as.numeric(ss_overlap_all)
				if (is.na(ss_overlap)) ss_overlap=0
						
									
			k_celeobd_korel=as.numeric(as.character(a_controls[5]))  #common period
			
			
			k_the_same_region=TRUE  # used for distinguish from grid points
			# k_the_same_region=as.numeric(as.character(a_controls[13]))
			

			k_plot=FALSE #at nevykresluje nic pri korelacich ...	
			
#			k_plot=(as.numeric(as.character(a_controls[ 20 + k_program_day])))
				# k_plot=ifelse(k_plot==1,T,F)
#			if( k_plot==1) k_plot=T else k_plot=F
			# plotkind="pdf"
			# plotkind="png"
#			plotkind=(as.character(a_controls[ 21 + k_program_day]))
			
			
						} #if ((n_pd_function=="3/15/0"))
					#nnnnnnnnnnnnnnnnnngggggggggggggggbbbbbbbbbbbbbbbbbbbbbb2
						
	

	
						
###############################################						
					
					
					
		# n_transformation=100 #differences
		
		std_nasobek_limit=1.96					
		# std_nasobek_limit=std_nasobek
		limit_confidence=0.95

		
		k_first_differences=TRUE

		
		k_standardizace_AVG=FALSE	
		k_standardizace_STD=FALSE	
		k_stand_AVG_STD= ((k_standardizace_AVG)|(k_standardizace_STD))
				
		k_standardize_Altitude=TRUE		
		k_regr_individually=TRUE		
		
		k_add_interquartile_range_coeff=TRUE
				
							

		deter_correct=0  #&&kor_deter   regression correction
		# deter_correct=val(opt13)  #&&oprava pomoci determinacniho keofficientu, 1 - oprava, 0 puvodni lin. regrese ciste       
			
		val_CDF_outliers_check=0.999	
			
		k_outliers_check=TRUE	
			
		# Max. percentage for Expected values calculated from non-standardized values
		prc_min_flag_o=100
		
		# QC_commands, 
			# SETTINGS/prg/run_neighbours_QC_batch.prg
			

		k_add_expected_value=TRUE		
			

neighbour_info=""



					#nnnnnnnnnnnnnnnnnngggggggggggggggbbbbbbbbbbbbbbbbbbbbbb
 if (n_pd_function=="7/4/0") {

 
data_file=a_files[1]
file_info=a_files[2]

file_info_time=a_files[3]  
neighbour_info=a_files[4]  


#file_out=a_files[3]
file_stat=a_files[5]  
file_stat2=a_files[6]  


###

      
# k_add_differences	
	

			std_nasobek=limit_confidence	
		# limit_confidence
		 if ((std_nasobek>0)&(std_nasobek<1)) {
				#je to too sided,  tak 0.95 musi prevest na jine ...
				std_nasobek=std_nasobek+ ((1-std_nasobek)/2)
   std_nasobek_limit=qnorm(std_nasobek)  #anvnrm(m.std_nasobek+((1-m.std_nasobek)/2))  &&je to oboustranne, tak misto .95 je .975
if (k_supress_output_all_possible==FALSE) {
print_my("Limit - double side: ",std_nasobek)   
print_my("Limit for values (standardized normal distribution): ", round(std_nasobek_limit,3))   
										  }
											}
		
		
		# ifelse(k_program_day==0,3,8)
		ii_pom=0
		if (k_program_day==0) ii_pom=-2
		

		k_add_stand_column=as.numeric(as.character(a_controls[ii_pom+7])) # IIF(val(opt7)=1,.T.,.F.)
   if (k_add_stand_column==T) {
    k_tranform_added_cols=as.numeric(as.character(a_controls[ii_pom+8])) # IIF(val(opt8)=1,.T.,.F.)
		if (k_tranform_added_cols==F) n_transformation=100 #differences
    # k_stand_AVG_STD_withoutOUT=IIF(val(opt9)=1,.T.,.F.)  &&hodnoty najite pri porovanni jako podezrele nebudou pouzity k vypoctu AVG a STD
								}

      k_standardizace_AVG=as.numeric(as.character(a_controls[ii_pom+10])) # IIF(val(opt10)=1,.T.,.F.)
      k_standardizace_STD=as.numeric(as.character(a_controls[ii_pom+11])) # IIF(val(opt11)=1,.T.,.F.)
		# *<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
		k_stand_AVG_STD= ((k_standardizace_AVG)|(k_standardizace_STD))
		# *<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

		# "Standardize to ALTitude ", k_Standardize_to_ALTitude	
    k_standardize_Altitude=as.numeric(as.character(a_controls[ii_pom+12])) # IIF(val(opt12)=1,.T.,.F.)
	
		# "Regr. for indiv. cases ", k_Regr_for_indiv_cases
    k_regr_individually=as.numeric(as.character(a_controls[ii_pom+13])) # IIF(val(opt13)=1,.T.,.F.)

	
		# "1 station - apply monhly AVG(+STD)", k_1_station_apply_monhly_AVG
     k_regr_individually_dopln_stand=as.numeric(as.character(a_controls[ii_pom+14])) # IIF(val(opt14)=1,.T.,.F.) 
	# *control values, during individual regression, if neibhours altitude are similar, but base station altitude is very different ... then the regression does not work well - and is not performed
		# kontrola hodnot, kdyz je individ. regrese - okolni stanice moc blizko s nadm. vyskou a base je uplne jinde...  moc blbe ..., 
	# or, other case:  to get expected value even in case when the only station (neighbour) is available (thus regression cannot be calculated), the value of the neighbour will be standardized with monthly AVG (and possibly STD); 	
		# flag=S

		# "Regression correction ", n_Regression_correction	
    deter_correct=as.numeric(as.character(a_controls[ii_pom+15])) # val(opt15)  
		# correction by means of determination coefficient, 1 - full correction, 0 - original linear regression, 
			# oprava pomoci determinacniho keofficientu, 1 - oprava, 0 puvodni lin. regrese ciste

	# *    k_control_distance_stand_vals=k_regr_individually      &&<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
     k_outliers_check=as.numeric(as.character(a_controls[ii_pom+16])) # IIF(val(opt16)=1,.T.,.F.)  &&.T.
				# Standardized neighbours values can be checked (comparing with original values of all neighbours) if they are not outliers 
          val_CDF_outliers_check=as.numeric(as.character(a_controls[ii_pom+17])) # VAL(opt17)
				# CDF values for the outliers check, 
				# if CDF  of  (diff. of standardized and original neighbour values / STD orig. values), of a particular neighbours exceeds the limit (is outlier), it is replaced with original  i.e. non standardized value (and Flag_regr column is O). 
	
	
  k_add_interquartile_range_coeff=as.numeric(as.character(a_controls[ii_pom+18])) # IIF(val(opt16)=1,.T.,.F.)
		# adds CDF_b_sMed -  probability (CDF) of base station compared to median from standardized (to altitute) neighbours		
  k_add_expected_value=as.numeric(as.character(a_controls[ii_pom+19])) # IIF(val(opt17)=1,.T.,.F.)
		# calculating expected value
  power_weights_dist=as.numeric(as.character(a_controls[ii_pom+20])) # val(opt18)
		# expected values are calcualted as weighting average with distances, distance is used with the specified power
    
 # k_trimmed_mean=IIF(val(opt19)=1,.T.,.F.)   &&spocte tz koncove statitiky jenom pro missvals
  # trimmed_mean_percentage_low=val(opt20)
  # trimmed_mean_percentage_high=0
   n_limits_repeated_duplicated=as.numeric(as.character(a_controls[ii_pom+21]))
   if (n_limits_repeated_duplicated==TRUE) {
		#repeated values, repeated,  limit of the number of the same values ...
		n_same_values=(as.character(a_controls[ii_pom+22]))

										n_same_values=gsub(",",";",n_same_values,fixed=TRUE)
										if (grepl(";",n_same_values)) {
												ss=n_same_values
												ss=unlist( strsplit(ss,";", fixed=TRUE) )
								   n_same_values=as.numeric( ss[1] )
								   n_same_values_0=as.numeric( ss[2] )
								   n_same_values_dupl=as.numeric( ss[3] )
																	} else {
									n_same_values=as.numeric(n_same_values)								
									n_same_values_0=n_same_values
									n_same_values_dupl=n_same_values_0
																			} 
										if (is.na(n_same_values_0)) n_same_values_0=n_same_values
										if (is.na(n_same_values_dupl)) n_same_values_dupl=n_same_values_0
											} # if (n_limits_repeated_duplicated==TRUE) 
		
	
					} #if (n_pd_function=="7/4/0")	
					#nnnnnnnnnnnnnnnnnngggggggggggggggbbbbbbbbbbbbbbbbbbbbbb
	

	
	
					#nnnnnnnnnnnnnnnnnngggggggggggggggbbbbbbbbbbbbbbbbbbbbbb	
 if ((n_pd_function=="7/4/0")|(n_pd_function=="3/16/0")) {
	
	
		k_check_thesame_vals=TRUE	# both   base station    and     the same base and neighbour (the same differences)
			n_same_values=n_same_values # 10 # 5  #repeating values, repeated,  limit of the number of the same values ...
				# n_same_values_0=31  #repeating values, repeated,  limit of the number of the the same values ...
				n_same_values_0=n_same_values_0 # 60 # 41  #repeating 0 values, repeated,  limit of the the number of the 0 values ...
			# n_same_values_transformation=30  #repeating values in case of precipitation ...
			
print("")			
print_my("Settings for repeated and duplicated values:")			
print_my(" limit (number) of repeated (non-zero) values: ", n_same_values)			
print_my(" limit (number) of repeated (Zero) values: ", n_same_values_0)
print_my(" limit (number) of duplicated values (the same ngb): ", n_same_values_dupl)
print("")			
			
			# if (k_tranform_added_cols)  n_same_values=n_same_values_transformation

			# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
		max_QC_result=6 # 7 #8 #7 #6  #maximum		   max_QC_result
				# 5 too many,  6 too few
				# maximum is 7,  6-7 is error,  3,4,5 - suspicious,  used for plots
				max_QC_result_suspicous_per=40 #percentage,  previous absolute value: 3/7
				# QC_res_per - in percentage
			# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
			
			
	n_days_around=5	 # for  Make_plots_QC function in rprog\functions_corr.r
	
	
	k_remove_aux_colums=k_remove_aux_colums # 0
		if (n_pd_function=="3/16/0") k_remove_aux_colums=1
	
	k_save_Auxl_into_Temp=TRUE
	
	
	k_plot=TRUE
	k_plot_suspicious=TRUE
	

	
	# limit_regr_deter - defined later
	
					} # if ((n_pd_function=="7/4/0")|(n_pd_function=="3/16/0"))
					#nnnnnnnnnnnnnnnnnngggggggggggggggbbbbbbbbbbbbbbbbbbbbbb
	

	
	
	
###############################################	




					#nnnnnnnnnnnnnnnnnngggggggggggggggbbbbbbbbbbbbbbbbbbbbbb
 if (n_pd_function=="3/16/0") {} #if (n_pd_function=="3/16/0")	
					#nnnnnnnnnnnnnnnnnngggggggggggggggbbbbbbbbbbbbbbbbbbbbbb
		


if (k_supress_output_all_possible==FALSE) {
print("")		
print("")		
print("")		
											}

###############################################	

###############################################	

###############################################	
		
	
	
	
	
	
	if (any(ls()=="file_stat2")) {		
	if (nchar(file_stat2)>0) {
		if (tolower(file_extension(file_stat2))=="csv") {		
			k_CSV=TRUE
if (k_supress_output_all_possible==FALSE) print_my("Outputs will be saved as CSV files", k_add_print_=TRUE)			
			file_stat2=gsub( file_extension(file_stat2,k_leave_dot=2), paste(".dbf",sep="") , file_stat2 , ignore.case = TRUE)		
				}
							} # if (nchar(file_stat2)>0)
	file_stat2_orig=file_stat2
								}	


	if (any(ls()=="file_stat"))	
	if (nchar(file_stat)>0) {
		if (tolower(file_extension(file_stat))=="csv") {		
			k_CSV=TRUE
if (k_supress_output_all_possible==FALSE) print_my("Outputs will be saved as CSV files", k_add_print_=TRUE)
			file_stat=gsub( file_extension(file_stat,k_leave_dot=2), paste(".dbf",sep="") , file_stat , ignore.case = TRUE)		
				}
							} # if (nchar(file_stat)>0)
	
	
	
	
# stop("stop after reading parameter settings")

#################################################	



	ss_idcol_pom=(as.character(a_controls[ length(a_controls)-1 ]))
	if (ss_idcol_pom!="1") ss_idcol=ss_idcol_pom
		# ss_idcol_pom=="1" -  single ID, otherwise,  Multi ID
							

			if (nchar(ss_idcol)>0)		{		
	ss_idcol=gsub("[+]",",",ss_idcol)
	ss_idcol=gsub("[;]",",",ss_idcol)
ss_idcol=unlist(strsplit(ss_idcol,','))
										} else {
											ss_idcol=character()
												}	
	ss_region=gsub("[+]",",",ss_region)
	ss_region=gsub("[;]",",",ss_region)
ss_region=unlist(strsplit(ss_region,','))






  
########  
  
#data=read.dbf(data_file,as.is=T)




########################################################





# stop("stop here: before reading data")




#prepares data
# DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDdd

# if ( (n_pd_function=="4/3/0")|(n_pd_function=="7/4/0") ) {

			
			if (any(ls()=="group_rda"))  rm(group_rda)
			if (any(ls()=="data_out_group"))  rm(data_out_group)			
			if (any(ls()=="data_out_ct_group"))  rm(data_out_ct_group)

				
				
		data=NA
		
 # if (file.exists(data_file)) { 
 if (nchar(data_file)>0) { 
  
			
print_my("Reading data file: ",data_file)

# stop("stop here before reading data file")   

		# data=my__read_dbf(data_file, remove.x=T, delete=F, read_MFD=T, k_del_NA=FALSE , k_convert_codepage=T)
		
		# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
		data=Read_file_dbf_csv(file_info=data_file, k_delete=TRUE, k_check_info_file=FALSE, k_check_data_file=TRUE, k_save_adjusted=FALSE , k_DataTable=FALSE , 
			k_the_same_region=k_the_same_region, k_CSV=k_CSV, k_use_marked_deleted=k_use_marked_deleted  ,
							print_output=(k_supress_output_all_possible==FALSE) )
				# file_info=data_file; k_delete=TRUE; k_check_info_file=FALSE; k_check_data_file=TRUE; k_save_adjusted=FALSE ; k_DataTable=FALSE 
				
		# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
					
print("")
					
								}
# stop("stop here after rading data ...")	

				
#######
					    
			
#get rids of empty columns,
#data=data_frame_remove_NA_cols(data) # already in my__read_dbf
  

  
		k_columns_regions=FALSE  #presumes months or days in columns ...
	
			# ii_pom= ncol(data) - sum( c("ID","YEAR","MONTH","DAY","TIME","ELEMENT","REGION") %in% names(data) )
			# ii_cols_= which( ( c("ID","YEAR","MONTH","DAY","TIME","ELEMENT","REGION","EG_EL_ABBR") %in% names(data) ) )
		
		# ii_cols_id = match( c("ID","ELEMENT","REGION","EG_EL_ABBR") , names(data) ) 
		ii_cols_id = lapply ( c("ID","ELEMENT","REGION","EG_EL_ABBR","MODEL","VERSION","SOURC","SCENAR","ENSEMBLE") , function(x) which(grepl(x,names(data) )) ) 
		ii_cols_id=sort(unlist(ii_cols_id))
				
			ii_cols_id=ii_cols_id[!is.na(ii_cols_id)]
		ii_cols_time = match( c("YEAR","MONTH","DAY","TIME") , names(data) )
			ii_cols_time=ii_cols_time[!is.na(ii_cols_time)]

			if (all(is.na(data))) n_col=0 else n_col=ncol(data)	
		ii_cols_regions= setdiff( (1:n_col) , c(ii_cols_id,ii_cols_time) )
		
		
			# what to exclude from the cols of "regions"
			ii_cols_exclude = lapply ( c("NO_CASES") , function(x) which(grepl(x,names(data) )) ) 
			ii_cols_exclude=sort(unlist(ii_cols_exclude))
			if (length(ii_cols_exclude)>0) {
				ii_cols_regions=ii_cols_regions[-(which(ii_cols_exclude==ii_cols_regions))]
											}
									
		
			# for monthly data, columns should not be used as groups	
			k_pom=TRUE
			k_pom2=( length( unique( gsub("[0-9]","", names(data)[ii_cols_regions] ) ) ) > 1 )
			if ((!("DAY" %in% names(data)))&(!("MONTH" %in% names(data)))&(k_pom2==TRUE)) {
					k_pom=FALSE
					k_program_day=0 #k_monthly=TRUE
																						   }
		
		if (k_pom==TRUE) if (k_pom2==TRUE) {
			k_columns_regions=TRUE
if (k_supress_output_all_possible==FALSE) 
print_my("Data structure: Elements or ... (generally value columns) are given in individual columns",k_add_print_=TRUE)			
		#																			} 
															}
	
	
#######
  
  
# stop("stop here, beginning")


			#upper case, converted to proper name ...
		ii_pom=match(toupper("x_Suffix"),names(data) )
		if (!is.na(ii_pom)) names(data)[ii_pom]="x_Suffix"	 
  
		# if ("x_Suffix" %in% idcol) {
		if ("x_Suffix" %in% names(data)) {
			# take care about NA ... later,  for data_DT
										 }

		
	
	
		#finds where number are not present in the column names
	ii_d_c=grep("[0-9]",names(data), ignore.case=TRUE,  invert=TRUE)
	
		if (k_columns_regions==TRUE) ii_d_c=setdiff( ii_d_c , ii_cols_regions )
	
	ii_d_d=grep("ID",names(data), ignore.case=TRUE)
		names_ID=names(data)[ii_d_d]
	
	idcol=names(data)[ sort(union(ii_d_d,ii_d_c)) ]
      if (length(ss_idcol)>0) idcol=ss_idcol
	  if ((length(ss_idcol)>0)&(all(ss_idcol=="1"))) idcol=names_ID[1]
	  

	 
	
	 
		 #sloupce, co existuji jenom necha ...
for (ff in ss_region) { if (!ff %in% names(data)) { ss_region[ss_region==ff]=NA; ss_region=ss_region[!is.na(ss_region)] } }
		 
for (ff in idcol) { if (!ff %in% names(data)) { idcol[idcol==ff]=NA; idcol=idcol[!is.na(idcol)] } }
		 
		 

		 
# stop("stop here before data processing")


					#ddddddddddddddddddddddddddd
		ss_group=ss_region
		names_measure=NA
		
 if (!(all(is.na(data)))) {
				
if (k_save_auxiliary_files==TRUE)
print_my("Retrieving info from data file ... ")
				
	#when numbers are in column names, takes it as data columns ...
	#ii_d_v=grep("N", substr(names(data_DT),1,nchar("N")) , ignore.case=TRUE)
	#ii_d_v=grep("VAL",names(data), ignore.case=TRUE)
	ii_d_v=grep("VAL", substr(names(data),1,nchar("VAL")) , ignore.case=TRUE)  #to be valid just in the beginning of the name, not in the middle,  
		names_measure=names(data)[ii_d_v]
			#if (length(ii_d_v)>0) ii_d_v=ii_d_v[1]
			#if (length(ii_d_v)>0) names_measure=names(data)[( ii_d_v:length(names(data)) )]
		
		if (length(names_measure)==0) { #zkusi N
				ii_d_v=grep("N", substr(names(data),1,nchar("N")) , ignore.case=TRUE)  #to be valid just in the beginning of the name, not in the middle,  
				if (length(ii_d_v)>0) names_measure=names(data)[ii_d_v] else ii_d_v=integer()
									  }
				
			names_measure=names_measure[!is.na(names_measure)]	

	  if ((length(names_measure)==0)&(length(ii_cols_regions)==1))	{
			k_columns_regions=TRUE
print_my("Data structure: Elements or ... (value columns) are given in one column", k_add_print_=TRUE)			
																	}									
									
		if ((k_columns_regions==TRUE)) {
			names_measure=names(data)[ii_cols_regions]
			ii_d_v=match( names_measure , names(data) ) 
										}
									
		
			k_dec=FALSE
#			if (find_value_in_data(data,-9999)) {
#				k_dec=TRUE
#print_my("Value columns will be divided by 10", k_add_print_=TRUE)							
#												}

			
		#if another type than Numeric, gives it away
		if (length(names_measure)>=1) {
					#names_measure=names(data)
		   for  (ii in (1:length(names_measure)) )  {
			        #print( paste("Column ", names_measure[ii] ," mode: ", mode( data[,names_measure[ii]] ) ) )					
			  if ( ( mode( data[,names_measure[ii]] )!="numeric") )  { #ii_c=c(ii_c,ii) #removes given columns, empty and non-numeric, 
					if (k_CSV) {
					
			        if (k_supress_output_all_possible==FALSE) 
					print_my( "Column ", names_measure[ii] ," of the original CSV file converted to Numeric data type" )
					
					if (is.data.table(data)) {
							ii_pom=which( names(data) %in% names_measure[ii] )							
						data[[ii_pom]] = as.numeric( data[[ii_pom]] )
											} else {
						data[,names_measure[ii]]=as.numeric( data[,names_measure[ii]] )
													}
								} else {
			        
					if (k_supress_output_all_possible==FALSE) 
					print( paste("Column ", names_measure[ii] ," removed from list of measure variables") )
										
					names_measure[ii]=NA    
										} # if (k_CSV)
															} # if ( ( mode( data[,names_measure[ii]] )!="numeric") )
									
				if (!is.na(names_measure[ii])) {
									
					if (k_dec==TRUE) data[,names_measure[ii]]=data[,names_measure[ii]]/10
									
					#converts -999.9
					if (is.data.table(data)) {	
					data[[ names_measure[ii] ]][ data[[ names_measure[ii] ]]==-999.9 | (is.na(data[[ names_measure[ii] ]])) ]=missval
					data[[ names_measure[ii] ]][ data[[ names_measure[ii] ]]==-9999  | (is.na(data[[ names_measure[ii] ]])) ]=missval
					data[[ names_measure[ii] ]][ data[[ names_measure[ii] ]]==-999  | (is.na(data[[ names_measure[ii] ]])) ]=missval
					# data[[ names_measure[ii] ]][ data[[ names_measure[ii] ]]==-99  | (is.na(data[[ names_measure[ii] ]])) ]=missval
											 } else {
					data[ data[, names_measure[ii] ]==-999.9 | (is.na(data[, names_measure[ii] ])) , names_measure[ii] ]=missval
					data[ data[, names_measure[ii] ]==-9999  | (is.na(data[, names_measure[ii] ])) , names_measure[ii] ]=missval
					data[ data[, names_measure[ii] ]==-999  | (is.na(data[, names_measure[ii] ])) , names_measure[ii] ]=missval
					# data[ data[, names_measure[ii] ]==-99  | (is.na(data[, names_measure[ii] ])) , names_measure[ii] ]=missval
													}
															
												} # if (!is.na(names_measure[ii]))															
															
											} #for 
		names_measure=names_measure[!is.na(names_measure)]
									  } #if (length(names_measure)>=1)

				
	
		# removes from idcol, what is measure variable, 
		ii_double=match(names_measure,idcol)
		ii_double=ii_double[!is.na(ii_double)]
			if (length(ii_double)>0) {
			
				if (k_supress_output_all_possible==FALSE) 
				print_my("These columns removed from (multi) ID: ",(idcol[ii_double]) ) 
																			
				idcol=idcol[-ii_double]
									}

		ss_group=ss_region								
		# removes from idcol, what is measure variable,
		ii_date=match( c("YEAR","MONTH","DAY"),idcol)
		ii_date=ii_date[!is.na(ii_date)]
			if (length(ii_date)>0) {
			
				if (k_supress_output_all_possible==FALSE)
				print_my("Columns removed from (multi) ID: ", (idcol[ii_date])  )
				
				ss_group=c(ss_group,idcol[ii_date])	# napr. "YEAR"  "MONTH",   ale at je to bez dne
						# ii_day=match( c("DAY"),ss_group)
						# if (length(ii_day)>0) ss_group=ss_group[-ii_day]
				idcol=idcol[-ii_date]			    # napr.   "ID"     "REGION"
									}

		# and removes the last column, e.g. rem ..., a jeste da pryc posledni sloupce - napr. rem,  atp.
				if (length(ii_d_v)>0) { 
		ii_too_far=match( names(data)[min(ii_d_v):length(names(data))] ,idcol)
		ii_too_far=ii_too_far[!is.na(ii_too_far)]
			if (length(ii_too_far)>0) { 
			
				if (k_supress_output_all_possible==FALSE)
				print_my("Last columns removed from (multi) ID: " , (idcol[ii_too_far]) )
				
				idcol=idcol[-ii_too_far]
										}
										} #if (length(ii_d_v)>0)					
		
		
		
		
		 
if (k_supress_output_all_possible==FALSE) {
print("")		 
print("ID columns (multi ID):")
	idcol=unique(idcol)
print(idcol)		 
print("")		 
print("Region:")
	ss_region=unique(ss_region)
print(ss_region)		 
print("")		 
print("Group:")
	ss_group=unique(ss_group)
print(ss_group)		 
											}

		 
if (length(idcol)==0) {
	# stop("No ID is given ...")
	warning("No ID is given ...")
					   }



if (k_supress_output_all_possible==FALSE) {
print("")		 
print("Names of measure variables:")
print(names_measure)
										  }
		


			# osetri missing value ... various codes ...
			for (ii_pom in names_measure) {
				# je to uz vyse ...				
										   }

										 										 
										 
		
	if (tolower(file_extension(data_file))=="dbf") {} else {
			# if csv, saves it as .dbf now ...
		
			# saves to .dbf
			data_file=filename2(data_file, extension="dbf")
			
				k_pom=NULL
				if ("MFD" %in% names(data)) k_pom=as.numeric(data$MFD)
				
#			my__write_dbf( data , data_file , print_output=TRUE , mfd=k_pom )
			
#print_my("Input data file saved as .dbf file: ",data_file)			
													} # if (file_extension(data_file)=="dbf")
	
 									
		
		
					 } #if (!(is.na(data)))
					#ddddddddddddddddddddddddddd
		 



###########
# stop("stop here after reading data")





		 

		 
##################
		 
	 
		 
data_DT=as.data.table(data)
setkeyv(data_DT,c(idcol))  #ss_region

#missval
	if (any(data_DT==missval, na.rm=TRUE)) data_DT[data_DT==missval]=NA
	
	
		# if ("x_Suffix" %in% idcol) {
	if ("x_Suffix" %in% names(data_DT)) {
		# take care about NA
		data_DT[ is.na(x_Suffix) , x_Suffix:="" ]	
										 }
	
	

							
							
#######

							
					
														

# stop("stop here after reading data")

data_DT_puv=data_DT

rm("data")

													 #	} #if ( (n_pd_function=="4/3/0")|(n_pd_function=="7/4/0") )

# DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDdd













# iiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

# stop("stop here before reading info_file")

# for 1/1, it takes it as well, since  file_info=file_geogr
if ((file.exists(file_info))) { 
							} else {
	k_plot_only_nearest=FALSE #jinak to nevykresli nic
	
	# checks avalability:
	if ( (!(file.exists(data_file))) & all(is.na(data_DT)) ) {
	
print_my("  info_file: ",file_info)	
print_my("  data_file: ",data_file)	
if (k_ECAD_mode==TRUE) {
	# warning(paste("Warning: no info_file nor data_file  is  available", file_info, data_file))
	print_my("Warning: no info_file nor data_file  is  available, info file:", file_info, ", data file: ",data_file, k_warning=TRUE)
	# sink()
	# break
	n_pd_function=""
		file_info=""
		data_file=""
		# data_DT=NA
		data_DT[]=0
					   } else {
	stop("An error: no info_file nor data_file  is  available")
								}
																}
	
	
									}


		k_use_marked_deleted=FALSE
										
	data_info_DT_puv=NA									

		#fffffffffffffffffffffffffff
if ((file.exists(file_info))
	# &(!(n_pd_function=="1/1/0"))  file_geogr=file_info
							) { #&(1==0)

print("")							
print_my("Reading info_file: ",file_info)
  
# stop("stop here before reading file_info")     
			# fffffffffffffffeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeee
					# v: R\Read_DBF\rprog\functions_corr.r
  data_info_DT=Read_file_dbf_csv(file_info, k_delete=FALSE, k_check_info_file=TRUE, k_check_data_file=FALSE, k_save_adjusted=TRUE , k_DataTable=TRUE , k_the_same_region=k_the_same_region, k_CSV=k_CSV, k_use_marked_deleted=k_use_marked_deleted  ,
							print_output=(k_supress_output_all_possible==FALSE) ) #(k_supress_output_all_possible==FALSE)
							# print_output=k_verbose ) #(k_supress_output_all_possible==FALSE)
			#    k_delete=FALSE; k_check_info_file=TRUE; k_check_data_file=FALSE; k_save_adjusted=TRUE ; k_DataTable=TRUE ; k_the_same_region=k_the_same_region; k_CSV=k_CSV; k_use_marked_deleted=k_use_marked_deleted
			# fffffffffffffffeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeee
	
																																	
 
 
 

					 # bbbbbbbbbbbbgggggggggggggggggggggggggggggggggggggggggggggggggggggggggggg
					# for 3/15, adds file with grid points ...
					if (n_pd_function=="3/15/0") {
					
print("Reading grid_points file:")	
			# fffffffffffffffeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeee
			data_info2=Read_file_dbf_csv( file_info=grid_points, k_delete=FALSE, k_check_info_file=TRUE, k_check_data_file=FALSE, k_save_adjusted=TRUE , k_DataTable=TRUE , k_the_same_region=k_the_same_region, k_CSV=k_CSV, k_use_marked_deleted=k_use_marked_deleted  ,
							print_output=(k_supress_output_all_possible==FALSE) )
			# fffffffffffffffeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeee						
						
						# repeats REGION cases
								# if Begin and End is present in input file, takes just Region
						if (all( c("REGION","BEGIN","END") %in% names(data_info2) )) {
							ii_pom=match( c("REGION"),names(data_info_DT) )
print_my("Region column cases will be repeated for all the grid points ...")	
																					} else {
								# otherwise takes Region,Begin and End
							ii_pom=match( c("REGION","BEGIN","END"),names(data_info_DT) )
print_my("Region,Begin,End columns cases will be repeated for all the grid points ...")	
																							}
								ii_pom=ii_pom[!is.na(ii_pom)]
						ss_regions_cases=NA
								# cccccccccccccccccccc
						if (length(ii_pom)>0) {
							ss_regions_cases=unique( data_info_DT[, ii_pom , with=FALSE] )
								
									# cccccccssssssssssss
							# check consistency:
							if ( length(unique(ss_regions_cases[[1]]))!=dim(ss_regions_cases)[1] ) {
print_my("Beware: Number of unique regions (in info_file): ",length(unique(ss_regions_cases[[1]])),", but number of Region,Begin,End unique cases: ",dim(ss_regions_cases)[1], k_warning=TRUE)			
print("")				
print(unique(ss_regions_cases[[1]]))				
print("")				
print(" vs. ")				
print(ss_regions_cases)				
print("")				
																								  } 
									# cccccccssssssssssss
												
												# data_info2[,REGION:=NULL]
							#	if (!("REGION" %in% names(data_info2))) data_info2[,REGION:=""]
							#	merge_my(data_info2,ss_regions_cases,ss_by="REGION")
							
								# cbind(data_info2[1,],ss_regions_cases)	
								data_info2 = cbind_repeate_with_rows( data_to_join=data_info2 , ss_cases=ss_regions_cases )	
							
												} # if (length(ii_pom)>0) 
								# cccccccccccccccccccc
							
					######	
						
						
						
					# binds it together:	
						if ("MFD" %in% names(data_info_DT)) data_info_DT=data_info_DT[ MFD==FALSE, ]
					data_info_DT[ , MFD:=TRUE ]
					
						if ("MFD" %in% names(data_info2)) data_info2=data_info2[ MFD==FALSE, ]
					data_info2[ , MFD:=FALSE]
					
					# binding together
					l = list( data_info_DT , data_info2 )
					data_info_DT=rbindlist(l, fill=TRUE)
					if (exists("l")) rm(l)
			
print("")			
print_my(" Info_file and grid_points were bound together ...")
					 if (k_CSV) {
				file_out_pom=gsub("[.]dbf",paste("",".csv", sep=""),file_info, ignore.case = TRUE)				  
		  # write.csv2( data_info_DT , file=file_out_pom, na="", row.names = FALSE)
		  write.table( data_info_DT , file=file_out_pom, na="", row.names = FALSE , sep=";", dec=Sys.localeconv()[1] )
								} else {
				file_out_pom=gsub( "[.]dbf" ,"__with_grids.dbf", file_info , ignore.case = TRUE)				  			
		  my__write_dbf( data_info_DT , file_out_pom ,  n_dec=3, print_output=FALSE )								
								
										}
print_my(" Saved into: ", file_out_pom)
					
												} # if (n_pd_function=="3/15/0")
					 # bbbbbbbbbbbbgggggggggggggggggggggggggggggggggggggggggggggggggggggggggggg
					 
 
 
 
 
	#musi najit ID
	ii_idcol=1
	ii_idcol=which( names(data_info_DT)=="ID_ORIG" )
		if (length(ii_idcol)==0) ii_idcol=which( names(data_info_DT)=="ID" )
		if (length(ii_idcol)==0) { ii_idcol=grep("ID" , names(data_info_DT), fixed=TRUE) #ignore.case=TRUE, 
						if (length(ii_idcol)>1) ii_idcol=ii_idcol[1]
									}
	
		
	


	data_info_DT_puv=data_info_DT


					
							} #if ((file.exists(file_info))
		#fffffffffffffffffffffffffff
							

# iiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF



				
				
				
				
				
##########################################				
##########################################				
##########################################				
				


				
			ss_region_puv=ss_region
		#	name_COLUMN_puv=name_COLUMN #="COLUMN"


			ss_group_orig=ss_group	
			names_measure_orig=names_measure
		
			# idcol_orig=idcol  - later
			
				
# stop("stop here before group")				
				
				
				k_force_groups=FALSE  #for 7/4 to decide how to work with group and neighbour_info consistency
			#ggggggg groups sGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGG

				ngb_info_DT=NA	
			
#checks the neighb_info file, its consistency with data	
				if ( (n_pd_function=="7/4/0")|(n_pd_function=="3/16/0") ) {
																			
					if (file.exists(neighbour_info)) {
				  	
				
			if ((ss_idcol_pom!="1")&(length(idcol)>1)) {
							# nnnnnnnnnnnnnnnnnnnnnnnnnnnnn
							
							
				#EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE
					# cases of data:
					ss_pom=ss_pom=apply(  data_DT[ , idcol, with=FALSE] ,1, paste, collapse="_")
					ss_pom=unique(ss_pom)
					ss_pom=paste("_",ss_pom,"_", sep="")				
					
					
					# neigbhour info file cases:		
				#	ngb_info=my__read_dbf(neighbour_info, T , delete=T , read_MFD=T , k_del_NA=F , k_convert_codepage=T )				
				#	names(ngb_info)=toupper(names(ngb_info))
				#	ngb_info_DT=as.data.table(ngb_info)
	
						ngb_info_DT=Read_file_dbf_csv(file_info=neighbour_info, k_delete=TRUE, k_check_info_file=FALSE, k_check_data_file=FALSE, k_save_adjusted=FALSE , k_DataTable=TRUE , 
							k_the_same_region=k_the_same_region, k_CSV=k_CSV, k_use_marked_deleted=k_use_marked_deleted ,
							print_output=(k_supress_output_all_possible==FALSE) , k_check_ngb_info=TRUE  ) # , k_NA_to_blank=TRUE
	
		
						stan_base=as.character(ngb_info_DT$ID_1) # ngb_info_DT_sel$ID_1[1]
						ngb_info_cases=stan_base
						
						a_region=""
							if ("REGION" %in% names(ngb_info_DT)) {
						a_region=ngb_info_DT$REGION # ngb_info_DT_sel$ID_1[1]
								if (is.na(a_region)) a_region=""
						ngb_info_cases=paste(stan_base,a_region, sep="_")
																   }
						ngb_info_cases=ngb_info_cases[(!is.na(stan_base)) & (!is.na(a_region))]
					
						ngb_info_cases=paste("_",ngb_info_cases,"_", sep="")				
					##################
					
					
					#now compares ...  data and ngb info file
					
						# is the same name
					 if ( sum(  ngb_info_cases %in% ss_pom ,na.rm=TRUE) == 0 ) {
					
						# is part of it?
					  for (ii_pom in (1:(length(ngb_info_cases))) ) {
					   if ( sum(  grepl( ngb_info_cases[ii_pom] , ss_pom , fixed=TRUE)  ,na.rm=TRUE) > 0 ) {
print("")					   
print("")					   
print("Neighbour_info: contains only partial information from the data file") 
print("Data files groups will be processed one by one ... ") 
print("")					   
print("")					   
				k_force_groups=TRUE				
	break # next # <<<<<<<<<<<<<<<<<<<<<<<<<<<<<< 				
																				           } 
																    }	
																			 } else {
# print("Neighbour_info  is  all right - consistent with the data file ")																			 
																					 }
					
			
					
						} # if ((ss_idcol_pom!="1")&(length(idcol)>1)) 
			# nnnnnnnnnnnnnnnnnnnnnnnnnnnnn


														}  else { #if (file.exists(neighbour_info))
# if (is.na(ngb_info_DT)) {
	# warning(paste("Warning:  no data for 7/4 ... ", file_info, data_file))
	print_my("Warning:  no  ngb_info file, neighbour_info: ", neighbour_info , k_warning=TRUE)
	# sink()
	# return()
	# rm(data_out)
	n_pd_function=""
		file_info=""
		data_file=""
		# data_DT=NA
		data_DT[]=0
		ss_periods_all=""		
#						}	 
																 }
																 
													} # if ( (n_pd_function=="7/4/0")|(n_pd_function=="3/16/0") ) 
			
			
			
			
			if (ss_idcol_pom!="1") 
				if ( (n_pd_function=="3/15/0") ) 
					if (file.exists(file_info)) {
					if ("REGION" %in% names(data_info_DT)) {
print("")					   
print("Info_file: values in Region column will be processed individially") 
print("")					   
				k_force_groups=TRUE				
															}
												}
			
			
			
			
			
			
# stop("stop here after initial file preparation")			
			
			

				
###################################			
												

		
			#ssssssss periods sSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
			
							ss_begin_all=gsub(",",";",ss_begin_all)#strednik za carku
							ss_begin_all=gsub(" ","",ss_begin_all) #mezery pryc
							ss_begin_all=unlist(strsplit(ss_begin_all,";", fixed=TRUE)) #fixed=FALSE - regular expression
							ss_begin_all=ss_begin_all[ss_begin_all!=""]
							
							ss_end_all=gsub(",",";",ss_end_all)#strednik za carku
							ss_end_all=gsub(" ","",ss_end_all) #mezery pryc
							ss_end_all=unlist(strsplit(ss_end_all,";", fixed=TRUE)) #fixed=FALSE - regular expression
							ss_end_all=ss_end_all[ss_end_all!=""]
														
			
				#ss_periods_all="1981-2010,2011- 2040"				
				ss_periods_all=gsub(",",";",ss_periods_all)#strednik za carku
				ss_periods_all=gsub(" ","",ss_periods_all) #mezery pryc
				ss_periods_all=unlist(strsplit(ss_periods_all,";", fixed=TRUE)) #fixed=FALSE - regular expression
				

# stop("stop here before period")				
				
													
						if ((length(ss_begin_all)>1)&(length(ss_end_all)>1)) {
							if ( (length(ss_begin_all))==(length(ss_end_all)>1) ) {
							ss_periods_all=paste(ss_begin_all,"-",ss_end_all, sep="")
print( "Periods created from End and period length " )
# print(ss_periods_all)
																				   }
																			} else 	{ #else
																					
						if (length(ss_begin_all)>1) {
							if ( length( ss_periods_all[ss_periods_all!=""] )>0 ) {
							ss_periods_all=paste(ss_begin_all,"-",as.character( as.numeric(ss_begin_all)+as.numeric(ss_periods_all)-1 ), sep="")
print( "Periods created from Begin and period length " )
# print(ss_periods_all)
																					}
													} else {  #else2
						if (length(ss_end_all)>1) {
							if ( length( ss_periods_all[ss_periods_all!=""] )>0 ) 	{
							ss_periods_all=paste(ss_end_all,"-",as.character( as.numeric(ss_end_all)-as.numeric(ss_periods_all)+1 ), sep="")
print( "Periods created from End and period length " )
# print(ss_periods_all)	
																					}
													}	else   {  # else3
										#when it is equal to one			
									if ( (any(nchar( ss_periods_all )>=1)) 
      									 | (n_pd_function=="7/1/0") 
      									 | (n_pd_function=="7/2/0") 
										 | (n_pd_function=="3/15/0")
																	) {  # elseXX 
										# pppppppppppppppppppppppppppp
														
														
												# ppp22222222
											# if ((file.exists(file_info))) {
												if (any(ls()=="data_info_DT")) {
														# ss_group_idcol=REGION...
															if ("MFD" %in% names(data_info_DT)) {
													 begin_all=min( data_info_DT[MFD==0,]$BEGIN , na.rm=TRUE )
													 end_all=  max( data_info_DT[MFD==0,]$END , na.rm=TRUE ) 
																								} else {
													 begin_all=min( data_info_DT$BEGIN , na.rm=TRUE )
													 end_all=  max( data_info_DT$END , na.rm=TRUE ) 
																										}
													 
															#round to decades
														if (class(begin_all)=="Date") begin_all=as.numeric(format(begin_all, format = "%Y")) 
														if (class(end_all)  =="Date") end_all  =as.numeric(format(  end_all, format = "%Y"))
														
														if (class(begin_all)=="character") begin_all=as.numeric(format( as.Date(begin_all), format = "%Y")) 
														if (class(end_all)  =="character") end_all  =as.numeric(format(  as.Date(end_all), format = "%Y"))
														
														begin_all_=10*floor(begin_all/10)   # signif(begin_all,3) # round
														end_all_  =10*ceiling(end_all/10)
														
if (k_supress_output_all_possible==FALSE)
print( "Periods created from data_info file, over all begin and end in info_file" )
														
													if (length(ss_begin_all)==0) ss_begin_all=begin_all_+1 #to get 1961 etc.
													if (length(ss_end_all  )==0) ss_end_all  =end_all_
														#overi, ze begin je ok
													
													# if nothing for period was specified in 7/2, it is created here ...
														year_begin=begin_all
														year_end  =end_all
															date_begin=as.Date(ISOdate(year_begin, 1, 1))					
															date_end  =as.Date(ISOdate(year_end, 12, 31))
															
if (k_supress_output_all_possible==FALSE)															
print_my("Overall period in the data (from data_info): ",year_begin,"-",year_end, k_add_print_=TRUE)
																		  } else   {
												if (any(ls()=="data_DT")) {							
												# finds the period from data ...
#													ss_group_idcol=idcol
#	data_info_DT2=data_DT[, list( BEGIN=min( as.numeric(YEAR) ), END=max(as.numeric(YEAR)) , LENGTH=sum(VALUE2*0+1, na.rm=TRUE)+sum(is.na(VALUE2)), MISS_CNT=sum( (VALUE2==missval)|is.na(VALUE2))  ) , by=ss_group_idcol ]
																		  } else {
																				 }	
																					}	
												# ppp22222222
												
											# now it is, 	ss_periods=as.numeric(ss_periods_all)	
									if ( ( length( ss_periods_all[ss_periods_all!=""] )>0 ) 
										& (any(nchar( ss_periods_all )>=1)) )  { # ss_periods_all="-"  it has length equal one
												n_step_years=as.numeric(ss_periods_all)
												n_overlap=0
# print_my(ss_periods_all)												
# stop("stop here when making periods")	
													if (any(nchar( ss_overlap_all )>=1)) {
														n_overlap=as.numeric(ss_overlap_all)
														if (n_overlap==1) { 
														ss_begin_all=ss_begin_all-1 #overlap, begins from 1960 instead of 1961 etc.
																		  } else {
														n_step_years=n_step_years-n_overlap
																				  }	
																						} #if (any(nchar( ss_overlap_all )>1))
											
											
												# if (length(ss_periods_all)==1) {}											
											i_per = seq(as.numeric(ss_begin_all[1]),as.numeric(ss_end_all[1]), by=n_step_years )
											
											
													#takse care if the end suits well, ze konec sedi ...
													#check the end periods (1920,1940 etc., not 1930, 1950 ...)
													if ( ! ( (as.numeric(ss_end_all[1])-n_step_years+(ifelse(n_overlap==1,0,1)) ) %in% i_per) ) {
														# sets the new begin, to get the right end, in the end
																ss_begin_all[1]=ss_end_all[1]
														while ( ss_begin_all[1]>begin_all ) {
																ss_begin_all[1]=ss_begin_all[1]-n_step_years
																							} # while
																ss_begin_all=ss_begin_all[1]+1							
print_my("Begin period adjusted to get the right end: ",ss_begin_all, "(end: ",ss_end_all,")")
											i_per = seq(as.numeric(ss_begin_all[1]),as.numeric(ss_end_all[1]), by=n_step_years )												
																								  } # if ( !(as.numeric(ss_end_all[1]-n_step_years+1) %in% i_per))
																								  
																								  
									        # ss_periods_all=paste(i_per,"-", i_per + n_step_years -1, sep="")
															if (n_overlap==1) n_step_years=n_step_years+1
									        ss_periods_all = paste(i_per,"-", i_per + n_step_years -1, sep="")
																						  }
																																											# pppppppppppppppppppppppppppp
																				} # elseXX					
																									
																} # else3		
															} #else2
																					
																						  } #else
				
		
  if (length(ss_periods_all)>0)
  if (k_supress_output_all_possible==FALSE) {	
print("Periods to be processed: ")
print(ss_periods_all)
										    }
											
													
# stop("stop here before period")				
				
				#ppppppppppppppppppppppppppppppppppppp
				#nechane zase dale ...				
				#ppppppppppppppppppppppppppppppppppppp


			
			k_period=0
		
			if (length(ss_periods_all)==0) ss_periods_all=""
			if (length(ss_periods_all)==1) if (ss_periods_all=="-") ss_periods_all=""
			if (length(ss_periods_all)==0) ss_periods_all=""
			
			#ssssssss periods sSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS



			
			if (length(ss_periods_all)>0) {
			  if (any(ls()=="data_info_DT")) data_info_DT_puv=data_info_DT  #kvuli periods
			  if (any(ls()=="maxpoc_stanic")) maxpoc_stanic_puv=maxpoc_stanic
			  
					file_stat_orig=file_stat
					file_stat2_orig=file_stat2
			  
										  }

			

				
###################################			
						
			
			
			
			
			
			
			
			
			
			
			
# stop("stop here before loops")			
			
			
			
			
			# divides  idcol
			# if (length(idcol)>1) { 
			# if (1==0) { 
			# if (((length(ss_idcol_pom)>0)&(all(ss_idcol_pom=="1")))) {  #if ((length(ss_idcol)>0)&(all(ss_idcol=="1"))) idcol=names_ID[1] 
					# ss_idcol_pom=="1" -  single ID, otherwise,  Multi ID
			# if ( (ss_idcol_pom!="1")&(length(idcol)>1) & (k_force_groups==TRUE) ) {
			if ( ((ss_idcol_pom!="1")&(length(idcol)>1)) | (k_force_groups==TRUE) ) {
		
					idcol_group=idcol[-1] # without the first
					if ("x_Suffix" %in% idcol_group) idcol_group=idcol_group[-(which("x_Suffix"==idcol_group))]
					
					
					if (n_pd_function=="3/15/0") {
						# it will utilize data_DT, even if only data_info_DT makes sense for this function
						idcol_group="REGION"
						data_DT=data_info_DT[]
						data_DT_puv=data_DT
												} 
												
print_my("Applying groups for data  based on these columns: ",idcol_group)
					# data_DT_puv=data_DT   -  data_DT_puv is used
					# ss_group_col_data = apply(  data_DT[ , paste(idcol_group), with=FALSE] ,1,paste, collapse="_")
					ss_group_col_data = apply(  data_DT[ , (idcol_group), with=FALSE] ,1,paste, collapse="_")
						# ss_group_col_data_original=ss_group_col_data
					groups_=unique(ss_group_col_data)
												
												
					# ss_pom=apply(  data_DT_puv[ , idcol_group, with=FALSE] ,1, paste, collapse="_")
					# ss_pom=unique(ss_pom)
					data_groups_all=paste("_",groups_,"_", sep="")				
					
					file_stat_orig=file_stat
					file_stat2_orig=file_stat2
																											
								} else { 
						# 111111111111111cccccccccccccccccccol		
					
					#puts away additional columns - it could make a problem for cross-table later ...
					if (length(idcol)>1) {
						idcol_group=idcol[-1] # without the first
						idcol=idcol[1]
print_my("Using only single ID (",idcol,"), and removing this column from data file (multi ID is not switched): ",idcol_group, k_warning=TRUE)
# Using only single ID (ID), and removing this columns from data file: REGION
								# ss_pom=names(data_DT)
								# ii_pom=match(idcol_group,ss_pom)
								# if (length(ii_pom)>0) ss_pom=ss_pom[-ii_pom]
								# data_DT[ , (ss_pom), with=FALSE]
								if (length(idcol_group)>0) {
									data_DT[ , c(idcol_group) :=NULL ] #remove several columns at once,  delete column
									
									# bacha, at neodstrani tako YEAR
									ii_pom=(match(idcol_group,ss_group))
									ii_pom=ii_pom[!is.na(ii_pom)]	
							   if (length(ii_pom)>0) ss_group=ss_group[-ii_pom]	
									ii_pom=(match(idcol_group,ss_group_orig))
									ii_pom=ii_pom[!is.na(ii_pom)]	
							   if (length(ii_pom)>0) ss_group_orig=ss_group_orig[-ii_pom]
								
															} 															
										 } # if (length(idcol)>1)

					idcol_group=NA
					groups_=NA
										 
						# 111111111111111cccccccccccccccccccol		
										}  #((ss_idcol_pom!="1")&(length(idcol)>1))
										
										
																				
# stop("stop here - before groups estimation")



			
		#	if ((n_pd_function=="7/1/0")|(n_pd_function=="7/2/0")) {
						# region se osetri primo v tom, jak se tvori distances ...
		#		if ("REGION" %in% names(data_info_DT))
		#		ss_group_col_data=unique(data_info_DT$REGION)
		#		groups_=unique(ss_group_col_data)
		#															}


			if (k_columns_regions==TRUE) {
					
						# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
					#removes empty columns 
					#zbavi se prazdnych sloupcu
						# Columns with NA values were removed: 
					data_DT=data_frame_remove_NA_cols(data_DT)
						# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
						
						names_measure=names_measure[names_measure %in% names(data_DT)]
					ss_group_col_data=names_measure
					groups_=names_measure

					data_DT_puv=data_DT # <<<<<<<<<<<<<<<<<<<<<, UPDATE
					
						if (length(ss_group_col_data)==1) {
							k_columns_regions=FALSE

							idcol_group=NA
							groups_=NA
															}
					
					# ss_group_orig=ss_group	
					names_measure_orig=names_measure
										
										
print_my("Taking groups from column names (",groups_,")", k_warning=FALSE , k_add_print_=TRUE )
										  }
										


###################


# stop("stop here - groups selection")


		# checks the regions to process ...
			# ccccccccccccckkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkk
		if (length(idcol)>1) {
		
			ss_pom=NA
		if (any(ls()=="ngb_info_DT")) if ("REGION" %in% names(ngb_info_DT)) ss_pom=unique(ngb_info_DT$REGION)
		if (all(is.na(ss_pom)))
			if (any(ls()=="data_info_DT")) if ("REGION" %in% names(data_info_DT)) ss_pom=unique(data_info_DT$REGION)
		
		
			if (!all(is.na(ss_pom))) {
				if ( (all(!is.na(idcol_group)))  ) { # if (nchar(a_region)>0) {   # NE: | (k_columns_regions)
					
				# a_region=unique(ngb_info_DT_sel$REGION) # ngb_info_DT_sel$ID_1[1]
				  a_region=ss_pom
					if (is.na(a_region)) a_region=""
		
					# data_groups_all
				#checks data
					k_pom=( data_groups_all %in%  paste("_",a_region,"_", sep="") )
				  if ( (sum( k_pom )>0) & (sum( k_pom )<length(k_pom)) )  {
				  
					# ggggggggggggggggggggggggggggg
				  if (dim(data_DT)[1]==length(ss_group_col_data)) {
				  
	print_my("   Only fraction of groups (Region) is defined in the info file compared to data file: ",sum( k_pom ), " / ",length(k_pom),", data file will be made smaller", k_warning=TRUE)
	
					# data_DT=data_DT[ (ss_group_col_data %in% (paste("_",a_region,"_", sep="")) ) , ]
					data_DT=data_DT[ ( (paste("_",ss_group_col_data,"_", sep="")) %in% (paste("_",a_region,"_", sep="")) ) , ]

					
					# re-new variables	
					ss_group_col_data = apply(  data_DT[ , (idcol_group), with=FALSE] ,1,paste, collapse="_")
					groups_=unique(ss_group_col_data)
												
					# ss_pom=apply(  data_DT_puv[ , idcol_group, with=FALSE] ,1, paste, collapse="_")
					# ss_pom=unique(ss_pom)
					data_groups_all=paste("_",groups_,"_", sep="")				
	
									
																	
																  } else {
																  
print_my("   Dimension of data file and generated groups does noe match (for sub-selection) ... ", k_warning=TRUE)
																	  
																  
																		} #  if (dim(data_DT)[1]==length(ss_group_col_data))
					# ggggggggggggggggggggggggggggg
																	
																	} # if ( (sum( k_pom )>0) & (sum( k_pom )<length(k_pom)) )
																	
													} # if ( (all(!is.na(idcol_group)))  )
			
									 } # if (all(is.na(ss_pom))) 

							 } # if (length(idcol)>1)
			# ccccccccccccckkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkk



###################





										
										
if (file.exists(file_stat_orig)) { 
		if (k_supress_output_all_possible==FALSE)
		print_my("File ", file_stat_orig, " removed")  
		
		file.remove(file_stat_orig) 	
								}
if (file.exists(file_stat2_orig)) { 
		if (k_supress_output_all_possible==FALSE)
		print_my("File ", file_stat2_orig, " removed")  
		
		file.remove(file_stat2_orig) 
									}




			# earlier:
			# ss_region_puv=ss_region
			# ss_group_orig=ss_group	
			# names_measure_orig=names_measure

			
			idcol_orig=idcol
										
												
			# ggggggggggggggggggggggggggggggggggggggggggggggggggggggggggg
			for (grp in groups_) {

# grp=groups_[2]

	#if (grp=="rcp45_cnrm-cerfacs-cnrm-cm5_r1i1p1_clmcom-cclm4-8-17_v1_CRU_T") {
 # stop("stop here before sel group")						
	#																	}

			
				ss_group=ss_group_orig
				names_measure=names_measure_orig

				# if ("x_Suffix" %in% idcol) idcol=idcol[-match("x_Suffix",idcol)]
				idcol=idcol_orig #"x_Suffix" je tam navic ...
				
			
				data_group=""	
			
if (k_supress_output_all_possible==FALSE) {
print("")
print("")										
											}
print("----------")										
					if (all(!is.na(idcol_group))) {

# progress_bar
print_my("Processing group: ",grp," ( ",which(grp==groups_)," / ",length(groups_)," ) ")					
print("")
							data_DT=data_DT_puv[ grp==apply(  data_DT_puv[ , (idcol_group), with=FALSE] ,1,paste, collapse="_") , ]
# print(data_DT)							

					data_DT__orig_group=data_DT  #_orig_grp
					if (any(ls()=="data_info_DT")) data_info_DT__orig_group=data_info_DT   # data_info_DT  may not exist yeat (insitu)



					# ss_pom=apply(  data_DT_puv[ , idcol_group, with=FALSE] ,1, paste, collapse="_")
					data_group=apply(  data_DT[ , idcol_group, with=FALSE] ,1, paste, collapse="_") #data_DT_puv
					data_group=unique(data_group)
					data_group=paste("_",data_group,"_", sep="")				


											 } # if (all(!is.na(idcol_group)))

			
###			
				
			if (k_columns_regions) {
print_my("Processing group (column): ",grp," ( ",which(grp==groups_)," / ",length(groups_)," ) ")					
print("")
					data_DT=data_DT_puv[]  # used also later ...
					data_DT__orig_group=data_DT  #_orig_grp
					if (any(ls()=="data_info_DT")) data_info_DT__orig_group=data_info_DT   # data_info_DT  may not exist yeat (insitu)
								
					data_group=paste("_",grp,"_", sep="")
					
									} # if (k_columns_regions)	 
			
			
			
			# chooses also the given region in Info_file
		#		regions se tvori primo u distances
			# if (n_pd_function=="7/2/0")
			#<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
		#	if (any(ls()=="data_info_DT_puv")) 
		#	if ("REGION" %in% names(data_info_DT_puv)) data_info_DT=data_info_DT_puv[ REGION==grp , ] # else data_info_DT=NA	
			#<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
			
			
			
###			
			
			if ( (all(!is.na(idcol_group)))	| (k_columns_regions) ) {
#					if (all(!is.na(idcol_group))) { #			# for (grp in groups_) { # ggggggggggggggggggggggggggggggggggggggggggggggggggggggggg2
# print_my("Processing group: ",grp)			
					if (nchar(file_stat_orig)>0) {
				file_stat = gsub( file_extension(file_stat_orig,k_leave_dot=2), paste("-",grp,".dbf",sep="") , file_stat_orig , ignore.case = TRUE)
				file_stat=adjust_filename(file_stat, char_repl="_" , k_path_care=TRUE)
				#								 } else {
				#file_stat=file_stat_orig				  
														}
#											 }

#					if (all(!is.na(idcol_group))) { #			# for (grp in groups_) { # ggggggggggggggggggggggggggggggggggggggggggggggggggggggggg2
# print_my("Processing group: ",grp)	
					if (nchar(file_stat2_orig)>0) {
				file_stat2 = gsub( file_extension(file_stat2_orig,k_leave_dot=2), paste("-",grp,".dbf",sep="") , file_stat2_orig , ignore.case = TRUE)
				file_stat2=adjust_filename(file_stat2, char_repl="_" , k_path_care=TRUE)
				#								  } else {
				#file_stat2=file_stat2_orig								  
															}
				
				
				file_stat__orig_group=file_stat
				file_stat2__orig_group=file_stat2
				
																	} # if ( (all(!is.na(idcol_group)))	| (k_columns_regions) )
		  			
							
				
				
				
				
				
				
				
			
			
			
			#ssssssss periods sSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS



# stop("stop here - before periods")			
			
			
			
	#prepares various periods, 
				##############################################################PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP
	for (period_ii in ss_periods_all) {
	
			ss_region=ss_region_puv
		#	name_COLUMN=name_COLUMN_puv
			
			#period_ii=ss_periods_all[1]
			k_period=0
			#year_begin=0
			#year_end=0
	
			
				# (any(nchar( ss_periods_all )>=1))
		if ( (length(ss_periods_all)>=1) & (nchar(period_ii)!=0) & ( length(grep("-",period_ii,ignore.case=TRUE))==1 ) ) {
		
			k_period=1
		 year_begin=as.numeric( substr(period_ii, 1, grep("-", unlist(strsplit(period_ii ,'')))-1) )
		 year_end=	as.numeric( substr(period_ii, grep("-", unlist(strsplit(period_ii ,'')))+1 , nchar(period_ii) )	)
			date_begin=as.Date(ISOdate(year_begin, 1, 1))					
			date_end  =as.Date(ISOdate(year_end, 12, 31))
				
print("")
print("---------------------------------------------------")
#print("========================================================")
			# if (length(ss_periods_all)>1) {
			if ( length( ss_periods_all[ss_periods_all!=""] )>0 ) { 
# progress_bar			
				
					#in case of group, let the progress be the group ...
				if ( (all(!is.na(idcol_group))) | (k_columns_regions) ) ss_pom="" else ss_pom=paste(" ( ",which(period_ii==ss_periods_all) ," / ",length(ss_periods_all)," ) ", sep="")
print(paste("Period to process: ",year_begin,'-',year_end, ss_pom , sep=""))	


			
		if ( (all(!is.na(idcol_group))) | (k_columns_regions) ) {
				
				# data_DT_puv already applied
		data_DT=data_DT__orig_group[]
		if (any(ls()=="data_info_DT__orig_group")) data_info_DT=data_info_DT__orig_group[] else data_info_DT=NA

			#musi pouzit to ulozene z group, pokud zaroven pracuje s periodama, tam se uz totiz neco nastavilo
		file_stat=file_stat__orig_group
		file_stat2=file_stat2__orig_group
		
									  } else {
		data_DT=data_DT_puv[]
		if (any(ls()=="data_info_DT_puv")) data_info_DT=data_info_DT_puv[] else data_info_DT=NA
											}
											
											
		ss_group=ss_group_orig
		names_measure=names_measure_orig
		
		# if ("x_Suffix" %in% idcol) idcol=idcol[-match("x_Suffix",idcol)]
		idcol=idcol_orig #"x_Suffix" je tam navic ...
		
		
		# period selection is performed later
		# period selectin - later vyber obdobi pozdeji
			# data_DT[dd<data_DT$BEGIN | dd>data_DT$END]=NULL
		

# print("")
# print_my("Cycle: ",which((period_ii==ss_periods_all)))
# print("Data_info:")
# print(data_info_DT)		
# stop("stop here before creating output files")

			if (nchar(file_stat_orig)>0) {
					ss_pom=file_stat_orig
					if ( (all(!is.na(idcol_group))) | (k_columns_regions) ) ss_pom=file_stat #combination with group name
				file_stat = gsub( file_extension(ss_pom,k_leave_dot=2), paste("_",year_begin,"-",year_end,".dbf",sep="") , ss_pom , ignore.case = TRUE)
				file_stat=filename_with_Temp( file_stat , k_save_Auxl_into_Temp=TRUE )
				file_stat=adjust_filename(file_stat, char_repl="_" , k_path_care=TRUE)
print_my("Preparing output file: ",file_stat)				
											}
			if (nchar(file_stat2_orig)>0) {
					ss_pom=file_stat2_orig
					if ( (all(!is.na(idcol_group))) | (k_columns_regions) ) ss_pom=file_stat2 #combination with group name
				file_stat2 = gsub( file_extension(ss_pom,k_leave_dot=2), paste("_",year_begin,"-",year_end,".dbf",sep="") , ss_pom , ignore.case = TRUE)
				file_stat2=filename_with_Temp( file_stat2 , k_save_Auxl_into_Temp=TRUE )
				file_stat2=adjust_filename(file_stat2, char_repl="_" , k_path_care=TRUE)
print_my("Preparing output file: ",file_stat2)				
											}
				


											} else {
print(paste("Period to process: ",year_begin,'-',year_end, sep=""))	
													}
print("")


								
												   
																						}	else {
								
		#data_DT=data_DT_puv
		
																									} 
	


# stop("stop here, period")	 
	
				
				
				
				
				
				
#######################################################################################################################  
#######################################################################################################################  
				
				
# stop("stop here, before CT")	
				
		
########  
  
			name_COLUMN=""
			names_measure_puv=names_measure
  
  
  
			# MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
	if (any(!is.na(names_measure))) {
  

							day_stM=""
						if ( ("MONTH" %in% names(data_DT)) & ( length(names_measure)>=28 ) )  {
							if (!("DAY" %in% names(data_DT))) { 
										day_stM="dd"
										k_program_day=1
																}
																							  }
																											
						#	mes_stM=""																				
						# if ( ("DAY" %in% names(data_DT)) & ( length(names_measure)>=12 ) & ( length(names_measure)<20 ) )  {
						#	mes_stM="mm"
						#																					}
							mes_stM=""
						if (!("MONTH" %in% names(data_DT)))	{
						if ( ( length(names_measure)>=12 ) & ( length(names_measure)<20 ) )  {
							if ("DAY" %in% names(data_DT)) {
								mes_stM="mm"
								if (k_program_day==0) k_program_day=1								
															} else {
								mes_stM="mm"
								# only monthly values - monthly mode?
								if ( !("DAY" %in% names(data_DT)) & !("MONTH" %in% names(data_DT)) ) {
								k_program_day=0 #k_monthly=TRUE
print_my("Monthly mode detected in data, months are in columns ...",k_add_print_=TRUE)								
																									  }				
																	}
																							  }
															}
						
						
							
						#col col cccccccccccccccccccccccccccccccccccccccccccc								
						# if ( ("MONTH" %in% names(data_DT)) & ( length( grep("31", names(data_DT) , ignore.case=TRUE))>0  ) ) {
					      if ( ( (day_stM=="dd")|(mes_stM=="mm") ) ) {  # (k_program_day!=0) &
							
							#prevede to, one column
		#1col 1col 1col 1col 1col 1col 1col 1col 1col 1col 1col 1col 1col 1col 1col 1col 1col 1col 
# data_DT_1col=melt(data_DT, id.vars=idcol_all, variable.name="COLUMN", value.name="VALUE2")
			if (day_stM=="dd") name_COLUMN="DAY"
			if (mes_stM=="mm") name_COLUMN="MONTH"
print(idcol)			
				# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
data_DT_1col=melt(data_DT, id.vars=c(ss_group,idcol), measure.vars=names_measure, variable.name=name_COLUMN, value.name="VALUE2")
				# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
print("")
print("1col created")	
	# setkeyv(data_DT_1col,c(idcol))
	setkeyv(data_DT_1col,c(ss_group,idcol))
	
	# re-orders
	data_DT_1col=Change_Column_order(data_DT_1col, c("YEAR","MONTH","DAY","TIME","VALUE2"),1000)
	
	
		#1col 1col 1col 1col 1col 1col 1col 1col 1col 1col 1col 1col 1col 1col 1col 1col 1col 1col 
		
			
			# removes all characters, odstrani vsechna pismena
				data_DT_1col_COLUMN=as.vector( unique(data_DT_1col[[name_COLUMN]] ) )
				data_DT_1col_COLUMN2=gsub("[a-z]","",data_DT_1col_COLUMN,ignore.case=TRUE)
				data_DT_1col_COLUMN2=gsub("[_]","",data_DT_1col_COLUMN2,ignore.case=TRUE)
				data_DT_1col_COLUMN2=data_DT_1col_COLUMN2[!nchar(data_DT_1col_COLUMN2)==0]
				
				if ( (!(all(is.na(data_DT_1col_COLUMN)))) & (length(data_DT_1col_COLUMN)==length(data_DT_1col_COLUMN2)) ) {				
			data_DT_1col=data_DT_1col[, col:=as.numeric( gsub("[a-z]","",data_DT_1col[[name_COLUMN]],ignore.case=TRUE) ) ]

			if (day_stM=="dd") data_DT_1col[, DAY:=col]			
			if (mes_stM=="mm") data_DT_1col[, MONTH:=col]			
			data_DT_1col[, c("col"):=NULL]
																				} #if length 
		
		
		
												} else {
							
							# eeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeee		
							
				if (k_columns_regions==TRUE)	{
					names_measure=grp
if (k_supress_output_all_possible==FALSE) print_my("For further processing, taking single column ", grp)
			
# stop("stop here before removing columns ...")			
						# removes other group columns from data
							ii_pom=match( groups_[!(groups_ %in% grp)] ,names(data_DT))
									# if the column has been removed, for NAs, it has to remove it as well ...
							# ii_pom=match( groups_[!(ss_group_col_data_original %in% grp)] ,names(data_DT))
									# solved through udpated data_DT_puv
							if (length(ii_pom)>0)
					data_DT=data_DT[ , -(ii_pom) , with=FALSE ]
											   }
											   
			#rename column ...
			if (length(names_measure)==1) {
					if (names_measure!="VALUE2") {
				setnames(data_DT, names_measure, "VALUE2" )
				names_measure="VALUE2"
if (k_supress_output_all_possible==FALSE) print_my("  ... renamed as ",names_measure)
												 }
											} 
					
													
			# <<<<<<<<<<<<<<<<<<<<<<<<<<<
			data_DT_1col=data_DT
			# <<<<<<<<<<<<<<<<<<<<<<<<<<<
								# eeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeee				
			
														} 
						#col col cccccccccccccccccccccccccccccccccccccccccccc								
				


				

###############2
	
# stop("stop here before 1-1 (1/1/0) function")	
# print("being before 1-1 (1/1/0) function ")																										 
			
			
				data_DT_1col_puv=data_DT_1col
					# data_DT_1col=data_DT_1col_puv[]
			
###
	# if (length(ss_periods_all)>1) {
	if ( length( ss_periods_all[ss_periods_all!=""] )>0 ) {
print_my("Selecting period: ", period_ii)
		  # removes period outside ..., 
		  
	data_DT_1col=data_DT_1col[ YEAR>=year_begin & YEAR<=year_end , ]
	
									} 												

									
###			
			
			
			if ("DAY" %in% names(data_DT_1col)) {
			data_DT_1col=data_DT_1col[ Existing_Date( YEAR, MONTH, DAY ) | (!is.na(VALUE2)) , ]				
												}
						
			#removes missing values	
			if (k_do_not_remove_NA==FALSE) {
if (k_supress_output_all_possible==FALSE) print_my("  missing values removed")
			if ("VALUE2" %in% names(data_DT_1col)) data_DT_1col=data_DT_1col[ !is.na(VALUE2) ,]
					# nrow(data_DT_1col)	
											}
			
			
	if (nrow(data_DT_1col)==0) {
	print_my("   ...  no data after period selection ", k_warning=TRUE)
	next # <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
								}		
			
			
			
			
			if (n_pd_function=="1/1/0") {
			
				if (k_do_not_remove_NA==FALSE) {
				
				
if (k_supress_output_all_possible==FALSE)
	print_my("   inserting rows for empty data ... ")
					# source("rprog/functions_corr.r",TRUE)		
					# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<,
											
							k_print=ifelse((n_pd_function=="1/1/0")&(k_supress_output_all_possible==FALSE),TRUE,FALSE)
							
			data_DT_1col = insert_rows_data( data_DT_1col , ss_group_idcol=idcol , hranice_dej_missval, k_leave_aux_cols=TRUE , k_print=k_verbose  )	# ss_separator="-"			
					# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<,
						# summary_DT(data_DT_1col)
if (k_supress_output_all_possible==FALSE)			
	print_my("   done", k_warning=TRUE)
	
											  } # if (k_do_not_remove_NA==FALSE) 
	
	
				idcol=c(idcol,"x_Suffix") # data_DT_1col = Col_names_for_R( data_DT_1col )
					#column_exists	
					idcol=idcol[ idcol %in% names(data_DT_1col) ]
										} # if (n_pd_function=="1/1/0")

				
			
				if (!is.na(grp))
				if (!("REGION" %in% names(data_DT_1col))&(nchar(grp)>0)) {
						data_DT_1col[ , REGION:=grp]
																		  }
				
					# source("rprog/functions_corr.r",TRUE)	,  create info file in situ
					# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<,
			data_info_DT_pom=Create_info_file_insitu( data_DT_1col , ss_group_idcol=c(idcol,"REGION","x_Suffix"), k_ID_multi=FALSE   )
					# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<,
					



				# data_info_DT_puv=NA
				# jjjjjjjjjjj iiiiiiiiiiiinnnnnnnffffffffffff								
		if (
				( (!(file.exists(file_info)))
				| (n_pd_function=="1/1/0")
				) 
			& (!(n_pd_function=="7/1/0"))
			& (!(n_pd_function=="7/2/0"))
			& (!(n_pd_function=="3/15/0"))
									) { 
			# creates info file ..., 
				# data_info_DT_puv=data_info_DT
			data_info_DT=data_info_DT_pom
										} else {
			# bind information together
				# setkeyv
				# key(data_info_DT)
				# ID_join
		print_my("Joining original data_info with the actual one (got from data itself, counting missing values) ... ")		

# if (grp=="DD")		
# stop("stop here before joining info_files")

			# from Create_info_file_insitu, Region column is all blank
			# if (all(nchar(data_info_DT_pom$REGION)==0)) data_info_DT_pom$REGION=NA
			if ("REGION" %in% names(data_info_DT_pom)) {  
					# data_info_DT_pom - is only part of the problem - only given region
			if (all(nchar(data_info_DT_pom$REGION)==0)) {
					data_info_DT_pom[, REGION:=NULL ]
			# if ("REGION" %in% names(data_info_DT)) {  
			# if (all(nchar(data_info_DT$REGION)==0)) data_info_DT_pom[, REGION:=NULL ]
if (k_supress_output_all_possible==FALSE)
print_my("REGION columns removed from data_info")			
													# }
														}
														}
		
		#	if (!("REGION" %in% names(data_info_DT_pom))) {
		#												  } else {
			
				ss_pom=c("ID")
				if ("REGION" %in% names(data_info_DT_pom)) ss_pom=c("ID","REGION")
			data_info_DT2 = merge_my( data_out_all=data_info_DT_pom , data_out=data_info_DT_puv , ss_by=ss_pom , ss_suffixes = c("","_x") , ss_all=FALSE , k_output=FALSE )
		#														}
		
				# checks the result:
						# removes the columns used as key
					# ss_names2=names(data_info_DT_pom)
					#ss_names2=setdiff(ss_names2,c("ID","REGION"))
				n_count=nrow( get_rows_without_NA_data( xz=data_info_DT2, ss_cols=setdiff(names(data_info_DT_pom),c("ID","REGION")) ) )
							if (n_count<nrow(data_info_DT2) ) {
		print_my("  ... after info_files join, rows with NA values occur")	
								
							  data_info_DT2b = merge_my( data_out_all=data_info_DT_pom , data_out=data_info_DT , ss_by=c("ID") , ss_suffixes = c("","_x") , ss_all=FALSE , k_output=FALSE )	
							  
							  n_count2=nrow( get_rows_without_NA_data( xz=data_info_DT2b, ss_cols=setdiff(names(data_info_DT_pom),c("ID")) ) )

									if (n_count2>n_count) {	
										print_my("Using only ID for joining data_info")				
										data_info_DT2=data_info_DT2b
										n_count=n_count2
																	  } else {
																	  
								data_info_DT2b = merge_my( data_out_all=data_info_DT_pom , data_out=data_info_DT , ss_by=c("ID_ORIG") , ss_suffixes = c("","_x") , ss_all=FALSE , k_output=FALSE )	
								
								n_count2=nrow( get_rows_without_NA_data( xz=data_info_DT2b, ss_cols=setdiff(names(data_info_DT_pom),c("ID_ORIG")) ) )
								
											if (n_count2>n_count) {	
												print_my("Using ID_ORIG for joining data_info")				
												data_info_DT2=data_info_DT2b
												n_count=n_count2
																			  }  
																			}  # else
															 
															 } # if (n_count<nrow(data_info_DT2))
				
					if (n_count>0) {
					
						ss_pom=c("ID")
						if ("REGION" %in% names(data_info_DT_pom)) ss_pom=c("ID","REGION")
					
					# data_info_DT=data_info_DT2
					data_info_DT = get_rows_without_NA_data( xz=data_info_DT2, ss_cols=setdiff(names(data_info_DT_pom), ss_pom) )
									}
				
												} #if (!(file.exists(file_info)))
				# jjjjjjjjjjj iiiiiiiiiiiinnnnnnnffffffffffff								
			

# stop("stop here before joining geography")			

				#ggggggggggggggggggggggggggggg
				if (file.exists(file_geogr)) {
if (k_supress_output_all_possible==FALSE)				
		print_my("Adding geographical information into info_file", k_add_print_=TRUE)
			
					if (!("ID_ORIG" %in% names(data_info_DT_puv))) {
						data_info_DT_puv[, ID_ORIG:=ID]
																	}
					if (!("ID_ORIG" %in% names(data_info_DT))) {
						data_info_DT[, ID_ORIG:=ID]
																	}
						#removes empty columns ...
						# data_frame_remove_NA_cols(data_info_DT)
						
																	
			# from Create_info_file_insitu, Region column is all blank
			# if (all(nchar(data_info_DT_pom$REGION)==0)) data_info_DT_pom$REGION=NA
			if ("REGION" %in% names(data_info_DT_pom))
			if (all(nchar(data_info_DT$REGION)==0)) data_info_DT[, REGION:=NULL ]
																	
																	
					# source("rprog/fce_rprog.r",TRUE)				
								# data_out_all= , data_out=
			data_info_DT2=merge_my( data_out_all=data_info_DT , data_out=data_info_DT_puv , ss_by=c("ID_ORIG") , ss_suffixes = c("","_or") , ss_all=FALSE, k_check_unique=FALSE , k_only_last_row_B=TRUE , k_output=(k_supress_output_all_possible==FALSE) )
						
			data_info_DT2=Change_Column_order(data_info_DT2, c("ID","ID_ORIG","x_Suffix","REGION","LATITUDE","LONGITUDE","ALTITUDE","BEGIN","END","LENGTH","CNT","MISS_CNT","MISS_MAX","PRC_MISS"), 1 )  
							
						
						ss_pom=c("ID")
						if ("REGION" %in% names(data_info_DT_pom)) ss_pom=c("ID","REGION")
				n_count=nrow( get_rows_without_NA_data( xz=data_info_DT2, ss_cols=setdiff(names(data_info_DT_pom), ss_pom ) ) )
				if (nrow(data_info_DT)==n_count) {
			data_info_DT=data_info_DT2							
												 } else {
		print_my("After joining geography, got ",n_count," rows, instead of original ", nrow(data_info_DT) , " ones", k_warning=TRUE)
		print("")
		print("Original data: ")
		print(data_info_DT)
		print("")
		print("Data with joined geography: ")
		print(data_info_DT2)
														}
											}
				#ggggggggggggggggggggggggggggg

				
				
		data_info_DT=as.data.table(data_info_DT)	#after merge_my  it is data.frame
				
		# if ((n_pd_function=="1/1/0"))		
		# checks values in Region
		if (length(groups_)>1)
		if ("REGION" %in% names(data_info_DT))
		if (!(grp %in% (unique(data_info_DT$REGION)))) {
			data_info_DT[ , REGION_ori:=REGION ]
			data_info_DT[ , REGION:=grp ]
													}
				
				
				
				
				
		########	
			
					# clears auxiliary columns (used during inserting rows with missing values)
					# data_DT_1col[ , c("ID_ORIG") := NULL ]
					if ("diff_date" %in% names(data_DT_1col)) data_DT_1col[ , c("diff_date") := NULL ]
					if ("dt" %in% names(data_DT_1col)) data_DT_1col[ , c("dt") := NULL ]  # otherwise the next  dcast.data.table  does not work well ...
			
			
# stop("stop here before 1/1 saving ...")			
			
			 if (nrow(data_DT_1col)>0) {
				#if ( (nrow(data_DT_1col)!=nrow(data_DT_1col_puv)) 
				#	 | ((n_pd_function=="1/1/0"))											
				#												 ) {
				if ((n_pd_function=="1/1/0"))   {	
				
					if (k_save_only_final_results==FALSE) {
					
						if (length(groups_)>1) {
						
if (k_supress_output_all_possible==FALSE)				
		print_my("Saving adjusted data file (change in rows, filled missing values): ")

						# zpet ct
						if ((nchar(name_COLUMN)>0)) {
							# ct ct ct
							ss_names_group=names(data_DT_1col)
								ss_names_group=ss_names_group[(ss_names_group!=name_COLUMN)&(ss_names_group!="VALUE2")]
								ss_formula=paste( paste( ss_names_group, collapse="+" ) ,"~",name_COLUMN)			
									# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
								data_out_ct2 = dcast.data.table(data_DT_1col, as.formula( ss_formula ) , fun.aggregate=NULL, value.var="VALUE2")		
									# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
							
							for (ii_pom in ((length(ss_names_group)+1) ):length(names(data_out_ct2)) ) {
									ss_pom=gsub("[0-9]","",names_measure_puv,ignore.case=TRUE)
									ss_pom=unique(ss_pom)
								setnames(data_out_ct2,  names(data_out_ct2)[ii_pom] ,  paste(ss_pom, gsub(" ","0",format( names(data_out_ct2)[ii_pom], justify="right" ,width=2) ) , sep="") )
																									} # for
							# ct ct ct
												  } else {
								data_out_ct2= data_DT_1col
														  } # if (nchar(name_COLUMN)>0)
									
									
# stop("stop here x_Suffix ")									
								data_out_ct2=data_table_remove_NA_col(data_out=data_out_ct2, column="x_Suffix", k_output=(k_supress_output_all_possible==FALSE))	
									
# print("")
# print("names of files:")
# print(file_stat2)									
# print(file_stat2_orig)									
							# takse into account both group and period,   for the output file
																					  # file_stat2_orig	
									
							ss_pom=string_get_diff_from_begin(text1=file_stat2, text2=file_stat2_orig, k_try_diff=TRUE, ss_try_diff="Temp/")							
							ss_pom=gsub( paste("[.]dbf", sep="") , "", ss_pom ) #without suffix, bez pripony
# print(ss_pom)							
						file_out_dbf= gsub( paste("[.]dbf", sep="") , paste( "_", ss_pom ,".dbf", sep=""), file_stat_orig , ignore.case = TRUE)
						file_out_dbf=filename_with_Temp( file_out_dbf , k_save_Auxl_into_Temp=TRUE )	 # 
						
						
						
							if (k_CSV) {
								file_out_dbf=gsub( paste("[.]dbf", sep="") , paste(".csv", sep="") , file_out_dbf , ignore.case = TRUE)
										}
if (k_supress_output_all_possible==FALSE)
print_my("   Saving new data file (change in rows) into: ", file_out_dbf)
		
						if (k_CSV==TRUE) {
						# write.csv2( data_out_ct2 , file=file_out_dbf, na="", row.names = FALSE)
						write.table( data_out_ct2 , file=file_out_dbf, na="", row.names = FALSE , sep=";", dec=Sys.localeconv()[1] )
										} else {
						my__write_dbf( data_out_ct2 , file_out_dbf ,  n_dec=3, print_output=FALSE ) #,  n_dec=3, print_output=FALSE
												}
							
										} else {
if (k_supress_output_all_possible==FALSE)				
print_my("   1/1 function - no Temp/ saving - having only one member in a group")										
												} # if (length(groups_)>1)
												
											} # if (k_save_only_final_results==FALSE) 
								
										} # if ((n_pd_function=="1/1/0"))
			

			
					
				###			
													
				if ( (nrow(data_DT_1col)!=nrow(data_DT_1col_puv)) 
					 | ((n_pd_function=="1/1/0"))											
																 ) {																
					# info file
						if (k_save_only_final_results==FALSE) {
						
						if (length(groups_)>1) {
						
									# for 1/1 the files are: file_stat=a_files[4]   # file_out					
									#					   file_stat2=a_files[3]  #data_info	<<<<<<<<<<<<<<<<<<<<<<<<<<<<<	
										ss_pom2=file_stat2_orig
							ss_pom=string_get_diff_from_begin( text1=file_stat2, text2=file_stat2_orig, k_try_diff=TRUE, ss_try_diff="Temp/")
							ss_pom=gsub( paste("[.]dbf", sep="") , "", ss_pom ) #bez pripony
										if (nchar(file_stat2_orig)==0) {
							ss_pom=""
											if (length(groups_)>1) ss_pom=paste("_",grp,sep="")
											if (length(ss_periods_all)>1) ss_pom=paste("_",ss_periods,sep="")
											ss_pom2=data_file
																		}
										
						file_out_dbf= gsub( paste("[.]dbf", sep="") , paste( "_", ss_pom ,".dbf", sep=""), ss_pom2 , ignore.case = TRUE)
						file_out_dbf=filename_with_Temp( file_out_dbf , k_save_Auxl_into_Temp=TRUE )	 # 
						
						
						data_info_DT=data_table_remove_NA_col(data_out=data_info_DT, column="x_Suffix", k_output=(k_supress_output_all_possible==FALSE))	
								
						
							if (k_CSV) {
								file_out_dbf=gsub( paste("[.]dbf", sep="") , paste(".csv", sep="") , file_out_dbf , ignore.case = TRUE)
										}
if (k_supress_output_all_possible==FALSE)
		print_my("   Saving info file (change in rows) into: ", file_out_dbf)
		
						if (k_CSV==TRUE) {
						# write.csv2( data_info_DT , file=file_out_dbf, na="", row.names = FALSE)
						write.table( data_info_DT , file=file_out_dbf, na="", row.names = FALSE , sep=";", dec=Sys.localeconv()[1] )
										} else {
						my__write_dbf( data_info_DT , file_out_dbf , n_dec=3, print_output=FALSE ) #,  n_dec=3, print_output=FALSE	
												}

if (k_supress_output_all_possible==FALSE)
		print("")				
		
										} else {
if (k_supress_output_all_possible==FALSE)				
print_my("   1/1 function - no Temp/ saving - having only one member in a group")										
												} # if (length(groups_)>1)
		
		
											} # if (k_save_only_final_results==FALSE) 
											
										  } # n_pd_function=="1/1/0")
														
				###			
														
										} # if (nrow(data_DT_1col)>0)

										
				rm("data_DT_1col_puv")
				rm("data_info_DT_pom")

				
				
		
				
###############2

		
# stop("stop here before creating cross table")		
				
				
					#ct_ct_ct_ct_ct_ct_ct_ct_ct
	if ((n_pd_function!="1/1/0")&(n_pd_function!="7/1/0")&(n_pd_function!="7/2/0")&(n_pd_function!="3/15/0") ) {
		# now makes cross table, ted udela CT
					#ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct 
					#ss_group
				ss_MONTH="MONTH"				
if (k_supress_output_all_possible==FALSE) print(paste("Creating cross table - for ",ss_MONTH," ..."))
		ss_names_group=names(data_DT_1col)
			ss_names_group=ss_names_group[(ss_names_group!=ss_MONTH)&(ss_names_group!="VALUE2")]
			ss_formula=paste( paste( ss_names_group, collapse="+" ) ,"~",ss_MONTH)
			
				# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
			data_out_ct = dcast.data.table(data_DT_1col, as.formula( ss_formula ) , fun.aggregate=NULL, value.var="VALUE2")		
				# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
					# renames output, prejmenuje vystup
				for (ii_pom in ((length(ss_names_group)+1) ):length(names(data_out_ct)) ) {
						#names(data_out_ct)[ii_pom] = paste("N", names(data_out_ct)[ii_pom] , sep="")
						if (substr(names(data_out_ct)[ii_pom],1,1)!="N")
						setnames(data_out_ct,  names(data_out_ct)[ii_pom] ,  paste("N", gsub(" ","0",format( names(data_out_ct)[ii_pom], justify="right" ,width=2) ) , sep="") )
																														}
																														
if (k_supress_output_all_possible==FALSE)  print(paste(" ... done "))
					#ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct 

data_DT=data_out_ct			
		ss_group=gsub("MONTH","DAY",ss_group)
		ss_group=unique(ss_group)				
		
		#if (length(names_measure)==0) { # tries N
				ii_d_v=grep("N", substr(names(data_DT),1,nchar("N")) , ignore.case=TRUE)  
				if (length(ii_d_v)>0) names_measure=names(data_DT)[ii_d_v] else ii_d_v=integer()
		#							  }
																			
		names_measure=names_measure[!is.na(names_measure)]
				

				
									} # if (!(n_pd_function=="1/1/0"))
					#ct_ct_ct_ct_ct_ct_ct_ct_ct
				
				
				
if (k_supress_output_all_possible==FALSE) {
print("")		 
print("Group:")
										
	#	ii_day=match( c("DAY"),ss_group)
	#	if (length(ii_day)>0) ss_group=ss_group[-ii_day]						
ss_group=unique(ss_group)	
print(ss_group)	
				
				
print("")		 
print("Names of measure variables:")
print(names_measure)	
											}
											

								} else  { #if (!is.na(names_measure))
								
###
# stop("stop here before cutting data info")
	if ((file.exists(file_info))) {
		if ( length( ss_periods_all[ss_periods_all!=""] )>0 ) {
			if ("BEGIN" %in% names(data_info_DT)) {
print("Adjusting info file according to periods")									
			  
	# data_DT_1col=data_DT_1col[ YEAR>=year_begin & YEAR<=year_end , ]
	data_info_DT=data_info_DT[ END>=date_begin & BEGIN<=date_end , ]
												  } # if ("BEGIN" %in% names(data_info_DT))
	
	
										} # (length(ss_periods_all)>1)												
									} #if ((file.exists(file_info)))


									
								
										} #else if (!is.na(names_measure))
			# MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM


						

						
						



		#fffffffffffffffffffffffffff
if ((file.exists(file_info))) { #&(1==0)



# stop("stop here before adding distances info")	

			#adds  k  data_info    info about the nearest neighbours etc.,   distances
					#cccccccccccccccccccoooooooooooooooooorrrrrrrrrrrrrrrrrrrrrr
#			if ( (n_pd_function=="4/3/0") | (n_pd_function=="1/1/0") ) {
														 # file_dist_1=data_info_DT[,c("LONGITUDE","LATITUDE","ALTITUDE"), with=FALSE] 

						if (!(all(c("ID_NEAR","DIST_MIN") %in% names(data_info_DT))))
							if (all(c("LONGITUDE","LATITUDE") %in% names(data_info_DT))) {
if (k_supress_output_all_possible==FALSE)
print_my("Adding info about distances ...")													
															
															data_info_DT=as.data.table(data_info_DT)
															if (any(c("ID_NEAR","DIST_MIN","DIST_AVG","DIST_MAX") %in% (names(data_info_DT))))
															data_info_DT[ , c("ID_NEAR","DIST_MIN","DIST_AVG","DIST_MAX"):=NULL ]
															
														 file_dist_1=data_info_DT[,c("LONGITUDE","LATITUDE"), with=FALSE] 
														 	

																DF_dist=data.frame( ID_NEAR=as.character(""), DIST_MIN=0, DIST_AVG=0, DIST_MAX=0 )
																DF_dist=DF_dist[0,] #zadnej radek
																DF_dist$ID_NEAR=as.character(DF_dist$ID_NEAR)
																
														if (nrow(file_dist_1)>0) {
															for (ii_d in 1:(dim(file_dist_1)[1]) ) {
																	
if ((dim(file_dist_1)[1])>1000) {
if (k_supress_output_all_possible==FALSE)
print_my("Distance for: ",ii_d,": ", file_dist_1[ii_d,])
								}																	
																	
																#fields::rdist.earth 	
																dist_pom=rdist.earth(file_dist_1[ii_d,] , file_dist_1, miles=FALSE)
																
																dist_pom[1,][dist_pom[1,]<=limist_near_distance]=NA
																
																
															if (all(is.na(dist_pom))) {
																DF_dist[ii_d,]=data.frame( ID_NEAR=NA , DIST_MIN=NA, DIST_AVG=NA, DIST_MAX=NA )
																					} else {
																	# <<<<<<<<<<<<<<<<<<<<<<<<
																ii_pom=order( dist_pom[1,] , na.last=TRUE )  # order - from the smallest,  vezme, od nejmensiho	
																	# <<<<<<<<<<<<<<<<<<<<<<<<
																		# zero distances are given in the end, 
																		ii_pom=ii_pom[!is.na(ii_pom)]
																DF_dist[ii_d,]=data.frame( ID_NEAR="" , DIST_MIN=dist_pom[1,ii_pom[1]], DIST_AVG=mean(dist_pom[1,],na.rm=TRUE), DIST_MAX=dist_pom[1, which.max(dist_pom[1,]) ] )
																DF_dist$ID_NEAR[ii_d]=as.character(  data_info_DT[ ii_pom[1] , ii_idcol , with=FALSE] )
																#DF_dist[ii_d,]
																							} # if (all(is.na(dist_pom)))
																
																							  } #for
																				 } # if (nrow(file_dist_1)>0)	 	
														
															DF_dist$DIST_MIN=round(DF_dist$DIST_MIN, digits=4)
															DF_dist$DIST_AVG=round(DF_dist$DIST_AVG, digits=4)
															DF_dist$DIST_MAX=round(DF_dist$DIST_MAX, digits=4)

															#<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<		
														# data_info_=cbind(data_info, DF_dist )	 
														data_info_=cbind(data_info_DT, DF_dist )	 
															#<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<		
															
																											  
# stop("stop here before saving distances")													  
													  ss_pom=file_info
													  
													  if (n_pd_function=="1/1/0") {
														ss_pom=file_stat2_orig
														if ( (all(!is.na(idcol_group))) | (k_columns_regions) ) ss_pom=file_stat2 #combination with group name
																				  }

							if (k_save_auxiliary_files==TRUE) {


									file_info_out= gsub(paste("[.]dbf", sep="") , paste("_dist2",".dbf", sep=""), ss_pom , ignore.case = TRUE)
									
									if ( length( ss_periods_all[ss_periods_all!=""] )>0 ) {									
											file_info_out= gsub(paste("[.]dbf", sep="") , paste( string_get_diff_from_begin(filename(file_stat2),filename(file_stat2_orig)) , "_dist2",".dbf", sep=""), file_info , ignore.case = TRUE)
																												
									file_info_out=filename_with_Temp( file_info_out , k_save_Auxl_into_Temp=TRUE )
																  } 

if (k_supress_output_all_possible==FALSE)
print_my("Info about distances saved into separated file: ", file_info_out)			
										
													my__write_dbf( data_info_, file_info_out , n_dec=3, print_output=FALSE ) #,  n_dec=3, print_output=FALSE
															  } #  if (k_save_auxiliary_files==TRUE)
													
data_info_DT=data_info_													
													
															} 
#										} 
					#cccccccccccccccccccoooooooooooooooooorrrrrrrrrrrrrrrrrrrrrr


	
							} #if ((file.exists(file_info))
		#fffffffffffffffffffffffffff
											
				
				


  
#######################################################################################################################  
#######################################################################################################################  
  
  						
						


# stop("stop here before calculation")
# if (k_supress_output_all_possible==FALSE) print("Starting calculations ...")						


							
if (n_pd_function=="1/1/0") {
						
	# zpet ct
						if ((nchar(name_COLUMN)>0)) {
							# ct ct ct
							ss_names_group=names(data_DT_1col)
								ss_names_group=ss_names_group[(ss_names_group!=name_COLUMN)&(ss_names_group!="VALUE2")]
								ss_formula=paste( paste( ss_names_group, collapse="+" ) ,"~",name_COLUMN)			
									# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
								data_out_ct2 = dcast.data.table(data_DT_1col, as.formula( ss_formula ) , fun.aggregate=NULL, value.var="VALUE2")		
									# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
							
							for (ii_pom in ((length(ss_names_group)+1) ):length(names(data_out_ct2)) ) {
									ss_pom=gsub("[0-9]","",names_measure_puv,ignore.case=TRUE)
									ss_pom=unique(ss_pom)
								setnames(data_out_ct2,  names(data_out_ct2)[ii_pom] ,  paste(ss_pom, gsub(" ","0",format( names(data_out_ct2)[ii_pom], justify="right" ,width=2) ) , sep="") )
																									} # for
								data_out_ct2 = Change_Column_order(data_out_ct2, c("Remark","ID_aux"), 1000 )
							# ct ct ct
												  } else {
								data_out_ct2= data_DT_1col
														  } # if (nchar(name_COLUMN)>0)
						data_DT=data_out_ct2
															
						
						
	#puts together ...
	
						#stat_ct_all puvodne, inspirace
					if (any(ls()=="data_out")) { 
					l = list(data_out, as.data.table(data_DT) )
					data_out=rbindlist(l, fill=TRUE)
					# stat_ct_all=c(stat_ct_all,file_stat2_rda)					
										   } else { 
											# stat_ct_all=stat_ct[] 
											data_out=as.data.table(data_DT) 
													}
	
						#info file
					if (any(ls()=="data_out_ct")) { 
					l = list(data_out_ct, as.data.table(data_info_DT) )
					data_out_ct=rbindlist(l, fill=TRUE)
					# stat_ct_all=c(stat_ct_all,file_stat2_rda)					
										   } else { 
											# stat_ct_all=stat_ct[] 
											data_out_ct=as.data.table(data_info_DT) 
													}
	
	

						     } # if (n_pd_function=="1/1/0")
						

						




  
#######################################################################################################################  
#######################################################################################################################  
#######################################################################################################################  
  
  						

						
					
					#ssssssssssssssssssss_cccccccccccccccccccccccccccccccccc
			if ( (n_pd_function=="7/1/0")|(n_pd_function=="7/2/0")|(n_pd_function=="3/15/0") ) {
print("")			
print("Entering QC functions - finding neighbours")			
						
													# dodane sem, aby nedelal vsechno se vsim, zbytecne
												if (k_the_same_region) {
												#	data_info_DT, data_info_DT_puv
																		}
												
												
												# grp,  and (length(groups_)>1)
												if (!is.na(grp))
												if (("REGION" %in% names(data_info_DT_puv))&(nchar(grp)>0)) {
														if (grp %in% unique(data_info_DT_puv$REGION)) {
														# if (any(groups_ %in% unique(data_info_DT_puv$REGION))) {
if (k_supress_output_all_possible==FALSE) 
print_my("Selecting only given Region (",grp,") from info_file")

													data_info_DT=data_info_DT_puv[REGION==grp,] 
													
																								}
																							}
						
						
						
												if (n_pd_function=="3/15/0") {
													#selection only from the neighbours, marked for deleting (MFD), not from the list of grid points appended to the list of ngbs

														if (k_force_groups==TRUE) {
															#groups are created here, save in data_DT
															data_info_DT=data_DT
																					}
													
													k_the_same_region=TRUE

														# REGION - grp variable
													data_info_DT[ , REGION_puv:=REGION ]
													
													data_info_DT$REGION=data_info_DT$MFD
																			 } # if (n_pd_function=="3/15/0")
																
																								
												if ( length( ss_periods_all[ss_periods_all!=""] )>0 ) {
													
												   maxpoc_stanic=maxpoc_stanic_puv
													
													# limits the stations - chooses only those measuring in the period
													
															begin_all=(data_info_DT$BEGIN)
															end_all  =(data_info_DT$END  )
														if (class(begin_all)=="Date") begin_all=as.numeric(format(begin_all, format = "%Y")) else begin_all=as.numeric(begin_all)
														if (class(end_all  )=="Date") end_all  =as.numeric(format(end_all, format = "%Y")) else end_all=as.numeric(end_all)
														
															k_pom=  (year_end >=begin_all ) & (year_begin <=end_all)
													data_info_DT=data_info_DT[k_pom , ]
														if (maxpoc_stanic>nrow(data_info_DT)) maxpoc_stanic=nrow(data_info_DT)
print_my("Sub-selection according to period: ",year_begin," - ",year_end, ", max number of ngbs: ",maxpoc_stanic, k_add_print_=TRUE)
																										
																			   } # if (length(ss_periods_all)>0)
												
												
												if (nrow(data_info_DT)==0) {
print_my("  ... no station found for the period ",period_ii,", ... skipping" , k_warning=T)
	# print(idcol_group)
	# data_info_DT=data_info_DT_puv  - je to nahore v loopu pro ss_periods
	next # <<<<<<<<<<<<<<<<<<<<<<<<<<<<<< ggggggggggggggg				  												
		ss_periods
																			}
												
												
												
												DF_dist=data.frame( ID_NEAR=as.character(""), DIST_MIN=0, DIST_AVG=0, DIST_MAX=0 , REG_near=as.character("") , stringsAsFactors=FALSE)
												DF_dist=DF_dist[0,] #zadnej radek
												DF_dist$ID_NEAR=as.character(DF_dist$ID_NEAR)
												
												file_dist_1=data_info_DT[,c("LONGITUDE","LATITUDE"), with=FALSE] 
												a_region=""
											
												if (any(ls()=="data_info_DT_1_all"))  rm(data_info_DT_1_all)
			

												ii_d_all=1:(dim(file_dist_1)[1])
													if ("MFD" %in% names(data_info_DT)) { #column_exist
														# k_use_marked_deleted==TRUE
														
														#creates NA output - whole DataFrame
														DF_dist[ ii_d_all , ]=NA
													
													# choose just what is not marked for deleting
													ii_d_all=which(data_info_DT$MFD!=TRUE)
print_my("Remark: only records NOT marked for deleting (in Info_file) are used as candidate stations: ",length(ii_d_all),"/",(dim(file_dist_1)[1])," stations;   but as neighbours, ALL stations are used " ,  k_add_print_=TRUE)
																						}
												
												
if (k_supress_output_all_possible==FALSE) {
print("")												
print("")												
											}
														# ffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffff
											for (ii_d in ii_d_all) {
																						
												maxpoc_stanic_indiv=maxpoc_stanic #for various regions, maxpoc_stanic_indiv may change
																						
a_stan=data_info_DT[ii_d,"ID", with=FALSE]  #data_info_DT$ID_1[ii_d]
													
													
													
													ss_pom=paste(" ( ",ii_d," / ",dim(file_dist_1)[1]," ) ", sep="")
												# if (any(nchar( ss_periods_all )>=1))	
												# if (length(ss_periods_all)>1) {
												if ( length( ss_periods_all[ss_periods_all!=""] )>0 ) {
													ss_pom=paste(" ( ", round( which(period_ii==ss_periods_all)-1 + (ii_d/dim(file_dist_1)[1]) , 2)," / ",length(ss_periods_all)," ) ", sep="")	
																				}				
													#in case of group, let the progress be the group ...
												if ( (all(!is.na(idcol_group))) | (k_columns_regions) ) ss_pom="" 
																												


												if (k_the_same_region) {
														file_dist_1=data_info_DT[,c("LONGITUDE","LATITUDE"), with=FALSE] 
														a_region=data_info_DT$REGION[ii_d]
															if (is.na(a_region)) a_region=""
														if (n_pd_function=="3/15/0") {
															a_region=TRUE # 1 # MFD, marked for deleting
																					 }
														#erases info about coordinates	
																 k_pom=(data_info_DT$REGION!=a_region)
																 k_pom[ii_d]=FALSE #station itself will be preserved (for 3/15/0)
														file_dist_1[ ,1][ k_pom ]=NA
														file_dist_1[ ,2][ k_pom ]=NA
																		}

# progress_bar																							
print(paste("  Distances for ", a_stan,
				ifelse(k_the_same_region,paste(", region: ",a_region,sep=""),""), 
				ifelse( ( length( ss_periods_all[ss_periods_all!=""] )>0 ) ,paste(", period: ",year_begin,'-',year_end,sep=""),""),
				ss_pom,
				sep="") )      #(length(ss_periods_all)>1)
# print_my("Distances, maxpoc_stanic: ",maxpoc_stanic, ", ", maxpoc_stanic_puv, ", ", maxpoc_stanic_indiv)				
																		
# stop("stop here getting distances")																			
																		#fields::rdist.earth
																		# older version of fields::rdist.earth
																		# may not work well,
																		# then try:
																	# packageVersion("fields")
																	# detach(package:fields)
																	# update.packages(checkBuilt=TRUE,ask=FALSE)
																	# packageVersion("fields")
																		# version should be at least: 8.10
												dist_pom=rdist.earth(file_dist_1[ii_d,] , file_dist_1, miles=FALSE)
												
												
												#stations with shorter distances (at the same place) are removed
													ii_pom=dist_pom[1,]<=limist_near_distance
														ii_pom[ii_d]=FALSE #without the given station
													if (sum(ii_pom,na.rm=TRUE)>0) {
print_my("   for these cases, distance was shorter than limit (",limist_near_distance,"), they were erased: ", data_info_DT[ii_pom, 1] )
																					}
												# dist_pom[1,][ ii_pom ]=NA
												dist_pom[1,][ dist_pom[1,]<=limist_near_distance ]=NA
												
												
												
												#get order, ascending
																	# <<<<<<<<<<<<<<<<<<<<<<<<
												ii_pom=order( dist_pom[1,] , na.last=TRUE )  #poradi vezme, od nejmensiho	
																	# <<<<<<<<<<<<<<<<<<<<<<<<
														#nulove vzdalenosti jsou na konci
														ii_pom=ii_pom[!is.na(ii_pom)]
if (length(ii_pom)<=1) {
print_my("  ... no neighbour found for ",a_stan,", period ",period_ii,", ... skipping" , k_warning=T)
# stop("stop here - no neighbour found ...")
	next # <<<<<<<<<<<<<<<<<<<<<<<<<<<<<< ggggggggggggggg				  
						} # if (length(ii_pom)<=1)
if (all(is.na(dist_pom))) {  #in case of regions (elements) of one station, ii_pom is not NA, but dist_pom is ..
print_my("  ... no neighbour found for ",a_stan,", period ",period_ii,", ... skipping" , k_warning=T)
# stop("stop here - no neighbour found ...")
	next # <<<<<<<<<<<<<<<<<<<<<<<<<<<<<< ggggggggggggggg				  
						} # if (length(ii_pom)<=1)
						
					
													#dist_pom[1,][ii_pom]
													#the most distant
													#data_info_DT[ ii_pom[length(ii_pom)] , 1 , with=FALSE]
												DF_dist[ii_d,]=data.frame( ID_NEAR="" , DIST_MIN=dist_pom[1,ii_pom[1]] , DIST_AVG=mean(dist_pom[1,],na.rm=TRUE), DIST_MAX=dist_pom[1, which.max(dist_pom[1,]) ] , REG_near=as.character(a_region) , stringsAsFactors=FALSE) #stringsAsFactors = default.stringsAsFactors() - factor to tam hodi a to pak blbne
												
												DF_dist$ID_NEAR[ii_d]=as.character(  data_info_DT[ ii_pom[1] , ii_idcol , with=FALSE] )
												#DF_dist[ii_d,]
												
																			  
										
# stop("stop here before making Distances output")
																		
										# expects to have BEGIN and END in the geography, if it is not the case, he will add empty cols ...
										if (!("BEGIN" %in% names(data_info_DT))) data_info_DT[, BEGIN:=NA]
										if (!("END" %in% names(data_info_DT))) data_info_DT[, END:=NA]
																				
										if (!("ALTITUDE" %in% names(data_info_DT))) {
										 data_info_DT[, ALTITUDE:=NA]
print_my("Column ALTITUDE is missing in the data_info file", k_warning=TRUE )
# Clever altitude selection
k_clever_altitude_sel=FALSE
																					}

																		
										#list of columns, gives in the output, seznam sloupcu, co da na vystup
										ss_fields_selection=c("ID","REGION","BEGIN","END","LATITUDE","LONGITUDE","ALTITUDE", "PRC_MISS")
										# corresponding list of columns in data_info1 and data_info2										
										ss_fields_selection_new_names_1=c("ID_1","REGION","BEG_1","END_1","LATITUDE","LONGITUDE","ALT_1", "PRC_MISS_1")
										ss_fields_selection_new_names_2=c("ID_2","REGION","BEG_2","END_2","LAT_2","LON_2","ALT_2", "PRC_MISS_2")
										
										#leaves only columns that exist
											k_pom=(ss_fields_selection %in% names(data_info_DT))
										ss_fields_selection=ss_fields_selection[ k_pom ]
										ss_fields_selection_new_names_1=ss_fields_selection_new_names_1[ k_pom ]
										ss_fields_selection_new_names_2=ss_fields_selection_new_names_2[ k_pom ]
										
										
										data_info_DT_1=data_info_DT[ii_d, ss_fields_selection, with=FALSE]
											if (k_the_same_region) {
												if (n_pd_function=="3/15/0") {
													data_info_DT_1$REGION=a_region #=TRUE # 1 # MFD, marked for deleting
																			}
																	}		
																	
																	
										data_info_DT_2=data_info_DT[ ii_pom , ss_fields_selection, with=FALSE]
										setnames(data_info_DT_1, ss_fields_selection, ss_fields_selection_new_names_1)
										setnames(data_info_DT_2, ss_fields_selection, ss_fields_selection_new_names_2)
											 
											 
																	# <<<<<<<<<<<<<<<<<<<<<<<<
										data_info_DT_out_pom=data.table( data_info_DT[ii_d,"ID", with=FALSE] , data_info_DT_2, Distance=dist_pom[1, ii_pom ] , Dist_order=1:(dim(data_info_DT)[1]), Stan_order=ii_d )
										if ("ID" %in% names(data_info_DT_out_pom)) setnames(data_info_DT_out_pom,"ID","ID_1")
										
										
# stop("stop here selection regions2")
										
										#the very last columns is the base station itself,  NA, thanks to  order  command with  na.last=TRUE
										 if (k_the_same_region) {
												#if more regions, more last NAs occur ...
														file_dist_1=data_info_DT[,c("LONGITUDE","LATITUDE"), with=FALSE] 
														a_region=data_info_DT$REGION[ii_d]
																	if (is.na(a_region)) a_region=""
																if (n_pd_function=="3/15/0") {
																	a_region=TRUE # 1 # MFD, marked for deleting
																							 }
														# file_dist_1[,1][ data_info_DT$REGION!=a_region ]=NA
																	# pozor na poradi ... ii_pom
																 k_pom=(data_info_DT$REGION[ii_pom]!=a_region)
																 k_pom[ii_d]=FALSE #station itself will be preserved (for 3/15/0)
														file_dist_1[ ,1][ k_pom ]=NA
														# file_dist_1[ ,2][ k_pom ]=NA
										# data_info_DT_out_pom[ REGION==a_region,Distance]
												# data_info_DT_out_pom = data_info_DT_out_pom[ REGION==a_region & !is.na(Distance) , ]
												data_info_DT_out_pom = data_info_DT_out_pom[ !k_pom & !is.na(Distance) , ]
										
															    } else {
										if (is.na(data_info_DT_out_pom$Distance[nrow(data_info_DT_out_pom)])) {
												data_info_DT_out_pom = data_info_DT_out_pom[1:(nrow(data_info_DT_out_pom)-1) , ]
																												}
																		} # if (k_the_same_region)

													
										
																	# <<<<<<<<<<<<<<<<<<<<<<<<
										
										
										if (k_the_same_region) {
											# thesame_region
											ss_cols_regions=c("ID_1","REGION")
																} else {
											ss_cols_regions=c("ID_1")
																		} # if (k_the_same_region)
              										
										#########			
													
										# join,  puts info about the base station
											setkeyv(data_info_DT_1, ss_cols_regions )
											setkeyv(data_info_DT_out_pom, ss_cols_regions )
										
										data_info_DT_out=merge( data_info_DT_out_pom,data_info_DT_1, by=ss_cols_regions, all.y=TRUE, SORT=FALSE)

										
										# play with time: 
																					
										data_info_DT_out$BEGIN=apply( data_info_DT_out[ , c("BEG_1","BEG_2") ] , 1 , max ) #, na.rm=TRUE,  bude to NA, pokud to druhe neni
										data_info_DT_out$END  =apply( data_info_DT_out[ , c("END_1","END_2") ] , 1 , min ) #, na.rm=TRUE,  bude to NA, pokud to druhe neni
										# data_info_DT_out[ , list( LENGTH=((END)-(BEGIN)+1)  ) ]  - ON Z TOHO UDELA STRING z toho as.Date - pri predeslem prevodu
										
											if ((class(data_info_DT_out$BEGIN)=="character")&(class(data_info_DT_out$BEG_2)=="Date")) data_info_DT_out$BEGIN=as.Date(data_info_DT_out$BEGIN)
											if ((class(data_info_DT_out$END)=="character")&(class(data_info_DT_out$END_2)=="Date")) data_info_DT_out$END=as.Date(data_info_DT_out$END)

										
											# takes into account period ...
										if ( length( ss_periods_all[ss_periods_all!=""] )>0 ) {
											if ( class(data_info_DT_out$BEGIN) %in% c("numeric","integer") ) ss_begin=year_begin else ss_begin=date_begin
											if ( class(data_info_DT_out$END  ) %in% c("numeric","integer") ) ss_end  =year_end   else ss_end  =date_end
											
												if (class(data_info_DT_out$BEGIN)=="character") { 
													data_info_DT_out$BEGIN=as.character(data_info_DT_out$BEGIN)
													ss_begin=as.character(ss_begin)
																								}
												if (class(data_info_DT_out$END)=="character")   {
													data_info_DT_out$END=as.character(data_info_DT_out$END)
													ss_end=as.character(ss_end)
																								}
											
											data_info_DT_out[ BEGIN<ss_begin , BEGIN:=ss_begin ]
											data_info_DT_out[ END>ss_end     , END  :=ss_end   ]
																								} else {
																								
												if (!all(is.na(data_info_DT_out$BEGIN))) {													
													# if ( class(data_info_DT_out$BEGIN) %in% c("numeric","integer") ) ss_begin=max(data_info_DT_out$BEGIN,na.rm=TRUE) else ss_begin=as.Date(paste( max( format(as.Date(data_info_DT_out$BEGIN,na.rm=TRUE) , format = "%Y") ,na.rm=TRUE ) ,"-01-01", sep=""))
													if ( class(data_info_DT_out$BEGIN) %in% c("numeric","integer") ) ss_begin=min(data_info_DT_out$BEGIN,na.rm=TRUE) else ss_begin=as.Date(paste( min( format(as.Date(data_info_DT_out$BEGIN,na.rm=TRUE) , format = "%Y") ,na.rm=TRUE ) ,"-01-01", sep=""))
																						}											
												if (!all(is.na(data_info_DT_out$END))) {
													if ( class(data_info_DT_out$END) %in% c("numeric","integer") ) ss_end=max(data_info_DT_out$END,na.rm=TRUE) else ss_end=as.Date(paste( max( format(as.Date(data_info_DT_out$END,na.rm=TRUE) , format = "%Y") ,na.rm=TRUE ) ,"-12-31", sep=""))
																						}											
																										
																										}
										
										
											if ((class(data_info_DT_out$END)=="character")&(class(data_info_DT_out$END_2)=="Date")) {
										data_info_DT_out$LENGTH=as.Date(data_info_DT_out$END)-as.Date(data_info_DT_out$BEGIN)+1
										len_comm_per=len_comm_per*365.25
											length_max=as.Date(ss_end)-as.Date(ss_begin)+1
														} else {
										data_info_DT_out$LENGTH=(data_info_DT_out$END)-(data_info_DT_out$BEGIN)+1
											length_max=as.numeric(ss_end)-as.numeric(ss_begin)+1
																} # if ((class
										
										
										
										# data_info_DT_out[ , list( alt_diff=((ALT_2)-(ALT_1))  ) ]
										data_info_DT_out[ , alt_diff:=((ALT_2)-(ALT_1))  ]

										
										#####################
										
# stop("stop here before merging correlations ...")						
											# cccccccccccccccccccccccccccccccccccccccccccccccccccccc
										if ((n_pd_function=="7/1/0")) {
											# if (file.exists(file_corr)) {
											if ((any(ls()=="data_corr_DT"))) {
																						
										
													# fffffffcccccccccccccccc
										Add_correlations = function(data_info_DT_out,data_corr_DT) {
													ss_pom=names(data_corr_DT)
														# ss_pom1=ss_pom[c(1,2,5)] #without BEGIN and END
														ss_pom1=ss_pom[c(1,2)] #without BEGIN and END
													ss_pom1=ss_pom1[ ss_pom1 %in% names(data_corr_DT) ]
										x_merge=merge( data_info_DT_out,data_corr_DT, by=ss_pom1, all.x=TRUE, all.y=FALSE, suffixes = c("_cx", "_c"), SORT=FALSE)
													# swaps ID_2 and ID_1
													ss_pom2=ss_pom[c(2,1)]
										y_merge=merge( data_info_DT_out,data_corr_DT, by.x=ss_pom1, by.y=ss_pom2, all.x=TRUE, all.y=FALSE, suffixes = c("_cx", "_c"), SORT=FALSE)
											setnames(y_merge, names(y_merge) , paste(names(y_merge),"_",sep="") )
										
										#binds together
										xy_merge=data.table(x_merge[,1:2], x_merge[, (dim(data_info_DT_out)[2]+1):(dim(x_merge)[2]) ] , y_merge[, (dim(data_info_DT_out)[2]+1):(dim(y_merge)[2]) ],  check.names=TRUE)
																				
										#chooses non-missing case
											ii_len=length((dim(data_info_DT_out)[2]+1):(dim(x_merge)[2]))
												#BEGIN and END, ss_column_COR
										for (ii_pom in (1:ii_len)) {
											k_pom=is.na( xy_merge[[2+ii_pom]] )
										xy_merge[ k_pom , c(2+ii_pom):=xy_merge[[2+ii_len+ii_pom]][k_pom] ]
																	}
										#final output with correlations
										xy_merge=data.table( data_info_DT_out , xy_merge[,(2+1):(2+ii_len) ] )
										# data_info_DT_out[[ss_column_COR]]
										
											# return(data_info_DT_out)
											return(xy_merge)
																		} #add_corerlations
													# fffffffcccccccccccccccc
										
										
										data_info_DT_out=Add_correlations(data_info_DT_out,data_corr_DT)
										
										
										################
										
													# if (all(is.na( data_info_DT_out[,c(ss_column_COR), with=FALSE] ))) {
													if (all(is.na( data_info_DT_out[[ss_column_COR]] ))) {
print_my("Merging list of neighbours with info from correlation file does not work ... no match found ... will try cutting IDs in Corr info file with _ ", k_warning=TRUE )

													ii_pom=which("alt_diff"==names(data_info_DT_out))
												data_info_DT_out=data_info_DT_out[ , 1:ii_pom ]

																	# data_corr_DT[,c(ss_pom[1]), with=FALSE]
																	ss_pom=names(data_corr_DT)
																if ( mean(nchar( data_corr_DT[[c(ss_pom[1])]] )) > mean(nchar( data_info_DT_out[[c(ss_pom[1])]] )) ) {
																if ( (sum(grepl("_",data_corr_DT[[c(ss_pom[1])]]))>0) &
																	(sum(grepl("_",data_info_DT_out[[c(ss_pom[1])]]))==0 ) )
																	data_corr_DT[,c(ss_pom[1]):=strextract( data_corr_DT[[c(ss_pom[1])]] ,"","_",FALSE) ]
																	data_corr_DT[,c(ss_pom[2]):=strextract( data_corr_DT[[c(ss_pom[2])]] ,"","_",FALSE) ]
																										}
																										
										data_info_DT_out=Add_correlations(data_info_DT_out,data_corr_DT)
																										
																														}
												
										# renames
										setnames(data_info_DT_out, ss_column_COR, "Correl" )
										
											
												
																		} #if (file.exists(file_cor))
																	   } #if ((n_pd_function=="7/1/0"))
										
											# cccccccccccccccccccccccccccccccccccccccccccccccccccccc
										
										
										
																	   
# stop("Stop here before stations selection ...")										
																	   
										
############################################################################################################	
										#SELECT
										
										
										# now it will devote to neighbours selection ...
											# adds negatively, what is wrong,   so the higher the number, the worse neigbour
										# now he will devote to selection of proper neibhgours
										
										
										# data_info_DT_out$k_select=T
										data_info_DT_out$k_select=0
										
										
										#odstrani radky, co nesplnuji podminku
										# period:  weight 5
										if (len_comm_per>0) data_info_DT_out$k_select=(data_info_DT_out$k_select) + 5 *!(data_info_DT_out$LENGTH>=len_comm_per)
										
										
										# altitude difference:  weight 2, originally, newly 1
										if (limit_diffs_altitude!=0) {
										
											if ( (limit_diffs_altitude>0) & (limit_diffs_altitude<=1) ) {
												# used as ratio
													
											# data_info_DT_out[ , alt_diff:=((ALT_2)-(ALT_1))  ]
											data_info_DT_out[ (!is.na(ALT_1)) , alt_limit1:=(ALT_1-(ALT_1*limit_diffs_altitude)) ]
											data_info_DT_out[ (!is.na(ALT_1)) , alt_limit2:=(ALT_1+(ALT_1*limit_diffs_altitude)) ]
																										
											data_info_DT_out[ (!is.na(ALT_1)) & (ALT_1<ALT_2) ,  pen_alt := ALT_1/ALT_2 ] 
											data_info_DT_out[ (!is.na(ALT_1)) & (ALT_1>ALT_2) ,  pen_alt := ALT_2/ALT_1 ] 
											data_info_DT_out[ (!is.na(ALT_1)) ,  pen_alt := pen_alt/limit_diffs_altitude ] 
											
												data_info_DT_out[ (!is.na(ALT_1)) , k_select:=(k_select) + 1 *( pen_alt ) ]
												
																										} else {
										
										# normal mode - altitude difference
											if (limit_diffs_altitude>0) {
												data_info_DT_out[ (!is.na(ALT_1)) , pen_alt:=abs(data_info_DT_out$alt_diff) / limit_diffs_altitude ]
												
												data_info_DT_out[ (!is.na(ALT_1)) , k_select:=(k_select) + 1 *( pen_alt ) ]
												
																		}  
											
											# prefefes bigger alt differences
											if (limit_diffs_altitude<0) {
											  if (!all(is.na(data_info_DT_out$alt_diff))) {
												data_info_DT_out$k_select=(data_info_DT_out$k_select) + 1 *! ( abs(data_info_DT_out$alt_diff) >= -limit_diffs_altitude )
																							}
																		}
																																				
																												} # else
																								
																												
																	  } # if (limit_diffs_altitude!=0)
																	 
																	 
																	 
										# distance:  weight 1
										if (limit_distance!=0) {
											if (limit_distance>0) {													
													data_info_DT_out[ , pen_dist:=round (Distance / limit_distance , 2)]
													data_info_DT_out[ , k_select:=k_select + 2 *( pen_dist ) ]
																  }
											
											#minimum distance limit ...
											if (limit_distance<0) data_info_DT_out$k_select=(data_info_DT_out$k_select) + 1*!( (data_info_DT_out$Distance) >= -limit_distance )
																	  }										
										
												
												
												
										# if (ss_column_COR %in% names(data_info_DT_out)) {
										if ("Correl" %in% names(data_info_DT_out)) {
												# renames
												# setnames(data_info_DT_out, ss_column_COR, "Correl" )
											#if (limit_correlation>0) {													
													data_info_DT_out[ , pen_corr:=round ( (1-(Correl)) / limit_correlation , 3)]
													# data_info_DT_out[ , k_select:=k_select + (2.5) *( pen_corr ) ]
												#at je vaha poradna, oproti vzdalenosti napr. ... nebo omezit vzdalenost?	
													data_info_DT_out[ , k_select:=k_select + (5) *( pen_corr ) ]
											#					  }
										
										
																						} 
										
										
										
										#info about common period,  2 times
											# data_info_DT_out$k_select=data_info_DT_out$k_select + (  1- (as.numeric(data_info_DT_out$LENGTH)/as.numeric(length_max)) )
																# per_common - prc_l_miss
											data_info_DT_out[ , prc_l_miss:=100*round(  1- (as.numeric(data_info_DT_out$LENGTH)/as.numeric(length_max)) , 2) ]
											data_info_DT_out[ , pen_length:= 2 *prc_l_miss/100 ]
											data_info_DT_out[ , k_select:=k_select + pen_length ]
										
										#missing values
												if ("PRC_MISS_2" %in% names(data_info_DT_out)) {
											data_info_DT_out[ , pen_miss2:= PRC_MISS_2/100 ]
											data_info_DT_out[ , k_select:=k_select + pen_miss2 ]
																								}


																								
										
										# data_info_DT_out$k_select - the higher the worse ...
										
										if (all(is.na(data_info_DT_out$k_select))) data_info_DT_out$k_select=0
										if (sum(is.na(data_info_DT_out$k_select))>0) {
print("   ... some selection (k_select) was NA (probably missing information about periods?) ")										
											data_info_DT_out[ is.na(k_select) , k_select:=10 ]
												}
										
										
										
#######										
										

										
											# ccccccccclllllllllllllll_nnnnnnnnnnnnnnnsssssssssssssssssssssssssss
		if (k_clever_altitude_sel==T) {
										
				if (ii_d==1) {
		print(paste('Clever altitude selection: the last ',(koef_data_verified),'% of neighbours are selected in the way that IQR (using ngb. altitudes) of base stattion altitude is below ', (koef_1_5), '  (weight for not meeting this criterion (SELECTION column) is 5!)'))    
								}						

	
	
	
    # verifies altitudes,  
		  # *vvvvvvvvvvvvvvvvvvvvvvvvvvv
		      
				a_vys=data_info_DT_out$ALT_1[1]
				a_stan=data_info_DT_out$ID_1[1]
					# a_region=data_info_DT_out$REGION[1]
				
				# data_info_DT_out$del_=FALSE
				data_info_DT_out[ , del_:=FALSE]
				
				
				data_info_DT_out[ , Alt_IQR:=missval ]
				
				
				ii_vys=0 #through the neighbours - counts appropriate neighbours
				ii_pos=1 # GO top,  position of the neighbour, counts all  - in the distance order
					pos_posl=0 # even the first neighbour may be quite different in the altitude
					k_print_done=FALSE
					
				reccount=(dim(data_info_DT_out)[1])
				
					# recno()=ii_pos,  ii=ii_vys  (stare=nove)
				# wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww
			  while ( (ii_vys < maxpoc_stanic_indiv) & (ii_pos <= reccount ) ) {

				if (data_info_DT_out$del_[ii_pos]==FALSE) {
				
						#starts estimating only above a given percentage of stations, 
							# koef_data_verified=33
							# iiiiiiiiiiiivvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv	
					if ( ii_vys < (trunc(maxpoc_stanic_indiv* (1-koef_data_verified/100)) ) ) {
						pos_posl=ii_pos  
						
						if (data_info_DT_out$k_select[ii_pos]!=0) {  #this is not suiatable, neni to vhodne ...
							ii_vys=ii_vys-1
														  } # if (data_info_DT_out$k_select!=0)
														
																			} else {
										# source("rprog/functions_corr.r",TRUE)	
						hodn_koef_vys = Check_altitudes_sel_for_neighbours( pole_data_vys=data_info_DT_out[ k_select==0 ,c("ALT_2","del_","Dist_order") ], a_vys , ii_pos)
						
						data_info_DT_out[ii_pos, Alt_IQR:=hodn_koef_vys ]
						
						
					   if (!is.na(hodn_koef_vys)) if (hodn_koef_vys>koef_1_5) {
						# &&<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
						 data_info_DT_out[ii_pos,del_:=TRUE]
						ii_vys=ii_vys-1	#
						
# print_my(ii_pos,ii_vys,k_print_done, sep=",")				
if (k_print_done==FALSE) { print(paste("     ",a_stan,': ','Altitude of base station (',a_vys,') differs significantly from neighbours ... ')) ; k_print_done=TRUE }
								
								
													 } else {
						# has to start finding again, since IQR statistics has changed ..., 
						
							# reverse find, *musi to hledat zpetne ...
						  if ( (data_info_DT_out$del_[ii_pos]==FALSE) & (ii_vys+1<maxpoc_stanic_indiv) 
								&  (  (pos_posl+1) <= (ii_pos-1) )          ) {
						  						  
								# ffffffffffffffffffff
						   for (jj_pos in ((pos_posl+1):(ii_pos-1)) ) {
										# counts without deleted, spocita to bez deleted			
						 hodn_koef_vys=Check_altitudes_sel_for_neighbours( pole_data_vys=data_info_DT_out[ k_select==0 ,c("ALT_2","del_","Dist_order")] , a_vys, ii_pos)
						 data_info_DT_out[ jj_pos , Alt_IQR:=hodn_koef_vys ]
						 
							if (hodn_koef_vys>koef_1_5) {
														 # &&<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
							  if (data_info_DT_out$del_[jj_pos]==FALSE) {
								# removes it,
								data_info_DT_out[jj_pos,del_:=TRUE]
								ii_vys=ii_vys-1
																		}
														 } else {
							  if (data_info_DT_out$del_[jj_pos]==TRUE) {
								# leaves it there, 
								data_info_DT_out[jj_pos,del_:=FALSE]
								ii_vys=ii_vys+1
																		}
																} #else 
													
							if ((ii_vys+1)>=maxpoc_stanic_indiv) {
print("leaving the ngb clever selection")							
							 break 
															} #	if
																		} # for (jj_pos in ((pos_posl+1):(ii_pos-1)))
								# ffffffffffffffffffff
																								} 
						    
					   
			   
													   } #if (hodn_koef_vys>m.koef_1_5)
			   
			
												    } 
							# iiiiiiiiiiiivvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv	
																					
							ii_vys=ii_vys+1
							
							
								# removes the same station, if it is repeated, 
									a_stan2 = data_info_DT_out$ID_2[ii_pos]
									jj_pom = data_info_DT_out$ID_2==a_stan2
									jj_pom[1:ii_pos] = FALSE
								data_info_DT_out[ jj_pom , del_:=TRUE ]
								
												  } #if (data_info_DT_out$del_[ii_pos]=FALSE)
												  
						ii_pos=ii_pos+1
												} # while 
				# wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww
												
			
      	# *vvvvvvvvvvvvvvvvvvvvvvvvvvv
 	

 
 ##########
							
							#removes rows that do not fulfill condition, del_ - outlied altitudes, 
							data_info_DT_out$k_select=(data_info_DT_out$k_select) + 1 *(data_info_DT_out$del_)
							


	
	
																	   } # if (k_clever_altitude_sel==T) 
											# ccccccccclllllllllllllll_nnnnnnnnnnnnnnnsssssssssssssssssssssssssss

# stop("stop here before final selection of station")
											

										#################################
										
										
										#stations selection:
											#	data_info_DT_out$k_select
											#	Distance
											# df<-df[,order(colnames(df),decreasing=TRUE)]
										# out_order=order(,decreasing=TRUE)
										
										if ("Correl" %in% names(data_info_DT_out)) {
										setorder(data_info_DT_out,  k_select,pen_corr  , na.last=TRUE )
																					} else {
										setorder(data_info_DT_out,  k_select,Distance  , na.last=TRUE )
																							}

										# marks for deleting excess rows, left just given number
										data_info_DT_out[, mfd_:=TRUE]
										
											# maxpoc_stanic_indiv=maxpoc_stanic
										if (maxpoc_stanic_indiv>nrow(data_info_DT_out)) maxpoc_stanic_indiv=nrow(data_info_DT_out)
										data_info_DT_out[ 1:(maxpoc_stanic_indiv) , mfd_:=FALSE ]


										
										#orders back according to original order
										if ("Correl" %in% names(data_info_DT_out)) {
										setorder(data_info_DT_out, pen_corr , na.last=TRUE )
																					} else {
										setorder(data_info_DT_out, Dist_order , na.last=TRUE )
																							}



										
											# neighbours order
											data_info_DT_out[ mfd_==FALSE , NGB_ORDER:= (1:(maxpoc_stanic_indiv)) ]
										
										
										# if some neighbour was not accepted and skipped, now marks mfd_ to let it on the output, just to know
											maxpoc_stanic_indiv=max(which(data_info_DT_out$mfd_==FALSE))
										
											#markes for del skipped unused neighbours	
											data_info_DT_out[ (mfd_==TRUE) & ((1:nrow(data_info_DT_out))<=maxpoc_stanic_indiv) , del_:=TRUE ]
																					
										data_info_DT_out[ 1:(maxpoc_stanic_indiv) , mfd_:=FALSE]
										

										data_info_DT_out[ , ID:=ID_1 ]
										data_info_DT_out[ 1:nrow(data_info_DT_out) , ID_1:="" ] # data_info_DT_1 has ID_1
										
										
										#################################
# stop("stop here before binding ngb info")										
												
										# adds period info
											data_info_DT_1[ , BEGIN:=BEG_1 ]
											data_info_DT_1[ , END  :=END_1 ]
										if ( length( ss_periods_all[ss_periods_all!=""] )>0 ) {
										
											if (class(data_info_DT_1$BEGIN)=="numeric") ss_begin=year_begin else ss_begin=date_begin
											if (class(data_info_DT_1$END  )=="numeric") ss_end  =year_end   else ss_end  =date_end
											data_info_DT_1[ 1 , BEGIN:=ss_begin ]
											data_info_DT_1[ 1 , END  :=ss_end   ]
											
											
											if (class(data_info_DT_out$BEGIN)=="character") { 
												data_info_DT_1$BEGIN=as.character(data_info_DT_1$BEGIN)
												ss_begin=as.character(ss_begin)
																							}
											if (class(data_info_DT_out$END)=="character")   {
												data_info_DT_1$END=as.character(data_info_DT_1$END)
												ss_end=as.character(ss_end)
																							}
																							
											data_info_DT_out[ BEGIN<ss_begin , BEGIN:=ss_begin ]
											data_info_DT_out[ END  >ss_end   , END  :=ss_end   ]

											
																	   } # if (length(ss_periods_all)>1)
																	   
											# Stan_order=ii_d
											data_info_DT_1[ , Stan_order:=ii_d]
											
											#binds together with previous results
										l = list(data_info_DT_1, as.data.table(data_info_DT_out) )
										data_info_DT_1=rbindlist(l, fill=TRUE)
										
											
										
										
										#adjusts the output
											# additional empty row										
										#if (k_append_blank) {
												l = list( data_info_DT_1  ,  data_info_DT_1[0][1,]  )
												data_info_DT_1=rbindlist(l, fill=TRUE)
										#  				  }	
											
										
											 
										data_info_DT_1[ is.na(mfd_) , mfd_:=FALSE ]	
											
										
									if (any(ls()=="data_info_DT_1_all")) { 
										l = list(data_info_DT_1_all, as.data.table(data_info_DT_1) )
										data_info_DT_1_all=rbindlist(l, fill=TRUE)
											if (exists("l")) rm(l)
															   } else { data_info_DT_1_all=data_info_DT_1[] }
										
										
											
																				} #for (ii_d in 1:dim(file_dist_1)[1])
														# ffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffff

														
														
#################																										
										
						
												if (n_pd_function=="3/15/0") {
													
													# k_the_same_region=TRUE
													data_info_DT[ , REGION_:=REGION ]
													data_info_DT[ , REGION:=REGION_puv ] 
														data_info_DT[ , REGION_puv:=NULL ]
													
													data_info_DT_1_all[ , REGION_:=REGION ]
														data_info_DT_1_all[ , REGION:=NULL ]
													data_info_DT_1_all[ , REGION:=grp ] # REGION_puv
														# erases
														data_info_DT_1_all[ , REGION_puv:=NULL ]
														
																			 } # if (n_pd_function=="3/15/0")
																										
										
#################
#saves the results


	if (any(ls()=="data_out_ct")) rm(data_out_ct)
	
if (any(ls()=="data_info_DT_1_all"))	{
						# sorts columns, 
						data_info_DT_1_all=Change_Column_order(data_info_DT_1_all, c("ID_1","ID_2","REGION","BEGIN","END","LENGTH","Correl","Distance","Dist_order","ALT_1","ALT_2","alt_diff","Alt_IQR","LATITUDE","LONGITUDE","LAT_2","LON_2","BEG_1","END_1","PRC_MISS_1","BEG_2","END_2","BEGIN_c","END_c","","PRC_MISS_2","per_miss2","pen_miss2","prc_l_miss","pen_length","pen_corr","pen_dist","pen_alt" , "k_select"), 1 )  # "per_common",
						
						data_info_DT_1_all=Change_Column_order(data_info_DT_1_all, c("Stan_order"), 1000 )
									
									
					if (nchar(file_stat2)>0) {  
							#file_stat2  - contains in the name a given element ...
							
					# if (k_save_auxiliary_files==TRUE) {
					if (length(groups_)>1)
					if (k_save_only_final_results==FALSE) {
						if (k_CSV==TRUE) {				  
						file_stat2_csv=gsub(paste("[.]","dbf", sep=""),".csv", file_stat2, ignore.case = TRUE)
							if (length(groups_)>1) file_stat2_csv=filename_with_Temp( file_stat2_csv , k_save_Auxl_into_Temp=TRUE )
						
						# write.csv2( data_info_DT_1_all[ mfd_==FALSE ,] , file=file_stat2_csv, na="", row.names = FALSE)
						write.table( data_info_DT_1_all[ mfd_==FALSE ,] , file=file_stat2_csv, na="", row.names = FALSE , sep=";", dec=Sys.localeconv()[1] )
											}

							  # source("rprog/my__write_dbf.r", local=F)
							file_stat2_csv=file_stat2
							if (length(groups_)>1) file_stat2_csv=filename_with_Temp( file_stat2_csv , k_save_Auxl_into_Temp=TRUE )
						my__write_dbf(  data_info_DT_1_all[ mfd_==FALSE ,] , file_stat2_csv ,n_dec=3, print_output=FALSE , mfd = ( data_info_DT_1_all[ mfd_==FALSE , del_ ]==TRUE ) ) #,  n_dec=3, print_output=FALSE
print_my("  Neighbour info save to: ",file_stat2_csv)
														} # if (k_save_only_final_results==FALSE) 
											 } # if (nchar(file_stat2)>0)				


data_out_ct=data_info_DT_1_all


#################

								#<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<		
							 data_info_=cbind(data_info_DT, DF_dist )	 
								#<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<		
							# data_info_DT
								
								
							if (k_save_auxiliary_files==TRUE) {
						file_info_out= gsub(paste("[.]dbf", sep="") , paste("_dist",".dbf", sep=""),file_info, ignore.case = TRUE)
						if ( length( ss_periods_all[ss_periods_all!=""] )>0 ) {
								file_info_out= gsub(paste("[.]dbf", sep="") , paste( string_get_diff_from_begin(filename(file_stat2),filename(file_stat2_orig)) , "_dist",".dbf", sep=""), file_info , ignore.case = TRUE)
																									
								file_info_out=filename_with_Temp( file_info_out , k_save_Auxl_into_Temp=TRUE )
													  } # 
													  
							if (k_CSV==TRUE) {				  

						# write.csv2( data_info_ , file=file_info_out, na="", row.names = FALSE)		
						write.table( data_info_ , file=file_info_out, na="", row.names = FALSE, sep=";", dec=Sys.localeconv()[1] )		
								
										     } else {
						my__write_dbf( data_info_, file_info_out , print_output=FALSE ) #,  n_dec=3, print_output=FALSE
												 }					  
print_my("  Auxiliary info saved to: ",file_info_out, k_CSV)
# stop("stop here before saving aux ...")								
															  } # if (k_save_auxiliary_files==TRUE)
									
									
										} # if (any(ls()=="data_info_DT_1_all"))
										
										
						} # if (n_pd_function=="7/1/0")|(n_pd_function=="7/2/0")|(n_pd_function=="3/15/0")
					#ssssssssssssssssssss_cccccccccccccccccccccccccccccccccc

									
						





################################################################################################################
################################################################################################################
################################################################################################################

  
  
  
  
  
  
  
		#nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnngggggggggggggggggggggggggggbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb
		#nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnngggggggggggggggggggggggggggbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb
		#nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnngggggggggggggggggggggggggggbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb
		if ( (n_pd_function=="7/4/0")|(n_pd_function=="3/16/0") ) {
  

 
			list_neighbours=""
			ngb_info=NA
			
		if (file.exists(neighbour_info)) {
  
  
  
		 # source("rprog/my__read_dbf.R", local=F)		  		 

		# data=read.dbf(data_file,as.is=T)
		if (k_supress_output_all_possible==FALSE) {
		print("Reading Neighbour_Info file")
		# print(neighbour_info)
		print(relative_filepath(neighbour_info)) #f=neighbour_info ;	f2=getwd()
													}
				

						ngb_info_DT=Read_file_dbf_csv(file_info=neighbour_info, k_delete=TRUE, k_check_info_file=FALSE, k_check_data_file=FALSE, k_save_adjusted=FALSE , k_DataTable=TRUE , 
							k_the_same_region=k_the_same_region, k_CSV=k_CSV, k_use_marked_deleted=k_use_marked_deleted ,
							print_output=(k_supress_output_all_possible==FALSE) , k_check_ngb_info=TRUE  ) # , k_NA_to_blank=TRUE

	
			# pokud neni COREL nebo DISTANCE, tak to doplni
			if (!("CORREL" %in% names(ngb_info_DT))) ngb_info_DT$CORREL=NA
			if (!("DISTANCE" %in% names(ngb_info_DT))) ngb_info_DT$DISTANCE=NA
			
						# "" is taken as normal ID, has to put NAs:
						ngb_info_DT[["ID_1"]][ nchar(ngb_info_DT[["ID_1"]])==0 ]=NA
						ngb_info_DT[["ID_2"]][ nchar(ngb_info_DT[["ID_2"]])==0 ]=NA
						
					
		# pro kontrolu
		ngb_info_DT$row_orig = (1:(nrow(ngb_info_DT)))
 
					  
					  # removes empty ID,  vymazani prazdnych ID ======
					  inds <- is.na(ngb_info_DT$ID_1) & is.na(ngb_info_DT$ID_2)
					  if (any(inds)) {
						# print(paste("There are some (",sum(inds),
						#			") missing IDs in the ngb_info file (\"", relative_filepath(neighbour_info) ,
						#			"\") => such a rows were removed.",sep=""),quote=F)
						#ngb info is of PD format probably
if (k_supress_output_all_possible==FALSE)						
						print(paste("   empty rows deleted from ngb info file: ",sum(inds)))
						
						ngb_info_DT <- ngb_info_DT[!inds]
										}
										
						ngb_info_DT$ii_row = (1:(nrow(ngb_info_DT)))				
					  
					  if (all(!is.na(ngb_info_DT$ID_1)) & all(!is.na(ngb_info_DT$ID_2))) {
						if (k_supress_output_all_possible==FALSE) {
						print(paste("The ngb_info/distances file (\"", "" ,
									"\") seems to be in the \"one ID_1 - one ID_2\" format.",
									sep=""),quote=F)
						print("=> It will be used in that way.",quote=F)
																	}	
																	
								val_diff_n=my_diff_zmena(ngb_info_DT$ID_1, val_0=0 , val_last=-1)
								val_diff_n=which(val_diff_n>0)
									id_ord=1
								for (i in 1:(length(val_diff_n)-1)) {
									id_ord[val_diff_n[i]:(val_diff_n[i+1]-1)]=i
																	}
									id_ord[(val_diff_n[i+1]):nrow(ngb_info_DT)]=i+1								
							ngb_info_DT$id_ord=id_ord
							
						info_format <- 1
						
					  } else if (all((!is.na(ngb_info_DT$ID_1) & is.na(ngb_info_DT$ID_2)) | 
									 (is.na(ngb_info_DT$ID_1) & !is.na(ngb_info_DT$ID_2)))) {
									 
					  # adjusts ngb_info,  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
									 									 
									 #PD PD PD PD PD PD PD PD PD PD PD PD PD PD PD PD PD PD PD PD PD PD PD PD PD PD 
						if (k_supress_output_all_possible==FALSE) {
									print(paste("The ngb_info/distances file (\"", "" ,
												"\") seems to be in the \"one ID_1 - more ID_2\" format.",
												sep=""),quote=F)
									print("=> It will be used in that way.",quote=F)
																  }
									# is ID_1 unique?  
									ids1 <- ngb_info_DT$ID_1
									ids1 <- ids1[!is.na(ids1)]
									if (any(duplicated(ids1))) {
							#		  stop("Column ID_1 in the distances file contains some duplicities, these ID's have to be unique with this format of the ngb_info/distances file. It would be possible to improve the scripts and remove this condition.")
						if (k_supress_output_all_possible==FALSE) {
							print("ID_1 is repeated (probably using various periods for the same ID_1? Check it ...)")
																	}
																}
																
									# all ID_1, vsechna ID_1, co tam jsou
									IDs <- ngb_info_DT$ID_1
									# begin rows of the ID_1s
									inds <- c( which(!is.na(IDs)), nrow(ngb_info_DT)+1 )
										
										#Begin End period for the parts,  in info from the neibhrous
										ngb_info_DT$BEG_2=ngb_info_DT$BEGIN
											BEG_2=ngb_info_DT$BEG_2
										ngb_info_DT$END_2=ngb_info_DT$END
											END_2=ngb_info_DT$END_2										
										BEG_2[ which(!is.na(IDs)) ]=NA
										END_2[ which(!is.na(IDs)) ]=NA										
										
											if (class(ngb_info_DT$BEGIN)=="character") ngb_info_DT$BEGIN=as.Date(ngb_info_DT$BEGIN)
										BEGIN=ngb_info_DT$BEGIN
											if (class(ngb_info_DT$END)=="character") ngb_info_DT$END=as.Date(ngb_info_DT$END)
										END=ngb_info_DT$END
																				
										ngb_info_DT$id_ord=NA
											id_ord = ngb_info_DT$id_ord
										# ngb_info_DT$ngb_ord=NA
										ngb_info_DT$NGB_ORDER=NA
											ngb_ord = ngb_info_DT$NGB_ORDER # ngb_info_DT$ngb_ord
										
										
													#ffffffffffffffffffffffffffffffffffffffffffffffffffffffffffff				
									for (i in 1:(length(inds)-1)) {
									  # estimating the neighbour list section
									  i1 <- inds[i]
									  i2 <- inds[i+1]
									  if (i2-i1 >= 2) {  # there is at least one neighbour ..., 
										ii_ngb=(i1+1):(i2-1)
										IDs[ii_ngb] <- IDs[i1]
										
										# if (i!=stations_candidate$id_ord[i]) {
# stop(paste("ID_1 order does not match ...",i,stations_candidate$id_ord))
																			# }										
										# if (i1!=stations_candidate$ii_row[i]) {
# stop(paste("ID_1 order does not match ...",i,stations_candidate$id_ord))
																			# }										
										BEGIN[ii_ngb]=ngb_info_DT$BEGIN[i1]
										END[ii_ngb]  =ngb_info_DT$END[i1]
										
										id_ord[ii_ngb]=i

										ngb_ord[ii_ngb]=(1:length(ii_ngb))
										
														}  #if (i2-i1 >= 2)
																	} #for 
													#ffffffffffffffffffffffffffffffffffffffffffffffffffffffffffff				
													
					  					  													
									ngb_info_DT$ID_1 <- IDs
									ngb_info_DT$BEGIN=BEGIN
									ngb_info_DT$END=END
									ngb_info_DT$BEG_2=BEG_2
									ngb_info_DT$END_2=END_2
									ngb_info_DT$id_ord=id_ord
									# ngb_info_DT$ngb_ord=ngb_ord
									ngb_info_DT$NGB_ORDER=ngb_ord
										ngb_info_DT_puv=ngb_info_DT
									
									# check, kontrola
									#			ii_pom=which (  (ngb_info_DT$NGB_ORDER==ngb_info_DT$K12)==FALSE )
									#			if length(ii_pom>0) {
									#	stop("PD ngb file and this prepararion does not match")		
									#								 }
										
										
										# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
									# removes empty ID_1 rows ...,  da pryc ty prazdne ID_1 radky ...
									ngb_info_DT <- ngb_info_DT[!is.na(ngb_info_DT$ID_1) & !is.na(ngb_info_DT$ID_2) , ]
										# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
									
									info_format <- 2
									
									 #PD PD PD PD PD PD PD PD PD PD PD PD PD PD PD PD PD PD PD PD PD PD PD PD PD PD 
									
						} else {
						stop("The format of ngb_info/distances file (\"",parameters$INFO_FILE_PATH,
							 "\") is unclear. It has to be either in \"one ID_1 - one ID_2\"",
							 " format or in \"one ID_1 - more ID_2\" format. In the first",
							 " case every row has to have both IDs, in the second case every row",
							 " has to have just one ID.")
								}
								
										 } #if (file.exists(neighbour_info))
 
 
 
###################################################################################################
###################################################################################################
###################################################################################################
 
# if (k_supress_output_all_possible==FALSE) {
	print("")
	print_my("Transformation of values: ")
	print_my( print_transformation(n_transformation) )
	print("")
										  # }
 
 

 
 ###################3
 
if (k_supress_output_all_possible==FALSE) {
 print("")
 print("")
 # print("")
 print("Running QC ... ")
 print("")
											}
											
 				if (any(ls()=="data_out_ct_sel_all"))  rm(data_out_ct_sel_all)
						if (any(ls()=="data_out"))  rm(data_out)						
				if (any(ls()=="stat_ct_all"))  rm(stat_ct_all)	
						if (any(ls()=="data_out_ct"))  rm(data_out_ct)
				
				if (any(ls()=="DT_Same_ngbs_all"))  rm(DT_Same_ngbs_all)	
				if (any(ls()=="DT_Same_base_all"))  rm(DT_Same_base_all)	
				

								col_names_diffs=NA
								col_names_diffs_stnd_p=NA
								col_names_ngbs_t1=NA
								col_names_ngbs_t1_diffs=NA
								col_names_ngbs_t1_diffs_stnd=NA
								col_names_ngbs_t1_diffs_stnd_p=NA
								col_names_ngbs_alt_stnd=NA
								col_names_ngbs_alt_stnd_p=NA
									col_names_ngbs_t1_stnd=NA
									col_names_ngbs_alt_t1=NA
									col_names_ngbs_alt_t1_stnd=NA
									col_names_ngbs_t1_stnd_b_diff=NA
									col_names_ngbs_t1_stnd_b_diff_p=NA
								col_names_diffs_check=NA
				
				n_deleted=0
				Perc_n_deleted=0
				
				
						#propr ID with x_Suffix
						# system.time(create_multi_id_with_suffix(data_DT_1col,idcol))							
				data_multi_id_all=create_multi_id_with_suffix(data_DT_1col,idcol)
				
# stop("stop here before 7-4 calculations ...") 


		if (!("id_ord" %in% names(ngb_info_DT))) {
stop(paste("7-4 function, QC: column ID_ord is not present in the ngb info file",neighbour_info))
												}


		# now he will repeat processing for selected region,  
				# nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn
	for (ii_cand in (unique(ngb_info_DT$id_ord)) ) {
		
		ngb_info_DT_sel=ngb_info_DT[  ngb_info_DT$id_ord==ii_cand , ] 				
		
		stan_base=as.character(unique(ngb_info_DT_sel$ID_1)) # ngb_info_DT_sel$ID_1[1]
			
			# various selections
			stan_id_indiv=NA
			if ("ID_INDIV" %in% names(ngb_info_DT_sel)) stan_id_indiv=unique(ngb_info_DT_sel$ID_INDIV)
		
		a_region=""
			if ("REGION" %in% names(ngb_info_DT_sel)) {
		a_region=unique(ngb_info_DT_sel$REGION) # ngb_info_DT_sel$ID_1[1]
						if (is.na(a_region)) a_region=""
		
				#checks data
			###	 if ( (all(!is.na(idcol_group)))  )  # alas, for (k_columns_regions) this never comes true
				if ((nchar(a_region)>0)&(nchar(data_group)>0)) {   # 
				  if (!grepl( paste("_",a_region,"_", sep="") ,  data_group , fixed=TRUE))  {
				  
	if (k_supress_output_all_possible==FALSE)
	print_my("   Different group for station ",stan_base, ", region ",a_region,", expected: ",data_group,", skipping ... ", k_warning=TRUE)
	
	next # <<<<<<<<<<<<<<<<<<<<<<<<<<<<<< ggggggggggggggg				  
																							}
																	} # if (nchar(a_region)>0)
			
													   } # if ("REGION" %in% names(ngb_info_DT_sel))
		
		
		
		stan_ngbs=as.character(ngb_info_DT_sel$ID_2)
		
		
			if (!("NGB_ORDER" %in% names(ngb_info_DT_sel))) {
print_my("Column NGB_ORDER not present in ngb_info file", k_warning=TRUE)		
				if (("ngb_ord" %in% names(ngb_info_DT_sel))) {
print_my("Column ngb_ord copied to NGB_ORDER, in ngb_info file", k_warning=TRUE)		
					ngb_info_DT_sel[, NGB_ORDER:=ngb_ord]					
															}
															}		
		
		ii_ngbs=ngb_info_DT_sel$NGB_ORDER
		# in CSV, it is not marked for deleting, use either non NA  NGB_ORDER, od DEL_column
			k_pom=!is.na(ii_ngbs)
			stan_ngbs=stan_ngbs[k_pom]
			ii_ngbs=ii_ngbs[k_pom]
		
		# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
		ngb_info_DT_sel=ngb_info_DT_sel[ k_pom , ]
		# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
		
		
			if (any(ii_ngbs!=(1:(length(stan_ngbs))))) {
print(ii_ngbs)
stop(paste("Column ngb_ord/NGB_ORDER - order of the neighbours - mismatch ..., station: ", stan_base))			

# you can let here just warning ...
print_my(stan_base," - column ngb_ord/NGB_ORDER - order of the neighbours - mismatch ..., station: ", k_warning=TRUE, k_add_print_=TRUE)
# repair:
			ii_ngbs=(1:(length(stan_ngbs)))
														}
		
		# later:
		# stan_base_altitude =unique(ngb_info_DT_sel$ALT_1)
		# stan_ngbs_altitudes=ngb_info_DT_sel$ALT_2
		# stan_ngbs_weights=ngb_info_DT_sel$DISTNACE
		
		
		date_begin=unique(ngb_info_DT_sel$BEGIN) 
			if (class(date_begin)=="integer") {
			year_begin=date_begin
											 } else {
			year_begin=as.numeric(format(date_begin, "%Y"))	
													}
		date_end  =unique(ngb_info_DT_sel$END)
			if (class(date_end)=="integer") {
			year_end=date_end
											 } else {
			year_end=  as.numeric(format(date_end, "%Y"))	
													}
		
		n_max_ngbs=max(ngb_info_DT$NGB_ORDER, na.rm=TRUE)
		
			
		######################
		
# stop("Stop here - before data selection ...")
			
		#select base and ngb stations
				col_id=idcol[1]	
					data_multi_id=NA
				k_multi_ID=FALSE
		#			if ( (!is.na(year_begin))&(!is.na(year_end)) ) {	
		#  later ...
		#															} else {
		data_DT_1col_sel=data_DT_1col[ (data_DT_1col[[col_id]] %in% c(stan_base,stan_ngbs) ) , ]
		#																	}
			
			
			
			# checks the selection ... combination of more columns ...
			# gggggggggggggggg
			if ( (all(!is.na(idcol_group)))  ) {  # NE: | (k_columns_regions)
			 if (nchar(a_region)>0) {
				ss_pom=apply(  data_DT_1col_sel[ , idcol_group, with=FALSE] ,1, paste, collapse="_")	
				ss_pom=paste("_",ss_pom,"_", sep="")				
				
				if (k_force_groups==TRUE) {
		data_DT_1col_sel=data_DT_1col_sel[ grepl( paste("_",a_region,"_", sep="") , ss_pom , fixed=TRUE) , ]
										  } else {
		data_DT_1col_sel=data_DT_1col_sel[ paste("_",a_region,"_", sep="") == ss_pom  , ]
												}
			
			
				#EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE
			#checks other data - if are empty or exist:
			if (nrow(data_DT_1col_sel)==0) {
								
						   k_pom=grepl( paste("_",a_region,"_", sep="")  , data_groups_all , fixed=TRUE) 			
				if ( sum(  k_pom ,na.rm=TRUE)==0 ) {
	if (k_supress_output_all_possible==FALSE)
	print_my("Candidate: ",stan_base, ", region ",a_region," -  data are empty", k_warning=TRUE, k_add_print_=TRUE)
	
	next # <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
													} else {
				# ######################sssssssssssssssssss
					#no data, a problem,  
					# it can be already given by the original selection, 
					# data_DT_1col[ (data_DT_1col[[col_id]] %in% c(stan_base,stan_ngbs) ) , ]
					# if, e.g.,  stan_base  is composed from ID+Region ...
					
							#	data_multi_id_all=create_multi_id_with_suffix(data_DT_1col,idcol)
						   k_pom=(data_multi_id_all %in% c(stan_base,stan_ngbs) )
				if ( sum(  k_pom ,na.rm=TRUE) == 0 ) {					
	print_my("Candidate: ",stan_base, ", region ",a_region," -  data are empty", k_warning=TRUE, k_add_print_=TRUE)
	next # <<<<<<<<<<<<<<<<<<<<<<<<<<<<<< ggggggggggggggg
													 } else {
				data_DT_1col_sel=data_DT_1col[ k_pom , ]
				k_multi_ID=TRUE
															}
																} # if ( sum(  k_pom ,na.rm=TRUE)==0 )
				# ######################sssssssssssssssssss
											} #if (nrow(data_DT_1col_sel)==0)
				#EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE
			
									} #if (nchar(a_region)>0)
									      } # if ( (all(!is.na(idcol_group))) | (k_columns_regions) )
			# gggggggggggggggg

			

					if (!is.na(year_begin)) {
		data_DT_1col_sel=data_DT_1col_sel[ (YEAR>=year_begin) , ]
											}	
					if (!is.na(year_end)) {	
		data_DT_1col_sel=data_DT_1col_sel[ (YEAR<=year_end) , ]
											}	


			
		
			cols_date=c("YEAR","MONTH","DAY","TIME")
		cols_date=cols_date[ cols_date %in% names(data_DT_1col_sel) ]
		
		
if (nrow(data_DT_1col_sel)==0) {
	print_my("Candidate: ",stan_base, ", period: ",year_begin," - ",year_end," -  data are empty", k_warning=TRUE, k_add_print_=TRUE)
	next # <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
								}		
		
		
############3


		 # QC ( X / Y ): Candidate: xxx, region: yyy, period:
		ss_pom=paste( "( ",ii_cand," / ",max(ngb_info_DT$id_ord, na.rm=TRUE)," )" ,sep="")
		if ( (all(!is.na(idcol_group))) | (k_columns_regions) ) {
			ss_pom=paste( " ( ",  
						round( (which(grp==groups_)-1) + ( ii_cand/max(ngb_info_DT$id_ord, na.rm=TRUE) ), 3)   
						," / ",length(groups_)," ) " ,
						"(station-region: ",ii_cand," out of ",max(ngb_info_DT$id_ord, na.rm=TRUE)," )"  ,	
										sep="") 
										} 
# progress_bar										
ss_pom=print_my(" QC ",ss_pom,": ","Candidate: ",stan_base,
			ifelse(nchar(a_region)>0, paste(", region:",a_region) ,"") ,  
			", period: ",ifelse(is.na(year_begin),"-",year_begin)," - ",ifelse(is.na(year_end),"-",year_end),
			", ngbs: ", stan_ngbs
				, k_add_print_=FALSE )			
					
		
############		
			
		#rename stations to general names
		data_DT_1col_sel[ data_DT_1col_sel[[col_id]]==stan_base , c(col_id):="st_base"]
			if (k_multi_ID) {
												#propr ID with x_Suffix
					data_multi_id=create_multi_id_with_suffix(data_DT_1col_sel,idcol)

				data_DT_1col_sel[ data_multi_id==stan_base , c(col_id):="st_base"]
							} 
		
			col_names_ngbs=NA
			col_names_stations="st_base"
		  for (ii_ngb in ii_ngbs) {
			col_names_ngbs[ii_ngb]=paste("st_",  gsub(' ','0',paste(format(ii_ngb, justify="right", width=floor(log10(n_max_ngbs))+1))) ,sep="")
			data_DT_1col_sel[ data_DT_1col_sel[[col_id]]==stan_ngbs[ii_ngb] , c(col_id):=col_names_ngbs[ii_ngb] ]
				if (k_multi_ID) data_DT_1col_sel[ data_multi_id==stan_ngbs[ii_ngb] , c(col_id):=col_names_ngbs[ii_ngb] ]
			col_names_stations=c(col_names_stations, col_names_ngbs[ii_ngb])
								} #for (ii_ngb in ii_ngbs)
			# summary_DT(data_DT_1col_sel)
		
		
			
					#ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct 
		#cross table 
				
				# ss_col="ID"				
				ss_col=col_id			
# if (k_verbose) 				
if (k_supress_output_all_possible==FALSE)
print(paste("   Creating cross table - for ", ss_col ," ..."))
			ss_names_group=names(data_DT_1col_sel)
			ss_names_group=ss_names_group[(ss_names_group!=ss_col)&(ss_names_group!="VALUE2")]
			ss_formula=paste( paste( ss_names_group, collapse="+" ) ,"~",ss_col)
			
			data_out_ct_sel = dcast.data.table(data_DT_1col_sel, as.formula( ss_formula ) , fun.aggregate=NULL, value.var="VALUE2")		
			# adjusts column order, upravi poradi sloupcu
			data_out_ct_sel=Change_Column_order(data_out_ct_sel,col_names_stations,1000)
			
					#ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct ct 
			
				#for monthly data ...
				if ("MONTH" %in% names(data_out_ct_sel)) {
					if (any( (as.numeric(data_out_ct_sel$MONTH))!=((data_out_ct_sel$MONTH)) , na.rm = TRUE)) {
						data_out_ct_sel[, MONTH_names:=MONTH]
						data_out_ct_sel=Change_Column_order(data_out_ct_sel,"MONTH_names",order="MONTH")
						data_out_ct_sel[, MONTH:=as.numeric(MONTH) ]
																											 }
														}
						
#####
# check the result table
if ((dim(data_DT_1col_sel)[1])==(dim(data_out_ct_sel)[1])) {
if (k_supress_output_all_possible==FALSE) {
print("")
print_my("Columns in input data: ",names(data_DT_1col_sel))
										   }
# stop("Strange thing happened: the data have the same lenght after making cross table (are the ID columns OK?)")
print_my(stan_base,": ",a_region,", Strange thing happened: the data have the same lenght after making cross table (are the ID columns OK?)" , k_warning=TRUE)
															}
			
			
			
			
#####
# check dates			
			
			# has to put away non-existing dates ...
			my_date=Existing_Date( year=as.numeric(data_out_ct_sel$YEAR), month = as.numeric(data_out_ct_sel$MONTH), day = as.numeric(data_out_ct_sel$DAY) ) 
			data_out_ct_sel=data_out_ct_sel[ my_date , ]
			
								#ttttttttttttttttttttttttttttttttttttttttttttttttt							
							#check gaps ...
			data_1_col_dt=as.Date( ISOdate( year=as.numeric(data_out_ct_sel$YEAR), month = as.numeric(data_out_ct_sel$MONTH), day = as.numeric(data_out_ct_sel$DAY)) ) 
							diff_date=my_diff( data_1_col_dt, my_lag=1 , start_NA=TRUE)  #, by=ss_by_differences
							diff_date[1]=1 #replaces first NA value
							# beware: when non-existing date (31/4), it creates two NAs ...				
                 if (sum(is.na(diff_date))) {
	print_my("   ", stan_base, ": NA gaps in dates occur ...  ", k_warning=TRUE , k_add_print_=FALSE)
											}							
							
								# val_unique_year=unique(na.omit(diff_date))	
								val_unique_year=(na.omit(diff_date))	
								if (any(val_unique_year>1))  {  
									# print(data_out_ct_sel[ diff_date>1 , ])
									k_pom= which(diff_date>1)
	print_my("   ", stan_base, ": there are time gaps in data, ",", gaps lenght: ", val_unique_year[val_unique_year>1],", positions (rows): ",k_pom, k_warning=TRUE)
									k_pom= c( (k_pom-1), k_pom )
									k_pom=sort(k_pom)
	# stop("PROBLEM - differences for date - there are probably some gaps ... ") 
	print("Table, with End data and Begin data (second row, after the gap): ")
									print(data_out_ct_sel[ k_pom , ])
								
															 }
								#ttttttttttttttttttttttttttttttttttttttttttttttttt							
			
			
			
			
############			
			
# stop("stop here before getting statistics")			
			
			
		if (!(n_pd_function=="3/16/0"))	{
			ii_pom =which("st_base"==names(data_out_ct_sel)) # col_names_stations
if (is.empty(ii_pom)) {
	# print_my("   ...  no data for base station (st_base) ", k_warning=TRUE)
# stop("stop here no data for base station")	

		ss_pom=""
		ss_pom=print_my(" QC ",ss_pom,": ","Candidate: ",stan_base,
			ifelse(nchar(a_region)>0, paste(", region:",a_region) ,"") ,  
			", period: ",ifelse(is.na(year_begin),"-",year_begin)," - ",ifelse(is.na(year_end),"-",year_end),
			", >>>  ...  skipping: no data for base station (st_base)  <<< " )			
	if (k_supress_output_all_possible==FALSE)
	print_my(ss_pom, k_warning=TRUE)
				
write_error_problem( ss_message=ss_pom,  file_log=paste(filepath(file_stat), "log_errors.txt", sep="") )
				
	next # <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
			
								  } # if (is.empty(ii_pom))
										} # if (!(n_pd_function=="3/15/0"))
			
			
			ii_d_sel=match(col_names_ngbs, names(data_out_ct_sel))
			ii_d_sel=ii_d_sel[!is.na(ii_d_sel)]											
if (is.empty(ii_d_sel)) {
if (k_supress_output_all_possible==FALSE) 
	print_my("Candidate: ",stan_base, ", no neighbour data found ... ", k_warning=TRUE)
	next # <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
						}
						
			ii_d_sel=match(col_names_ngbs, names(data_out_ct_sel))
if (sum(is.na(ii_d_sel))>0)	{
		ss_pom=paste(col_names_ngbs[is.na(ii_d_sel)],stan_ngbs[is.na(ii_d_sel)],sep=": ")
if (k_supress_output_all_possible==FALSE) {
	print("")
print_my("These neigbhours has no data: ",ss_pom, k_warning=TRUE , sep=",")
											}
							}
			
			
			
		
			#sssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
			
		#calculates statistics
	
				# source("rprog/functions_corr.r",TRUE, encoding = "UTF-8")	coding for unix
	
# if (k_verbose) 
if (k_supress_output_all_possible==FALSE)
print("   Getting stations statistics ...")

			stat_ct = Get_statistics_basic( ss_col_base="st_base", ss_cols=col_names_stations , ss_names_ngb=col_names_ngbs , 
											ss_name_suffix="", k_append_blank=FALSE, k_include_KS=TRUE, k_verbose=k_verbose, stat_ct=NA )
			
											 
		###				
			
			
		# info about correlations									
			stat_ct = Get_statistics_covariates(  ss_col_base="st_base" , ss_cols=col_names_ngbs , 
													ss_name_suffix="" , k_append_blank=FALSE , stat_ct=stat_ct )
			


			
			#sssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
			
###############################				
					
			
				#helpfull statitistics:
										ii_d_sel=match(col_names_ngbs, names(data_out_ct_sel))
											ii_d_sel=ii_d_sel[!is.na(ii_d_sel)]
								data_out_ct_sel[ , q025_ngbs := Stat_calculate_row(  data_out_ct_sel[, ii_d_sel, with=FALSE], "p" , na_rm=TRUE, probs=0.25 ) ]	
								
								data_out_ct_sel[ , q050_ngbs := Stat_calculate_row(  data_out_ct_sel[, ii_d_sel, with=FALSE], "p" , na_rm=TRUE, probs=0.50 ) ]	
								
								data_out_ct_sel[ , q075_ngbs := Stat_calculate_row(  data_out_ct_sel[, ii_d_sel, with=FALSE], "p" , na_rm=TRUE, probs=0.75 ) ]	
								
	
															 
			# gets coefficient of IQR - interquartile range
							ii_pom =which("st_base"==names(data_out_ct_sel))
							ii_d_sel=match(col_names_ngbs, names(data_out_ct_sel))
											ii_d_sel=ii_d_sel[!is.na(ii_d_sel)]
							
							if (!is.empty(ii_pom)) {
						data_out_ct_sel[ , Coef_IQR:=Stat_calculate_row_IQR( x=data_out_ct_sel[, ii_pom , with=FALSE] , Y=data_out_ct_sel[, ii_d_sel, with=FALSE] ) ]	
													} # if (!is.empty(ii_pom))
										
				
################
			
			
			
			
			
			
			
			
			
			
# *k_add_differences
  # *AAAAAAAAADDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD
# if (k_add_differences=.T.) and(k_base_exist_values=.T.)  AND (k_base_data_type='N') {

# DIFFERENCES
if (k_verbose)  print("   Getting difference")

					col_names_diffs=NA
			for (ii_ngb in ii_ngbs) {
				col_names_diffs[ii_ngb]=paste("diff_",  gsub(' ','0',paste(format(ii_ngb, justify="right", width=floor(log10(n_max_ngbs))+1))) ,sep="")
					
					ii_pom =which("st_base"==names(data_out_ct_sel))
					ii_pom2=which(col_names_ngbs[ii_ngb]==names(data_out_ct_sel))
						
					# differences or ratios or transformed values	
							if (!is.empty(ii_pom)) {
				data_out_ct_sel[ , c(col_names_diffs[ii_ngb]) := ( transform_data( data_out_ct_sel[ , ii_pom2 , with=FALSE] , data_out_ct_sel[ , ii_pom , with=FALSE] , n_transformation ) ) ]
													} # if (!is.empty(ii_pom))
								   } # for (ii_ngb in ii_ngbs)								
				# summary_DT(data_out_ct_sel)
				
				
						

		# statistics for diferences
			#sssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
			
					
				# col_names_diffs  - diff_
			stat_ct = Get_statistics_basic( ss_col_base="", ss_cols=col_names_diffs ,  ss_names_ngb=col_names_diffs , 
											ss_name_suffix=string_same_letters(col_names_diffs), k_append_blank=FALSE, k_include_KS=TRUE, k_verbose=k_verbose, stat_ct=stat_ct)

																
			#sssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
			
			



# STANDARDIZED DIFFERENCES
if (k_verbose)  print("   Getting STANDARDIZED difference")

					col_names_diffs_stnd=NA
			for (ii_ngb in ii_ngbs) {
				#st_naz_dif
				col_names_diffs_stnd[ii_ngb]=paste("d_stnd_",  gsub(' ','0',paste(format(ii_ngb, justify="right", width=floor(log10(n_max_ngbs))+1))) ,sep="")
					# col_names_stations[ii_ngb+1] #the first is st_base
																												
														 
				if (!(col_names_diffs[ii_ngb] %in% names(data_out_ct_sel))) {
next 				
						  }										 
														 
				#standardize differences, by month
				data_out_ct_sel[ , c(col_names_diffs_stnd[ii_ngb]) := (lapply(.SD, standardize )) , by=MONTH, .SDcols=c(col_names_diffs[ii_ngb]) ]
				# takes care about NAs
					ii_pom2=which( col_names_diffs_stnd[ii_ngb]==names(data_out_ct_sel))
							if (!is.empty(ii_pom2)) {
				data_out_ct_sel[ data_out_ct_sel[[ii_pom2]]==missval , c(col_names_diffs_stnd[ii_ngb]) := NA ]
													} # if (!is.empty(ii_pom))

								   } # for (ii_ngb in ii_ngbs)								
				
 


		# statistics for _stnd diferences
			#sssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
			
			
			#standardized differences
			stat_ct = Get_statistics_basic( ss_col_base="", ss_cols=col_names_diffs_stnd , ss_names_ngb=col_names_diffs_stnd , 
											ss_name_suffix=string_same_letters(col_names_diffs_stnd), k_append_blank=FALSE, k_include_KS=TRUE, k_verbose=k_verbose, stat_ct=stat_ct )

						 		
					
			#sssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
																					
			
###############################				
			
						
if (k_verbose)  print("   Calculating probability ...")
								
										col_names_diffs_stnd_p=NA
								for (ii_ngb in ii_ngbs) {
									#st_naz_dif
									col_names_diffs_stnd_p[ii_ngb]=paste("pd_stnd_",  gsub(' ','0',paste(format(ii_ngb, justify="right", width=floor(log10(n_max_ngbs))+1))) ,sep="")

				if (!(col_names_diffs_stnd[ii_ngb] %in% names(data_out_ct_sel))) {
next 				
						  }										 
																		
									data_out_ct_sel[ , c(col_names_diffs_stnd_p[ii_ngb]) := (lapply(.SD, pnorm )) , by=MONTH, .SDcols=c(col_names_diffs_stnd[ii_ngb]) ]
									#converts all to upper tail
											ii_d_sel=which( col_names_diffs_stnd_p[ii_ngb]==names(data_out_ct_sel))
												ii_d_sel=ii_d_sel[!is.na(ii_d_sel)]
											k_pom=data_out_ct_sel[[ii_d_sel]]<0.5
									data_out_ct_sel[ k_pom , c(col_names_diffs_stnd_p[ii_ngb]) := (1 - (data_out_ct_sel[ k_pom , ii_d_sel, with=FALSE]))  ]
													   } # for (ii_ngb in ii_ngbs)								
									

					#########					

					
						ii_d_sel=match(col_names_diffs_stnd, names(data_out_ct_sel))
							ii_d_sel=ii_d_sel[!is.na(ii_d_sel)]
							if (!is.empty(ii_d_sel)) {							
					data_out_ct_sel=data_out_ct_sel[ , CNT:=Stat_calculate_row(  data_out_ct_sel[, ii_d_sel, with=FALSE], "CNT" ) ]	
											
												# std_nasobek_limit - corresponds to  limit_confidence 
					data_out_ct_sel=data_out_ct_sel[ , Exc_count:=PD_calculate_row(  data_out_ct_sel[, ii_d_sel, with=FALSE] , std_nasobek_limit , k_eq_value=1,k_mt_value=1,k_lt_value=0 , k_abs_val=TRUE, na_rm=TRUE ) ]
					data_out_ct_sel=data_out_ct_sel[ CNT>0 , Perct_Exc:=Exc_count/CNT ]	
											
					# data_out_ct_sel$Exc_count[(n_nbgs-data_out_ct_sel$CNT)>n_max_missing]=NA					
					# data_out_ct_sel$Exc_count[data_out_ct_sel$CNT==0]=NA

													} else { # if (!is.empty(ii_pom))
													
						ii_d_sel=match(col_names_ngbs, names(data_out_ct_sel))
							ii_d_sel=ii_d_sel[!is.na(ii_d_sel)]
					data_out_ct_sel=data_out_ct_sel[ , CNT:=Stat_calculate_row(  data_out_ct_sel[, ii_d_sel, with=FALSE], "CNT" ) ]	
															} 
					
					#########					
					
					
					#gets  p  maximum		
						ii_d_sel=match(col_names_diffs_stnd_p, names(data_out_ct_sel))
							ii_d_sel=ii_d_sel[!is.na(ii_d_sel)]
							
							if (!is.empty(ii_d_sel)) {							
							
					# if empty, this gives warning ...
					data_out_ct_sel=data_out_ct_sel[ CNT!=0 , CDF_max_d:=Stat_calculate_row(  data_out_ct_sel[ CNT!=0 , ii_d_sel, with=FALSE], "MAX" , na_rm=TRUE) ]	
						data_out_ct_sel[ CNT==0 , CDF_max_d := NA]
					#gets  p  median
					data_out_ct_sel=data_out_ct_sel[ , CDF_med_d:=Stat_calculate_row(  data_out_ct_sel[, ii_d_sel, with=FALSE], "p" , na_rm=TRUE, probs=0.5 ) ]	
						data_out_ct_sel[ CNT==0 , CDF_med_d := NA]
					
													} # if (!is.empty(ii_pom))
					
#######
			
			# } # if (k_add_differences=.T.) and(k_base_exist_values=.T.)  AND (k_base_data_type='N') {
# *k_add_differences
  # *AAAAAAAAADDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD

  


				
################									
								
								
															
								
								
# stop("stop here before first differences")											


								col_names_ngbs_t1=NA
				# DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD	
	if (k_first_differences) {
	
if (k_verbose) print("   Getting the first differences")
				
				
				# first differences for base and ngbs
							
							
							if ("st_base" %in% names(data_out_ct_sel))		
							data_out_ct_sel[ , t1_base := my_diff( transform_data_1( st_base , n_transformation ) , my_lag=1 , n_transformation=n_transformation) ] # k_ratios=(n_transformation<=0)
							
								col_names_ngbs_t1=NA
					for (ii_ngb in ii_ngbs) {
							col_names_ngbs_t1[ii_ngb]=paste("t1_",  gsub(' ','0',paste(format(ii_ngb, justify="right", width=floor(log10(n_max_ngbs))+1))) ,sep="")
							ii_pom =which(col_names_ngbs[ii_ngb]==names(data_out_ct_sel))

							data_out_ct_sel[ , c(col_names_ngbs_t1[ii_ngb]) := my_diff( transform_data_1( data_out_ct_sel[ , ii_pom , with=FALSE] , n_transformation ) , my_lag=1 , n_transformation=n_transformation) ] # k_ratios=(n_transformation<=0)
							
						   
											} # for (ii_ngb in ii_ngbs)								

										

					# check the time gaps	
								#ttttttttttttttttttttttttttttttttttttttttttttttttt
					data_1_col_dt=as.Date( ISOdate( year=as.numeric(data_out_ct_sel$YEAR), month = as.numeric(data_out_ct_sel$MONTH), day = as.numeric(data_out_ct_sel$DAY)) ) 
							
									# ss_by_differences="idcol_all"
							diff_date=my_diff( data_1_col_dt, my_lag=1)  #, by=ss_by_differences
																										
								val_unique_year=(na.omit(diff_date))	
								if (any(val_unique_year>1))  {  
# this is solved also above just after creating cross table ct								
# print("Table, with End data (after the gap): ")
									k_pom= which(diff_date>1)
										
	print_my("   ", stan_base, ", PROBLEM - differences for date - there are probably some gaps in data ...",", positions (rows): ",k_pom, k_warning=TRUE)
						
# stop("Stop here printing gaps data")				
															 }
								#ttttttttttttttttttttttttttttttttttttttttttttttttt
															 


				
			# statistics for first differences
			#sssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
							
							# c("t1_base" ,col_names_ngbs_t1)
			stat_ct = Get_statistics_basic( ss_col_base="t1_base" , ss_cols=c("t1_base" ,col_names_ngbs_t1) , ss_names_ngb=col_names_ngbs_t1 , 
											ss_name_suffix=string_same_letters(col_names_ngbs_t1), k_append_blank=FALSE, k_include_KS=TRUE, k_verbose=k_verbose,  stat_ct=stat_ct)
						
			
			#sssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
									
					
													
						# uuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuu
			if (!((n_pd_function=="3/16/0"))) {

																												 
				# gets coefficient of IQR - interquartile range
			
							ii_pom =which("t1_base"==names(data_out_ct_sel))
							ii_d_sel=match(col_names_ngbs_t1, names(data_out_ct_sel))
								ii_d_sel=ii_d_sel[!is.na(ii_d_sel)]
								
							if (!is.empty(ii_pom)) {
						data_out_ct_sel[ , IQR_time:=Stat_calculate_row_IQR( x=data_out_ct_sel[, ii_pom , with=FALSE] , Y=data_out_ct_sel[, ii_d_sel, with=FALSE] ) ]	
					
					
				#compares time change there and back ... mean of t and t+1
						data_out_ct_sel[ , IQR_time_back:=c(data_out_ct_sel$IQR_time[-1], NA) ]	
						ii_d_sel=match( c("IQR_time","IQR_time_back") , names(data_out_ct_sel))
							ii_d_sel=ii_d_sel[!is.na(ii_d_sel)]
					data_out_ct_sel[ , IQR_time2:=Stat_calculate_row(  data_out_ct_sel[, ii_d_sel, with=FALSE], "AVG" ) ]	
													} # if (!is.empty(ii_pom))	
					
					
				
#############				
				
				
		# diffs of first DIFFERENCES
		
				# has to create  differences with base station ...
		
					col_names_ngbs_t1_diffs=NA
			for (ii_ngb in ii_ngbs) {
				col_names_ngbs_t1_diffs[ii_ngb]=paste("d_t1_",  gsub(' ','0',paste(format(ii_ngb, justify="right", width=floor(log10(n_max_ngbs))+1))) ,sep="")
					# col_names_stations[ii_ngb+1] #the first is t1_base
										
					ii_pom =which("t1_base"==names(data_out_ct_sel))
					ii_pom2=which(col_names_ngbs_t1[ii_ngb]==names(data_out_ct_sel))
						
					# differences or ratios or transformed values	
							if (!is.empty(ii_pom)) {
				data_out_ct_sel[ , c(col_names_ngbs_t1_diffs[ii_ngb]) := ( transform_data( data_out_ct_sel[ , ii_pom2 , with=FALSE] , data_out_ct_sel[ , ii_pom , with=FALSE] , n_transformation ) ) ]
													}
								   } # for (ii_ngb in ii_ngbs)								
				# summary_DT(data_out_ct_sel)
				
					

		# statistics for diferences
			#sssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
			
					
				# col_names_ngbs_t1_diffs  - diff_ of first differences
			stat_ct = Get_statistics_basic( ss_col_base="", ss_cols=col_names_ngbs_t1_diffs ,  ss_names_ngb=col_names_ngbs_t1_diffs , 
											ss_name_suffix=string_same_letters(col_names_ngbs_t1_diffs), k_append_blank=FALSE, k_include_KS=TRUE,k_verbose=k_verbose, stat_ct=stat_ct)

																
			#sssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
			
			



		# STANDARDIZED DIFFERENCES of first differences
					col_names_ngbs_t1_diffs_stnd=NA
			for (ii_ngb in ii_ngbs) {
				#st_naz_dif
				col_names_ngbs_t1_diffs_stnd[ii_ngb]=paste("d_t1_",  gsub(' ','0',paste(format(ii_ngb, justify="right", width=floor(log10(n_max_ngbs))+1))) ,"_stnd",sep="")
																											
				#standardize differences, by month
				data_out_ct_sel[ , c(col_names_ngbs_t1_diffs_stnd[ii_ngb]) := (lapply(.SD, standardize )) , by=MONTH, .SDcols=c(col_names_ngbs_t1_diffs[ii_ngb]) ]
				# takes care about NAs
					ii_pom2=which( col_names_ngbs_t1_diffs_stnd[ii_ngb]==names(data_out_ct_sel))
				data_out_ct_sel[ data_out_ct_sel[[ii_pom2]]==missval , c(col_names_ngbs_t1_diffs_stnd[ii_ngb]) := NA ]

								   } # for (ii_ngb in ii_ngbs)								
				# summary_DT(data_out_ct_sel)
				
				

		# statistics for _stnd diferences
			#sssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
			
			
			#standardized differences
			stat_ct = Get_statistics_basic( ss_col_base="", ss_cols=col_names_ngbs_t1_diffs_stnd , ss_names_ngb=col_names_ngbs_t1_diffs_stnd , 
											ss_name_suffix=string_same_letters(col_names_ngbs_t1_diffs_stnd), k_append_blank=FALSE, k_include_KS=TRUE, k_verbose=k_verbose,  stat_ct=stat_ct )

						 		
					
			#sssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
																					

																					
																					
						
			# calculates probability
								
										col_names_ngbs_t1_diffs_stnd_p=NA
								for (ii_ngb in ii_ngbs) {
									#st_naz_dif
									col_names_ngbs_t1_diffs_stnd_p[ii_ngb]=paste("pd_t1_",  gsub(' ','0',paste(format(ii_ngb, justify="right", width=floor(log10(n_max_ngbs))+1))) ,"_stnd",sep="")

									data_out_ct_sel[ , c(col_names_ngbs_t1_diffs_stnd_p[ii_ngb]) := (lapply(.SD, pnorm )) , by=MONTH, .SDcols=c(col_names_ngbs_t1_diffs_stnd[ii_ngb]) ]
									#converts all to upper tail
											ii_d_sel=which( col_names_ngbs_t1_diffs_stnd_p[ii_ngb]==names(data_out_ct_sel))
												ii_d_sel=ii_d_sel[!is.na(ii_d_sel)]
											k_pom=data_out_ct_sel[[ii_d_sel]]<0.5
									data_out_ct_sel[ k_pom , c(col_names_ngbs_t1_diffs_stnd_p[ii_ngb]) := (1 - (data_out_ct_sel[ k_pom , ii_d_sel, with=FALSE]))  ]
													   } # for (ii_ngb in ii_ngbs)								
									# summary_DT(data_out_ct_sel)
									

					#########					
					
						ii_d_sel=match(col_names_ngbs_t1_diffs_stnd, names(data_out_ct_sel))
							ii_d_sel=ii_d_sel[!is.na(ii_d_sel)]
					data_out_ct_sel=data_out_ct_sel[ , CNT_ngb_t1:=Stat_calculate_row(  data_out_ct_sel[, ii_d_sel, with=FALSE], "CNT" ) ]	
											
												# std_nasobek_limit - corresponds to  limit_confidence 
					data_out_ct_sel=data_out_ct_sel[ , Exc_t1_CNT:=PD_calculate_row(  data_out_ct_sel[, ii_d_sel, with=FALSE] , std_nasobek_limit , k_eq_value=1,k_mt_value=1,k_lt_value=0 , k_abs_val=TRUE, na_rm=TRUE ) ]
					
					data_out_ct_sel=data_out_ct_sel[ CNT_ngb_t1>0 , Perc_t1_Exc:=Exc_t1_CNT/CNT_ngb_t1 ]	
											
					# data_out_ct_sel$Exc_count[(n_nbgs-data_out_ct_sel$CNT_ngb_t1)>n_max_missing]=NA					
					# data_out_ct_sel$Exc_count[data_out_ct_sel$CNT_ngb_t1==0]=NA

					
				#compares time change there and back ... mean of t and t+1
						data_out_ct_sel[ , t1_Exc_pback:=c(data_out_ct_sel$Perc_t1_Exc[-1], NA) ]	
						ii_d_sel=match( c("Perc_t1_Exc","t1_Exc_pback") , names(data_out_ct_sel))
							ii_d_sel=ii_d_sel[!is.na(ii_d_sel)]
					data_out_ct_sel[ , Exc_t1_pr2:=Stat_calculate_row(  data_out_ct_sel[, ii_d_sel, with=FALSE], "AVG" ) ]	
					
					
					
					#########					
					
					
					#gets  p  maximum		
						ii_d_sel=match(col_names_ngbs_t1_diffs_stnd_p, names(data_out_ct_sel))
							ii_d_sel=ii_d_sel[!is.na(ii_d_sel)]
					# if empty, this gives warning ...
					data_out_ct_sel=data_out_ct_sel[ CNT!=0 , CDF_max_t1:=Stat_calculate_row(  data_out_ct_sel[ CNT!=0 , ii_d_sel, with=FALSE], "MAX" , na_rm=TRUE) ]	
						data_out_ct_sel[ CNT==0 , CDF_max_t1 := NA]
					#gets  p  median
					data_out_ct_sel=data_out_ct_sel[ , CDF_med_t1:=Stat_calculate_row(  data_out_ct_sel[, ii_d_sel, with=FALSE], "p" , na_rm=TRUE, probs=0.5 ) ]	
						data_out_ct_sel[ CNT==0 , CDF_med_t1 := NA]
					
							
					} # if (!((n_pd_function=="3/16/0")))
						# uuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuu
		
					

							 }	# if (k_first_differences)		
				# DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD	



					
					
					
					
########################################################
					




					
					
      # if (k_stand_AVG_STD=.T.)or (k_standardize_Altitude=.T.)  


				# sssssssssstttttttttttttttttttttttAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAaa
	  if ((k_standardize_Altitude==TRUE) | (k_stand_AVG_STD==TRUE)) {
 				
							
#transformation of values ...
if (k_verbose)  print(paste("   Transformation of values: ", n_transformation))
								# "st_base_"
								col_names_ngbs_alt=NA	# st_naz_puv_stand_alt
								col_names_stations_alt="st_base_"
							if ("st_base" %in% names(data_out_ct_sel)) 	
							data_out_ct_sel[ , "st_base_" := ( transform_data_1( st_base , n_transformation ) ) ]	
							
					for (ii_ngb in ii_ngbs) {
						col_names_ngbs_alt[ii_ngb]=paste("st_",  gsub(' ','0',paste(format(ii_ngb, justify="right", width=floor(log10(n_max_ngbs))+1))), "_base" ,sep="")
						col_names_stations_alt=c(col_names_stations_alt,col_names_ngbs_alt[ii_ngb])	

								ii_pom=which(col_names_ngbs[ii_ngb]==names(data_out_ct_sel))
								if (!is.empty(ii_pom)) {
							data_out_ct_sel[ , c(col_names_ngbs_alt[ii_ngb]) := ( transform_data_1( data_out_ct_sel[ , ii_pom , with=FALSE] , n_transformation ) ) ]					
														}
										    } # for (ii_ngb in ii_ngbs)								
						
						
						if (!("st_base" %in% names(data_out_ct_sel))) col_names_stations_alt=col_names_stations_alt[-1] # "st_base_"
						
							
################							




   # *STD AVG STD AVG STD AVG STAND
	if (k_stand_AVG_STD==T) {

if (k_verbose)  print("   Standardization to AVG and STD")							  
					  
					for (ii_ngb in ii_ngbs) {

							ii_pom=which(col_names_ngbs_alt[ii_ngb]==names(data_out_ct_sel))
														 
									stat_avg_alt=data_out_ct_sel[ , lapply(.SD, mean,na.rm=TRUE) , by=MONTH , .SDcols=col_names_stations_alt]
									stat_std_alt=data_out_ct_sel[ , lapply(.SD, sd  ,na.rm=TRUE) , by=MONTH , .SDcols=col_names_stations_alt]
							for (mm in (1:12)) {
										#base station
										avg_	= as.numeric( stat_avg_alt[MONTH==mm, col_names_stations_alt[1]  , with=FALSE] )	
										std_	= as.numeric( stat_std_alt[MONTH==mm, col_names_stations_alt[1]  , with=FALSE] )
										#ngb station
										hodn_avg= as.numeric( stat_avg_alt[MONTH==mm, col_names_ngbs_alt[ii_ngb]  , with=FALSE] )
										hodn_std= as.numeric( stat_std_alt[MONTH==mm, col_names_ngbs_alt[ii_ngb]  , with=FALSE] )
								  if (k_standardizace_STD==F) { hodn_std=1 ; std_=1 } #  &&pokud je standardizace poze na AVG<<<<<<<<<
								  if (k_standardizace_AVG==T) {} else {avg_=hodn_avg}
										#works with tranformed value
							data_out_ct_sel[ MONTH==mm , c(col_names_ngbs_alt[ii_ngb]) := (  										    
										( ( ( ( ( data_out_ct_sel[ MONTH==mm , ii_pom , with=FALSE] ) - ( hodn_avg ) ) / hodn_std )* std_ ) + avg_ )
																				) ]
												} #for (mm in (1:12))	
							               
										    } # for (ii_ngb in ii_ngbs)
							

							} #if (k_stand_AVG_STD=T)
   # *STD AVG STD AVG STD AVG STAND





################							

								if (typeof(ngb_info_DT_sel$ALT_1)=="character") ngb_info_DT_sel$ALT_1=as.numeric(ngb_info_DT_sel$ALT_1)
								if (typeof(ngb_info_DT_sel$ALT_2)=="character") ngb_info_DT_sel$ALT_2=as.numeric(ngb_info_DT_sel$ALT_2)
	
								stan_base_altitude =unique(ngb_info_DT_sel$ALT_1)
				
# STANDARDIZATION to ALTITUDE				
					# AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAALlllllllllllllllllllllllllllllllllttttttttttttttttttttttttttttttttttt
	  if ( (k_standardize_Altitude==TRUE)&(k_regr_individually==TRUE) ) {
						

if (k_verbose)  print("   Standardization to Altitude - regression individually")							  
						
#regression - based on transformed data	(col_names_stations_alt)					
							#prepares altitude information
								
								stan_ngbs_altitudes=ngb_info_DT_sel$ALT_2
								
								if ("st_base" %in% names(data_out_ct_sel)) {
							values_altitudes=c(stan_base_altitude,stan_ngbs_altitudes)
																		   } else {
							values_altitudes=c(stan_ngbs_altitudes)
																		   		   }
										
									ii_d_sel=match(col_names_stations_alt, names(data_out_ct_sel))
										k_pom=!is.na(ii_d_sel)
										ii_d_sel=ii_d_sel[k_pom]
										#puts away also corresponding values in altitudes
										values_altitudes=values_altitudes[k_pom]

if (length(values_altitudes)!=dim(data_out_ct_sel[, ii_d_sel, with=FALSE])[2]) {
stop("stop here: incompatible dimensions")
																				}							
										
							# column names are given - shold not be solved here,  zde neresis nazvy, ty jsou dane
							my_regr = as.data.frame( ( Stat_calculate_row_lm( x=values_altitudes , Y=data_out_ct_sel[, ii_d_sel, with=FALSE]  ) ) )
																
								# cbind.data.table does not exist yet
							data_out_ct_sel=cbind(data_out_ct_sel,my_regr)

	

						# values_altitudes=c(stan_base_altitude,stan_ngbs_altitudes)  # ngb_info_DT_sel$ALT_2	
						hodn_koef_vys = Check_altitude_base_neighbours( pole_data_vys=stan_ngbs_altitudes, a_vys=stan_base_altitude )
						
					   if (!is.na(hodn_koef_vys)) if (hodn_koef_vys>koef_1_5) {
						# &&<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
						
ss_pom=paste(stan_base,': ','Altitude of base station (',stan_base_altitude,') differs significantly from neighbours: ')			
if (k_supress_output_all_possible==FALSE) print(ss_pom)
if (k_supress_output_all_possible==FALSE) print(paste('  Coeff. of interquartile range is: ',hodn_koef_vys ))
warning(ss_pom)
																				} #  if (hodn_koef_vys>koef_1_5)
	

				#############	

							if (!("Flag_regr" %in% names(data_out_ct_sel)))	data_out_ct_sel[ , Flag_regr:="-" ]	  # this is also above
									# data_out_ct_sel[ , Flag_regr:=NA ]	
																		
							#all flags saved to remarks:
							data_out_ct_sel[ , Flag_rem:="" ]
									
									
					for (ii_ngb in ii_ngbs) {

							ii_pom =which(col_names_ngbs[ii_ngb]==names(data_out_ct_sel))
							ii_pom2=which(col_names_ngbs_alt[ii_ngb]==names(data_out_ct_sel))


							if ( (is.empty(ii_pom)) ) {
if (k_supress_output_all_possible==FALSE)
	print_my("   ...  no data for neighbour: ", col_names_ngbs[ii_ngb] , k_warning=TRUE)
	next # <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<							
																			}
							if ( (is.empty(ii_pom2)) ) {
if (k_supress_output_all_possible==FALSE)	
	print_my("   ...  no data for neighbour: ", col_names_ngbs_alt[ii_ngb] , k_warning=TRUE)
	next # <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<							
																			}
							
								
								
							# in the begeginnn, there are these values set:
							# data_out_ct_sel[ , c(col_names_ngbs_alt[ii_ngb]) := ( transform_data_1( data_out_ct_sel[ , ii_pom , with=FALSE] , n_transformation ) )
								
								#use ii_pom2 so that the calculation is applied for transformed values ...
									# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
							data_out_ct_sel[ , c(col_names_ngbs_alt[ii_ngb]) := (  
										( ( (regr_deter^deter_correct)*(  
										( ( data_out_ct_sel[ , ii_pom2 , with=FALSE] ) - ( regr_b1 * (stan_ngbs_altitudes[ii_ngb] - stan_base_altitude) ) )
											) ) +
										( (1-(regr_deter^deter_correct))*( data_out_ct_sel[ , ii_pom2 , with=FALSE] ) ) )
																				) ]
									# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
								
							    k_pom=(!is.na( data_out_ct_sel[[ii_pom2]] ))&( (is.na(data_out_ct_sel$regr_b1)) | (is.na(data_out_ct_sel$regr_deter)) )
								data_out_ct_sel[ k_pom , Flag_regr:="n" ] 
									# data_out_ct_sel[ k_pom , Flag_rem:=paste(Flag_rem,"n",sep="") ]
									data_out_ct_sel[ k_pom & !grepl("n", Flag_regr), Flag_rem:=paste(Flag_rem,"n",sep="") ]
									
								data_out_ct_sel[ k_pom , c(col_names_ngbs_alt[ii_ngb]) := ( transform_data_1( data_out_ct_sel[ k_pom , ii_pom , with=FALSE] , n_transformation ) ) ]
							
							 if ((k_regr_individually=T)&(k_regr_individually_dopln_stand=T)) {
								k_pom=(is.na( data_out_ct_sel[[ii_pom2]]))&(!is.na( data_out_ct_sel[[ii_pom]] ))		
								data_out_ct_sel[ k_pom , Flag_regr:="S" ] # 
									# data_out_ct_sel[ k_pom , Flag_rem:=paste(Flag_rem,"S",sep="") ]  - toto kumuluje S
									data_out_ct_sel[ k_pom & !grepl("S", Flag_regr), Flag_rem:=paste(Flag_rem,"S",sep="") ]								
									
								data_out_ct_sel[ k_pom , c(col_names_ngbs_alt[ii_ngb]) := ( transform_data_1( data_out_ct_sel[ k_pom , ii_pom , with=FALSE] , n_transformation ) ) ]
									
																								}            
										    } # for (ii_ngb in ii_ngbs)
							

									
							poc_pom = nrow( data_out_ct_sel[ Flag_regr=="n" | Flag_regr=="S" ,  ] )
						  if ((poc_pom>0)&(length(ii_ngbs)>1)) {							
ss_pom=paste(stan_base,': Standardization to altitude NOT performed (no regression, Flag_regr="n") in ',poc_pom,' cases (',round( (100*poc_pom/(dim(data_out_ct_sel)[1])) , 1),'%), Original values were preserved then', sep="")
if (k_supress_output_all_possible==FALSE) print(ss_pom)
warning(ss_pom)  
																		} #if ((poc_pom>0)&(length(ii_ngbs)>1))
  
				
				
						
													 } #if ((k_standardize_Altitude==TRUE)&(k_regr_individually==TRUE))
					# AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAALlllllllllllllllllllllllllllllllllttttttttttttttttttttttttttttttttttt
	
								
								
								
								
	# print("   Getting stations statistics for standardized neighbours ...")
			stat_ct = Get_statistics_basic( ss_col_base="st_base_" , ss_cols=c("st_base_" ,col_names_ngbs_alt) , ss_names_ngb=col_names_ngbs_alt ,  ss_name_suffix=string_same_letters(col_names_ngbs_alt), k_append_blank=FALSE, k_include_KS=TRUE, k_verbose=k_verbose,  stat_ct=stat_ct)
								
								
								
				
################	
				
									
						# checking outliers				
			if (k_outliers_check) {
					
if (k_verbose)  print("   Checking outliers ")							  
					
					
# checks wrong (problematic) regression					
					# * ddddddddddddddddddddddd
					
# limit_regr_deter = (0.4)^2							 
limit_regr_deter = (0.3)^2	#,  regr_deter=0.09, 

							    k_pom=(  (data_out_ct_sel$regr_deter<limit_regr_deter)&(data_out_ct_sel$regr_deter>0)  )
								    #   & (data_out_ct_sel$Flag_regr=='-') )  # (data_out_ct_sel$Flag_regr!='n')
									
									  
									    k_pom[is.na(k_pom)]=FALSE
							if (sum(k_pom)>0) {
								
								data_out_ct_sel[ k_pom , Flag_regr:="o" ] 
									data_out_ct_sel[ k_pom , Flag_rem:=paste(Flag_rem,"o",sep="") ]
								
								# now repairs all ..., 
								for (ii_ngb in ii_ngbs) {
										ii_pom =which(col_names_ngbs[ii_ngb]==names(data_out_ct_sel))
										ii_pom2=which(col_names_ngbs_alt[ii_ngb]==names(data_out_ct_sel))

							if ( (is.empty(ii_pom)) | (is.empty(ii_pom2)) ) {
#							if ( (is.empty(ii_pom)) ) {
#	print_my("   ...  no data for neighbour: ", col_names_ngbs[ii_ngb] , k_warning=TRUE)
	next # <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<							
#																			}
#							if ( (is.empty(ii_pom2)) ) {
#	print_my("   ...  no data for neighbour: ", col_names_ngbs_alt[ii_ngb] , k_warning=TRUE)
#	next # <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<							
																			}
										
										
														
										data_out_ct_sel[ k_pom , c(col_names_ngbs_alt[ii_ngb]) := ( transform_data_1( data_out_ct_sel[ k_pom , ii_pom , with=FALSE] , n_transformation ) ) ]					
														} # for (ii_ngb in ii_ngbs)								
											
												} #if (sum(k_pom)>0)	
			# Flag_regr:="o"
			      																	
							poc_pom = nrow( data_out_ct_sel[ Flag_regr=="o" ,  ] )
						  if ((poc_pom>0)&(length(ii_ngbs)>1)) {							
ss_pom=paste(stan_base,': Determination coefficient too low in ',poc_pom,' cases (',round( (100*poc_pom/(dim(data_out_ct_sel)[1])) , 1),'%), Original values were preserved then (Flag_regr="o")', sep="")
if (k_supress_output_all_possible==FALSE) print(ss_pom)
warning(ss_pom)  
																		} #if 
											
					# * ddddddddddddddddddddddd
								
								

################	

							
																			
# checking, if the standardized ngb values are not outside the range of original neighbours (its. avg, std)
				# QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ          
								# avg  for a row
								# std  for a row, 									
					
						ii_d_sel=match(col_names_ngbs, names(data_out_ct_sel))  # col_names_ngbs_alt
								ii_d_sel=ii_d_sel[!is.na(ii_d_sel)]
						
		#avg and std are calculated using original values, it has to be transformed (if needed)				
					data_out_ct_sel=data_out_ct_sel[ , ngb_avg:=Stat_calculate_row( transform_data_1( data_out_ct_sel[, ii_d_sel, with=FALSE] , n_transformation ), "AVG" ) ]	
					data_out_ct_sel=data_out_ct_sel[ , ngb_std:=Stat_calculate_row( transform_data_1( data_out_ct_sel[, ii_d_sel, with=FALSE] , n_transformation ), "SD" ) ]	
											
					#########	
					
					# checks only values, upon which regression has been applied
					k_pom=(data_out_ct_sel$Flag_regr=='-')	# (data_out_ct_sel$Flag_regr!='n')  #Flag_regr!="n"
										
										col_names_ngbs_alt_stnd=NA
								for (ii_ngb in ii_ngbs) {
									#ds_ngb_  puvodne,  r_stnd_1
									col_names_ngbs_alt_stnd[ii_ngb]=paste("r_stnd_",  gsub(' ','0',paste(format(ii_ngb, justify="right", width=floor(log10(n_max_ngbs))+1))) ,sep="")									
									
								  #STANDARDIZED NGB  evaluation	
									# difference of standardized ngb from original neighbour AVG and STD
									# original values has to be standardized where appropriate (transform_data_1)
									ii_pom2=which(col_names_ngbs_alt[ii_ngb]==names(data_out_ct_sel))  
									
												if ( (is.empty(ii_pom2)) ) {
#	print_my("   ...  no data for neighbour: ", col_names_ngbs_alt[ii_ngb] , k_warning=TRUE)
	next # <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<							
																			}
																		
							data_out_ct_sel[ k_pom, c(col_names_ngbs_alt_stnd[ii_ngb]) := (
										transform_data_1( data_out_ct_sel[ k_pom , ii_pom2 , with=FALSE] , n_transformation ) 
										- data_out_ct_sel$ngb_avg[ k_pom ] ) / data_out_ct_sel$ngb_std[ k_pom ] ]
													   } # for (ii_ngb in ii_ngbs)								
					
					#########	
					
									# its probability												
										col_names_ngbs_alt_stnd_p=NA
								for (ii_ngb in ii_ngbs) {
									col_names_ngbs_alt_stnd_p[ii_ngb]=paste("pr_stnd_",  gsub(' ','0',paste(format(ii_ngb, justify="right", width=floor(log10(n_max_ngbs))+1))) ,sep="")
											ii_pom=which(col_names_ngbs_alt_stnd[ii_ngb]==names(data_out_ct_sel))						
											
												if ( (is.empty(ii_pom)) ) {
#	print_my("   ...  no data for neighbour: ", col_names_ngbs_alt[ii_ngb] , k_warning=TRUE)
	next # <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<							
																			}
																						
											k_pom2=(!is.na(data_out_ct_sel[[ii_pom]]))
											# probability of deviation of standardized to base altitude values, standardized by altitude base AVG and STD (AVG and STD of original data)
							data_out_ct_sel[ (k_pom & k_pom2), c(col_names_ngbs_alt_stnd_p[ii_ngb]) := pnorm( data_out_ct_sel[[ii_pom]][k_pom & k_pom2] ) ]
													
									# inverts values where needed,  
											ii_pom_=which(col_names_ngbs_alt_stnd_p[ii_ngb]==names(data_out_ct_sel))
											
												if ( (is.empty(ii_pom_)) ) {
#	print_my("   ...  no data for neighbour: ", col_names_ngbs_alt[ii_ngb] , k_warning=TRUE)
	next # <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<							
																			}
																						
											k_pom2=(data_out_ct_sel[[ii_pom_]]<0.5) & (!is.na(data_out_ct_sel[[ii_pom_]]))
									data_out_ct_sel[ (k_pom & k_pom2), c(col_names_ngbs_alt_stnd_p[ii_ngb]) := (1 - data_out_ct_sel[[ii_pom_]][k_pom & k_pom2] )  ]
													   } # for (ii_ngb in ii_ngbs)								
									
					#########					
										
					# proceses standardized ngbs probabilities 
						# number of values
							ii_d_sel=match(col_names_ngbs_alt_stnd, names(data_out_ct_sel))
								ii_d_sel=ii_d_sel[!is.na(ii_d_sel)]
						data_out_ct_sel=data_out_ct_sel[ , CNT_ngb:=Stat_calculate_row(  data_out_ct_sel[, ii_d_sel, with=FALSE], "CNT" ) ]	
					
						data_out_ct_sel[ , Exc_r_CNT:=0 ] #number of original values (taken back)
						ii_d_sel=match(col_names_ngbs_alt_stnd_p, names(data_out_ct_sel))  # col_names_ngbs_alt
							ii_d_sel=ii_d_sel[!is.na(ii_d_sel)]
						# std_nasobek_limit	
					data_out_ct_sel=data_out_ct_sel[ k_pom , Exc_r_CNT:=PD_calculate_row(  data_out_ct_sel[ k_pom , ii_d_sel, with=FALSE] , val_CDF_outliers_check , k_eq_value=1,k_mt_value=1,k_lt_value=0 , k_abs_val=TRUE, na_rm=TRUE ) ]
						
					# in percentage	
						data_out_ct_sel[ , Exc_r_perct:=0 ] #number of original values (taken back)
					data_out_ct_sel=data_out_ct_sel[ CNT_ngb>0 , Exc_r_perct:=Exc_r_CNT/CNT_ngb ]	
											
					# data_out_ct_sel$Exc_r_CNT[(n_nbgs-data_out_ct_sel$CNT_ngb)>n_max_missing]=NA					
					# data_out_ct_sel$Exc_r_CNT[data_out_ct_sel$CNT_ngb==0]=NA
					
					
					#gets  p  maximum		
# CDF_max_r - evaluation of standardized neighbours					
						ii_d_sel=match(col_names_ngbs_alt_stnd_p, names(data_out_ct_sel))
							ii_d_sel=ii_d_sel[!is.na(ii_d_sel)]
					# if empty, this gives warning ...
					data_out_ct_sel=data_out_ct_sel[ CNT_ngb!=0 , CDF_max_r:=Stat_calculate_row(  data_out_ct_sel[ CNT_ngb!=0 , ii_d_sel, with=FALSE], "MAX" , na_rm=TRUE) ]	
						data_out_ct_sel[ CNT_ngb==0 , CDF_max_r := NA]
			
			
					#########					


					# CORRECTing the standardized values (rolling back) - for individual ngbs
if (k_verbose)  print("   CORRECTing the standardized values (rolling back) - for individual ngbs")							  
					
					 k_pom=(  (data_out_ct_sel$Exc_r_CNT>=1)   )
								     #  & (data_out_ct_sel$Flag_regr=='-') )  # (data_out_ct_sel$Flag_regr!='n') 
													
								data_out_ct_sel[ k_pom , Flag_regr:="O" ] 								
									# data_out_ct_sel[ k_pom , Flag_rem:="O" ]
									data_out_ct_sel[ k_pom , Flag_rem:=paste(Flag_rem,"O",sep="") ]
									
								# *corrects all standardized values - for all the neighbours
								for (ii_ngb in ii_ngbs) {
										ii_pom =which(col_names_ngbs[ii_ngb]==names(data_out_ct_sel))
										ii_pom2=which(col_names_ngbs_alt[ii_ngb]==names(data_out_ct_sel))

									if ( (is.empty(ii_pom)) | (is.empty(ii_pom2)) ) {
#							if ( (is.empty(ii_pom)) ) {
#	print_my("   ...  no data for neighbour: ", col_names_ngbs[ii_ngb] , k_warning=TRUE)
	next # <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<							
#																			}
#							if ( (is.empty(ii_pom2)) ) {
#	print_my("   ...  no data for neighbour: ", col_names_ngbs_alt[ii_ngb] , k_warning=TRUE)
#	next # <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<							
																					}
										
											ii_pom_=which(col_names_ngbs_alt_stnd_p[ii_ngb]==names(data_out_ct_sel))						
											k_pom2=(data_out_ct_sel[[ii_pom_]]>=val_CDF_outliers_check) & (!is.na(data_out_ct_sel[[ii_pom_]]))
											
											data_out_ct_sel[ (k_pom & k_pom2) , Flag_rem:=paste(Flag_rem,ii_ngb,sep="") ]
											
														
										data_out_ct_sel[ (k_pom & k_pom2) , c(col_names_ngbs_alt[ii_ngb]) := ( transform_data_1( data_out_ct_sel[ (k_pom & k_pom2) , ii_pom , with=FALSE] , n_transformation ) ) ]					
														} # for (ii_ngb in ii_ngbs)								
												# data_out_ct_sel$Flag_rem
							########

							poc_pom = nrow( data_out_ct_sel[ Flag_regr=="O" ,  ] )
						  if ((poc_pom>0)&(length(ii_ngbs)>1)) {							
ss_pom=paste(stan_base,': Standardization to altitude problematic in ',poc_pom,' cases - rows (individual neighbours CDF of stndzed (to ngb_avg and ngb_std) values exceeding ',val_CDF_outliers_check,'), number of cases:',round( (100*poc_pom/(dim(data_out_ct_sel)[1])) , 1),'% (Original values of the given neighbours were preserved then)', sep="")
if (k_supress_output_all_possible==FALSE) print(ss_pom)
warning(ss_pom)  
																		} #if ((poc_pom>0)&(length(ii_ngbs)>1))
  
									
						

			#sssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
						
# print("   Getting statistics for standardized neighbours - standardized ...")
				# calculated statistics for standardized (to altitude) neighbours 
					# col_names_ngbs_alt_stnd_p
			stat_ct = Get_statistics_basic( ss_col_base="st_base_", ss_cols=col_names_ngbs_alt_stnd , ss_names_ngb=col_names_ngbs_alt_stnd , 
											ss_name_suffix=string_same_letters(col_names_ngbs_alt_stnd), k_append_blank=FALSE, k_include_KS=TRUE, k_verbose=k_verbose,  stat_ct=stat_ct)

			#sssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
									

									
				# QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ               											
				
											} # if (k_outliers_check)
							

							
################							
							

################
if (k_verbose)  print("   Adding IQR ... from standardized neighbours")
	
				#helpfull statitistics:
										ii_d_sel=match(col_names_ngbs_alt, names(data_out_ct_sel))
											ii_d_sel=ii_d_sel[!is.na(ii_d_sel)]
												ii_d_sel=ii_d_sel[!is.na(ii_d_sel)]
								data_out_ct_sel[ , q025_ngbs_base := Stat_calculate_row(  data_out_ct_sel[, ii_d_sel, with=FALSE], "p" , na_rm=TRUE, probs=0.25 ) ]	
									data_out_ct_sel[ CNT==0 , q025_ngbs_base := NA]
									
								data_out_ct_sel[ , q050_ngbs_base := Stat_calculate_row(  data_out_ct_sel[, ii_d_sel, with=FALSE], "p" , na_rm=TRUE, probs=0.5 ) ]	
									data_out_ct_sel[ CNT==0 , q050_ngbs_base := NA]
																		
								data_out_ct_sel[ , q075_ngbs_base := Stat_calculate_row(  data_out_ct_sel[, ii_d_sel, with=FALSE], "p" , na_rm=TRUE, probs=0.75 ) ]	
									data_out_ct_sel[ CNT==0 , q075_ngbs_base := NA]
	
	
															 
			# gets coefficient of IQR - interquartile range
							ii_pom =which("st_base_"==names(data_out_ct_sel))
							ii_d_sel=match(col_names_ngbs_alt, names(data_out_ct_sel))
								ii_d_sel=ii_d_sel[!is.na(ii_d_sel)]
							
			# Coef_IQR, from original values, it is above ...				
							if (!is.empty(ii_pom)) {
						data_out_ct_sel[ , Coef_IQR_:=Stat_calculate_row_IQR( x=data_out_ct_sel[, ii_pom , with=FALSE] , Y=data_out_ct_sel[, ii_d_sel, with=FALSE] ) ]	
													}
										
				
################



				
# CDF_b_sMed -  probability (CDF) of base station compared to median from standardized (to altitute) neighbours		
															
  if (k_add_interquartile_range_coeff==TRUE) {

	
if (k_verbose)  print("   Adding interquartile range coeff")							  
								
							
								# standard deviation by month
								if ("st_base_" %in% names(data_out_ct_sel)) {
								data_out_ct_sel[ , STD_base_ := sd(st_base_, na.rm=TRUE), by=MONTH ]
			
			
							# CDF_b_sMed
							data_out_ct_sel[ , CDF_b_sMed := (st_base_ - q050_ngbs_base)/STD_base_ ]
																	
								# its probability												
								data_out_ct_sel[ , CDF_b_sMed := pnorm( CDF_b_sMed , mean=0, sd=1) ]
													
									# inverts values where needed,  
											k_pom2=(data_out_ct_sel$CDF_b_sMed<0.5) & (!is.na(data_out_ct_sel$CDF_b_sMed))
									data_out_ct_sel[ k_pom2 , CDF_b_sMed := (1 - CDF_b_sMed ) ]
				
																			}
					
				
				
											} # if (k_add_interquartile_range_coeff=TRUE)
						



#########################						

					# QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQtttttttttttttttttttttt

						# checking outliers				
			if ( (k_outliers_check) 
				& (k_first_differences) ) { # even for 3/16/0, let it to be processed - controlled, (n_pd_function=="3/16/0")
				  
			
							
if (k_verbose)  print("   Checking outliers: time aspect of standardized neighbours")							  
							
											
				# first differences for transformed and standardized base and ngbs
							if ("st_base" %in% names(data_out_ct_sel))
							data_out_ct_sel[ , t1_base_ := my_diff( ( st_base_ ) , my_lag=1 , n_transformation=n_transformation) ] # k_ratios=(n_transformation<=0)
							
								col_names_ngbs_alt_t1=NA
					for (ii_ngb in ii_ngbs) {
							col_names_ngbs_alt_t1[ii_ngb]=paste("t1_",  gsub(' ','0',paste(format(ii_ngb, justify="right", width=floor(log10(n_max_ngbs))+1))), "_base" ,sep="")

							ii_pom2=which(col_names_ngbs_alt[ii_ngb]==names(data_out_ct_sel))
			
							data_out_ct_sel[ , c(col_names_ngbs_alt_t1[ii_ngb]) := my_diff( ( data_out_ct_sel[ , ii_pom2 , with=FALSE] ) , my_lag=1 , n_transformation=n_transformation) ] # k_ratios=(n_transformation<=0)
											} # for (ii_ngb in ii_ngbs)								

			# statistics for first differences
			#sssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


						# c("t1_base_",col_names_ngbs_alt_t1)
			stat_ct = Get_statistics_basic( ss_col_base="t1_base_", ss_cols=c("t1_base_",col_names_ngbs_alt_t1) , ss_names_ngb=col_names_ngbs_alt_t1 , 
											ss_name_suffix=string_same_letters(col_names_ngbs_alt_t1), k_append_blank=FALSE, k_include_KS=TRUE, k_verbose=k_verbose,  stat_ct=stat_ct)

			#sssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss
			

			
			
	# gets coefficient of IQR - interquartile range
																				
							ii_pom =which("t1_base_"==names(data_out_ct_sel))
							ii_d_sel=match(col_names_ngbs_alt_t1, names(data_out_ct_sel))
								ii_d_sel=ii_d_sel[!is.na(ii_d_sel)]
								
							if (!is.empty(ii_pom)) {
						data_out_ct_sel[ , IQR_time_alt:=Stat_calculate_row_IQR( x=data_out_ct_sel[, ii_pom , with=FALSE ] , Y=data_out_ct_sel[, ii_d_sel, with=FALSE] ) ]	
													}	
											
			

###
						
# now compares standaradized values ...

		# STANDARDIZED vals of first differences
				# col_names_ngbs_t1 <<<<<<<<<<<<
					col_names_ngbs_t1_stnd=NA
			for (ii_ngb in ii_ngbs) {
				col_names_ngbs_t1_stnd[ii_ngb]=paste("t1_",  gsub(' ','0',paste(format(ii_ngb, justify="right", width=floor(log10(n_max_ngbs))+1))) ,"__stnd",sep="")
																											
				#standardize values, by month
				data_out_ct_sel[ , c(col_names_ngbs_t1_stnd[ii_ngb]) := (lapply(.SD, standardize )) , by=MONTH, .SDcols=c(col_names_ngbs_t1[ii_ngb]) ]
				
				#takes care about NAs
					ii_pom2=which( col_names_ngbs_t1_stnd[ii_ngb]==names(data_out_ct_sel))
				data_out_ct_sel[ data_out_ct_sel[[ii_pom2]]==missval , c(col_names_ngbs_t1_stnd[ii_ngb]) := NA ]

								   } # for (ii_ngb in ii_ngbs)								
				
		# STANDARDIZED (stnd to altitude) vals of first differences
				# col_names_ngbs_alt_t1 <<<<<<<<<<<<
					col_names_ngbs_alt_t1_stnd=NA
			for (ii_ngb in ii_ngbs) {
				col_names_ngbs_alt_t1_stnd[ii_ngb]=paste("t1_",  gsub(' ','0',paste(format(ii_ngb, justify="right", width=floor(log10(n_max_ngbs))+1))) ,"_base__stnd",sep="")
																											
				#standardize values, by month
				data_out_ct_sel[ , c(col_names_ngbs_alt_t1_stnd[ii_ngb]) := (lapply(.SD, standardize )) , by=MONTH, .SDcols=c(col_names_ngbs_alt_t1[ii_ngb]) ]
				
				#takes care about NAs
					ii_pom2=which( col_names_ngbs_alt_t1_stnd[ii_ngb]==names(data_out_ct_sel))
							if (!is.empty(ii_pom2)) {
				data_out_ct_sel[ data_out_ct_sel[[ii_pom2]]==missval , c(col_names_ngbs_alt_t1_stnd[ii_ngb]) := NA ]
													}

								   } # for (ii_ngb in ii_ngbs)								
				


		# statistics for _stnd first diferences
																					

		#gets the difference
			names(data_out_ct_sel)
			data_out_ct_sel[, ]

				# col_names_ngbs_t1
					col_names_ngbs_t1_stnd_b_diff=NA
			for (ii_ngb in ii_ngbs) {
			
					ii_pom =which( col_names_ngbs_t1_stnd[ii_ngb]==names(data_out_ct_sel))
					ii_pom2=which( col_names_ngbs_alt_t1_stnd[ii_ngb]==names(data_out_ct_sel))
					
				col_names_ngbs_t1_stnd_b_diff[ii_ngb]=paste("d_t1_",  gsub(' ','0',paste(format(ii_ngb, justify="right", width=floor(log10(n_max_ngbs))+1))) ,"__stnd_base",sep="")  # __base
							
					if ( (!is.empty(ii_pom))&(!is.empty(ii_pom2)) ) {
				data_out_ct_sel[ , c(col_names_ngbs_t1_stnd_b_diff[ii_ngb]) :=  data_out_ct_sel[, ii_pom2 , with=FALSE ]  - data_out_ct_sel[, ii_pom , with=FALSE ]  ]
											}				
				
								   } # for (ii_ngb in ii_ngbs)								
				

				
					#########					
																					
			# calculates probability
						#		
										col_names_ngbs_t1_stnd_b_diff_p=NA
								for (ii_ngb in ii_ngbs) {
									#st_naz_dif
									col_names_ngbs_t1_stnd_b_diff_p[ii_ngb]=paste("pd_t1_",  gsub(' ','0',paste(format(ii_ngb, justify="right", width=floor(log10(n_max_ngbs))+1))) ,"__stnd_base",sep="")  # __base

									# probability
									data_out_ct_sel[ , c(col_names_ngbs_t1_stnd_b_diff_p[ii_ngb]) := (lapply(.SD, pnorm )) , by=MONTH, .SDcols=c(col_names_ngbs_t1_stnd_b_diff[ii_ngb]) ]
									#converts all to upper tail
											ii_d_sel=which( col_names_ngbs_t1_stnd_b_diff_p[ii_ngb]==names(data_out_ct_sel))
												ii_d_sel=ii_d_sel[!is.na(ii_d_sel)]
											k_pom=data_out_ct_sel[[ii_d_sel]]<0.5
									data_out_ct_sel[ k_pom , c(col_names_ngbs_t1_stnd_b_diff_p[ii_ngb]) := (1 - (data_out_ct_sel[ k_pom , ii_d_sel, with=FALSE]))  ]
													   } # for (ii_ngb in ii_ngbs)								
									

					#########					
					
						ii_d_sel=match(col_names_ngbs_t1_stnd_b_diff_p, names(data_out_ct_sel))
							ii_d_sel=ii_d_sel[!is.na(ii_d_sel)]
					data_out_ct_sel=data_out_ct_sel[ , CNT_t1_ngb_stnd_diffs_p:=Stat_calculate_row(  data_out_ct_sel[, ii_d_sel, with=FALSE], "CNT" ) ]													
					
												# std_nasobek_limit - corresponds to  limit_confidence 
					data_out_ct_sel=data_out_ct_sel[ , Exc_t1_base_Count:=PD_calculate_row(  data_out_ct_sel[, ii_d_sel, with=FALSE] , val_CDF_outliers_check , k_eq_value=1,k_mt_value=1,k_lt_value=0 , k_abs_val=TRUE, na_rm=TRUE ) ]
					
					data_out_ct_sel=data_out_ct_sel[ CNT_t1_ngb_stnd_diffs_p>0 , Perc_t1_base_Count:=Exc_t1_base_Count/CNT_t1_ngb_stnd_diffs_p ]	
											
					# data_out_ct_sel$Exc_count[(n_nbgs-data_out_ct_sel$CNT_ngb_t1_stnd_diffs)>n_max_missing]=NA
					# data_out_ct_sel$Exc_count[data_out_ct_sel$CNT_ngb_t1_stnd_diffs==0]=NA

						
###
# check for problems with standardization, evaluation ...
# Software also checks standardized neighbours values (comparing original and standardized value - calculating probability - CDF of normal distribution; to run this, check Outliers check option and as a threshold the specified value is used, if at least in one case it is exceeded, all standardized values are replaced with original ones, Flag_regr column then contains "t" value)

					
						# data_out_ct_sel[ , Flag_regr:="-" ]	
						if (!("Flag_regr" %in% names(data_out_ct_sel)))	data_out_ct_sel[ , Flag_regr:="-" ]	  # this is also above
		
		
						k_pom = (  (data_out_ct_sel$Exc_t1_base_Count>=1)  )
								     #  & (data_out_ct_sel$Flag_regr=='-') ) # (data_out_ct_sel$Flag_regr!='n')
													
									    k_pom[is.na(k_pom)]=FALSE
							if (sum(k_pom)>0) {
						
								data_out_ct_sel[ k_pom , Flag_regr:="t" ] 
									data_out_ct_sel[ k_pom , Flag_rem:=paste(Flag_rem,"t",sep="") ]

						
								# now repairs all ..., 
								for (ii_ngb in ii_ngbs) {
										ii_pom =which(col_names_ngbs[ii_ngb]==names(data_out_ct_sel))
										ii_pom2=which(col_names_ngbs_alt[ii_ngb]==names(data_out_ct_sel))

							if ( (is.empty(ii_pom)) | (is.empty(ii_pom2)) ) {
#							if ( (is.empty(ii_pom)) ) {
#	print_my("   ...  no data for neighbour: ", col_names_ngbs[ii_ngb] , k_warning=TRUE)
	next # <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<							
#																			}
#							if ( (is.empty(ii_pom2)) ) {
#	print_my("   ...  no data for neighbour: ", col_names_ngbs_alt[ii_ngb] , k_warning=TRUE)
#	next # <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<							
																			}
																				
														
										data_out_ct_sel[ k_pom , c(col_names_ngbs_alt[ii_ngb]) := ( transform_data_1( data_out_ct_sel[ k_pom , ii_pom , with=FALSE] , n_transformation ) ) ]					
														} # for (ii_ngb in ii_ngbs)								
											
												} #if (sum(k_pom)>0)	
			# Flag_regr:="t"
			      																
							poc_pom = nrow( data_out_ct_sel[ Flag_regr=="t" ,  ] )
						  if ((poc_pom>0)&(length(ii_ngbs)>1)) {							
ss_pom=paste(stan_base,': Standardization to altitude (time aspect - first diffs, Flag_regr="t") problematic in ',poc_pom,' cases (',round( (100*poc_pom/(dim(data_out_ct_sel)[1])) , 1),'%)', sep="")
if (k_supress_output_all_possible==FALSE) print(ss_pom)
warning(ss_pom)  


																		} #if ((poc_pom>0)&(length(ii_ngbs)>1))
										

										
									} #if (k_outliers_check)
										
					# QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQtttttttttttttttttttttt

										

				
				
				
				
				
										} 	 # if ((k_standardize_Altitude==TRUE) | (k_stand_AVG_STD==TRUE))
				# sssssssssstttttttttttttttttttttttAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAaa
 
 
 
 



################	



				# EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE
	if (k_add_expected_value) {
			

if (k_verbose)  print("   Adding expected value ")							  

					
				
			# Expected value			
				#if (power_weights_dist!=0) {
				stan_ngbs_weights=(1/ngb_info_DT_sel$DISTANCE)^(power_weights_dist)
					stan_ngbs_weights[ngb_info_DT_sel$DISTANCE==0]=0.001
										 # }
							ii_d_sel=match(col_names_ngbs_alt, names(data_out_ct_sel))
								k_pom=!is.na(ii_d_sel)
								ii_d_sel=ii_d_sel[k_pom]
								#puts away also corresponding values in altitudes
								stan_ngbs_weights=stan_ngbs_weights[k_pom]
																	
				 # Expect_trf	 vs Expect_val					
						# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
				data_out_ct_sel[ , Expect_val:=Stat_calculate_row_weighted_mean( x=stan_ngbs_weights , Y=data_out_ct_sel[, ii_d_sel, with=FALSE] ) ]	
						# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
								
			
			# calculated differences of Expected value and base station values
						# calculates differences of original and Expected value	(transformed, if needed ...)
							ii_pom =which("st_base_"==names(data_out_ct_sel))
							ii_pom2=which("Expect_val"==names(data_out_ct_sel))	

							if (!is.empty(ii_pom)) {
					# differences or ratios or transformed values	
					data_out_ct_sel[ , diffs := ( transform_data( data_out_ct_sel[ , ii_pom , with=FALSE] , data_out_ct_sel[ , ii_pom2 , with=FALSE] , n_transformation ) ) ]

					
					# evaluates the differences
							data_out_ct_sel[ , mean_diffs := mean(diffs, na.rm=TRUE), by=MONTH ]
							data_out_ct_sel[ , STD_diffs := sd(diffs, na.rm=TRUE), by=MONTH ]
							
							data_out_ct_sel[ , p_diffs := pnorm( diffs , mean=0, sd=STD_diffs) ]
									#converts all to upper tail
											ii_d_sel=which( "p_diffs"==names(data_out_ct_sel))
											k_pom=data_out_ct_sel[[ii_d_sel]]<0.5
									data_out_ct_sel[ k_pom , p_diffs := (1 - p_diffs) ]
							
													} # if (!is.empty(ii_pom)) 	
							
								
				
			###############
			
			#	if (k_add_interquartile_range_coeff=TRUE) {
			
# CDF_b_sMed -  probability (CDF) of base station compared to median from standardized (to altitute) neighbours		
# CDF_e_oMed -  Expected value, compared to original neighbours	
						#base station - is part of the calculation - regression to altitude, so it influences it,
						#Expected value should not differ much outside neighbour values
						#	if so - then it is caused by the fault base station - that influenced the regression to altitude 
												
															
							if ("STD_base_" %in% names(data_out_ct_sel)) {
					data_out_ct_sel[ , CDF_e_oMed := (Expect_val - q050_ngbs)/STD_base_ ]
							
																	
							# its probability												
							data_out_ct_sel[ , CDF_e_oMed := pnorm( CDF_e_oMed , mean=0, sd=1) ]

							
							# inverts values where needed,  
									k_pom2=(data_out_ct_sel$CDF_e_oMed<0.5) & (!is.na(data_out_ct_sel$CDF_e_oMed))
							data_out_ct_sel[ k_pom2 , CDF_e_oMed := (1 - CDF_e_oMed ) ]
		
																		 }
				
				
			
								# standard deviation by month
# CDF_b_sMed vs. CDF_e_sMed								
# CDF_e_oMed or CDF_e_oMd2: it does not make much sense,  
	#	for 7-4: CDF_e_oMed, base station is part of the regression to altitude, so then, Expected value outside negbhours means that original base station is wrong ... outlier
	#	for 3/16: if the altitude regression is o.k., so then the Expected value may be outside the original neighbours,
	#		but it should not be much outside standardized neighbours, then it is strange ... 
	
							if ("Expect_val" %in% names(data_out_ct_sel)) {
								# STD of Expected value
								data_out_ct_sel[ , STD_Exp_val := sd(Expect_val, na.rm=TRUE), by=MONTH ]
			
					data_out_ct_sel[ , CDF_e_sMed := (Expect_val - q050_ngbs_base)/STD_Exp_val ]
							
								# its probability												
								data_out_ct_sel[ , CDF_e_sMed := pnorm( CDF_e_sMed , mean=0, sd=1) ]
								
							# inverts values where needed,  
									k_pom2=(data_out_ct_sel$CDF_e_sMed<0.5) & (!is.na(data_out_ct_sel$CDF_e_sMed))
							data_out_ct_sel[ k_pom2 , CDF_e_sMed := (1 - CDF_e_sMed ) ]								
								
																				}
				
				
			#								} # if (k_add_interquartile_range_coeff=TRUE)
				
									
			###############
									
                 #  flag='o'
 			     #   'o - orig. vals (no standardization)' &&st_naz  with st_Base
                 #  flag='n'
 			     #   'n - no regression (to altitude)' &&st_naz  with st_Base
                 #  flag='t'
 			     #   't - orig. vals (no standardization) (time aspect)' &&st_naz  with st_Base
				
				
			# prc_min_flag_o=100
							poc_pom = nrow( data_out_ct_sel[ Flag_regr!="-" ,  ] )
							poc_pom_prc=(100*poc_pom/(nrow(data_out_ct_sel)))
						  if ((poc_pom>0)&(length(ii_ngbs)>1)  & (poc_pom_prc>=prc_min_flag_o) ) {							
ss_pom=paste(stan_base,": Expected values were all ERASED, problematic ",poc_pom," cases (",round( poc_pom_prc , 1),"%), Original values of neighbours were preserved (limit is ",prc_min_flag_o,"%, you can change the limit, recommended value: 25%)", sep="")
if (k_supress_output_all_possible==FALSE) print(ss_pom)
warning(ss_pom)  
								
				data_out_ct_sel[ , Expect_val := NA ]
				# has to delete also differences, not to confuse user ...
				data_out_ct_sel[ , diffs := NA ] # "diffs"
																		} #if ((poc_pom>0)&(length(ii_ngbs)>1))
			
												


												
			###############		

			

		# Expected value statistics ...		
if (k_verbose) print("  Getting Expected value statistics ...	")			


		stat_ct = Get_statistics_basic( ss_col_base="Expect_val", ss_cols="Expect_val" , ss_names_ngb="Expect_val" , 
											ss_name_suffix="_Expected_value", k_append_blank=TRUE, k_include_KS=FALSE, k_verbose=k_verbose, stat_ct=stat_ct)


		stat_ct = Get_statistics_covariates(  ss_col_base="st_base" , ss_cols="Expect_val" , ss_name_suffix="_Expected_value" , k_append_blank=FALSE , stat_ct=stat_ct )
					
					
	
					
			###############
					
				
				
							data_out_ct_sel[ , Exp_val_t1 := my_diff( transform_data_1( Expect_val , n_transformation ) , my_lag=1 , n_transformation=n_transformation) ] # k_ratios=(n_transformation<=0)
				
							ii_pom =which("Exp_val_t1"==names(data_out_ct_sel))
							ii_d_sel=match(col_names_ngbs_t1, names(data_out_ct_sel))
								ii_d_sel=ii_d_sel[!is.na(ii_d_sel)]
								if (!is.empty(ii_d_sel)) {
						data_out_ct_sel[ , IQR_time_E:=Stat_calculate_row_IQR( x=data_out_ct_sel[, ii_pom , with=FALSE] , Y=data_out_ct_sel[, ii_d_sel, with=FALSE] ) ]	
														}

																
									}
				# EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE
									
									
									
									
									
									
################
################
################


if (k_verbose)  print("   Counting number of values with various Flags ...")	

		# adds flats statistics
						# data_out_ct_sel$Flag_regr	, ss_col_flag="Flag_regr",									
			stat_ct = Get_statistics_basic_CNT_values(  ss_values=unique( c("n","o","O","t", data_out_ct_sel$Flag_regr) )  , k_append_blank=FALSE , stat_ct=stat_ct )						
									

									
################


				# SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS					
		  if ( (k_check_thesame_vals==TRUE)
			  & ("st_base" %in% names(data_out_ct_sel))
										  )	{

		
		#differences>  i.e. two stations are the same ...

if (k_verbose)  print("   Checking the same vals")							  

				# duplicated values:
										list_Same_ngbs=integer(0)
		
										col_names_diffs_check=NA	
										# st_1_check,st_2_check,st_3_check,...
								for (ii_ngb in ii_ngbs) {
										col_names_diffs_check[ii_ngb]=paste("Same_",  gsub(' ','0',paste(format(ii_ngb, justify="right", width=floor(log10(n_max_ngbs))+1))), "_check" ,sep="")

										ii_pom =which(col_names_diffs[ii_ngb]==names(data_out_ct_sel))
										ii_pom2=ii_pom
													
# print_my("nbg: ",ii_ngb)													
								# analysis differences,  the same values of base and ngbs = repeating zeros in differences	
								# the same neighbour
							dt_same_values = as.data.table( Get_values_changes( x=my_diff(data_out_ct_sel[ , ii_pom , with=FALSE] , k_ratios=FALSE ), 
																				limit_value=0 , n_min_consecutive_vals=n_same_values_dupl , start_NA=TRUE ) )
																				# limit_value=0 , n_min_consecutive_vals=n_same_values ) )
									#checks values of the base and also of the differences
										ii_pom =which( "st_base"==names(data_out_ct_sel))
										if (!is.empty(ii_pom)) {
											
										dt_same_values_diff=Check_values_changes( x=data_out_ct_sel[ , ii_pom2 , with=FALSE], vals_change_in=dt_same_values, n_min_consecutive_vals=n_same_values_dupl, n_min_consecutive_vals_0=NA,  k_print=(k_supress_output_all_possible==FALSE) , k_add_stats=TRUE )
										
									dt_same_values=Check_values_changes( x=data_out_ct_sel[ , ii_pom , with=FALSE], vals_change_in=dt_same_values, n_min_consecutive_vals=n_same_values_dupl, n_min_consecutive_vals_0=n_same_values_0,  k_print=(k_supress_output_all_possible==FALSE) , k_add_stats=TRUE )
									
																} # if (!is.empty(ii_pom))
																
										# if the neighbour is the same, there is not need to further check the same values (of the neighbour ...)							
								
								# cbind.data.table does not exist yet
							 if ( max(dt_same_values$len, na.rm=TRUE) > 0 ) {
								# names(dt_same_values)[1]=col_names_diffs_check
								setnames( dt_same_values , 1, col_names_diffs_check[ii_ngb] )
							data_out_ct_sel=cbind(data_out_ct_sel , dt_same_values[,1] )

								# LLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLL
							# writes down the problem, later it sums into Same_ngbs:
							# logs info about ngb station
											list_Same_ngbs=c(list_Same_ngbs,ii_ngb)
							
													#gets changes of a lenght,  various periods
											val_diff_n=my_diff_zmena(dt_same_values[[1]], val_0=0 , val_last=-1)  #, by=ss_group_id]
											val_diff_n=which(val_diff_n>0)

											dates_changes=data_out_ct_sel[ val_diff_n, c(cols_date) , with=FALSE]
											dates_changes=cbind( dates_changes , dt_same_values[val_diff_n,1:2] )
											setnames(dates_changes,length(names(dates_changes))-1,"Length")
											
											#prida statistiky hodnot
											dates_changes=cbind( dates_changes , dt_same_values[val_diff_n,3:5] )
											dates_changes=cbind( dates_changes , dt_same_values_diff[val_diff_n,3:5] )
											setnames(dates_changes,(length(names(dates_changes))-2):length(names(dates_changes)),c("avg_diff","min_diff","max_diff"))
																						
							DT_Same_ngbs=data.table(ID=stan_base,ID_ngb=stan_ngbs[ii_ngb],
										ID_2=col_names_ngbs[ii_ngb], Remark="Same_ngbs", 
										DISTANCE=ngb_info_DT_sel$DISTANCE[ii_ngb], 
										ALT_1=stan_base_altitude, ALT2_=ngb_info_DT_sel$ALT_2[ii_ngb],  
										CORREL=ngb_info_DT_sel$CORREL[ii_ngb], 
										Period_beg=date_begin, Period_end=date_end)
							DT_Same_ngbs=cbind( DT_Same_ngbs , dates_changes )
											
								if (any(ls()=="DT_Same_ngbs_all")) { 
									l = list(DT_Same_ngbs_all, as.data.table(DT_Same_ngbs) )
									DT_Same_ngbs_all=rbindlist(l, fill=TRUE)
										if (exists("l")) rm(l)
										   } else { 
									DT_Same_ngbs_all=DT_Same_ngbs[] 
													}
								# LLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLL
								
																		  } else { 
							# NOTHING found											  
							data_out_ct_sel[ , c(col_names_diffs_check[ii_ngb]):=0 ]
																					} #if ( max(dt_same_values	

														} # for (ii_ngb in ii_ngbs)		
														
									#row summary for the further processing,  
									ii_d_sel=match(col_names_diffs_check, names(data_out_ct_sel))
											ii_d_sel=ii_d_sel[!is.na(ii_d_sel)]
											# st_sum_Check = Same_ngbs
									data_out_ct_sel=data_out_ct_sel[ CNT!=0 , Same_ngbs:=Stat_calculate_row(  data_out_ct_sel[ CNT!=0 , ii_d_sel, with=FALSE], "SUM" , na_rm=TRUE) ]	
				
								
##############
			#time aspect - the same consecutive values ...		
			# repeated values
			
										ii_pom =which( "st_base"==names(data_out_ct_sel))
								# similar to  Stat_calculate_row_lm								
							dt_same_values_base = as.data.table( Get_values_changes( x=my_diff( data_out_ct_sel[ , ii_pom , with=FALSE] ) , 
																				limit_value=0 , n_min_consecutive_vals=n_same_values , start_NA=TRUE ) )
									# output: len, order
									
# if (ii_cand==2) stop("stop here check cons")								
									# checks 0 values:
									dt_same_values_base=Check_values_changes( x=data_out_ct_sel[ , ii_pom , with=FALSE], vals_change_in=dt_same_values_base, n_min_consecutive_vals=n_same_values, n_min_consecutive_vals_0=n_same_values_0, k_print=(k_supress_output_all_possible==FALSE), k_add_stats=TRUE  )
								
								# cbind.data.table does not exist yet
							 if ( max(dt_same_values_base$len, na.rm=TRUE) > 0 ) {

								setnames( dt_same_values_base , 1, "Same_base" )
							data_out_ct_sel=cbind(data_out_ct_sel , dt_same_values_base[,1] )
							
							
								# LLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLL
							# writes down the problem, later it sums into Same_base:
							# logs info about base station
													#gets changes of a lenght,  various periods
											val_diff_n=my_diff_zmena(dt_same_values_base[[1]], val_0=0 , val_last=-1)  #, by=ss_group_id]
											val_diff_n=which(val_diff_n>0)
											
											dates_changes=data_out_ct_sel[ val_diff_n, c(cols_date) , with=FALSE]
											dates_changes=cbind( dates_changes , dt_same_values_base[val_diff_n,1:2] )
											setnames(dates_changes,length(names(dates_changes))-1,"Length")

											#prida statistiky hodnot
											dates_changes=cbind( dates_changes , dt_same_values_base[val_diff_n,3:5] )
											
							# DT_Same_base=data.table(ID=stan_base,ID_ngb=stan_ngbs[ii_ngb],
										# ID_2=col_names_ngbs[ii_ngb], Remark="Same_base", 
										# DISTANCE=ngb_info_DT_sel$DISTANCE[ii_ngb], 
										# ALT_1=stan_base_altitude, ALT2_=ngb_info_DT_sel$ALT_2[ii_ngb],  
										# CORREL=ngb_info_DT_sel$CORREL[ii_ngb], 
										# Period_beg=date_begin, Period_end=date_end)
							DT_Same_base=data.table(ID=stan_base,
										Remark="Same_base", 
										ALT_1=stan_base_altitude, 
										Period_beg=date_begin, Period_end=date_end)
										
							DT_Same_base=cbind( DT_Same_base , dates_changes )
											
								if (any(ls()=="DT_Same_base_all")) { 
									l = list(DT_Same_base_all, as.data.table(DT_Same_base) )
									DT_Same_base_all=rbindlist(l, fill=TRUE)
										if (exists("l")) rm(l)
										   } else { 
									DT_Same_base_all=DT_Same_base[] 
													}
								# LLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLL
															
							
							
																		  } else { 
							data_out_ct_sel[ , Same_base:=0 ]
																					} #if ( max(dt_same_values_base	
														
									
		
										} #if (k_check_thesame_vals=TRUE)
				# SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS					
									
 
  

################	 




# select problematic / suspicious values
				

		# max_QC_result=7  #maximum		
				
# Evaluation of QC:					

		k_pom=(c("Perct_Exc","CDF_med_d","CDF_b_sMed","CDF_e_oMed","IQR_time","Perc_t1_Exc","Same_base","Same_ngbs") %in% names(data_out_ct_sel))		
		# eeeeeeeeeeeeeevvvvvvvvvvvvvvvvvvvvvvaaaaaaaaaaaaaaaaaaaaaaaaallllllllllllllllllllllllllllllll
	if (all(k_pom)) {
				
				
if (k_verbose)  print("   Summing up found problems from individual detections (QC Evaluation) ...")							  
				
				# QC_result2 - tries to sum problems not equally, but according to severenes - percentage - i.e. continuously,  snaha to sesumovat ne po jednotkach za kazdy problem, ale podle zavaznosti - procent, za kazde, tedy spojite,  
				# but this does not work well, it is better to cound each problem as 1
		data_out_ct_sel[ , QC_result:=0 ] 
		data_out_ct_sel[ , QC_result2:=0 ] 
			data_out_ct_sel[ , Check_flag:="" ] 
		
		
# Perct_Exc,CDF_med_d	,Coef_IQR ,CDF_b_sMed , CDF_e_oMed , IQR_time ,Perc_t1_Exc

		data_out_ct_sel[ abs(Coef_IQR)>=3 , QC_result:=QC_result+1 ]
		data_out_ct_sel[  , QC_result2:=QC_result2 + (1-(1/(1+abs(Coef_IQR)))) ] #1+ - to get ouside 0-1 range, 1/[0-1] would be a problem
			data_out_ct_sel[ abs(Coef_IQR)>=3 , Check_flag:=paste(Check_flag,"Ci", sep="") ] 

						# Coef_IQR_ is based on st_base_ - i.e. transformed values
#		data_out_ct_sel[ abs(Coef_IQR_)>=3 , QC_result:=QC_result+1 ] 
#			data_out_ct_sel[ abs(Coef_IQR_)>=3 , Check_flag:=paste(Check_flag,"Ci", sep="") ] 

			
		data_out_ct_sel[ Perct_Exc>=0.75 , QC_result:=QC_result+1 ] 
		data_out_ct_sel[  , QC_result2:=QC_result2 + Perct_Exc ] 
			data_out_ct_sel[ Perct_Exc>=0.75 , Check_flag:=paste(Check_flag,"Ep", sep="") ] 
					
					
				# CDF_Med_d  contains CDF value (probability, normal distribution) of median of all (neighbours - base) differences	
		data_out_ct_sel[ CDF_med_d>=0.95 , QC_result:=QC_result+1 ] 
		data_out_ct_sel[  , QC_result2:=QC_result2 + CDF_med_d ] 
			data_out_ct_sel[ CDF_med_d>=0.95 , Check_flag:=paste(Check_flag,"Md", sep="") ] 
			
###

										
				# CDF_b_sMed -  probability (CDF) of base station compared to median of standardized (to altitute) neighbours
					# CDF_b_sMed := (st_base_ - q050_ngbs_base)/STD_base_
		data_out_ct_sel[ CDF_b_sMed>=0.95 , QC_result:=QC_result+1 ] 
		data_out_ct_sel[  , QC_result2:=QC_result2 + CDF_b_sMed ] 
			data_out_ct_sel[ CDF_b_sMed>=0.95 , Check_flag:=paste(Check_flag,"Bs", sep="") ] 

			
			# CDF_e_oMed := (Expect_val - q050_ngbs_base)/STD_base_ 
			# would CDF_e_oMed be high, it would mean that the Expected value calculation is wrong ... thus it should not be used here, for outliers finding
			# marks problem, only when the value is high ...
		data_out_ct_sel[ CDF_e_oMed>=0.75 , QC_result:= QC_result -1 ] # &&0.75 should be low, otherwise Expected value is probably calculated in a wrong way
		data_out_ct_sel[  , QC_result2:= QC_result2 - (2*(CDF_e_oMed-0.5)) ] # &&0.75 should be low, otherwise Expected value is probably calculated in a wrong way
			data_out_ct_sel[ CDF_e_oMed>=0.75 , Check_flag:=paste(Check_flag,"-Eo", sep="") ] 
			

	
###
			
		# beware, that time change is there and back ...
		 data_out_ct_sel[ abs(IQR_time)>=3 , QC_result:=QC_result+1 ] 
		 data_out_ct_sel[  , QC_result2:=QC_result2 + (1-(1/(1+abs(IQR_time)))) ]  
			data_out_ct_sel[ abs(IQR_time)>=3 , Check_flag:=paste(Check_flag,"It", sep="") ] 
		
		 data_out_ct_sel[ Perc_t1_Exc>=0.75 , QC_result:=QC_result+1 ] 
		 data_out_ct_sel[  , QC_result2:=QC_result2 + Perc_t1_Exc ] 
			 data_out_ct_sel[ Perc_t1_Exc>=0.75 , Check_flag:=paste(Check_flag,"T1", sep="") ] 

			#data_out_ct_sel[ abs(IQR_time2)>=3 , QC_result:=QC_result+1 ] 
			#	data_out_ct_sel[ abs(IQR_time2)>=3 , Check_flag:=paste(Check_flag,"It", sep="") ] 
			
			#data_out_ct_sel[ Exc_t1_pr2>=0.75 , QC_result:=QC_result+1 ] 
			#	data_out_ct_sel[ Exc_t1_pr2>=0.75 , Check_flag:=paste(Check_flag,"T1", sep="") ] 

			
# QC_result>=8
			
		# data_out_ct_sel[ abs(IQR_time_E)>=3 , QC_result:=QC_result+1 ] 
			# data_out_ct_sel[ abs(IQR_time_E)>=3 , Check_flag:=paste(Check_flag,"Ie", sep="") ] 
			
			
################	 
		
			# the weight is bigger for repeated values
		data_out_ct_sel[ Same_base>0 , QC_result:=QC_result + 5 ] # &&0.75 should be low, otherwise Expected value is probably calculated in a wrong way
			data_out_ct_sel[ Same_base>0 , Check_flag:=paste(Check_flag,"Sb", sep="") ] 

			# the way is bigger for duplicated values
		data_out_ct_sel[ Same_ngbs>0 , QC_result:=QC_result + 5 ] # &&0.75 should be low, otherwise Expected value is probably calculated in a wrong way
			data_out_ct_sel[ Same_ngbs>0 , Check_flag:=paste(Check_flag,"Sn", sep="") ] 


				

################	 

		# number of methods finding problems in percentage
		data_out_ct_sel[ QC_result>0  & Same_base==0 & Same_ngbs==0, QC_res_per := round( 100*QC_result  / max_QC_result , 1 ) ]
		data_out_ct_sel[ QC_result2>0 & Same_base==0 & Same_ngbs==0, QC_percnt2 := round( 100*QC_result2 / max_QC_result , 1 ) ]
							
################	 
					# 0... ok
					# 1... error ((70/100% probability of being error)
					# 2... suspicious values (40/70% probability of being error)
					# 4... repeated value (result of consistency check)
					# 5... duplicated value (same value found in neighbor station)
					# 9... missing value		
#		data_out_ct_sel[ , QC_flag :=0  ]  #repeated values
		data_out_ct_sel[ , QC_flag :=""  ]  #flagged values
		
			# errors
		data_out_ct_sel[ QC_res_per>=70, QC_flag := "1" ]  
			# suspicious values, max_QC_result_suspicous_per=40
		data_out_ct_sel[ QC_res_per>=max_QC_result_suspicous_per & QC_res_per<70, QC_flag := "2" ]  
						
			# repeated values
		data_out_ct_sel[ Same_base>0, QC_flag := paste0(QC_flag,"4") ]  
			# duplicated values
		data_out_ct_sel[ Same_ngbs>0, QC_flag := paste0(QC_flag,"5") ]  
		
			#missing values
		data_out_ct_sel[ st_base==missval | is.na(st_base) , QC_flag := "9" ]  

		data_out_ct_sel[ QC_flag=="" , QC_flag :="0"  ]


					} #if (all(k_pom))
		# eeeeeeeeeeeeeevvvvvvvvvvvvvvvvvvvvvvaaaaaaaaaaaaaaaaaaaaaaaaallllllllllllllllllllllllllllllll

		
	
################	 



					
if (k_verbose)  print("   Marking rows (deletion) ...")							  
					

							k_deleted=rep(FALSE,nrow(data_out_ct_sel))
							k_deleted2=k_deleted
				if (all( c("st_base","Same_ngbs") %in% names(data_out_ct_sel)) ) {	
							
							k_deleted=( (is.na(data_out_ct_sel[["st_base"]])) | 
												data_out_ct_sel[["st_base"]]==missval | 
												data_out_ct_sel[["Expect_val"]]==missval | 
									(data_out_ct_sel[["QC_flag"]] != "1" ) )  #<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
									# (data_out_ct_sel[["QC_result"]] < max_QC_result-1 ) )  #<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
		
								k_deleted[ data_out_ct_sel[["Same_ngbs"]]>0 ]=FALSE
								k_deleted[ data_out_ct_sel[["Same_base"]]>0 ]=FALSE
								
								######
									# to plot also suspucious ...
							
									k_deleted2=( (is.na(data_out_ct_sel[["st_base"]])) | 
														data_out_ct_sel[["st_base"]]==missval | 
														data_out_ct_sel[["Expect_val"]]==missval | 
											(data_out_ct_sel[["QC_res_per"]] < max_QC_result_suspicous_per ) )  # 40 percent   #<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
											# (data_out_ct_sel[["QC_result"]] < max_QC_result_suspicous ) )  
				
										k_deleted2[ data_out_ct_sel[["Same_ngbs"]]>0 ]=FALSE
										k_deleted2[ data_out_ct_sel[["Same_base"]]>0 ]=FALSE

								######
								
									
							n_deleted = nrow(data_out_ct_sel) - sum(k_deleted, na.rm=TRUE)
							# Perc_n_deleted=(100*n_deleted/(dim(data_out_ct_sel)[1]))
							Perc_n_deleted=(100*n_deleted/(nrow(data_out_ct_sel)))
ss_pom=paste(stan_base,": number of found errors: ",n_deleted," (",round( Perc_n_deleted , 1),"%)", sep="")
if (k_supress_output_all_possible==FALSE) print(ss_pom)
							n_deleted2 = nrow(data_out_ct_sel) - sum(k_deleted2, na.rm=TRUE)
							Perc_n_deleted2=(100*n_deleted2/(nrow(data_out_ct_sel)))
ss_pom=paste(stan_base,": number of found suspicious values: ",n_deleted2," (",round( Perc_n_deleted2 , 1),"%)", sep="")
if (k_verbose) print(ss_pom) # \  								


							data_out_ct_sel[ , deleted_:=k_deleted ]	# n_deleted
					
															
															} # if (all( c("st_base","Same_ngbs") %in% names(data_out_ct_sel)) )


															
															
################	 

# save plot
		

									 
									 
						ss_text_base_ord=paste(stan_base, sep="")
						
						# distinction
								ss_pom=paste(ngb_info_DT$ID_1,"_",ngb_info_DT$BEGIN, sep="")
								if (length(unique(ngb_info_DT$ID_1))!=length(unique(ss_pom))) {
					 ss_text_base_ord=paste(stan_base,"_", date_begin , sep="")					
																							  }
								if (k_multi_ID) {
								  if ((all(!is.na(idcol_group)))) {
										if (grepl(grp,ss_text_base_ord)) {
											ss_text_base_ord=gsub(paste("__",grp,sep=""),"",ss_text_base_ord)
											ss_text_base_ord=gsub(paste("_",grp,sep=""),"",ss_text_base_ord)
											ss_text_base_ord=gsub(paste("",grp,sep=""),"",ss_text_base_ord)
																		 }
																  }	
												}
																			

																			
							plotkind="pdf"								
																		
								# local letters													
								ss_text_base_ord=Convert_CZ_to_x(ss_text_base_ord)
									
							file_pdf = gsub("[.]dbf",paste("_",paste(ss_text_base_ord, sep=""),".",plotkind, sep=""), file_stat, ignore.case = TRUE)		
							file_pdf=adjust_filename(file_pdf, char_repl="_" , k_path_care=TRUE)
							
							
									# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<,
									file_pdf_original=file_pdf
									# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<,
									# further use:
									# filename_with_Temp( file_pdf_original , k_save_Auxl_into_Temp, ss_add_path="/plots" )
									


		if (k_save_auxiliary_files) {
if (k_verbose)  print("   Preparing for saving plots ...")
								
								
		if (k_plot==TRUE) {
					# ttttttttttttttttttttttttttttttttttt	
					#saves only errors, and also errors + suspicious into subdir ...			
		for (ii_pom_del in c(1,2)) {
								
								
					if (ii_pom_del!=1) {			
if (k_plot_suspicious==FALSE) next
								# suspicious and error values, it will be put into subfolder
					
						file_pdf=filename_with_Temp( file_pdf_original , k_save_Auxl_into_Temp, paste(ss_add_path="/plots_",plotkind,"/Suspicious_and_errors",sep="") )
						k_deleted_12=k_deleted2
# print_my("Saving errors and suspicous values ...")						
																	} else {
						file_pdf=filename_with_Temp( file_pdf_original , k_save_Auxl_into_Temp, paste(ss_add_path="/plots_",plotkind,sep="") )
						k_deleted_12=k_deleted
# print_my("Saving only errors ... ")						
																			}
								
								
################	 
				# to plot also suspicious ...
				# k_deleted=( ... (data_out_ct_sel[["QC_result"]] < max_QC_result ) )  #<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
				# k_deleted2=( (data_out_ct_sel[["QC_result"]] < max_QC_result_suspicous ) ) # 3  #<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
		

################	 
		
					# PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP
		if ((k_plot==TRUE)&(sum(!k_deleted_12 , na.rm=TRUE)>0)) {
						
if (k_verbose)  print("   Plotting found problems")							  

				Make_plots_QC( data_out_ct_sel , k_deleted_12, file_pdf, stan_base , ii_cand , stan_ngbs, col_names_ngbs_alt , ss_text_base_ord, k_verbose=(k_supress_output_all_possible==FALSE) ) 
				
																
							
																	} #if ((k_plot==TRUE)&(sum(!k_deleted_12 , na.rm=TRUE)>0))	 
					# PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP

					
					
									} # for (ii_pom_del in c(1,2))																			
					# ttttttttttttttttttttttttttttttttttt	
							} # if (k_plot==TRUE) {							


							
						} # if (k_save_auxiliary_files)

					
					
##################################################################################					
					
							
					

# adjust the output					
if (k_verbose) print("  Adjusting the output ...")					

				
							
					# change order, column order,  zmen_poradi_sloupcu()
							cosl_to_remove=c( "CNT_ngb_t1",  
								col_names_diffs,col_names_diffs_stnd_p,
								"t1_base", 
									col_names_ngbs_t1,
									col_names_ngbs_t1_diffs,col_names_ngbs_t1_diffs_stnd,col_names_ngbs_t1_diffs_stnd_p,
								col_names_ngbs_alt_stnd,col_names_ngbs_alt_stnd_p,
								"Exc_r_CNT","Exc_r_perct", "CDF_max_r" ,
								"Exc_t1_CNT", 
									"CDF_max_t1",  "Exp_val_t1", 
								"CNT_ngb",
								"CNT", 
								"q025_ngbs_base","q075_ngbs_base",
								"Flag_rem","IQR_time_back","t1_Exc_pback",
								"IQR_time_alt",
								"Coef_IQR_",  # from _base (alt standardized) stations ... does not work well - better to do it from ngbs straight
								"t1_base_","CNT_t1_ngb_stnd_diffs_p",
									col_names_ngbs_t1_stnd,
									col_names_ngbs_alt_t1,
									col_names_ngbs_alt_t1_stnd,
									col_names_ngbs_t1_stnd_b_diff,
									col_names_ngbs_t1_stnd_b_diff_p,
									"Perc_t1_base_Count",  #Exc_t1_base_Count
								col_names_diffs_check
												)
												
								if (n_pd_function=="3/16/0") cosl_to_remove=c(cosl_to_remove, 
									  "q025_ngbs","q050_ngbs","q075_ngbs", # "Exc_t1_base_Count",									  
									  "STD_Exp_val"  									  
																				)
								
									# <<<<<<<<<<<<<<<<<<<<<<<<<<<<
								cosl_to_remove=cosl_to_remove[!is.na(cosl_to_remove)]
									# <<<<<<<<<<<<<<<<<<<<<<<<<<<<
								
								
					
				#removes some columns, exclude columns, exclude_columns
					# k_remove_aux_colums=1
				if (k_remove_aux_colums==1) {	
							ii_d_sel=match(cosl_to_remove,names(data_out_ct_sel))	
								ii_d_sel=ii_d_sel[!is.na(ii_d_sel)]
								if (!is.empty(ii_d_sel)) {
							data_out_ct_sel=data_out_ct_sel[, -ii_d_sel , with=FALSE]
															}
											} # if (k_remove_aux_colums==1)
				
				
if (k_verbose) print("  Changing column order")					
				
				# Change order
				#expected value	put  in the beginning of the columns
						
						if (all( c("st_base") %in% names(data_out_ct_sel)) ) {
							ii_pom=which("st_base"==names(data_out_ct_sel) ) +1						
																			 } else {
							# (n_pd_function=="3/16/0")											 
							ii_pom=which(col_names_ngbs[1]==names(data_out_ct_sel) ) +0
																					}
					data_out_ct_sel=Change_Column_order( data_out_ct_sel, col_names=c("Expect_val","diffs") , order=ii_pom )
						
					data_out_ct_sel=Change_Column_order( data_out_ct_sel, c("regr_b1","regr_brs","regr_deter","regr_pval","regr_cor") , which("st_base_"==names(data_out_ct_sel) )  )
					data_out_ct_sel=Change_Column_order( data_out_ct_sel, c("Flag_regr","Flag_rem","Exc_t1_base_Count") , which("ngb_avg"==names(data_out_ct_sel) ) )
					
						
						if (all( c("Same_ngbs") %in% names(data_out_ct_sel)) ) {
						ii_pom=which("Same_ngbs"==names(data_out_ct_sel) )
																				} else {
						# (n_pd_function=="3/16/0")													
						ii_pom=which("q075_ngbs_base"==names(data_out_ct_sel) )+1						
																						}
					data_out_ct_sel=Change_Column_order( data_out_ct_sel, c("Coef_IQR_","q050_ngbs_base","STD_base_","STD_Exp_val","CDF_b_sMed","CDF_e_sMed","CDF_e_oMd2","CDF_e_oMed","IQR_time_E") ,  ii_pom )

					
				    # re-orders the columns, if other neighbours were added later, they are in another place ... in final file,  later ...
				# order, sort: needed here, for stations with more neighbours given later ... 							   
if (k_verbose) print("  Changing column order, in the final file (for a given station)")					
					data_out_ct_sel=Change_Column_order( data_out_ct_sel, col_names_ngbs ,  which(col_names_ngbs[1]==names(data_out_ct_sel) ) )
					data_out_ct_sel=Change_Column_order( data_out_ct_sel, col_names_diffs ,  which(col_names_diffs[1]==names(data_out_ct_sel) ) )
					data_out_ct_sel=Change_Column_order( data_out_ct_sel, col_names_diffs_stnd ,  which(col_names_diffs_stnd[1]==names(data_out_ct_sel) ) )
					data_out_ct_sel=Change_Column_order( data_out_ct_sel, col_names_ngbs_alt ,  which(col_names_ngbs_alt[1]==names(data_out_ct_sel) ) )
					
					
						 
#####						
					
					
				# adds info about distances and altitudes	- to QC file
								# nnnnnnnnnnnnnnnnnnnnnnnnnnn					
				if (nrow(data_out_ct_sel)>0) {
if (k_verbose) print("  Adding info into data file")					
					
							#Insert empty row - append blank
							stat_alt=data_out_ct_sel[0][1,]
								stat_alt[, c( col_names_ngbs ) := as.list( ngb_info_DT_sel$ALT_2 ) ]
								stat_alt[,Remark:="Altitude"]
								
								if (all( c("st_base") %in% names(data_out_ct_sel)) ) {
								stat_alt[,st_base:=stan_base_altitude]
																					}
									# saves also further info, 
									stat_alt[, c( col_names_ngbs_alt ) := as.list( ngb_info_DT_sel$ALT_2 ) ]
									
									# and limits
									if (all( c(col_names_diffs_stnd) %in% names(data_out_ct_sel)) )
									stat_alt[, c( col_names_diffs_stnd ) := as.list( round(std_nasobek_limit,3) ) ]
									
									# stat_alt$CDF_max_d=round(limit_confidence,3)
									if (all( c("CDF_max_d") %in% names(data_out_ct_sel)) )
									stat_alt$CDF_max_d=round(std_nasobek,3)
									
									
									
									
							stat_dist=data_out_ct_sel[0][1,]
								if ("DISTANCE" %in% names(ngb_info_DT_sel)) stat_dist[, c( col_names_ngbs ) := as.list( ngb_info_DT_sel$DISTANCE ) ]
								stat_dist[,Remark:="Distance"]
							stat_corr=data_out_ct_sel[0][1,]
								if ("CORREL" %in% names(ngb_info_DT_sel)) stat_corr[, c( col_names_ngbs ) := as.list( ngb_info_DT_sel$CORREL ) ]
								stat_corr[,Remark:="Corr"]

										ss_element=""
										ss_name_element=""
								#first column to be region or element in input file, it gives it in the beginning also here, in the output
								if (class(data_out_ct_sel[[1]])=="character") if ( (names(data_out_ct_sel)[1]=="ELEMENT") | (names(data_out_ct_sel)[1]=="REGION") ) {
										ss_element=unique(data_out_ct_sel[[1]])
										ss_element=ss_element[!is.na(ss_element)]
									if (length(ss_element)>1) {	
print_my("Problem: not unique value of the first column in the data file (element): ",ss_element,  k_warning=TRUE)
															}	
									stat_alt[[1]]=ss_element 
									stat_dist[[1]]=ss_element
									stat_corr[[1]]=ss_element 
										ss_name_element=names(stat_corr)[1]
																			  }	 # if (class(data_out_ct_sel[[1]])=="character")
								
						#binds together
						l = list( stat_alt , stat_dist , stat_corr , data_out_ct_sel )  
						data_out_ct_sel=rbindlist(l, fill=TRUE)
						
							if (exists("l")) rm(l)
						
							# change column order for Remark
							data_out_ct_sel=Change_Column_order( data_out_ct_sel, c("Remark") , which(col_names_ngbs[1]==names(data_out_ct_sel) ) +0 )

							
				#####	

					
				# adds cols - information about the processed station
						# for (ii_cand in (unique(ngb_info_DT$id_ord)) 
					data_out_ct_sel$id_ord=ii_cand

					
				# the base station itself,  jeste samotnou stanici
				data_out_ct_sel$ID=stan_base				
														
				data_out_ct_sel=data_out_ct_sel[ nchar(Remark)==0 , Remark := paste(year_begin,"-",year_end, sep="") ]
														
				data_out_ct_sel=Change_Column_order( data_out_ct_sel, c("ID") , 1 )	
								
					
					# adds info about stations
						for (ii_ngb in rev(ii_ngbs) ) {
							stat_ngbs=data_out_ct_sel[0][1,]
								if (k_multi_ID==TRUE) {	
									# multi_ID columns will be added:
								stat_ngbs[ , c(idcol):=data_out_ct_sel[ nrow(data_out_ct_sel) , idcol, with=FALSE] ]
								
								stan_ngbs_=unlist(lapply( stan_ngbs, function(x) gsub( paste("_",a_region,sep="") , "", x, fixed=TRUE) ))
								stat_ngbs$ID=paste(" ",stan_ngbs_[ii_ngb], sep="")  #with blank space in the beginning ...
													  } else {
								stat_ngbs$ID=paste(" ",stan_ngbs[ii_ngb], sep="")  #with blank space in the beginning ...
															 }
								
								
								stat_ngbs$Remark=col_names_ngbs[ii_ngb]
										ii_pom=which(  col_names_ngbs[ii_ngb] == names(stat_ngbs))
									stat_ngbs[ , c(col_names_ngbs[ii_ngb]) := ngb_info_DT_sel$DISTANCE[ii_ngb] ] 
								# stat_ngbs[[1]]=ss_element 
							if (ss_name_element %in% names(data_out_ct_sel)) {  # nchar(ss_name_element)>0
								stat_ngbs[ , c(ss_name_element) :=ss_element ]
																			}			
								
							l = list( stat_ngbs , data_out_ct_sel  )  #stat_cnt_ct[0][1,]
							data_out_ct_sel=rbindlist(l, fill=TRUE)
												      } # for (ii_ngb in ii_ngbs)
							if (exists("l")) rm(l)

													  
						# changes order in the beginning,  
							ii_pom2=length(ii_ngbs)
							ii_pom=c( (ii_pom2+1):(ii_pom2+3), ii_ngbs , (ii_pom2+4):(nrow(data_out_ct_sel)))							
						# change row order	
						data_out_ct_sel=data_out_ct_sel[ ii_pom , ]
					
					
					
													} # if (nrow(data_out_ct_sel)>0) 
								# nnnnnnnnnnnnnnnnnnnnnnnnnnn					
					
				
						n_header=(1:(3+length(ii_ngbs)))
					if (Perc_n_deleted==0) {
						data_out_ct_sel[ , deleted_:=TRUE ]	
										} else {
						data_out_ct_sel[ n_header , deleted_:=FALSE ]	
							# second and third row will be deleted, to give the same output as ProClimDB	
						data_out_ct_sel[ (2:3) , deleted_:=TRUE ]	
												}

					if (n_pd_function=="3/16/0") {
						data_out_ct_sel[ , deleted_:=FALSE ] # k_deleted	
							data_out_ct_sel[ (2:3) , deleted_:=TRUE ]	
						data_out_ct_sel[ n_header , deleted_:=TRUE ]	
												 }							
										


###
					# adds info about various selections
					if (!is.na(stan_id_indiv)) {
						data_out_ct_sel[ , ID_INDIV:=stan_id_indiv ]
						data_out_ct_sel=Change_Column_order(data_out_ct_sel, c("ID_INDIV"), 1)
												}

										
########

												
# info file					
if (k_verbose) print("  Adding info into info_file")					
				#####
						# VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVv
					# get characteristics
						
						ii_pom=which("st_base"==names(data_out_ct_sel))
						ii_pom2=which("Expect_val"==names(data_out_ct_sel))
					if ((!is.empty(ii_pom))&(!is.empty(ii_pom2))) {
								k_pom=!is.na(data_out_ct_sel$YEAR)
if (k_verbose) print("  Calculating validation characteristics ")			
					
								# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<	
						stat_ct_chars=getChars2( DT1=data_out_ct_sel[ k_pom , (1:ii_pom), with=FALSE], 
												 DT2=data_out_ct_sel[ k_pom , c((1:(ii_pom-1)),ii_pom2) , with=FALSE]	, 
									valCol=c("st_base","Expect_val","VAL") ,	
									idCol=c("ID","ID_1","ID_2") ,		
									dataName = "\"Original\"-\"expected\"" ,
									k_verbose=k_verbose )
								# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<	
											
							ss_pom=names(stat_ct_chars)
							ss_pom=gsub("REMARK","stat", ss_pom)
							ss_pom=gsub("DATA","ID", ss_pom)
							
							for (mm in 1:12) {
									ss1=paste("K",mm, sep="")
									ss2=paste("N",  gsub(' ','0',paste(format(mm, justify="right", width=floor(log10( 12 ))+1))) ,sep="")
								ii_pom=which(ss1==ss_pom)
								ss_pom[ii_pom]=ss2
											 } # for 
										
					if (nrow(stat_ct_chars)>0) {
							stat_ct_chars$ID_2="Expected value"
					#rename		
					setnames(stat_ct_chars, names(stat_ct_chars), ss_pom)		
					
						
					#binds together
						l = list( stat_ct , stat_ct_chars)  #,  stat_cnt_ct[0][1,]						
						stat_ct=rbindlist(l, fill=TRUE)
							if (exists("l")) rm(l)
						
												}	 #if (nrow(stat_ct_chars)>0)				
						
																	} # if ((!is.empty(ii_pom))&(!is.empty(ii_pom2)))
						# VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVv
					
					
					
				#####	############
					

				# adds info about distances and altitudes	- to QC INFO file
							# info from: ngb_info_DT_sel
					stat_ct[ ID_1==stan_base & nchar(as.character(ID_2))==0 , DISTANCE:=0 ]
					stat_ct[ ID_1==stan_base & nchar(as.character(ID_2))==0 , ALT_1:=stan_base_altitude ]
						for (ii_ngb in rev(ii_ngbs) ) {
							stat_ct[ ID_2==stan_ngbs[ii_ngb] & nchar(as.character(ID_1))==0 , DISTANCE:=ngb_info_DT_sel$DISTANCE[ii_ngb] ]
							stat_ct[ ID_2==stan_ngbs[ii_ngb] & nchar(as.character(ID_1))==0 , ALT_2:=stan_ngbs_altitudes[ii_ngb] ]
							stat_ct[ ID_2==stan_ngbs[ii_ngb] & nchar(as.character(ID_1))==0 , ALT_1:=stan_base_altitude ]
												      } # for (ii_ngb in ii_ngbs)
					 
					
				stat_ct$id_ord=ii_cand
				
				stat_ct = Change_Column_order( stat_ct, c("DISTANCE","ALT_1","ALT_2") , which("stat"==names(stat_ct) ) +1 )	
				
				
				
				# adds info about various selections
				if (!is.na(stan_id_indiv)) {
					stat_ct[ , ID_INDIV:=stan_id_indiv ]
					stat_ct=Change_Column_order(stat_ct, c("ID_INDIV"), 1)
											}
				
							
					
###################					
###################					
###################					
				


if (k_verbose) print("  ... loop finished")				

# stop('stop here before saving ... in ( (n_pd_function=="7/4/0")|(n_pd_function=="3/16/0") ) ')
					
#######
					
		###
		# bind all results together			
				
					# adds empty row
					#	if (k_append_blank) {
									l = list( data_out_ct_sel  ,  data_out_ct_sel[0][1,]  )				
									data_out_ct_sel=rbindlist(l, fill=TRUE)

									l = list( stat_ct  ,  stat_ct[0][1,]  )
									stat_ct=rbindlist(l, fill=TRUE)
										if (exists("l")) rm(l)
					#						}	 																								
					
							# here it treats deleted_, since NAs may be present there
							data_out_ct_sel[ is.na(deleted_), deleted_:=TRUE ]									



							
						# ssssssssssfffffffffffffffffffrrrrrrrrrrrrrrrrrrrrrsssssssssssss
					 # if (k_save_only_final_results==FALSE) {
					 if (k_save_data_into_files_rda) {

					 
							# rda_rda_rda_rda_rda_rda_rda_rda_rda_rda_rda_	
					#to save the memory, instead of one bif variable containing everything, the results are coninousle saved, and later read and finally wrote down as a whole
					file_stat_rda=gsub( paste(".",plotkind, sep=""), paste("__cand_",ii_cand,".rda",sep=""), filename_with_Temp( file_pdf_original , k_save_Auxl_into_Temp, ss_add_path="/_temp_rda" ) , ignore.case = TRUE)
					#<<<<<<<<<<<<<<<<<<<<<<
					save( data_out_ct_sel , file=file_stat_rda )		
					#<<<<<<<<<<<<<<<<<<<<<<
					
					# k_save_data_into_files_rda=TRUE
					
				# if (any(ls()=="data_out")) data_out=rbind(data_out,data_out_pom, all=TRUE) else data_out=data_out_pom
				if (any(ls()=="data_out_ct_sel_all")) { 
					data_out_ct_sel_all=c(data_out_ct_sel_all,file_stat_rda)
					
					
										   } else { 
										   data_out_ct_sel_all=file_stat_rda 
													}
							# rda_rda_rda_rda_rda_rda_rda_rda_rda_rda_rda_	
					

					
							# rda_rda_rda_rda_rda_rda_rda_rda_rda_rda_rda_	
					file_stat2_rda=gsub( paste(".",plotkind, sep=""), paste("_stat__cand_",ii_cand,".rda",sep=""), filename_with_Temp( file_pdf_original , k_save_Auxl_into_Temp, ss_add_path="/_temp_rda" ) , ignore.case = TRUE)
					#<<<<<<<<<<<<<<<<<<<<<<
					save( stat_ct , file=file_stat2_rda )					
					#<<<<<<<<<<<<<<<<<<<<<<

					if (any(ls()=="stat_ct_all")) { 
					stat_ct_all=c(stat_ct_all,file_stat2_rda)
					
										   } else { 
											stat_ct_all=file_stat2_rda 
													}
							# rda_rda_rda_rda_rda_rda_rda_rda_rda_rda_rda_	
							
															} # if (k_save_only_final_results==FALSE)
						# ssssssssssfffffffffffffffffffrrrrrrrrrrrrrrrrrrrrrsssssssssssss
					
#######

						if (.Platform$OS.type=="windows") data_out_ct_sel[ , ID:=iconv(ID,  to="1250", from="UTF-8" ) ]

						
						# ssssssssssfffffffffffffffffffrrrrrrrrrrrrrrrrrrrrrsssssssssssss
					 if (k_save_only_final_results==TRUE) {
						
		# save results	
		# if (k_save_individual) {
						

						#	k_deleted=( (is.na(data_out_ct_sel[["st_base"]])) | 
						#						data_out_ct_sel[["st_base"]]==missval | 
						#						data_out_ct_sel[["Expect_val"]]==missval | 
						#						(data_out_ct_sel[["QC_result"]] < max_QC_result ) )				
								
						
							if (nrow(  data_out_ct_sel[ !(deleted_) , ] )>0) {

				# eeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeee
				# saves errors for a given group, partial results
				if (k_ECAD_mode==FALSE)				
				if (k_save_auxiliary_files==TRUE) # if (k_save_only_final_results==FALSE)
					if (!(n_pd_function=="3/16/0"))	{
					
				if (k_CSV==TRUE) {				  

						file_stat_txt=gsub(paste(".",plotkind, sep=""),"_errors.csv", filename_with_Temp( file_pdf_original , k_save_Auxl_into_Temp, ss_add_path="/errors_txt" ) , ignore.case = TRUE)

					# write.csv2( data_out_ct_sel[ !(deleted_) , ] , file=file_stat_txt, na="", row.names = FALSE)
					write.table( data_out_ct_sel[ !(deleted_) , ] , file=file_stat_txt, na="", row.names = FALSE, sep=";", dec=Sys.localeconv()[1] )
					
									}

					
						file_stat_dbf=gsub(paste(".",plotkind, sep=""),"_errors.dbf", filename_with_Temp( file_pdf_original , k_save_Auxl_into_Temp, ss_add_path="/errors_dbf" ) , ignore.case = TRUE)
						
if (k_verbose) print_my("  Saving  found Errors  for individual station: ", relative_filepath(file_stat_dbf) )	
						
						
								ii_pom2=!(data_out_ct_sel$deleted_)
									ii_pom=data_out_ct_sel$YEAR[ii_pom2]
									ii_pom=!(ii_pom>0)
									ii_pom[is.na(ii_pom)]=TRUE
					my__write_dbf( data_out_ct_sel[ !(deleted_) , ] , file_stat_dbf ,  n_dec=3, print_output=FALSE , mfd=ii_pom ) 
					
					
															} # if (nrow(  data_out_ct_sel[ !(deleted_) , ] )>0)
																																						
																																				

				###			
						if (k_save_auxiliary_files==TRUE)  # if (k_save_only_final_results==FALSE)
						if (all( c("Same_ngbs") %in% names(data_out_ct_sel)) )
							if (nrow(  data_out_ct_sel[ Same_ngbs>0 , ] )>0) {												
						file_stat_dbf=gsub(paste(".",plotkind, sep=""),"_duplicated.dbf", filename_with_Temp( file_pdf_original , k_save_Auxl_into_Temp, ss_add_path="" ) , ignore.case = TRUE)		
if (k_verbose) print_my("  Saving found Repeated values  for individual station: ", relative_filepath(file_stat_dbf) )	
									ii_pom=match( "st_base", names(data_out_ct_sel))
									ii_pom=1:ii_pom
									
									# in list_Same_ngbs, partical neighbours (number - order) is saved
									
										if (length(list_Same_ngbs)>0) {
									  ii_d_sel=match( c(col_names_ngbs[list_Same_ngbs],"Same_ngbs","id_ord") , names(data_out_ct_sel))
																		} else {
									  ii_d_sel=match( c(col_names_ngbs,"Same_ngbs","id_ord") , names(data_out_ct_sel))
																				}
											ii_d_sel=ii_d_sel[!is.na(ii_d_sel)]
									ii_d_sel=c(ii_pom,ii_d_sel)
												ii_pom=match( "Remark", names(data_out_ct_sel)) 
												ii_d_sel=c(ii_pom,ii_d_sel)
									
										ii_pom2=unique(c(n_header, which(data_out_ct_sel$Same_ngbs>0)))
											ii_pom=data_out_ct_sel$YEAR[ii_pom2]
											ii_pom=!(ii_pom>0)
											ii_pom[is.na(ii_pom)]=TRUE
											# first two rows are Distance and Altitude, so let it in the output:
											ii_pom[1:3]=FALSE
											ii_pom[3+list_Same_ngbs]=FALSE #given station row
											
					my__write_dbf( data_out_ct_sel[ ii_pom2 , ii_d_sel , with=FALSE ] , file_stat_dbf ,  n_dec=3, print_output=FALSE , mfd=ii_pom ) #, mfd=data_out_ct_sel$deleted_
																			} # if (nrow(  data_out_ct_sel[ !(deleted_) , ] )>0)
					
					
				###			
						if (k_save_auxiliary_files==TRUE)  # if (k_save_only_final_results==FALSE)
						if (all( c("Same_base") %in% names(data_out_ct_sel)) )
							if (nrow(  data_out_ct_sel[ Same_base>0 , ] )>0) {	
																		# _same_base
						file_stat_dbf=gsub(paste(".",plotkind, sep=""),"_repeated.dbf", filename_with_Temp( file_pdf_original , k_save_Auxl_into_Temp, ss_add_path="" ) , ignore.case = TRUE)		
									ii_pom=match( "st_base", names(data_out_ct_sel))
									ii_pom=1:ii_pom
									
									ii_d_sel=match( c("Same_base","id_ord"), names(data_out_ct_sel))
										ii_d_sel=ii_d_sel[!is.na(ii_d_sel)]
									ii_d_sel=c(ii_pom,ii_d_sel)
if (k_verbose) print_my("  Saving found Repeated values  for individual station: ", relative_filepath(file_stat_dbf) )	
									# , mfd=(n_header %in% (1:nrow(data_out_ct_sel[ Same_base>0 ,])))	
					my__write_dbf( data_out_ct_sel[ Same_base>0 , ii_d_sel , with=FALSE] , file_stat_dbf ,  n_dec=3, print_output=FALSE  ) #, mfd=data_out_ct_sel$deleted_
																			} # if (nrow(  data_out_ct_sel[ !(deleted_) , ] )>0)
				

													} # if (!(n_pd_function=="3/16/0"))
				# eeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeee
				
				
				#######
					if (k_save_auxiliary_files==TRUE) # if (k_save_only_final_results==FALSE)				
					if ( ((any(ls()=="stat_ct"))&(nchar(file_stat2)>0)) ) {  # | (n_pd_function=="4/1/0") | (n_pd_function=="3/11/0")
					
					
						if (k_CSV==TRUE) {
				
						file_stat2_txt=gsub(paste(".",plotkind, sep=""),"_stat.csv", filename_with_Temp( file_pdf_original , k_save_Auxl_into_Temp, ss_add_path="/stats_txt" ) , ignore.case = TRUE)
					
						# write.csv2( stat_ct , file=file_stat2_txt, na="", row.names = FALSE)
						write.table( stat_ct , file=file_stat2_txt, na="", row.names = FALSE, sep=";", dec=Sys.localeconv()[1] )

if (k_verbose) print_my("  Saving Statistics  for invidial station: ", relative_filepath(file_stat2_txt) )	
											} else {
									
						file_stat2_dbf_stat=gsub(paste(".",plotkind, sep=""),"_stat.dbf", filename_with_Temp( file_pdf_original , k_save_Auxl_into_Temp, ss_add_path="/stats_dbf" ) , ignore.case = TRUE)
									
						  my__write_dbf( stat_ct , file_stat2_dbf_stat ,  n_dec=3, print_output=FALSE ) #, mfd=data_out_ct_sel$deleted_

if (k_verbose) print_my("  Saving Statistics  for invidial station: ", relative_filepath(file_stat2_dbf_stat) )	
													}									
																							 
																			}
																			
			
						#		}	# if (k_save_individual)		
								
															} # if (k_save_only_final_results==FALSE)
						# ssssssssssfffffffffffffffffffrrrrrrrrrrrrrrrrrrrrrsssssssssssss

if (k_supress_output_all_possible==FALSE) print("")					
if (k_supress_output_all_possible==FALSE) print("")					

#######
					
					
									} # for (ii_cand in (unique(ngb_info_DT$id_ord)) )
				# nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn

if (k_supress_output_all_possible==FALSE)
print(" ... going through stations finished")	
				
########################################  
########################################  
########################################  
  

				   		
		
		# remove variables		
								# if (exists("rr")) rm("rr")
							ss_pom=c("data","data_DT","data_DT_1col","dt_pom","l")	
									# "data_puv","data_DT_puv",
								#lapply( ss_pom ,  exists )
							ss_pom= ss_pom[as.logical( lapply( ss_pom ,  exists ) )] 
							lapply( ss_pom , function(x) { if (k_supress_output_all_possible==FALSE) print(paste("  removing ",x)); rm(list=x,pos=1)} )  #ve funkci - musi to smazat v prostredi vyse pos=1

							
		
				                 				   

									# kkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkk				
				if (any(ls()=="data_out_ct_sel_all")) {
									
									
						# ssssssssssfffffffffffffffffffrrrrrrrrrrrrrrrrrrrrrsssssssssssss
					 # if (k_save_only_final_results==FALSE) {
									
						if (k_save_data_into_files_rda==TRUE) {
							# rda_rda_rda_rda_rda_rda_rda_rda_rda_rda_rda_	
						# data_out_ct_sel_all contains only list of saved rda files (file_stat_rda)
						data_out_ct_sel_all__rda=data_out_ct_sel_all
						#<<<<<<<<<<<<<<<<<<<<<<
						if (any(ls()=="data_out_ct_sel"))  rm(data_out_ct_sel)
						if (file.exists(data_out_ct_sel_all__rda[1])) load(data_out_ct_sel_all__rda[1]) #data_out_ct_sel
						#<<<<<<<<<<<<<<<<<<<<<<
						data_out_ct_sel_all=data_out_ct_sel[] ; rm(data_out_ct_sel)
						
						if (length(data_out_ct_sel_all__rda)>1) for (ii_pom in data_out_ct_sel_all__rda[-1]) {
								#<<<<<<<<<<<<<<<<<<<<<<
								if (any(ls()=="data_out_ct_sel"))  rm(data_out_ct_sel)
								if (file.exists(ii_pom)) load(ii_pom) #data_out_ct_sel
								#<<<<<<<<<<<<<<<<<<<<<<
								l = list(data_out_ct_sel_all, as.data.table(data_out_ct_sel) )
								data_out_ct_sel_all=rbindlist(l, fill=TRUE)
									if (exists("l")) rm(l)
									rm(data_out_ct_sel)
																												} #for (ii_pom
							# rda_rda_rda_rda_rda_rda_rda_rda_rda_rda_rda_	
															  }	# if (k_save_data_into_files_rda==TRUE)	

						#									} # if (k_save_only_final_results==FALSE)
						# ssssssssssfffffffffffffffffffrrrrrrrrrrrrrrrrrrrrrsssssssssssss
							
							
							
							
							
if (k_verbose) print("  Changing column order")					
				# order, sort: it is also needed earlier ... for individual stations
if (k_verbose) print("  Changing column order, in the final file (for a group)")					
					data_out_ct_sel_all=Change_Column_order( data_out_ct_sel_all, "QC_res_per" ,  which( "Remark"==names(data_out_ct_sel_all) ) )
					data_out_ct_sel_all=Change_Column_order( data_out_ct_sel_all, col_names_ngbs ,  which(col_names_ngbs[1]==names(data_out_ct_sel_all) ) )
					data_out_ct_sel_all=Change_Column_order( data_out_ct_sel_all, col_names_diffs ,  which(col_names_diffs[1]==names(data_out_ct_sel_all) ) )
					data_out_ct_sel_all=Change_Column_order( data_out_ct_sel_all, col_names_diffs_stnd ,  which(col_names_diffs_stnd[1]==names(data_out_ct_sel_all) ) )
					data_out_ct_sel_all=Change_Column_order( data_out_ct_sel_all, col_names_ngbs_alt ,  which(col_names_ngbs_alt[1]==names(data_out_ct_sel_all) ) )

					
		  					  
							  
######							  
							  
		  		  
						# gggggggggggssssssssssssssssssssssssss
if ( (any(ls()=="data_out_ct_sel_all")) & ( (all(!is.na(idcol_group))) | (k_columns_regions) ) ) {


if (k_supress_output_all_possible==FALSE) {
	print("")
	print_my("Saving outputs for an individual group: ", grp)
		  # source("rprog/my__write_dbf.r", local=F, encoding = "UTF-8")		  		 
		  
	  
	print(file_stat)
											}
	
	
	
				# only for Windows, takes care about special characters
				if (.Platform$OS.type=="windows") data_out_ct_sel_all[ , ID:=iconv(ID,  to="1250", from="UTF-8" ) ]
					# enc2native(x)  gsub  a UTF-8,  toto je reseni
				
								
				# eeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeee
	if (k_ECAD_mode==FALSE)				
	if (k_save_only_final_results==FALSE)				
	if (!(n_pd_function=="3/16/0"))	{
				
	  
		  #saves only error values
				file_stat_deleted=gsub( "[.]dbf" ,"_errors.dbf", file_stat , ignore.case = TRUE)				  			
				
					if (all( c("Same_base","Same_ngbs") %in% names(data_out_ct_sel_all)) ) {
					dt_pom=data_out_ct_sel_all[ (!(deleted_))&(Same_ngbs<=0)&(Same_base<=0) , ]
																						} else {
					dt_pom=data_out_ct_sel_all[ (!(deleted_)) , ]
																								}
					
				# if (sum(dt_pom)==0) {	
				if (nrow(dt_pom)==0) {	
if (k_supress_output_all_possible==FALSE)
print_my("  ... No Error found, file NOT saved: ",basename(file_stat_deleted))
									} else {

				if (k_CSV==TRUE) {
				file_stat_deleted_csv=gsub(paste("[.]","dbf", sep=""),".csv", file_stat_deleted, ignore.case = TRUE)
				# print(file_stat_deleted_csv)	
				# write.csv2( dt_pom , file=file_stat_deleted_csv, na="", row.names = FALSE)
				write.table( dt_pom , file=file_stat_deleted_csv, na="", row.names = FALSE, sep=";", dec=Sys.localeconv()[1] )
									}
						
						# source("rprog/my__write_dbf.r", local=F)		  		 
		  my__write_dbf( dt_pom , file_stat_deleted ,  n_dec=3, print_output=FALSE , mfd=( (dt_pom$YEAR<=0) | (is.na(dt_pom$YEAR)) ) ) #, mfd=data_out_ct_sel$deleted_
if (k_supress_output_all_possible==FALSE)	{
print("")				
print_my("List of errors save into: ",file_stat_deleted, k_add_print_=TRUE)
											}
											}		
							
				
				
				
#######				
# saves the whole calculation:
		#		file_stat_csv=gsub(paste(".","dbf", sep=""),".csv", file_stat, ignore.case = TRUE)
# print(file_stat_csv)	
		#		write.csv2( data_out_ct_sel_all , file=file_stat_csv, na="")
				
		#		file_stat_zip=gsub(paste(".","dbf", sep=""),".zip", file_stat, ignore.case = TRUE)
					# zip csv
		#		zip(file_stat_zip,file_stat_csv)
		

		
						# ssssssssssfffffffffffffffffffrrrrrrrrrrrrrrrrrrrrrsssssssssssss
					 if (k_save_auxiliary_files==TRUE)
					 if (k_save_only_final_results==FALSE) {
				# file_stat_zip=gsub(paste(".","dbf", sep=""),".csv.gz", file_stat, ignore.case = TRUE)
				file_stat_zip=gsub(paste("[.]","dbf", sep=""),".csv.gz", file_stat, ignore.case = TRUE)
if (k_supress_output_all_possible==FALSE)
print_my("Saving the whole calculation: ",file_stat_zip, k_add_print_=TRUE)	

		# write.csv2( data_out_ct_sel_all , file=gzfile(file_stat_zip, compression = 9) , na="", row.names = FALSE)
		write.table( data_out_ct_sel_all , file=gzfile(file_stat_zip, compression = 9) , na="", row.names = FALSE, sep=";", dec=Sys.localeconv()[1] )
		
															} # if (k_save_only_final_results==FALSE)
						# ssssssssssfffffffffffffffffffrrrrrrrrrrrrrrrrrrrrrsssssssssssss
		
		
									}  # if (!(n_pd_function=="3/16/0"))
				# eeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeee
		
		
		
		
						# ssssssssssfffffffffffffffffffrrrrrrrrrrrrrrrrrrrrrsssssssssssss
					 if (k_save_only_final_results==FALSE) {

															
				# bbbbbbbbbbbbbbbbbbbbbbbbbbbbb						
								# data_out_ct_sel_all		  						
								
			ii_size=(as.numeric( object.size( get("data_out_ct_sel_all") )))
		  if ( ii_size > 1100100100 ) {
print_my(" the output is very big, saving only part of it ... size=", prettyNum(ii_size,  big.mark = " ") , k_warning=FALSE)

					
					
					
						# st_1	st_2	st_3	st_4	st_5
					ii_d_sel=match( col_names_ngbs , names(data_out_ct_sel_all))
					ii_d_sel=1:(max(ii_d_sel, na.rm=TRUE)) 
					ii_pom=match( c("QC_res_per","QC_flag","Check_flag","deleted_","n_problems","n_periods","id_ord") , names(data_out_ct_sel_all))
						#group gives as the first					
						ii_pom2=match( c("group") , names(data_out_ct_sel_all))
						
					ii_d_sel=c(ii_pom2,ii_d_sel,ii_pom)
					ii_d_sel=ii_d_sel[!is.na(ii_d_sel)]
						ii_d_sel=unique(ii_d_sel) #at se to neopakuje
					
				dt_pom=data_out_ct_sel_all[ , ii_d_sel , with=FALSE]
					ii_size=(as.numeric( object.size( get("dt_pom") )))
if (k_supress_output_all_possible==FALSE)					
print_my(" new size: ", prettyNum(ii_size,  big.mark = " ")  )  # prettyNum(r, big.mark = ","), format(r, big.mark = ",")
				
											} else { # if ( (as.numeric( object.siz ...
				dt_pom=data_out_ct_sel_all							
													}
															
			#is it still big?					
			ii_size=(as.numeric( object.size( get("dt_pom") )))
		  if ( ii_size > 1900100100 ) {
						# col_names_diffs,col_names_diffs_stnd
					ii_d_sel=match( col_names_diffs_stnd , names(dt_pom))	
					ii_d_sel=setdiff((1:ncol(dt_pom)),ii_d_sel)
				dt_pom=dt_pom[ , ii_d_sel , with=FALSE]
										}
			ii_size=(as.numeric( object.size( get("dt_pom") )))
		  if ( ii_size > 1900100100 ) {
					ii_d_sel=match( col_names_ngbs_alt , names(dt_pom))	
					ii_d_sel=setdiff((1:ncol(dt_pom)),ii_d_sel)
				dt_pom=dt_pom[ , ii_d_sel , with=FALSE]
										}
				# bbbbbbbbbbbbbbbbbbbbbbbbbbbbb						
							
			ii_size=(as.numeric( object.size( get("dt_pom") )))
			if ( ii_size < 2100100100 ) {
		  my__write_dbf( dt_pom , file_stat ,  n_dec=3, print_output=FALSE , mfd=dt_pom$deleted_ )
										} else {
print_my(" Data into the file ",file_stat," could not be saved, the data size is still too big for .dbf: ", prettyNum(ii_size,  big.mark = " ")  , k_warning=TRUE )  # prettyNum(r, big.mark = ","), format(r, big.mark = ",")
												}
	
 
													} # if (k_save_only_final_results==FALSE)
						# ssssssssssfffffffffffffffffffrrrrrrrrrrrrrrrrrrrrrsssssssssssss
						
 
									} # if ( (any(ls()=="data_out_ct_sel_all")) & (all(!is.na(idcol_group))) ) {	
						# gggggggggggssssssssssssssssssssssssss
									
#######	
				if (k_save_data_into_files_rda==TRUE) {
				data_out=data_out_ct_sel_all__rda  # kvuli  group  ulozeni
				if (any(ls()=="data_out_ct_sel_all")) rm(data_out_ct_sel_all)
														} # if (k_save_data_into_files_rda==TRUE)


			
							
													  }  #else { data_out_ct_sel_all=NA  }  , 
									# kkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkk				
							
							
#######							
							
		if (exists("DT_Same_ngbs_all")) {
											# _same_ngb
				file_stat_log=gsub( "[.]dbf" ,"_duplicated.dbf", file_stat , ignore.case = TRUE)				  			
				
				if (k_CSV==TRUE) {
				file_stat_log_csv=gsub(paste("[.]","dbf", sep=""),".csv", file_stat_log, ignore.case = TRUE)
				# print(file_stat_log_csv)	
				# write.csv2( DT_Same_ngbs_all , file=file_stat_log_csv, na="", row.names = FALSE)
				write.table( DT_Same_ngbs_all , file=file_stat_log_csv, na="", row.names = FALSE, sep=";", dec=Sys.localeconv()[1] )
									}
if (k_supress_output_all_possible==FALSE) {
print("")				
print_my("List of stations with the same neighbour values saved into: ",file_stat_log, k_add_print_=TRUE)
										  }
		  my__write_dbf( DT_Same_ngbs_all , file_stat_log ,  n_dec=3, print_output=FALSE  ) #, mfd=data_out_ct_sel$deleted_			

				if (any(ls()=="DT_Same_ngbs_all"))  rm(DT_Same_ngbs_all)
								
										} # if (exists("DT_Same_ngbs_all"))
										
#######
							
		if (exists("DT_Same_base_all"))  {
											  # _repeated
				file_stat_log2=gsub( "[.]dbf" ,"_repeated.dbf", file_stat , ignore.case = TRUE)	

				if (k_CSV==TRUE) {
				file_stat_log2_csv=gsub(paste("[.]","dbf", sep=""),".csv", file_stat_log2, ignore.case = TRUE)
				# print(file_stat_log2_csv)	
				# write.csv2( DT_Same_base_all , file=file_stat_log2_csv, na="", row.names = FALSE)
				write.table( DT_Same_base_all , file=file_stat_log2_csv, na="", row.names = FALSE, sep=";", dec=Sys.localeconv()[1] )
									}
if (k_supress_output_all_possible==FALSE) {
print("")				
print_my("List of stations with repeating values saved into: ",file_stat_log2, k_add_print_=TRUE)
											}
		  my__write_dbf( DT_Same_base_all , file_stat_log2 ,  n_dec=3, print_output=FALSE  ) #, mfd=data_out_ct_sel$deleted_				

				if (any(ls()=="DT_Same_base_all"))  rm(DT_Same_base_all)
		  
										} # if (exists("DT_Same_base_all"))
	
	
	
	
#######
#######
	




									# kkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkk2
				if (any(ls()=="stat_ct_all")) {
				
					 if (k_save_data_into_files_rda==TRUE) {
							# rda_rda_rda_rda_rda_rda_rda_rda_rda_rda_rda_	
						# stat_ct_all contains only list of saved rda files (file_stat2_rda)
						stat_ct_all__rda=stat_ct_all
						#<<<<<<<<<<<<<<<<<<<<<<
						if (any(ls()=="stat_ct"))  rm(stat_ct)
						if (file.exists(stat_ct_all__rda[1])) load(stat_ct_all__rda[1]) #stat_ct
						#<<<<<<<<<<<<<<<<<<<<<<
						stat_ct_all=stat_ct[] ; rm(stat_ct)
						
						if (length(stat_ct_all__rda)>1) for (ii_pom in stat_ct_all__rda[-1]) {
								#<<<<<<<<<<<<<<<<<<<<<<
								if (any(ls()=="stat_ct"))  rm(stat_ct)
								if (file.exists(ii_pom)) load(ii_pom) #stat_ct
								#<<<<<<<<<<<<<<<<<<<<<<
								l = list(stat_ct_all, as.data.table(stat_ct) )
								stat_ct_all=rbindlist(l, fill=TRUE)
									if (exists("l")) rm(l)
									rm(stat_ct)
																												} #for (ii_pom
							# rda_rda_rda_rda_rda_rda_rda_rda_rda_rda_rda_	
													} # if (k_save_data_into_files_rda==TRUE)
															
		  
						# ssssssssssfffffffffffffffffffrrrrrrrrrrrrrrrrrrrrrsssssssssssss
					 if (k_save_only_final_results==FALSE) {
		

						# gggggggggggssssssssssssssssssssssssss2
if ( ((any(ls()=="stat_ct_all"))&(nchar(file_stat2)>0)) & ( (all(!is.na(idcol_group))) | (k_columns_regions) ) ) {  # | (n_pd_function=="4/1/0") | (n_pd_function=="3/11/0")
print(file_stat2)
print_my("Saving statistics (of groups): ",file_stat2, k_add_print_=TRUE)	
		  
  
		  
		  
				if (.Platform$OS.type=="windows") stat_ct_all[ , ID_1:=iconv(ID_1,  to="1250", from="UTF-8" ) ]
				if (.Platform$OS.type=="windows") stat_ct_all[ , ID_2:=iconv(ID_2,  to="1250", from="UTF-8" ) ]
								
					# marks deleted -later
					dele__stat_ct=is.na(stat_ct_all[["ID"]])
					dele__stat_ct[ grepl("CNT",stat_ct_all$stat, fixed=TRUE) ]=TRUE
					
					dele__stat_ct[ grepl("_d_t$",stat_ct_all$stat) ]=TRUE
					dele__stat_ct[ grepl("_t$",stat_ct_all$stat) ]=TRUE
					dele__stat_ct[ grepl("_d_stnd$",stat_ct_all$stat) ]=TRUE
					dele__stat_ct[ grepl("_r_stnd$",stat_ct_all$stat) ]=TRUE
					dele__stat_ct[ grepl("_t_stnd$",stat_ct_all$stat) ]=TRUE
					
					
		  my__write_dbf( stat_ct_all , file_stat2 ,  n_dec=3, print_output=FALSE ,  mfd=dele__stat_ct  )
				#my_file=file_stat ;  n_dec=3 ; print_output=FALSE

		  
		  #write.table(data_out, file=file_out, sep = "\t", quote=FALSE, row.names=FALSE)


		  
							} #if ( ((any(ls()=="stat_ct_all"))&(nchar(file_stat2)>0)) & (all(!is.na(idcol_group))) )	
						# gggggggggggssssssssssssssssssssssssss2

		# if (k_save_data_into_files_rda==TRUE) {
		if (k_save_only_final_results==FALSE) {
			data_out_ct=stat_ct_all__rda   # 
												} # if (k_save_data_into_files_rda==TRUE)

												
															} # if (k_save_only_final_results==FALSE)
						# ssssssssssfffffffffffffffffffrrrrrrrrrrrrrrrrrrrrrsssssssssssss
												
					   
												} # if (any(ls()=="stat_ct_all"))
									# kkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkk2
											   
											   
											   
											   
											   
								 }  # if ( (n_pd_function=="7/4/0")|(n_pd_function=="3/16/0") )
		#nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnngggggggggggggggggggggggggggbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb
		#nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnngggggggggggggggggggggggggggbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb
		#nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnngggggggggggggggggggggggggggbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb




    
	
	
  
  
  
  
  	
					
					if (k_period!=0)	{
								if (any(ls()=="data_out")) {
									if (any(ls()=="data_out_per")) {
						l = list(data_out_per, data_out[, `:=`(begin=year_begin,end=year_end,length=(year_end-year_begin)+1) ] )
						data_out_per=rbindlist(l, fill=TRUE )
							if (exists("l")) rm(l)
																  } else {
			data_out_per=data_out[, `:=`(begin=year_begin,end=year_end,length=(year_end-year_begin)+1)]
																		 }
															}
															
								if (any(ls()=="data_out_ct")) {
									if (any(ls()=="data_out_ct_per")) {
						l = list(data_out_ct_per, data_out_ct[, `:=`(begin=year_begin,end=year_end,length=(year_end-year_begin)+1) ] )
						data_out_ct_per=rbindlist(l, fill=TRUE)
							if (exists("l")) rm(l)
																	  } else {
					data_out_ct_per=data_out_ct[, `:=`(begin=year_begin,end=year_end,length=(year_end-year_begin)+1) ]	
																			 }
															  }
										} #(k_period!=0)
	
	
								   } #  #for (period_ii in ss_periods_all)
				##############################################################PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP
				#periods
	

	
#####################
	
# stop("stop here before end of group")	
 
	
									# sGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGG
					if ( ( (all(!is.na(idcol_group))) | (k_columns_regions) )
						 & (!(n_pd_function=="1/1/0"))	
												 )	{ #			# for (grp in groups_) { # ggggggggggggggggggggggggggggggggggggggggggggggggggggggggggg
					
						
							
							if (any(ls()=="data_out_per")) data_out=data_out_per	
							
							if (any(ls()=="data_out_ct_per")) data_out_ct=data_out_ct_per		


							
							
						if ( (n_pd_function=="7/1/0")|(n_pd_function=="7/2/0")|(n_pd_function=="3/15/0") ) {
						
								if (any(ls()=="data_out_ct")) {
									if (any(ls()=="data_out_ct_group")) {
						l = list(data_out_ct_group, data_out_ct[, `:=`(group=grp) ] )
						data_out_ct_group=rbindlist(l, fill=TRUE)
							if (exists("l")) rm(l)
						
																	  } else {
						data_out_ct_group=data_out_ct[, `:=`(group=grp) ]	

																			 }
															  }
												
																										} # if 

							
							
						#7/4	/0
						if ( (n_pd_function=="7/4/0")|(n_pd_function=="3/16/0") ) {  # |(n_pd_function=="1/1/0") 
							# data_out_ct_sel_all  - data_out
							# stat_ct_all  - data_out_ct
								# DT_Same_ngbs_all
								# DT_Same_base_all

					
							if (any(ls()=="data_out")) {
											if (any(ls()=="data_out_group")) {
									
									data_out_group=c(data_out_group,data_out)
										group_rda=c(group_rda, rep(grp,length(data_out)) )
									
																			  } else {
									
									data_out_group=data_out
										group_rda = rep(grp,length(data_out))
									
																					 }
														}
				
											if (any(ls()=="data_out_ct")) {
												if (any(ls()=="data_out_ct_group")) {
									
									data_out_ct_group=c(data_out_ct_group,data_out_ct)
										group_ct_rda = c(group_ct_rda, rep(grp,length(data_out_ct)) )
									
																				  } else {
									
									data_out_ct_group=data_out_ct
										group_ct_rda = rep(grp,length(data_out_ct))
																						 }
																		  }
												

																				} # if 


												
													} # if ( ( (all(!is.na(idcol_group))) | (k_columns_regions) )
									# sGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGG

									

						   	if ((n_pd_function=="1/1/0"))	{											 
								if (length(groups_)>1)	{
								# if (!all(unique(data_info_DT$REGION)==grp)) 
																	
									# data_out[ , REGION:=grp ]			 
									
									# this is being saved earlier as individual data files, by means of: 
									# data_out_ct2
									
									
				# data_out ne, sem se uz kumuluje data_DT,  musi zde byt samotn data_DT					
									
									if (any(ls()=="data_out_group")) {
									
									 # l = list(data_out_group, data_out[, `:=`(REGION=grp) ] )
									 l = list(data_out_group, data_DT[, `:=`(REGION=grp) ] )
									 data_out_group=rbindlist(l, fill=TRUE )
									
																			  } else {
									# data_out_group=data_out[, `:=`(REGION=grp) ]										
									data_out_group=data_DT[, `:=`(REGION=grp) ]										
																					 }
																							
									
									
														 }			 
															} # ((n_pd_function=="1/1/0"))
												 							
									
							
# if (which(grp==groups_)==2) stop("stop here after second loop ...")											    

	
									
						     } #for (grp in groups_) 
			# ggggggggggggggggggggggggggggggggggggggggggggggggggggggggggg
									
									
			#ggggggg groups sGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGG
									

  
  
  
  
  
  
  
  
  
#####################################  
#####################################  
#####################################  
  
  
  
  
  
  
  
  
			#ssssssss periods sSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
  	
					if (k_period!=0) {
					
								if (any(ls()=="data_out_per")) data_out=data_out_per	
								if (any(ls()=="data_out_ct_per")) data_out_ct=data_out_ct_per									
							# timto to prebyje ... pokud je group
							if (any(ls()=="data_out_group")) data_out=data_out_group	
							if (any(ls()=="data_out_ct_group")) data_out_ct=data_out_ct_group		

							
							
													
							if (any(ls()=="data_out_ct")) {

						
							#osetri BEGIN a begin
							if (("BEGIN" %in% names(data_out_ct))&("begin" %in% names(data_out_ct))) {
								setnames(data_out_ct, c("begin") , c("BEGIN_") )
																									  }
							if (("END" %in% names(data_out_ct))&("end" %in% names(data_out_ct))) {
								setnames(data_out_ct, c("end") , c("END_") )
																									  }
							if (("LENGTH" %in% names(data_out_ct))&("length" %in% names(data_out_ct))) {
								setnames(data_out_ct, c("length") , c("LENGTH_") )
																									  }
						
																} # if (any(ls()=="data_out_ct"))
									
						if (any(ls()=="data_out_group")) rm(data_out_group) # result is in data_out
						if (any(ls()=="data_out_ct_group")) rm(data_out_ct_group) # result is in data_out_ct
									
									
							
									 } else {
						# (n_pd_function=="7/4/0")
							if (any(ls()=="data_out_group")) data_out=data_out_group	
							if (any(ls()=="data_out_ct_group")) data_out_ct=data_out_ct_group		
											} #if (k_period!=0) 
	

			#ssssssss periods sSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
  
  

  
  
  
  
  
									# sGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGG
#   					if (all(!is.na(idcol_group))) { #			# for (grp in groups_) { # ggggggggggggggggggggggggggggggggggggggggggggggggggggggggggg

							
							
							
							
							
if (k_supress_output_all_possible==FALSE) 
if (length(groups_)>0) print_my(">>> Groups finished <<<", k_add_print_=TRUE)							
							
# stop("stop here after groups finished")							
							
							
########################################################################################							
########################################################################################							
########################################################################################							
							
							
							
							
							
							
							
							
							
							
		
							
							
# stop("stop here before saving overall results ... ")							
							
			if ( (n_pd_function=="7/1/0") | (n_pd_function=="7/2/0") | (n_pd_function=="3/15/0") ) {
			
						# ssssssssssfffffffffffffffffffrrrrrrrrrrrrrrrrrrrrrsssssssssssss
					 # if (k_save_only_final_results==TRUE) {
					 if (length(groups_)>1) {
			
			
			
if (k_supress_output_all_possible==FALSE) 
print("")
			
				if (any(ls()=="data_out_ct")) { 
print("Saving overall Periods results:")
print(file_stat2_orig)

						data_info_DT_1_all=data_out_ct
												
						if (k_CSV==TRUE) {			
						file_stat_orig_csv=gsub(paste("[.]","dbf", sep=""),".csv", file_stat2_orig, ignore.case = TRUE)
						# write.csv2( data_info_DT_1_all[ mfd_==FALSE ,] , file=file_stat_orig_csv, na="", row.names = FALSE )
						write.table( data_info_DT_1_all[ mfd_==FALSE ,] , file=file_stat_orig_csv, na="", row.names = FALSE, sep=";", dec=Sys.localeconv()[1] )
											} 

						my__write_dbf(  data_info_DT_1_all[ mfd_==FALSE ,] , file_stat2_orig ,n_dec=3, print_output=FALSE , mfd = ( data_info_DT_1_all[ mfd_==FALSE , del_ ]==TRUE ) ) #,  n_dec=3, print_output=FALSE
								
						if (any(ls()=="data_info_DT_1_all")) rm(data_info_DT_1_all)		
						if (any(ls()=="data_out_ct")) rm(data_out_ct)
												} else {
print_my("Saving overall Period results:  NO RESULTS TO SAVE", k_warning=TRUE)
														}
			
															} # if (k_save_only_final_results==FALSE)
						# ssssssssssfffffffffffffffffffrrrrrrrrrrrrrrrrrrrrrsssssssssssss
			
			
										} # if (n_pd_function=="7/2/0")
							
							
#######
							

					# if (k_save_data_into_files_rda==TRUE) {
					# if (k_save_only_final_results==TRUE) {		
					if (any(ls()=="data_out")) {		
							# rda_rda_rda_rda_rda_rda_rda_rda_rda_rda_rda_	
						# data_out contains only list of saved rda files (file_stat_rda)
						
if (k_supress_output_all_possible==FALSE)						
print_my("Taking list of RDA files and making final variable from it to save ... " , k_add_print_=TRUE)	
			
							
							# earlier: haveing groups ... data_out=data_out_ct_sel_all__rda
					if (!(any( c("data.table","data.frame") %in% class(data_out) ))) {
					
						data_out__rda=data_out
						#<<<<<<<<<<<<<<<<<<<<<<
						if (any(ls()=="data_out_ct_sel"))  rm(data_out_ct_sel)
						if (file.exists(data_out__rda[1])) load(data_out__rda[1]) #data_out_ct_sel
						#<<<<<<<<<<<<<<<<<<<<<<
							if (any(ls()=="group_rda")) data_out_ct_sel[, `:=`( group=group_rda[1] ) ]
						data_out=data_out_ct_sel[] ; rm(data_out_ct_sel)
						
						if (length(data_out__rda)>1) for (ii_pom in data_out__rda[-1]) {
								#<<<<<<<<<<<<<<<<<<<<<<
								if (any(ls()=="data_out_ct_sel"))  rm(data_out_ct_sel)
								if (file.exists(ii_pom)) load(ii_pom) #data_out_ct_sel
								#<<<<<<<<<<<<<<<<<<<<<<
									if (any(ls()=="group_rda")) data_out_ct_sel[, `:=`( group=group_rda[which(ii_pom==data_out__rda)] ) ]
									
								l = list(data_out, as.data.table(data_out_ct_sel) )
								data_out=rbindlist(l, fill=TRUE)
									if (exists("l")) rm(l)
									rm(data_out_ct_sel)
																												} #for (ii_pom
							# rda_rda_rda_rda_rda_rda_rda_rda_rda_rda_rda_	
															} else {  # if (k_save_data_into_files_rda==TRUE)
								if (any(ls()=="data_out_ct_sel")) {
									data_out=data_out_ct_sel							
																 }
																 
																					} # if (!(any( c("data.table","data.frame") %in% class(data_out) )))
																					
																	} # if (k_save_data_into_files_rda==TRUE)
							

							
							if (!any(ls()=="data_out")) if (any(ls()=="data_out_ct_sel")) {
print_my("data_out  variable does not exist,  but  data_out_ct_sel does" , k_warning=TRUE)	
stop("stop here: data_out variable does not exist ...")
									data_out=data_out_ct_sel
																						  }
																						  
							if (!any(ls()=="data_out")) if (n_pd_function=="7/4/0") {
if (k_ECAD_mode==TRUE) {
	# warning(paste("Warning:  no data for 7/4 ... ", file_info, data_file))
	print_my("Warning:  no data for 7/4 ... :", file_info, ", data file: ",data_file, k_warning=TRUE)
	# sink()
	# return()
	rm(data_out)
	n_pd_function=""
					   } else {
stop("stop: no data for 7/4 ...")
							   }
																					}
							
							
#########################################							
							
						

# stop("stop here before saving ...")


						
# saves the data ...
			#ssssssssssssssssssssssssssssssssssssss11111111111111111111111111# saves the data ...
		if (any(ls()=="data_out"))	{
		
		
		
if (k_supress_output_all_possible==FALSE)
print_my("after Groups and Periods are finished, saving the overall results:", k_add_print_=TRUE)
										
						
						
			
					# moves Group column to the first position
					if ("group" %in% names(data_out)) {
						ii_d_sel=1:(length(names(data_out)))
						#group gives as the first					
						ii_pom2=match( c("group") , names(data_out))
						ii_d_sel=unique(c(ii_pom2,ii_d_sel))
						ii_d_sel=ii_d_sel[!is.na(ii_d_sel)]					
						data_out=data_out[ , ii_d_sel , with=FALSE]					
														}
								
								
								
								
				if (n_pd_function=="1/1/0") {
							# if ("x_Suffix" %in% idcol) {
						if ("x_Suffix" %in% names(data_out)) {
							# take care about NA
							if (all(is.na(data_out$x_Suffix))) ii_pom=0 else ii_pom=data_out[ , sum(nchar(x_Suffix)!=0) ]
							if (ii_pom==0) {
print("")
print("x_Suffix column in data_file: it was whole empty, so it was removed")							
							data_out[ , x_Suffix:=NULL ]	
							
								# check also data_info
								if ("x_Suffix" %in% names(data_out_ct)) {
											ii_pom=data_out_ct[ , sum(nchar(x_Suffix)!=0) ]
										if (ii_pom==0) {
print("x_Suffix column in info_file: removed as well for being empty")							
							data_out_ct[ , x_Suffix:=NULL ]	
													  } #if (ii_pom==0) 
																		} # if ("x_Suffix" %in% names(data_out_ct))	
print("")									
							
											} #if (ii_pom==0) 
															 } # if ("x_Suffix" %in% names(data_out))
											} # if (n_pd_function=="1/1/0")
									
			

						# ssssssssssfffffffffffffffffffrrrrrrrrrrrrrrrrrrrrrsssssssssssss
					 if (k_save_auxiliary_files==TRUE) {
			#		 if (k_save_only_final_results==TRUE) {

#				if (k_CSV==TRUE) {
			
				file_stat_orig_csv=gsub(paste("[.]","dbf", sep=""),".csv", file_stat_orig, ignore.case = TRUE)
				
print_my("Saving the whole calculation: ",file_stat_orig_csv, k_add_print_=TRUE)	
				# write.csv2( data_out , file=file_stat_orig_csv, na="", row.names = FALSE)
				write.table( data_out , file=file_stat_orig_csv, na="", row.names = FALSE, sep=";", dec=Sys.localeconv()[1] )
				
	
															} # if (k_save_only_final_results==FALSE)
						# ssssssssssfffffffffffffffffffrrrrrrrrrrrrrrrrrrrrrsssssssssssss


						
			 if (k_ECAD_mode==FALSE)
			 if (n_pd_function=="7/4/0") {
		  #saves only problematic values
				file_stat_deleted=gsub( "[.]dbf" ,"__errors.dbf", file_stat_orig , ignore.case = TRUE)				  			
				
					if (all( c("Same_base","Same_ngbs") %in% names(data_out)) ) {
				dt_pom=data_out[ (!(deleted_))&(Same_ngbs<=0)&(Same_base<=0) , ]
																						} else {
				dt_pom=data_out[ (!(deleted_)) , ]
																								}
				
						if (k_CSV==TRUE) {
						file_stat_deleted_csv=gsub(paste("[.]","dbf", sep=""),".csv", file_stat_deleted, ignore.case = TRUE)
						# write.csv2( dt_pom , file=file_stat_deleted_csv, na="", row.names = FALSE)
						write.table( dt_pom , file=file_stat_deleted_csv, na="", row.names = FALSE, sep=";", dec=Sys.localeconv()[1] )
											}													
				
				if (nrow(dt_pom)==0) {	
if (k_supress_output_all_possible==FALSE)
print_my("  ... No Error found, file NOT saved: ",basename(file_stat_deleted), k_add_print_=TRUE)
									} else {
						
						# source("rprog/my__write_dbf.r", local=F)		  		 
		  my__write_dbf( dt_pom , file_stat_deleted ,  n_dec=3, print_output=FALSE , mfd=( (dt_pom$YEAR<=0) | (is.na(dt_pom$YEAR)) ) ) #, mfd=data_out_ct_sel$deleted_
if (k_supress_output_all_possible==FALSE)
print_my("List of errors save into: ",file_stat_deleted, k_add_print_=TRUE)
											}
										 } # if (n_pd_function=="7/4/0")

										 
#######				

			 # if (k_save_auxiliary_files==TRUE)
			 if (k_ECAD_mode==FALSE)
			 if (n_pd_function=="7/4/0") {
		  #saves only problematic values
															
				file_stat_deleted=gsub( "[.]dbf" ,"__errors2.dbf", file_stat_orig , ignore.case = TRUE)				  			
				

					if (all( c("Same_base","Same_ngbs") %in% names(data_out)) ) {
				# dt_pom=data_out[ (QC_flag<9)&(QC_flag>0)&(Same_ngbs<=0)&(Same_base<=0) , ]
				dt_pom=data_out[ (QC_flag!="9")&(QC_flag!="0")&(Same_ngbs<=0)&(Same_base<=0) , ]
																						} else {
				# dt_pom=data_out[ (QC_flag<9)&(QC_flag>0) , ]
				dt_pom=data_out[ (QC_flag!="9")&(QC_flag!="0") , ]
																								}
						
						if (k_CSV==TRUE) {
						file_stat_deleted_csv=gsub(paste("[.]","dbf", sep=""),".csv", file_stat_deleted, ignore.case = TRUE)
						# write.csv2( dt_pom , file=file_stat_deleted_csv, na="", row.names = FALSE)
						write.table( dt_pom , file=file_stat_deleted_csv, na="", row.names = FALSE, sep=";", dec=Sys.localeconv()[1] )
											}													
						
				if (nrow(dt_pom)==0) {	
if (k_supress_output_all_possible==FALSE)
print_my("  ... No Error found, file NOT saved: ",basename(file_stat_deleted), k_add_print_=TRUE)
									} else {
						
			ii_size=(as.numeric( object.size( get("dt_pom") )))
			if ( ii_size < 2100100100 ) {
						# source("rprog/my__write_dbf.r", local=F)		  		 
		  my__write_dbf( dt_pom , file_stat_deleted ,  n_dec=3, print_output=FALSE , mfd=( (dt_pom$YEAR<=0) | (is.na(dt_pom$YEAR)) ) ) #, mfd=data_out_ct_sel$deleted_
if (k_supress_output_all_possible==FALSE)
print_my("List of errors (and suspicious values) save into: ",file_stat_deleted, k_add_print_=TRUE)
										}
											}
										 } # if (n_pd_function=="7/4/0")


#######				
	
			 if (n_pd_function=="7/4/0") {
# saving in ecad format				
								
					ii_d_sel=match( c("group","ID","ELEMENT","REGION","YEAR","MONTH","DAY","TIME","st_base","Expect_val","diffs","QC_flag","QC_res_per") , names(data_out))
					ii_d_sel=ii_d_sel[!is.na(ii_d_sel)]
					
				dt_pom=data_out[ YEAR>0 , ii_d_sel , with=FALSE]
					# rename columns
					if ("group" %in% names(dt_pom)) setnames(dt_pom, "group", "Element" )	
					if ("st_base" %in% names(dt_pom)) setnames(dt_pom, "st_base", "Value" ) 
					if ("QC_res_per" %in% names(dt_pom)) setnames(dt_pom, "QC_res_per", "QC_prob" )

				file_stat_deleted=gsub( "[.]dbf" ,"__ecad.dbf", file_stat_orig , ignore.case = TRUE)				  			

				if (k_CSV==TRUE) {
				file_stat_deleted_csv=gsub(paste("[.]","dbf", sep=""),".csv", file_stat_deleted, ignore.case = TRUE)
				# print(file_stat_deleted_csv)	
				# write.csv2( dt_pom , file=file_stat_deleted_csv, na="", row.names = FALSE)
				write.table( dt_pom , file=file_stat_deleted_csv, na="", row.names = FALSE, sep=";", dec=Sys.localeconv()[1] )
if (k_supress_output_all_possible==FALSE)
print_my("List of errors (in ECAD format) save into: ",file_stat_deleted_csv, k_add_print_=TRUE)
									}
				
			ii_size=(as.numeric( object.size( get("dt_pom") )))
			if ( ii_size < 2100100100 ) {		  
						# source("rprog/my__write_dbf.r", local=F)		  		 
		  # my__write_dbf( dt_pom , file_stat_deleted ,  n_dec=3, print_output=FALSE , mfd=( (dt_pom$QC_flag<1) | (dt_pom$QC_flag>=9) ) ) #, mfd=data_out_ct_sel$deleted_
		  my__write_dbf( dt_pom , file_stat_deleted ,  n_dec=3, print_output=FALSE , mfd=( (dt_pom$QC_flag=="0") | (dt_pom$QC_flag=="9") ) ) #, mfd=data_out_ct_sel$deleted_
		  
		  
if (k_supress_output_all_possible==FALSE)
print_my("List of errors (in ECAD format) save into: ",file_stat_deleted, k_add_print_=TRUE)
										} 
										
										 } # if (n_pd_function=="7/4/0")

						

#######															
									
						# ssssssssssfffffffffffffffffffrrrrrrrrrrrrrrrrrrrrrsssssssssssss
				#	 if (k_save_only_final_results==TRUE) {
			 if (k_ECAD_mode==FALSE) {
									  

			 if ( (n_pd_function=="7/4/0")|(n_pd_function=="3/16/0") ) {
			 
			 
				# bbbbbbbbbbbbbbbbbbbbbbbbbbbbb						
print_my("Saving overall results (of the whole process): ",file_stat_orig, k_add_print_=TRUE)											

			ii_size=(as.numeric( object.size( get("data_out") )))
		  if ( ii_size > 1100100100 ) {
print_my(" the output is very big, saving only part of it ... size=", prettyNum(ii_size,  big.mark = " ") , k_warning=FALSE, k_add_print_=TRUE)
					
						# st_1	st_2	st_3	st_4	st_5
					ii_d_sel=match( col_names_ngbs , names(data_out))
					ii_d_sel=1:(max(ii_d_sel, na.rm=TRUE)) 
					ii_pom=match( c("QC_res_per","QC_flag","Check_flag","deleted_","n_problems","n_periods","id_ord") , names(data_out))
						#group gives as the first					
						ii_pom2=match( c("group") , names(data_out))

					ii_d_sel=c(ii_pom2,ii_d_sel,ii_pom)
					ii_d_sel=ii_d_sel[!is.na(ii_d_sel)]
						ii_d_sel=unique(ii_d_sel) #at se to neopakuje
					
				data_out=data_out[ , ii_d_sel , with=FALSE]
					ii_size=(as.numeric( object.size( get("data_out") )))
print_my(" new size: ", prettyNum(ii_size,  big.mark = " ")  )  # prettyNum(r, big.mark = ","), format(r, big.mark = ",")
				
										} # if ( (as.numeric( object.siz ...
										
										
													
			#is it still big?					
			ii_size=(as.numeric( object.size( get("data_out") )))
		  if ( ii_size > 1900100100 ) {
						# col_names_diffs,col_names_diffs_stnd
					ii_d_sel=match( col_names_diffs_stnd , names(data_out))	
					ii_d_sel=setdiff((1:ncol(data_out)),ii_d_sel)
				data_out=data_out[ , ii_d_sel , with=FALSE]
										}
			ii_size=(as.numeric( object.size( get("data_out") )))
		  if ( ii_size > 1900100100 ) {
					ii_d_sel=match( col_names_ngbs_alt , names(data_out))	
					ii_d_sel=setdiff((1:ncol(data_out)),ii_d_sel)
				data_out=data_out[ , ii_d_sel , with=FALSE]
										}
				# bbbbbbbbbbbbbbbbbbbbbbbbbbbbb						
										 } # if (n_pd_function=="7/4/0")									
														
														
														
			ii_size=(as.numeric( object.size( get("data_out") )))
			if ( ii_size < 2100100100 ) {
			
#				 if ((n_pd_function=="1/1/0")&(k_save_only_final_results==FALSE)) {
#						# k_ECAD_mode
#if (k_supress_output_all_possible==FALSE)
#print("Data files were saved separately ...")
#																				} else {
		  my__write_dbf( data_out , file_stat_orig ,  n_dec=3, print_output=FALSE , mfd=data_out$deleted_ ) 
#																						}
										} else {
print_my(" Data into the file ",file_stat_orig," could not be saved, the data size is still too big for .dbf: ", prettyNum(ii_size,  big.mark = " ")  , k_warning=TRUE )  # prettyNum(r, big.mark = ","), format(r, big.mark = ",")
												}
										
															} # if (k_ECAD_mode==FALSE)					
										
				 if ( (n_pd_function=="1/1/0")&(nchar(file_stat_orig)>0) ) { # &(k_save_only_final_results==FALSE)

# if (k_supress_output_all_possible==FALSE)
print_my(" Data file save to: ",file_stat_orig ) 
				if (k_CSV==TRUE) {
				file_stat_deleted_csv=gsub(paste("[.]","dbf", sep=""),".csv", file_stat_orig, ignore.case = TRUE)
				# print(file_stat_deleted_csv)	
				# write.csv2( data_out , file=file_stat_deleted_csv, na="", row.names = FALSE )
				write.table( data_out , file=file_stat_deleted_csv, na="", row.names = FALSE , sep=";", dec=Sys.localeconv()[1] )
									}
		  
		  
				my__write_dbf( data_out , file_stat_orig ,  n_dec=3, print_output=FALSE , mfd=data_out$deleted_ ) 
													} 

										
					#										} # if (k_save_only_final_results==FALSE)
						# ssssssssssfffffffffffffffffffrrrrrrrrrrrrrrrrrrrrrsssssssssssss
		  
		  
		  
									} else {
			# ( |(n_pd_function=="7/1/0") )			
		    if (!( n_pd_function %in% c("7/2/0") ))	{
print_my(" ... no (data file) results to save",file_stat_orig, k_add_print_=TRUE)									
													}
											}  # if (any(ls()=="data_out"))	 		
			#ssssssssssssssssssssssssssssssssssssss11111111111111111111111111
			# saves the data ...
		

									
#########									

									
							#7/4/0
						if (nchar(file_stat2_orig)>0) {
							if (any(ls()=="data_out_ct")) {
							
						# ssssssssssfffffffffffffffffffrrrrrrrrrrrrrrrrrrrrrsssssssssssss
			#		 if (k_save_only_final_results==TRUE) {
														
print_my("Saving overall results 2: ",file_stat2_orig, k_add_print_=TRUE)											



							# if (k_save_data_into_files_rda==TRUE) {
							if (!(any( c("data.table","data.frame") %in% class(data_out_ct) ))) {
							
									# rda_rda_rda_rda_rda_rda_rda_rda_rda_rda_rda_	
								# data_out_ct contains only list of saved rda files (file_stat_rda)
								data_ct_out__rda=data_out_ct
								#<<<<<<<<<<<<<<<<<<<<<<
								if (any(ls()=="stat_ct"))  rm(stat_ct)
								if (file.exists(data_ct_out__rda[1])) load(data_ct_out__rda[1]) #stat_ct
								#<<<<<<<<<<<<<<<<<<<<<<
									if (any(ls()=="group_ct_rda")) stat_ct[, `:=`( group=group_ct_rda[1] ) ]
								data_out_ct=stat_ct[] ; rm(stat_ct)
								
								if (length(data_ct_out__rda)>1) for (ii_pom in data_ct_out__rda[-1]) {
										#<<<<<<<<<<<<<<<<<<<<<<
										if (any(ls()=="stat_ct"))  rm(stat_ct)
										if (file.exists(ii_pom)) load(ii_pom) #stat_ct
										#<<<<<<<<<<<<<<<<<<<<<<
											if (any(ls()=="group_ct_rda")) stat_ct[, `:=`( group=group_ct_rda[which(ii_pom==data_ct_out__rda)] ) ]
											
										l = list(data_out_ct, as.data.table(stat_ct) )
										data_out_ct=rbindlist(l, fill=TRUE)
											if (exists("l")) rm(l)
											rm(stat_ct)
																														} #for (ii_pom
																								} # 
									# rda_rda_rda_rda_rda_rda_rda_rda_rda_rda_rda_	
								#									} # if (k_save_data_into_files_rda==TRUE)
			

								# stat_ct_all
														
											# marks deleted -later
													stat_ct_all=data_out_ct
											dele__stat_ct=is.na(stat_ct_all[["ID"]])
									if ( (n_pd_function=="7/4/0")|(n_pd_function=="3/16/0") ) {
											dele__stat_ct[ grepl("CNT",stat_ct_all$stat, fixed=TRUE) ]=TRUE
											
											dele__stat_ct[ grepl("_d_t$",stat_ct_all$stat) ]=TRUE
											dele__stat_ct[ grepl("_t$",stat_ct_all$stat) ]=TRUE
											dele__stat_ct[ grepl("_d_stnd$",stat_ct_all$stat) ]=TRUE
											dele__stat_ct[ grepl("_r_stnd$",stat_ct_all$stat) ]=TRUE
											dele__stat_ct[ grepl("_t_stnd$",stat_ct_all$stat) ]=TRUE
																								} # if (n_pd_function=="7/4/0")
									if ( (n_pd_function=="7/2/0")|(n_pd_function=="7/1/0") ) {
											
											data_out_ct=data_out_ct[ mfd_==FALSE ,]
											
											dele__stat_ct=rep(FALSE, nrow(data_out_ct) )
											
												# data_info_DT_1_all[ mfd_==FALSE , del_ ]==TRUE )
											dele__stat_ct[ (data_out_ct$del_==TRUE) | (data_out_ct$mfd_==TRUE) ]=TRUE				
											
																							  }															
											
				if (k_CSV==TRUE) {
				file_stat_deleted_csv=gsub(paste("[.]","dbf", sep=""),".csv", file_stat2_orig, ignore.case = TRUE)
				# print(file_stat_deleted_csv)	
				# write.csv2( data_out_ct , file=file_stat_deleted_csv, na="", row.names = FALSE)
				write.table( data_out_ct , file=file_stat_deleted_csv, na="", row.names = FALSE , sep=";", dec=Sys.localeconv()[1] )
									}
											
											
		  my__write_dbf( data_out_ct , file_stat2_orig ,  n_dec=3, print_output=FALSE  , mfd=dele__stat_ct ) 
																
				#											} # if (k_save_only_final_results==FALSE)
						# ssssssssssfffffffffffffffffffrrrrrrrrrrrrrrrrrrrrrsssssssssssss
													
													
															} # if (any(ls()=="data_out_ct"))
													  }	 # if (nchar(file_stat2_orig)>0)
										
										
					
#												   } # if (all(!is.na(idcol_group))) {
									# sGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGG
  
	
	
				# bbbbbbbbbbbbbbbbbbbbbbbbbbbbb22222222222222222222222
		if ( (n_pd_function=="3/16/0") ) { } # if ( (n_pd_function=="3/16/0") )
				# bbbbbbbbbbbbbbbbbbbbbbbbbbbbb22222222222222222222222
	
	
	
	
	
	

#############	
#ulozi do logu, pokud by to bylo vicekrat spustene
df=data.frame(Status="R finished",file_in=data_file,file_out=file_stat, datetime=Sys.time())
file_log_multi='log_multi.txt'
#pokud log neexistuje, tak udela novy soubor a zapise nazvy sloupcu
if (!file.exists(file_log_multi)) write.table( df[0,] , file=file_log_multi, sep = "\t", quote=TRUE, row.names=FALSE,col.names = TRUE,   append = FALSE )
write.table( df , file=file_log_multi, sep = "\t", quote=TRUE, row.names=FALSE,col.names = FALSE,   append = TRUE )
	
	
		
	

	
if (k_supress_output_all_possible==FALSE) {
# print("R mode:")	
# print(R_mode)
print("")	
print("Warnings during the processing: ")
print(warnings())
print("")	
										  }	
	

				
if (R_mode=="RGui") {
	# warning("Rgui, stopped")
print("Rgui, finished (launch_QC.r)")
	# stop("Rgui, finished")

if (.Platform$OS.type=="windows") {
# q("no")
									}

 } else
 {
print("Rterm, finished (launch_QC.r)")
print("> q()")
if (.Platform$OS.type=="windows") {
# q() 
									}
 }
 	

	
# clean the memory ...
sink()

		
# clearing some variables 
# remove variables		
			# if (exists("rr")) rm("rr")
		ss_pom=c("data_DT","data_DT_1col","dt_pom","l" , "data_out","data_out_ct", "data_out_all", "data_info_DT_puv", "data_info_DT", "data_out_ct2","data_ct_out__rda","cor_out_1col_all","cor__data_out2_all","data_info_DT_1_all","stat_ct","stat_ct_all","data_out_ct_sel","data_out_ct_sel_al",
		"maxpoc_stanic","ngb_info_DT","data_info_DT__orig_group",
		"group_rda","data_out_group","data_out_ct_group")	
			# ss_pom[duplicated(ss_pom)]
		ss_pom=unique(ss_pom)
		
				# "data_puv","data_DT_puv",
			#lapply( ss_pom ,  exists )
		ss_pom= ss_pom[as.logical( lapply( ss_pom ,  exists ) )] 
		if (length(ss_pom)>0)
		lapply( ss_pom , function(x) { if (k_supress_output_all_possible==FALSE) print(paste("  removing ",x)); rm(list=x,pos=1)} )  #ve funkci - musi to smazat v prostredi vyse pos=1

					

							
		
